//wxHatch CVS $Id: autotxtdlg.cpp,v 1.2 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
//A wxhatch file Copyright Chris Elliott and the University of York 2001
// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include "autotxtdlg.h" 


BEGIN_EVENT_TABLE(MyAutoTextDialog, wxDialog)

END_EVENT_TABLE()

// ----------------------------------------------------------------------------
// MyAutoTextDialog
// ----------------------------------------------------------------------------

MyAutoTextDialog::MyAutoTextDialog(wxWindow *parent)
: wxDialog(parent, -1, wxEmptyString, wxDefaultPosition, wxDefaultSize,
wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER )

{
    wxString myCaption ;
    
    myCaption = wxT("Setup Autotext") ;
    SetTitle(myCaption) ;
    
    
    myAbbrTxtBox = new wxTextCtrl   ( this, -1 );
    myExpandTxtBox = new wxTextCtrl   ( this, -1 );
    
    // now build the dialog
    wxBoxSizer *topsizer = new wxBoxSizer( wxVERTICAL  );
    myStaticText = new wxStaticText (this, -1, wxT("Autotext abbreviation..."), wxDefaultPosition, wxDefaultSize);
    topsizer->Add(myStaticText, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    
    topsizer->Add(myAbbrTxtBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    myStaticText = new wxStaticText (this, -1, wxT("Expansion..."), wxDefaultPosition, wxDefaultSize);
    topsizer->Add(myStaticText, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    
    topsizer->Add(myExpandTxtBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    
    topsizer->Add(CreateButtonSizer( wxOK|wxCANCEL), 0, wxCENTER|wxALL, 10); 
    
    SetSizerAndFit( topsizer );        // actually set the sizer
    myAbbrTxtBox-> SetFocus();
}



wxString MyAutoTextDialog::GetExpandValue ()
{
    return myExpandTxtBox->GetValue()  ;
}

wxString MyAutoTextDialog::GetAbbrValue ()
{
    return myAbbrTxtBox->GetValue()  ;
}

void MyAutoTextDialog::SetAbbrValue (const wxString & s)
{
    myAbbrTxtBox->SetValue(s) ;
}

void MyAutoTextDialog::SetExpandValue (const wxString & s)
{
    myExpandTxtBox->SetValue(s) ;
}