//wxHatch CVS $Id: bitmenu.cpp,v 1.14 2004/05/04 15:09:01 biol75 Exp $
// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#include "wx/mdi.h"
#endif

#include <wx/datetime.h>
#include <wx/filename.h>
#include <wx/textfile.h>

#include "projdefs.h"
#include "bitmenu.h"
#include "bitmaps/blank.xpm"

//TODO make it read the name of the OnEnable method out of the cpp file

void RemoveNonCChars ( wxString & sTarget )
{
    size_t i = 0;
    while ( i < sTarget.Len() )
    {
        wxChar c = sTarget[i] ;
        i ++ ;
        if ( c != space )
        {
            //letters between Z and a
        if ( c == wxT('[') || c == wxT('\\') || c == wxT(']') || c == wxT('^') || c == wxT('`') )
        {
            wxString sOld (c) ;
            sTarget.Replace( sOld, wxT("Q") );
            i = 0;

        }
        
        if ( c > wxT('z') )
        {
            wxString sNew = underline + wxString(wxChar(c - 25)) ;
            wxString sOld (c) ;
            sTarget.Replace( sOld, sNew );
            i = 0;
        }
        if ( c < wxT('A') && ( c < wxT('0') || c > wxT('9')) )
        {
            wxString sNew = underline + wxString(wxChar(c + 25)) ;
            wxString sOld (c) ;
            sTarget.Replace( sOld, sNew );
            i = 0;
        }
        }
        
    }
}

TBitmapMenu::TBitmapMenu (const wxString & s, const wxString &sAcc,const wxString & sHlp,
    const wxString & sLastMenuBarText, bool b, bool bIsNewPopup)
{
    // construct new data from menu interactive input
    // menubar &Edit &Edit
    // menuitem &Copy Edit
    // or when reading a file and get a separator File
    sActualText = s;             //eg &Open  Save &As

    bIsSeparator = FALSE ;
    if (s==wxT("SEPARATOR")) bIsSeparator = TRUE ;

    wxString caption ; 
    //caption to be Open or Save__As
    if (!s.StartsWith(wxT("&"),&caption)) caption = s;
    caption.Replace( ampersand, underline );
    caption.Replace( space, underline );
    RemoveNonCChars ( caption ); 

    if (!sLastMenuBarText.StartsWith(wxT("&"),&sMyMenuname)) sMyMenuname = sLastMenuBarText;
    sMyMenuname.Replace( ampersand, underline );
    sMyMenuname.Replace( space, underline );
    RemoveNonCChars ( sMyMenuname ) ;

    bIsBase = b;
    if (bIsBase)
    {
        x = new int ;
        w = new int ;
    }
    else
    {
        sID = sMyMenuname.BeforeFirst(wxT('_')) + caption ;
        sID = sID.MakeUpper();
        sID = wxT("wxH_") + sID ;

        sOnMethodName = wxT("On") + sMyMenuname.BeforeFirst(wxT('_')) + caption ;
        sAccel = sAcc ;
        sHelp = sHlp ;

    }
    bIspopup = bIsNewPopup ;
};


TBitmapMenu::TBitmapMenu (const wxString & sMenuName, const wxString & sLabel, bool bIsNewPopup )
{

    //constructor for menubar from eg File_menu &File
    //called from reading a project when it gets to a menubar
    sActualText = sLabel;        //&File
                                 //File
    sMyMenuname = sMenuName ;
    sOnMethodName =  sID = wxEmptyString;

    bIsSeparator = FALSE ;
    bIsBase = TRUE;
    bIspopup = bIsNewPopup ;
    x = new int ;
    w = new int ;
}; 

TBitmapMenu::TBitmapMenu (const wxString & sIDin, const wxString & sMenuName, const wxString & sLabel,
        const wxString & sMethod, const wxString & sAcc, const wxString & sHlp)
{
    sActualText = sLabel;        //&New
    bIsSeparator = FALSE ;
                                 //  File
    sMyMenuname = sMenuName ;

    bIsBase = FALSE;
    if (bIsBase)
    {
        x = new int ;
        w = new int ;
    }

    sOnMethodName = sMethod ;    //OnFileNew
    sHelp = sHlp ;
    sAccel = sAcc ;
    sID = sIDin ;                //wxH_FILENEW
    sID.Trim(TRUE).Trim(FALSE);

    bIspopup = FALSE ;
}


void TBitmapMenu::ReAlign (TBitmapMenu * prev,  wxDC & dc)
{
    int wTmp ;
    dc.GetTextExtent (sActualText, &wTmp, &h);
    h = h + 2 * del ;
    wTmp = wTmp + 2 * del ;
    if ((bIsBase) && (!prev))    // first menubar
    {
        root = NULL ;
                                 // leave room for icon
        *x =  2 * (1 + iToolbarmax) ;
        y = iToolbarmax ;
        *w = wTmp ;
        // h we know
    }
    if ((bIsBase) && (prev))     // any other menubar
    {
        root = NULL ;
        *x = *(prev -> x) + *(prev -> w) + 1;
        y = iToolbarmax ;
        *w = wTmp ;
        // h we know

    }
    if (bIspopup)
    {
        *x = (*x) + 50 ;
        y = y + 50 ;
    }
    if (!bIsBase)                // menuitems
    {
        root = prev -> root ;
        if (prev->bIsBase)
        {
            root = prev ;
        }
        x = prev -> x ;
        w = prev -> w ;
        sMyMenuname = prev -> GetBaseString() ;
        if (wTmp > *w) *w = wTmp ;
        y = prev -> y + prev ->h ;

    }
}


void TBitmapMenu::DrawBitMenu ( wxDC & dc, bool bSelected)
{
    dc.SetBrush(*wxTheBrushList -> FindOrCreateBrush(*wxLIGHT_GREY, wxSOLID) );
    if (bSelected) dc.SetPen(*wxThePenList -> FindOrCreatePen(*wxBLACK, 2, wxSOLID) );
    dc.DrawRectangle ( *x,y,*w,h );
    if (!bSelected )
    {
        dc.SetPen(*wxThePenList -> FindOrCreatePen(*wxWHITE, 1, wxSOLID) );
        dc.DrawLine(*x,y, *x+*w, y);
        dc.DrawLine(*x,y, *x, y+h );
        dc.SetPen(*wxMEDIUM_GREY_PEN) ;
        dc.DrawLine(*x+*w,y+h, *x+*w, y);
        dc.DrawLine(*x+*w,y+h, *x, y+h );
    }
    //dc.DrawText ( sActualText, *x + del, y + del );
    //try and draw underline on character
    wxString sStart = sActualText.BeforeFirst(wxT('&')) ;
    wxString sEnd = sActualText.AfterFirst(wxT('&')) ;
    wxString sEmphasize ;
    if (!sEnd.IsEmpty()) sEmphasize = sEnd.Left(1) ;
    int iW, iH, xT, yT ;
    xT = *x + del ;
    yT = y + del ;
    dc.DrawText ( sStart, xT, yT );
    dc.GetTextExtent ( sStart, &iW, &iH );
    xT = xT + iW ;
    dc.DrawText ( sEnd, xT, yT );
    if (!sEnd.IsEmpty())
    {
        sEmphasize = sEnd.Left(1) ;
        dc.GetTextExtent ( sEmphasize, &iW, &iH );
        yT = yT + iH ;
        dc.SetPen(*wxBLACK_PEN) ;
        dc.DrawLine ( xT, yT, xT + iW, yT );
    }

}


TBitmapMenu::~TBitmapMenu ()
{
    if (bIsBase)
    {
        delete x;
        delete w;
    }
} ;
bool TBitmapMenu::Contains ( int xIn, int yIn )
{
    if ( xIn < *x ) return FALSE ;
    if ( xIn > *x + *w ) return FALSE ;
    if ( yIn < y ) return FALSE ;
    if ( yIn > y+h ) return FALSE ;
    return TRUE ;
};

bool TBitmapMenu::IsSeparator () { return bIsSeparator ;};

bool TBitmapMenu::IsBase () {return bIsBase;};

bool TBitmapMenu::IsPopup () {return bIspopup;};

wxString TBitmapMenu::GetBaseString()
{
    return  sMyMenuname ;
};


wxString TBitmapMenu::GetOnString()
{
    return sOnMethodName ;       //OnFileNew
};

wxString TBitmapMenu::GetOnEnableString()
{
    return wxT("OnEnable") + sOnMethodName.AfterFirst(wxT('n')) ;       //OnEnableFileNew
};


wxString TBitmapMenu::GetHelpString()
{
    return sHelp ;               //OnFileNew
};


wxString TBitmapMenu::GetAccelString()
{
    return sAccel ;
};



wxString TBitmapMenu::GetConCatString()
{
                                 //FileNew
    return sOnMethodName.AfterFirst(wxT('n')) ;
};


wxString TBitmapMenu::GetLabel()
{
    return sActualText ;         //&New
};

void TBitmapMenu::SetLabel(const wxString & s)
{
    sActualText = s ;         //&New
};


wxString TBitmapMenu::GetMenuName()
{
    return sMyMenuname ;
};


wxString TBitmapMenu::GetIDString()
{
    return sID ;
};


                                 //    wxH_FILE_OPEN,
wxString TBitmapMenu::GetIDText ()
{
    if (bIsBase) return wxEmptyString ;
    wxString sTmp;
                                 //indent 4 spaces and add comma
    sTmp.Printf(wxT("    %s"),sID.c_str());
    return sTmp ;
};


wxString TBitmapMenu::GetDeclarationText ()
{
    wxString sTmp;
    //    void OnFileOpen (wxCommandEvent & event);
                                 //OnFile_Open
    sTmp.Printf(wxT("    void %s (wxCommandEvent & event);"),sOnMethodName.c_str());
    return sTmp ;
} ;


wxString TBitmapMenu::GetEnableDeclarationText ()
{
    wxString sTmp;
    //    void OnEnableFileOpen (wxUpdateUIEvent & event);
                                 //OnFile_Open
    sTmp.Printf(wxT("    void %s (wxUpdateUIEvent & event);"),GetOnEnableString().c_str());
    return sTmp ;
} ;

wxString TBitmapMenu::GetEventTableText ()
{
    wxString sTmp;
    //    EVT_MENU ( wxH_FILEOPEN, MyFrame::OnFileOpen)
    sTmp.Printf(wxT("    EVT_MENU ( %s, MyFrame::%s)"),sID.c_str(),sOnMethodName.c_str() );
    return sTmp ;
} ;

wxString TBitmapMenu::GetEventTableEnableText ()
{
    wxString sTmp;
    //    EVT_UPDATE_UI ( wxH_FILEOPEN, MyFrame::OnEnableFileOpen)
    sTmp.Printf(wxT("    EVT_UPDATE_UI ( %s, MyFrame::%s)"),sID.c_str(),GetOnEnableString().c_str() );
    return sTmp ;
} ;

wxString TBitmapMenu::GetBodyText ()
{
    wxString sTmp;
    /*
    void MyFrame::OnFileOpen (wxCommandEvent & WXUNUSED(event))
    {
        //Respond to menu here
    }
    */
    sTmp.Printf(wxT("void MyFrame::%s (wxCommandEvent & WXUNUSED(event)) \n{\n    //Respond to menu here \n    \n}\n\n"),sOnMethodName.c_str());
    return sTmp ;
} ;


wxString TBitmapMenu::GetEnableText ()
{
    wxString sTmp;
    /*
    void MyFrame::OnEnableFileOpen (wxUpdateUIEvent & event)
    {
        //Controls enable of tool and menu
    }
    */
    sTmp.Printf(wxT("void MyFrame::%s (wxUpdateUIEvent & event) \n{\n    //Controls enable of tool and menu \n    bool b = TRUE ; //or FALSE\n    event.Enable(b);\n}\n\n"),
       GetOnEnableString().c_str());
    return sTmp ;
} ;


wxString TBitmapMenu::GetMenuText ()
{
    wxString sTmp;
    if (bIsSeparator)
    {
    sTmp.Printf(wxT("    %s -> AppendSeparator ();" ),
        sMyMenuname.c_str() );
    }
    else
    {
    //    File_menu -> Append ( wxH_FILEOPEN, "&Open\Ctrl+O", "help open" );
    sTmp.Printf(wxT("    %s -> Append ( %s, wxT(\"%s%s\"), wxT(\"%s\") );" ),
        sMyMenuname.c_str(),
        sID.c_str(),
        sActualText.c_str(),
        sAccel.c_str(),          // has to hold \Ctrl+X
        sHelp.c_str()  );
    }
    return sTmp ;
} ;


void TBitmapMenu::GetMidPoint (int * xm, int * ym)
{
    *xm = *x + *w/2;
    *ym = y + h/2;
    return ;
}

TBitmapMenu * TBitmapMenu::GetRoot ()
{
    return root ;
}

/////////////////////////////////////////////////////////////////////////////////////////////////////////

#include "mcanvas.h"
wxString TBitmapTool::GetAddToolText (MyCanvas* pCanvas)
{
    wxString sTmp ;

    wxString sTool =  pCanvas -> MatchTool (myID) -> GetConCatString () ;
    sTmp.Printf ( wxT("    toolBar->AddTool(%s, wxBitmap ( %s_xpm ), wxT(\"%s\")); "),
        myID.c_str(), sTool.c_str(), myHelp.c_str() );
    return sTmp ;
} ;


wxString TBitmapTool::GetConCatString (MyCanvas* pCanvas)
{
    return pCanvas -> MatchTool (myID) -> GetConCatString () ;

} ;


TBitmapTool::TBitmapTool (const wxString& s /*= wxEmptyString*/,
            const wxString& sI /* = wxEmptyString*/,
            const wxString& sH /* = wxEmptyString*/)
        {
            myFilename = s ;
            if (!myFilename.IsEmpty() ) 
            {
                myBitmap.LoadFile(myFilename,wxBITMAP_TYPE_XPM) ;
                modTime = wxFileName(myFilename).GetModificationTime() ;
            }
		else 
		{
		myBitmap = wxBitmap( blank_xpm );
		
		}
            myID = sI ;
            myHelp = sH;
        };

bool TBitmapTool::IsAlteredOnDisk ( )
{
    if (myFilename.IsEmpty()) return FALSE ;
    if (!modTime.IsValid()) return FALSE ;
    wxDateTime fDT = wxFileName(myFilename).GetModificationTime();
    if (!fDT.IsValid()) return FALSE;
    return modTime.IsEarlierThan(fDT);
}

void TBitmapTool::SetModTime ()
{
    modTime = wxDateTime::Now();
}

wxString TBitmapTool::Get_XPM_Name ( )
{
    if (myFilename.IsEmpty()) return wxEmptyString ;

	wxTextFile XPMfile ;
    size_t i = 0 ;
    bool bNotFound = TRUE ;
    wxString sLine ;
    if (!XPMfile.Open (myFilename)) return wxEmptyString ;

    while (( i < XPMfile.GetLineCount () ) && (bNotFound) )
    {
        sLine = XPMfile [i];
        if (sLine.Contains(wxT("char"))) bNotFound = FALSE ;
        else i ++ ;
    }
    if (bNotFound) return wxEmptyString ;
	// sLine contains static char *FileNew_16_xpm[] = {
	sLine = sLine.AfterFirst(c_asterisk);
	sLine = sLine.BeforeLast(c_underline);
	sLine = sLine + wxT(".xpm");
	return sLine ;

}

