//wxHatch CVS $Id: cfgdlg.cpp,v 1.7 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
//A wxHatch file Copyright Chris Elliott and the University of York 2001

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include <wx/dialog.h>
#include <wx/button.h>
#include <wx/checkbox.h>
#include <wx/config.h>
#include "cfgdlg.h"
#include "projdefs.h"
#include "tooldlg.h"

const int n = 8 ;

BEGIN_EVENT_TABLE(MyConfigDialog, wxDialog)
EVT_BUTTON(-1, MyConfigDialog::OnButton)
EVT_UPDATE_UI(-1, MyConfigDialog::OnUpdateButton)
END_EVENT_TABLE()

// ----------------------------------------------------------------------------
// MyModalDialog
// ----------------------------------------------------------------------------

MyConfigDialog::MyConfigDialog(wxFrame *parent,
const wxString & myName, const wxString & myCaption,
const wxArrayString & myTexts, long myStyle)
: wxDialog(parent, -1, myCaption, wxDefaultPosition, wxDefaultSize,
wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER )

{
    myParent = parent ;
    wxBoxSizer *topsizer = new wxBoxSizer( wxHORIZONTAL  );
    myListBox = new wxListBox ( this, -1, wxDefaultPosition, wxDefaultSize,
        0, NULL, wxLB_SINGLE	 );
    // fill up the listbox
    int i = 0 ;    
    for (i = 0; i < (int)myTexts.GetCount(); i++)
       {
       myListBox -> Append (myTexts[i].BeforeFirst(wxT(';')));
       sTools.Add(myTexts[i]);
       }


    myStaticText = new wxStaticText ( (wxWindow *)this, -1, myName, wxDefaultPosition, wxDefaultSize);
    topsizer->Add(myStaticText, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    topsizer->Add(myListBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    wxBoxSizer *button_sizer = new wxBoxSizer( wxVERTICAL  );
    wxButton * pButton = new wxButton( this, wxID_OK, wxT("&OK") ) ;
    button_sizer->Add(pButton,
        0,                       // make horizontally unstretchable
        wxALL,                   // make border all around (implicit top alignment)
        10 );                    // set border width to 10

    button_sizer->Add(
        new wxButton( this, wxID_CANCEL, wxT("&Cancel") ),
        0,                       // make horizontally unstretchable
        wxALL,                   // make border all around (implicit top alignment)
        10 );                    // set border width to 10

    button_sizer->Add(
        new wxButton( this, wxH_WXHTOOLS, wxT("&Help") ),
        0,                       // make horizontally unstretchable
        wxALL,                   // make border all around (implicit top alignment)
        10 );                    // set border width to 10
    button_sizer->Add(
        new wxButton( this, wxh_EDIT, wxT("&Edit") ),
        0,                       // make horizontally unstretchable
        wxALL,                   // make border all around (implicit top alignment)
        10 );                    // set border width to 10
    button_sizer->Add(
        new wxButton( this, wxh_ADD, wxT("&Add") ),
        0,                       // make horizontally unstretchable
        wxALL,                   // make border all around (implicit top alignment)
        10 );                    // set border width to 10
    button_sizer->Add(
        new wxButton( this, wxh_DELETE, wxT("De&lete") ),
        0,                       // make horizontally unstretchable
        wxALL,                   // make border all around (implicit top alignment)
        10 );                    // set border width to 10
    button_sizer->Add(
        new wxButton( this, wxh_UP, wxT("Move &Up") ),
        0,                       // make horizontally unstretchable
        wxALL,                   // make border all around (implicit top alignment)
        10 );                    // set border width to 10
    button_sizer->Add(
        new wxButton( this, wxh_DOWN, wxT("Move &Down") ),
        0,                       // make horizontally unstretchable
        wxALL,                   // make border all around (implicit top alignment)
        10 );                    // set border width to 10

    pButton -> SetDefault ();
    topsizer->Add(
        button_sizer,
        0,                       // make vertically unstretchable
        wxALIGN_CENTER );        // no border and centre horizontally

    SetAutoLayout( TRUE );       // tell dialog to use sizer

    SetSizer( topsizer );        // actually set the sizer

    topsizer->Fit( this );       // set size to minimum size as calculated by the sizer
                                 // set size hints to honour mininum size
    topsizer->SetSizeHints( this );
    myListBox -> SetSelection ( 0 ) ;
}


void MyConfigDialog::OnButton(wxCommandEvent& event)
{
    int i = myListBox->GetSelection();
    wxString sTmp = myListBox->GetStringSelection();
    switch (event.GetId())
    {
    case wxH_WXHTOOLS :
        myParent -> ProcessCommand(wxH_WXHTOOLS);
        break ;
    case wxh_EDIT :
{
    wxString sCmd = sTools[i].BeforeFirst (wxT(';')) ;
    wxString sParam = sTools[i].AfterFirst (wxT(';'));
    MyToolDialog dialog(this,
    wxT("Enter the menu label "), wxT("command"),
    wxT("Enter the command to execute"), wxT("param"),
    wxT("Edit Tool"),
    sCmd, sParam,
    wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;

    wxArrayString myResult = dialog.GetValue() ;
    sCmd = myResult [0] ;
    sParam = myResult [1] ;

    sTools[i] = sCmd + wxT(" ; ") + sParam ;
}
        break ;
    case wxh_ADD :
{
    wxString sCmd = wxEmptyString ;
    wxString sParam = wxEmptyString ;
    MyToolDialog dialog(this,
    wxT("Enter the menu label "), wxT("command"),
    wxT("Enter the command to execute"), wxT("param"),
    wxT("Add Tool"),
    sCmd, sParam,
    wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;

    wxArrayString myResult = dialog.GetValue() ;
    sCmd = myResult [0] ;
    sParam = myResult [1] ;

    sTools.Add(sCmd + wxT(" ; ") + sParam);
}
        break ;
    case wxh_DELETE :
        sTools.Remove(i);
        if (i > 0) i -- ;
        break ;
    case wxh_UP :
        sTools.Remove(i);
        sTools.Insert( sTmp, i-1 );
        i -- ;
        break ;
    case wxh_DOWN :
        sTools.Remove(i);
        sTools.Insert( sTmp, i+1 );
        i ++ ;
        break ;

    default :
    EndModal (event.GetId()) ;
    return ;
    }
    myListBox->Clear();
    int iCount = 0 ;
    for (iCount = 0; iCount < (int)sTools.GetCount(); iCount++)
       {
       myListBox -> Append (sTools[iCount].BeforeFirst(wxT(';')));
       }
    myListBox->SetSelection(i);
}


wxArrayString MyConfigDialog::GetValue ()
{
    return sTools ;
}


int MyConfigDialog::ShowModal ()
{
//    myComboBox -> SetSelection ( 0, iLen ) ;
//    myComboBox -> SetFocus ();
    return  wxDialog::ShowModal ();
}

void MyConfigDialog::OnUpdateButton  (wxUpdateUIEvent & event)
{
    int i = myListBox->GetSelection();
    switch (event.GetId())
    {
    case wxh_DELETE :
        event.Enable (myListBox-> GetCount() > 0);
        break ;
    case wxh_UP :
        event.Enable (i > 0);
        break ;
    case wxh_DOWN :
        event.Enable (i < myListBox-> GetCount() - 1);
        break ;

    default :
    event.Enable(TRUE);
    
    }
}
