//Default frame.cpp for wxHatch

// For compilers that support precompilation, includes "wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include <wx/image.h>
#include <wx/filename.h>

#include "bitmaps/test_show_dialog.xpm" 
class MyFrame ;


#include "frame.h"

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
    EVT_MENU ( wxH_TESTE_XIT, MyFrame::OnTestE_xit)
    EVT_MENU ( wxH_TESTSHOW_DIALOG, MyFrame::OnTestShow_dialog)
    EVT_CLOSE(MyFrame::OnClose)
END_EVENT_TABLE()

IMPLEMENT_APP(MyApp)

bool MyApp::OnInit()
{

    MyFrame *frame = new MyFrame (wxT("fram: A simple dialog tester"),
                                  wxPoint(20,20), wxSize(600,450));

    frame->Show (TRUE);
    ::wxInitAllImageHandlers();
    wxIcon myIcon ;
    wxFileName fn ( argv[0] );
    myIcon.CopyFromBitmap(wxBitmap(wxImage(fn.GetPathWithSep() + wxT("anIcon.ico"))));
    frame->SetIcon(myIcon);
    SetTopWindow (frame);
    return TRUE;
}

MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
    : wxFrame((wxFrame *)NULL, -1, title, pos, size)
{
// create a child control here
    
    

//  menu setup goes here


    wxMenu * Test_menu = new wxMenu ; 
    Test_menu -> Append ( wxH_TESTSHOW_DIALOG, wxT("&Show dialog"), wxT("") );
    Test_menu -> Append ( wxH_TESTE_XIT, wxT("E&xit"), wxT("") );
    wxMenuBar *menuBar = new wxMenuBar;

    menuBar->Append (Test_menu, wxT("&Test") );
    SetMenuBar (menuBar); 
    CreateToolBar(wxNO_BORDER | wxTB_FLAT | wxTB_HORIZONTAL);
    InitToolBar(GetToolBar());
    
}



void MyFrame::OnClose (wxCloseEvent& event)
{
    event.Skip();
    // or event.Veto();
}



void MyFrame::OnTestShow_dialog (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
#include "MyDlg.inc"
    
}


void MyFrame::OnTestE_xit (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
    Close ();
}


void MyFrame::InitToolBar(wxToolBar* toolBar)
{
  
    toolBar->AddTool(wxH_TESTSHOW_DIALOG, wxBitmap ( test_show_dialog_xpm ), wxT("Test Dialog")); 
    toolBar->Realize();
} 


