//wxHatch CVS $Id: dchild.cpp,v 1.25 2004/05/04 08:45:25 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
// ===========================================================================
// declarations
// ===========================================================================

// ---------------------------------------------------------------------------
// headers
// ---------------------------------------------------------------------------
#ifdef __BORLANDC__ 
#pragma hdrstop 
#endif 


#ifndef WX_PRECOMP 
#include "wx/wx.h" 
#endif 


// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#include "wx/mdi.h"
#endif

#include <wx/docview.h>
#include <wx/html/helpctrl.h>
#include <wx/treectrl.h>
#include <wx/treebase.h>
#include <wx/listctrl.h>
#include <wx/imaglist.h>


class MyFrame ;

#include "projdefs.h"
#include "bitmenu.h"
#include "wx/stc/stc.h"
#include "mytext.h"
#include "tchild.h"
#include "trchild.h"
#include "dchild.h"
#include "wxhatch.h"

//#include "bitmaps/dlg.xpm"

//base images added to list in wxHatch.cpp
#define nBaseImages 2

#define iDlgId 0
#define iPropId 1
#define iCBSizer 2

BEGIN_EVENT_TABLE(dlgChild, wxMDIChildFrame)
EVT_MENU(wxH_CHILD_QUIT, dlgChild::OnQuit)
EVT_BUTTON(-1,dlgChild::OnButton)
EVT_ACTIVATE(dlgChild::OnActivate)
EVT_TREE_ITEM_ACTIVATED(-1, dlgChild::OnTreeBoxDClick)
EVT_TREE_BEGIN_LABEL_EDIT(-1, dlgChild::OnTreeBoxEdit)
EVT_TREE_END_LABEL_EDIT(-1, dlgChild::OnTreeBoxDoneEditing)
EVT_CLOSE(dlgChild::OnClose)
END_EVENT_TABLE()

int wxCALLBACK wxListCtrlCompareFunction(long item1, long item2, long sortData)
{
    return item1 - item2 ;
}

BEGIN_EVENT_TABLE(wxhTreeCtrl, wxTreeCtrl)
    EVT_MENU ( wxH_GOTOFIRST_USE,   wxhTreeCtrl::OnGotoFirst_use)
    EVT_MENU ( wxH_GOTOBODY,        wxhTreeCtrl::OnGotoBody)
    EVT_MENU ( wxH_GOTODECLARATION, wxhTreeCtrl::OnGotoDeclaration)
    EVT_RIGHT_DOWN(wxhTreeCtrl::OnRightDown)
END_EVENT_TABLE()

wxhTreeCtrl::wxhTreeCtrl(dlgChild* parent, wxWindowID id, wxSize size, long style) :
 wxTreeCtrl(parent, id, wxDefaultPosition, size, style )
{
    dChild = parent ;
    Goto_menu = new wxMenu  (wxT("Goto"));
    wxMenu *ctrl_sub_menu = new wxMenu;
    
    Goto_menu -> Append ( wxH_GOTODECLARATION, wxT("&Header"), wxT("") );
    Goto_menu -> Append ( wxH_GOTOBODY, wxT("&Code cpp file"), wxT("") );
    Goto_menu -> Append ( wxH_GOTOFIRST_USE, wxT("&Include"), wxT("") );
    Goto_menu -> AppendSeparator();

    Goto_menu -> Append ( wxH_SUB_MENU, wxT("Insert"), ctrl_sub_menu, wxT("Choose a Control to Insert") ) ;
    dChild -> frame -> CreateCtrlMenu (ctrl_sub_menu, NULL);
    
    Goto_menu->Append(wxH_CTRL_UP, wxT("Move Ctrl &Up"), wxT("Move Control Up the Tree") );
    Goto_menu->Append(wxH_CTRL_DOWN, wxT("Move Ctrl &Down"), wxT("Move Control Down the Tree") );
    Goto_menu->Append(wxH_CTRL_RIGHT, wxT("Move Ctrl &Right"), wxT("Move Control to SubSizer") );
    Goto_menu->Append(wxH_CTRL_LEFT, wxT("Move Ctrl &Left"), wxT("Move Control Up to Ouside sizer") );

    Goto_menu -> AppendSeparator();
    Goto_menu->Append(wxH_CTRL_TAB_UP, wxT("Tab Earlier"), wxT("Move Control Up the Tab order") );
    Goto_menu->Append(wxH_CTRL_TAB_DOWN, wxT("Tab Later"), wxT("Move Control Down the Tab order") );
    Goto_menu -> AppendSeparator();
    Goto_menu->Append(wxH_CTRL_RENAME, wxT("Rename Control"), wxT("Rename Control in Tree") );
    Goto_menu->Append(wxH_CTRL_DEL, wxT("De&lete Control"), wxT("Remove Control from the Tree") );
}

wxhTreeCtrl::~wxhTreeCtrl()
{
    delete Goto_menu ;
}

void wxhTreeCtrl::OnRightDown(wxMouseEvent & event )
{
    PopupMenu (Goto_menu, event.GetPosition());
}


void wxhTreeCtrl::OnGotoDeclaration (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
    dChild->myTextChild->alternateWin->Activate();
}


void wxhTreeCtrl::OnGotoBody (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
        dChild->myTextChild->Activate();

}


void wxhTreeCtrl::OnGotoFirst_use (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here
    if (dChild->frame->pInc)
        dChild->frame->pInc->Activate();

}

// ---------------------------------------------------------------------------
// dlgChild
// ---------------------------------------------------------------------------

dlgChild::dlgChild(wxMDIParentFrame *parent, const wxString& title, TextChild * tc )
: wxMDIChildFrame(parent, -1, title )
{
    //MDI toolbars only under windows, so make our own button bar (ButtonSizer)
    //CreateToolBar(wxNO_BORDER | wxTB_FLAT | wxTB_HORIZONTAL, -1, wxT("Toolbar"));
    
    frame = (MyFrame *) parent ;
    myTextChild = tc ;
    
    bPropertyChanged = FALSE ;
    
    mainsizer  = new wxBoxSizer( wxHORIZONTAL );
    wxBoxSizer * leftsizer  = new wxBoxSizer( wxVERTICAL );
    wxBoxSizer * rightsizer = new wxBoxSizer( wxVERTICAL );
    ButtonSizer = new wxBoxSizer( wxVERTICAL );
    
    TabBox = new wxListCtrl(this, -1, wxDefaultPosition, wxSize(200,200), wxLC_LIST );    
    TreeBox = TreeBox = new wxhTreeCtrl (this, -1, wxSize(200,200), wxTR_HAS_BUTTONS | wxTR_EDIT_LABELS);
    
	wxImageList * pCtrlImageList = new wxImageList (16,16, TRUE);
	TreeBox -> AssignImageList(pCtrlImageList);

    leftsizer -> Add(new wxStaticText (this, -1, wxT("  Dialog Hierarchy")), 0, wxEXPAND | wxALIGN_CENTER_VERTICAL);
    leftsizer -> Add(TreeBox, 1, wxEXPAND );

    rightsizer -> Add(new wxStaticText (this, -1, wxT("  Tab Order")), 0, wxEXPAND | wxALIGN_CENTER_HORIZONTAL);
    rightsizer -> Add(TabBox , 1, wxEXPAND);

    mainsizer -> Add (ButtonSizer, 0, wxEXPAND );
    mainsizer -> Add (leftsizer, 1, wxEXPAND );   
    mainsizer -> Add (rightsizer, 1, wxEXPAND );
    
    SetSizer( mainsizer );
    mainsizer->SetSizeHints( this );
   // DoActivate();

}


dlgChild::~dlgChild()
{

}


void dlgChild::OnQuit(wxCommandEvent& WXUNUSED(event))
{
    Close(TRUE);
}


void dlgChild::OnButton (wxCommandEvent& event)
{
    frame -> OnAddAnyCtrl(event) ;
}

void dlgChild::OnActivate(wxActivateEvent& event)
{
    if ( event.GetActive() && myTextChild->textctrl->isDlgUpDated)
    {
        DoActivate() ;
        myTextChild->textctrl->isDlgUpDated = FALSE ;
    }
    else
    {
        if (! (frame ->  DoDlgSanityCheck (myTextChild, 0)))
        {
            (void)wxMessageBox( wxT("Dialog code disordered and cannot autocorrect it \n Compiler or Run_time error Likely"), wxT("wxHatch failure"));
            
        }
        
    }
}

void dlgChild::FindExpandedItems(const wxTreeItemId & ID, long myCookie)
{
    wxTreeItemId ClassID = TreeBox -> GetFirstChild(ID, myCookie);
    while (ClassID.IsOk())
        {
            if  (TreeBox->ItemHasChildren(ClassID))
            {
                FindExpandedItems(ClassID, myCookie + 1L);
            }
            if (TreeBox->IsExpanded(ClassID))
            {
                wxString sTmp = TreeBox->GetItemText(ClassID);
                ExpandedArray.Add(sTmp);
            }
            ClassID = TreeBox -> GetNextChild(ID, myCookie );
        }
}

void dlgChild::DoActivate()
{
    long myCookie = 234 ;
    if (TreeRootId.IsOk())
    {
        FindExpandedItems(TreeRootId, myCookie) ;
    }
    TreeBox ->  DeleteAllItems ();
    TabBox -> DeleteAllItems() ;

    //newdlg045599::newdlg045599(wxFrame *parent
    //newdlg045599::newdlg045599(wxWindow *parent
    
    long iLine = frame -> DoFindLine (wxT( "(wxFrame *parent" ), 0, myTextChild);
    if (iLine == wxNOT_FOUND) iLine = frame -> DoFindLine (wxT( "(wxWindow *parent" ), 0, myTextChild);

    wxString sDialogName = myTextChild -> GetLineText (iLine-1);
    sDialogName = sDialogName.BeforeFirst(wxT( ':' ));
    sDialogName.Trim(TRUE).Trim(FALSE);
    SetTitle (wxT("Dialog Editing ") + sDialogName );
    
    iLine = frame -> DoFindLine (wxT( "SetSizer" ), 0, myTextChild);
    wxString sSizerName = myTextChild  -> GetLineText (iLine-1);
    sSizerName = sSizerName.AfterFirst(wxT('('));
    sSizerName = sSizerName.BeforeFirst(wxT(')'));
    sSizerName.Trim(TRUE).Trim(FALSE);
    
    TreeRootId = TreeBox->AddRoot(sDialogName + wxT(" Control List"), iDlgId);
	
	int iIndex = frame->sControlNames.Index(wxT("wxBoxSizer")) + nBaseImages ;
	//int iMax = TreeBox -> GetImageList() -> GetImageCount ();
    wxTreeItemId CurrentId = TreeBox->AppendItem(TreeRootId, sSizerName, iIndex);
	
    TreeBox -> SelectItem ( CurrentId );
    ClassArray.Clear();
    ClassArray.Add(sSizerName) ;
    
    while ( iLine != wxNOT_FOUND )
    {
        iLine = BuildControlList (iLine, CurrentId, sSizerName);
        
    } // end of while
    int iControlLine = frame-> DoFindLine ( sSizerName + wxT("=new"), 0, myTextChild);
    wxString sControlType = myTextChild -> GetLineText ( iControlLine - 1 ) ;
    wxString sControlProperties = sControlType.AfterLast(wxT('('));
    sControlProperties = sControlProperties.BeforeFirst(wxT(')'));
    sControlProperties.Trim(TRUE).Trim(FALSE);

    TreeBox->AppendItem(CurrentId, sControlProperties, iPropId);
    TreeBox->Expand(CurrentId);
    TreeBox->Expand(TreeRootId);

    TabBox -> SortItems (wxListCtrlCompareFunction, 0);
    TreeBox->SetFocus();
    
}

long dlgChild::BuildControlList(int iLine, wxTreeItemId myID, const wxString & myControl)
{
    iLine = frame->DoReverseFindLine ( myControl + wxT(" -> Add ("), iLine, myTextChild );
    while (iLine != wxNOT_FOUND)
    {
        wxString sLine = myTextChild -> GetLineText ( iLine + 1 ) ;
        wxString sControlAdded = sLine.AfterFirst(wxT('(')).BeforeFirst(wxT(','));
        sControlAdded.Trim(TRUE).Trim(FALSE);
        
        int iControlLine = frame-> DoFindLine ( sControlAdded + wxT("=new"), 0, myTextChild);
        wxString sControlType, sControlProperties ;
        if ( iControlLine == wxNOT_FOUND )
        {
            sControlProperties = sControlAdded.AfterFirst(wxT('(')) ;
            sControlAdded = sControlAdded.BeforeFirst(wxT('('));
            sControlType = sControlAdded ;
        }
        else
        {
            sControlType = myTextChild -> GetLineText ( iControlLine - 1 ) ;
            sControlProperties = sControlType ;
            sControlType = sControlType.AfterFirst(wxT('='));
            sControlType = sControlType.AfterFirst(wxT('w'));
            sControlType = sControlType.BeforeFirst(wxT('('));
            sControlType.Trim(TRUE).Trim(FALSE);
            
            sControlProperties = sControlProperties.AfterFirst(wxT('('));
            if ( sControlProperties.Contains(wxT("this")) )
            {
                sControlProperties = sControlProperties.AfterFirst(wxT(','));
                sControlProperties = sControlProperties.AfterFirst(wxT(','));
            }
        }
        sControlProperties = sControlProperties.BeforeLast(wxT(')'));
        sControlProperties.Trim(TRUE).Trim(FALSE);

        wxTreeItemId CurrentId = TreeBox->InsertItem(myID, 0, sControlAdded,
            frame->sControlNames.Index(sControlType) + nBaseImages);
        TreeBox->AppendItem(CurrentId, sControlProperties, iPropId );

        if (sControlType.Contains(wxT("Sizer")))
		{
			BuildControlList (iLine, CurrentId, sControlAdded);
			TreeBox->Expand(CurrentId) ;
		}
        else
        {
        
        if ( iControlLine != wxNOT_FOUND && !sControlType.Contains(wxT( "Static" ) ) )
        {
            long iItem = TabBox -> InsertItem (0, sControlAdded);
            TabBox -> SetItemData ( iItem , iControlLine ) ;
        }
        }
        if (ExpandedArray.Index(sControlAdded) != wxNOT_FOUND) TreeBox->Expand(CurrentId) ;
        iLine = frame->DoReverseFindLine ( myControl + wxT(" -> Add ("), iLine, myTextChild );
    }
    return iLine ;
}






void dlgChild::OnClose(wxCloseEvent& event)
{
    if (this == frame -> pDlgWin) frame -> pDlgWin = NULL ;
    event.Skip();
}


void dlgChild::OnTreeBoxDClick(wxTreeEvent & event)
{
    if (IsProperty())
    {
        wxTreeItemId ClassID = TreeBox->GetSelection();
        if (ClassID.IsOk())
        {
            TreeBox->EditLabel(ClassID) ;
        }
    }
}

wxString dlgChild::GetValue ()
{
    wxString sResult;
    wxTreeItemId ClassID = TreeBox->GetSelection();
    if (ClassID.IsOk())
    {
        sResult = TreeBox->GetItemText(ClassID);
    }
    return sResult ;
}

wxString dlgChild::GetParentValue ()
{
    wxString sResult;
    wxTreeItemId ClassID = TreeBox->GetSelection();
    if (ClassID.IsOk())
    {
        ClassID = TreeBox->GetItemParent(ClassID) ;
        if (ClassID.IsOk())
        {
            sResult = TreeBox->GetItemText(ClassID);
        }
    }
    return sResult ;
}
//fix this to do recursion !
wxString dlgChild::GetGrandParentValue ()
{
    wxString sResult;
    wxTreeItemId ClassID = TreeBox->GetSelection();
    if (ClassID.IsOk())
    {
        ClassID = TreeBox->GetItemParent(ClassID) ;
        if (ClassID.IsOk())
        {
        ClassID = TreeBox->GetItemParent(ClassID) ;
        if (ClassID.IsOk())
        {
            sResult = TreeBox->GetItemText(ClassID);
            }
        }
    }
    return sResult ;
}

wxString dlgChild::GetPreviousSel ()
{
    return sPreviousSel ;
}

wxString dlgChild::GetSubSizer ()
{
    return sChildSizer ;
}

wxString dlgChild::GetPreviousValue ()
{
    wxString sResult;
    wxTreeItemId ClassID = TreeBox->GetSelection();
    if (ClassID.IsOk())
    {
        ClassID = TreeBox->GetPrevSibling(ClassID) ;
        if (ClassID.IsOk())
        {
            sResult = TreeBox->GetItemText(ClassID);
        }
    }
    return sResult ;
}

bool dlgChild::SelectNextValue ()
{
    wxTreeItemId NextID ;
    wxTreeItemId ClassID = TreeBox->GetSelection();
    sPreviousSel = TreeBox->GetItemText(ClassID) ;
    if (ClassID.IsOk())
    {
        NextID = TreeBox->GetNextSibling(ClassID);
        //next item on same level; but not a property
        if ( NextID.IsOk() && TreeBox->GetNextSibling(NextID).IsOk() )
        {
            TreeBox->SelectItem(NextID);
            return TRUE;
        }
    }
    return FALSE ;
}

bool dlgChild::IsProperty ()
{
    wxTreeItemId ClassID = TreeBox->GetSelection();

    if ( !ClassID.IsOk() ) return FALSE ;

    return ! (TreeBox -> ItemHasChildren ( ClassID ) );
}

void dlgChild::OnTreeBoxEdit(wxTreeEvent & event)
{
     if ( ! IsProperty () ) event.Veto();
     bPropertyChanged = TRUE ;
     LastId = TreeBox->GetSelection();
}

void dlgChild::OnTreeBoxDoneEditing (wxTreeEvent & event)
{
    OnTreeBoxChanged (event.GetLabel()) ;
}



void dlgChild::OnTreeBoxChanged (const wxString & sValue)
{
    if ( bPropertyChanged )
    {
        bPropertyChanged = FALSE ;
        
        // check if it is a property
        if ( ! IsProperty () ) return ;
        
        // get [stored] parent
        wxString sParent = TreeBox->GetItemText( TreeBox->GetItemParent (LastId) );
        int iLine = frame-> DoFindLine ( sParent + wxT("=new"), 0, myTextChild);
        if (iLine == wxNOT_FOUND) return ;

        // extract line creating control or sizer
        wxString sNewLine ;
        wxString sLine = frame-> RemoveLine (  iLine - 1, myTextChild );
        //m_CheckBox = new wxCheckBox(this, -1, wxT("label"));
        //m_BoxSizer = new wxBoxSizer(wxHORIZONTAL);
        
        if ( sLine.Contains(wxT("this")) )
        {
            //its a control
            sNewLine = sLine.BeforeFirst (comma) + comma ;
            sLine = sLine.AfterFirst (comma);
            // -1, wxT("label"));
            sNewLine = sNewLine + sLine.BeforeFirst (comma) + comma ;
            sLine = sLine.AfterFirst (comma);
            // wxT("label"));
            sNewLine = sNewLine + space + sValue + wxT(" );") ;
        }
        else
        {
            // its a sizer
            sNewLine = sLine.BeforeFirst (wxT('(')) + wxT("( ");
            sNewLine = sNewLine + sValue + wxT(" );") ;
        }
        
        frame-> WriteLine (myTextChild,  iLine-1, sNewLine );
        bPropertyChanged = FALSE ;
        
    }
    
}

bool dlgChild::CanDlgSel(wxUpdateUIEvent & event)
{
	if (event.GetId() == wxH_CTRL_UP)
	{
        return CanMoveUp();
    }
	// event down
	if (event.GetId() == wxH_CTRL_DOWN)
	{
        return CanMoveDown();
    }
    if (event.GetId() == wxH_CTRL_LEFT)
	{
        return CanMoveLeft();
    }
    if (event.GetId() == wxH_CTRL_RIGHT)
	{
        return CanMoveRight();
    }    
    if (event.GetId() == wxH_CTRL_DEL)
	{
        return CanDel();
    }    
    return FALSE ;
}


bool dlgChild::CanMoveUp()
{
    if (FindFocus() == TabBox) return FALSE;
	if ( ! TreeRootId.IsOk()) return FALSE;
    if (GetValue().Contains(wxT("CreateButtonSizer"))) return FALSE;

	wxTreeItemId SelId = TreeBox -> GetSelection();

    // Is it > the first sizer level
    if ( TreeRootId == SelId ) return FALSE ;
    if ( TreeRootId == TreeBox -> GetItemParent(SelId) ) return FALSE ;

    //is it the first child of the main sizer?
	wxTreeItemId SibId = TreeBox -> GetPrevSibling(SelId);
	if ( ! SibId.IsOk() ) return FALSE;

    return ! IsProperty() ;
}


bool dlgChild::CanMoveDown() 
{
    if (FindFocus() == TabBox) return FALSE;
	if ( ! TreeRootId.IsOk()) return FALSE;
    if (GetValue().Contains(wxT("CreateButtonSizer"))) return FALSE;

	wxTreeItemId SelId = TreeBox -> GetSelection();

    // Is it > the first sizer level
    if ( TreeRootId == SelId ) return FALSE ;
    if ( TreeRootId == TreeBox -> GetItemParent(SelId) ) return FALSE ;

    //is it the last real child of the main sizer?
	wxTreeItemId SibId = TreeBox -> GetNextSibling(TreeBox -> GetNextSibling(SelId));
	if ( ! SibId.IsOk() ) return FALSE;

    long cookie1 = 1213L;
    wxTreeItemId DlgId = TreeBox -> GetFirstChild(TreeRootId, cookie1);
	if ( ! DlgId.IsOk() ) return FALSE;
	
	//no down for property, CreateButtonSizer or las real control
	wxTreeItemId CtrlId = TreeBox -> GetLastChild(DlgId);
	if (SelId == CtrlId) return FALSE ;
	CtrlId = TreeBox -> GetPrevSibling(CtrlId);
    if (SelId == CtrlId) return FALSE ;
	CtrlId = TreeBox -> GetPrevSibling(CtrlId);
    if (SelId == CtrlId) return FALSE ;

    return ! IsProperty() ;
}


bool dlgChild::CanMoveLeft() 
{
    if (FindFocus() == TabBox) return FALSE;
	if ( ! TreeRootId.IsOk()) return FALSE;

	wxTreeItemId SelId = TreeBox -> GetSelection();

    // Is it > the second sizer level
    if ( TreeRootId == SelId ) return FALSE ;
    if ( TreeRootId == TreeBox -> GetItemParent(SelId) ) return FALSE ;
    if ( TreeRootId == TreeBox -> GetItemParent( TreeBox -> GetItemParent(SelId) ) ) return FALSE ;

    return ! IsProperty() ;
}

bool dlgChild::CanMoveRight() 
{
    if (FindFocus() == TabBox) return FALSE;
	if ( ! TreeRootId.IsOk()) return FALSE;
    if (GetValue().Contains(wxT("CreateButtonSizer"))) return FALSE;

	wxTreeItemId SelId = TreeBox -> GetSelection();

    // Is it > the first sizer level
    if ( TreeRootId == SelId ) return FALSE ;
    if ( TreeRootId == TreeBox -> GetItemParent(SelId) ) return FALSE ;

    // is it a property [probably not needed]
    if (IsProperty()) return FALSE;
    
    // has it got a sizer as child ?
    long cookie1 = 1213L;
    wxTreeItemId ParentId = TreeBox -> GetItemParent( SelId );
    wxTreeItemId ChildId = TreeBox -> GetFirstChild(ParentId, cookie1);
	while ( ChildId.IsOk() )
	{
        if ( ChildId == SelId ) return FALSE;
        wxString sChild = TreeBox->GetItemText(ChildId) ;
	    if ( frame -> IsSizer (sChild, myTextChild))
	    {
	        sChildSizer = sChild ;
	        return TRUE ;
	    }
	    ChildId = TreeBox -> GetNextChild(SelId, cookie1);
	}
	
    return FALSE;
}

bool dlgChild::CanDel ()
{
    if (FindFocus() == TabBox) return FALSE;
	if ( ! TreeRootId.IsOk()) return FALSE;
    if (GetValue().Contains(wxT("CreateButtonSizer"))) return FALSE;

	wxTreeItemId SelId = TreeBox -> GetSelection();

    // Is it > the first sizer level
    if ( TreeRootId == SelId ) return FALSE ;
    if ( TreeRootId == TreeBox -> GetItemParent(SelId) ) return FALSE ;

    // is it a property [probably not needed]
    if (IsProperty()) return FALSE;

    //has it got any child controls ??
    size_t iChildren = TreeBox -> GetChildrenCount (SelId) ;
    return ( iChildren == 1 );
}

wxString dlgChild::GetTabBoxSel () 
{
    return TabBox->GetItemText (GetTabBoxIndex());
}

wxString dlgChild::GetTabBoxPrev () 
{
    return TabBox->GetItemText (GetTabBoxIndex()-1);
}

wxString dlgChild::GetTabBoxNext () 
{
    return TabBox->GetItemText (GetTabBoxIndex()+1);
}

long dlgChild::GetTabBoxIndex()
{
    return TabBox->GetNextItem(-1, wxLIST_NEXT_ALL,wxLIST_STATE_SELECTED);
}

bool dlgChild::CanTabUp()
{
    if (FindFocus() == TreeBox) return FALSE;
    return (GetTabBoxIndex() > 0) ;
}

bool dlgChild::CanTabDown()
{
    if (FindFocus() == TreeBox) return FALSE;
    long item = GetTabBoxIndex() ;
    return (item >= 0 && item != TabBox->GetItemCount () -1) ;
}



