#ifndef _dchild_h
#define _dchild_h


class dlgChild ;

class wxhTreeCtrl: public wxTreeCtrl
{
    public:
    wxMenu * Goto_menu ;
    dlgChild * dChild ;
    
    wxhTreeCtrl(dlgChild* parent, wxWindowID id, wxSize size, long style) ;
	~wxhTreeCtrl ();
    void OnRightDown(wxMouseEvent & event );
    void OnGotoDeclaration (wxCommandEvent & event);
    void OnGotoBody (wxCommandEvent & event);
    void OnGotoFirst_use (wxCommandEvent & event);
    
    
    DECLARE_EVENT_TABLE()
    } ;

    

class dlgChild: public wxMDIChildFrame
{
    public:

        MyFrame *frame;

        wxhTreeCtrl * TreeBox;
        wxListCtrl * TabBox ;
        wxTreeItemId TreeRootId, LastId ;
        TextChild * myTextChild ;

        wxBoxSizer * ButtonSizer;
        wxBoxSizer * mainsizer ;

        bool bPropertyChanged ;

        wxArrayString ClassArray, ExpandedArray ;
        
        dlgChild(wxMDIParentFrame *parent, const wxString& title, TextChild * tc);
        ~dlgChild();
        void OnButton (wxCommandEvent& event) ;

        void OnActivate(wxActivateEvent& event);
        void DoActivate ();
        void FindExpandedItems(const wxTreeItemId & ID, long myCookie) ;
        long BuildControlList(int iLine, wxTreeItemId myID, const wxString & myControl);
        
        void OnQuit(wxCommandEvent& event);

        void OnClose(wxCloseEvent& event);
        void OnTreeBoxDClick(wxTreeEvent& event) ;

        
        wxString GetValue () ;
        wxString GetParentValue () ;
        wxString GetGrandParentValue () ;
        wxString GetPreviousValue () ;
        wxString GetPreviousSel () ;
        wxString GetSubSizer () ;

        long GetTabBoxIndex() ;
        wxString GetTabBoxSel () ;
        wxString GetTabBoxPrev () ;
        wxString GetTabBoxNext () ;

        bool IsProperty () ;
        bool SelectNextValue () ;

        bool CanDlgSel (wxUpdateUIEvent & event);
		bool CanMoveDown() ;
		bool CanMoveUp() ;
		bool CanMoveLeft() ;
		bool CanMoveRight() ;
        bool CanTabUp() ;
        bool CanTabDown() ;
        bool CanDel ();

        void OnTreeBoxEdit(wxTreeEvent & event) ;
        void OnTreeBoxDoneEditing (wxTreeEvent & event) ;
        void OnTreeBoxChanged(const wxString & sValue);
    private :
    wxString sPreviousSel, sChildSizer ;
        DECLARE_EVENT_TABLE()
};
#endif
