//wxHatch CVS $Id: xpmedit.cpp,v 1.3 2004/05/02 14:43:54 biol75 Exp $
//Default frame.cpp for wxHatch

// For compilers that support precompilation, includes "wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include <wx/image.h>
#include <wx/colordlg.h>
#include <wx/cmdline.h>

class MyFrame ;


#include "canvas.h" 
#include "xpmedit.h"

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
    EVT_MENU ( wxH_FILENEW_32, MyFrame::OnFileNew_32)
    EVT_MENU ( wxH_FILENEW_16, MyFrame::OnFileNew_16)
    EVT_MENU ( wxH_HELPABOUT, MyFrame::OnHelpAbout)
    EVT_MENU ( wxH_SELECTCOLOR, MyFrame::OnSelectColor)
    EVT_MENU ( wxH_FILEE_XIT, MyFrame::OnFileE_xit)
    EVT_MENU ( wxH_FILESAVE__AS, MyFrame::OnFileSave__As)
    EVT_MENU ( wxH_FILESAVE, MyFrame::OnFileSave)
    EVT_MENU ( wxH_FILEOPEN, MyFrame::OnFileOpen)
    EVT_CLOSE(MyFrame::OnClose)
END_EVENT_TABLE()

IMPLEMENT_APP(MyApp)

bool MyApp::OnInit()
{

    MyFrame *frame = new MyFrame (wxT("Built with wxHatch"),
                                  wxPoint(20,20), wxSize(600,450));

    frame->Show (TRUE);
    ::wxInitAllImageHandlers();
    wxIcon myIcon ;
    myIcon.CopyFromBitmap(wxBitmap(wxImage(wxT("xpmedit.ico"))));
    frame->SetIcon(myIcon);
    SetTopWindow (frame);
    // test for command line;

    static const wxCmdLineEntryDesc cmdLineDesc[] =
    {

        { wxCMD_LINE_SWITCH, wxT("h"), wxT("help"),  wxT("show this message"), wxCMD_LINE_VAL_NONE, wxCMD_LINE_OPTION_HELP },
        { wxCMD_LINE_SWITCH, wxT("v"), wxT("verbose"),  wxT("be verbose")  },
        { wxCMD_LINE_OPTION, wxT("f"), wxT("file"),   wxT("open existing file") },
        { wxCMD_LINE_PARAM,  NULL, NULL, "input file", wxCMD_LINE_VAL_STRING, wxCMD_LINE_PARAM_OPTIONAL },
        { wxCMD_LINE_NONE }
    };

    wxCmdLineParser parser(cmdLineDesc, argc, argv);

    int iParser = parser.Parse() ;
    if (iParser > 0) parser.Usage();

    wxString strVal;
    // now test for command line options ....
    if (iParser == 0)
    {
        //choose one of these to handle the command line
        if ( parser.Found(wxT("f"), &strVal) )
            {
            //act on this file
            //frame->DoOpenFile(strVal);
            }
        if ( parser.Found(wxT("v")) )
            {
                //set verbose help
            }
        size_t iParams ;
        for (iParams=0; iParams < parser.GetParamCount(); iParams++)
            {
            strVal = parser.GetParam(iParams);
            frame->myBitmap = wxBitmap(wxImage(strVal));
            frame->canvas->Refresh();
            }
    }

//end of wx &CmdLineParser
    return TRUE;
}

MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
    : wxFrame((wxFrame *)NULL, -1, title, pos, size)
{
// create a child control here
    canvas = new MyCanvas(this);
    myColour = *wxWHITE ;
    DoNew(16);
    

//  menu setup goes here


    wxMenu * Help_menu = new wxMenu;
    wxMenu * Select_menu = new wxMenu;
    wxMenu * File_menu = new wxMenu;
    File_menu -> Append ( wxH_FILENEW_16, wxT("&New 16"), wxT("New toolbar item") );
    File_menu -> Append ( wxH_FILENEW_32, wxT("&New 32"), wxT("") );
    File_menu -> Append ( wxH_FILEOPEN, wxT("&Open"), wxT("") );
    File_menu -> Append ( wxH_FILESAVE, wxT("&Save"), wxT("") );
    File_menu -> Append ( wxH_FILESAVE__AS, wxT("Save &As"), wxT("") );
    File_menu -> Append ( wxH_FILEE_XIT, wxT("E&xit"), wxT("") );
    Select_menu -> Append ( wxH_SELECTCOLOR, wxT("&Color"), wxT("") );
    Help_menu -> Append ( wxH_HELPABOUT, wxT("&About"), wxT("") );
    wxMenuBar *menuBar = new wxMenuBar;

    menuBar->Append (File_menu, wxT("&File") );
    menuBar->Append (Select_menu, wxT("&Select") );
    menuBar->Append (Help_menu, wxT("&Help") );
    SetMenuBar (menuBar); 
    
}



void MyFrame::OnClose (wxCloseEvent& event)
{
    event.Skip();
    // or event.Veto();
}





void MyFrame::OnFileOpen (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
//wx &OpenFile Dialog
    wxString myFilename ;
    wxFileDialog dialog(this, wxT("Open"), wxEmptyString, myFilename,
        wxT("XPM files (*.xpm)|*.xpm|All files (*.*)|*.*"),
        wxOPEN); // for opening files

    if (dialog.ShowModal() == wxID_OK)
    {
        myFilename = dialog.GetPath() ;
        myBitmap = wxBitmap(wxImage(myFilename));
        canvas->Refresh();
    }

//end of wx&FileDialog snippet

}


void MyFrame::OnFileSave (wxCommandEvent & event) 
{
    //Respond to menu here 
    if (myFilename.IsEmpty()) 
        { 
        OnFileSave__As (event) ; 
        return ; 
        } 
    
    myBitmap.ConvertToImage().SaveFile (myFilename,wxBITMAP_TYPE_XPM); 
}


void MyFrame::OnFileSave__As (wxCommandEvent & event) 
{
    //Respond to menu here 
//wx &SaveFile Dialog

    wxFileDialog dialog(this, wxT("Save as"), wxEmptyString, myFilename,
        wxT("XPM files (*.xpm)|*.xpm|All files (*.*)|*.*"),
        wxSAVE|wxOVERWRITE_PROMPT);

    if (dialog.ShowModal() == wxID_OK)
    {
        myFilename = dialog.GetPath() ;
        
        // code might continue, but delete the WXUNUSED from the lines above
        OnFileSave (event);
        
    }

//end of wx&FileDialog snippet

}


void MyFrame::OnFileE_xit (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
Close();
}


void MyFrame::OnSelectColor (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
//wx &Colour Dialog


    wxColourData data;
    data.SetChooseFull(TRUE);
    for (int i = 0; i < 16; i++)
    {
    wxColour colour(i*16, i*16, i*16);
    data.SetCustomColour(i, colour);
    }
    
    data.SetColour ( myColour );    
    wxColourDialog dialog(this, &data);
    if (dialog.ShowModal() == wxID_OK) // OK was pressed, otherwise myColour is unchanged
    {
    wxColourData retData = dialog.GetColourData();
    myColour = retData.GetColour();
    }
    /*
    //code might then continue  
    
    canvas->SetBackgroundColour(myColour);
    canvas->Refresh();
    */
    
//end of wx&ColourDialog snippet
}


void MyFrame::OnHelpAbout (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
//wx &About
    
     wxString sTmp ;    
  #ifdef __WXMSW__
    sTmp = wxT("Usage: xpmedit.exe") ;
  #else
    sTmp = wxT("Usage: xpmedit");
  #endif
    (void)wxMessageBox(wxT("xpmedit\nAuthor: myname (c) date\n") + 
                       sTmp, wxT("About xpmedit"));
    

//end of wxhAbout snippet

}


void MyFrame::OnFileNew_16 (wxCommandEvent & WXUNUSED(event)) 
{

    //Respond to menu here 
DoNew(16);
}


void MyFrame::OnFileNew_32 (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
DoNew(32);
}



void MyFrame::DoNew (int i)
{
    myBitmap = wxBitmap ( i, i );

    wxMemoryDC temp_dc;
    temp_dc.SelectObject(myBitmap);
//draw it as a black square in memory
    temp_dc.SetBrush(*wxBLACK_BRUSH);
    temp_dc.SetPen(*wxBLACK_PEN);
    temp_dc.DrawRectangle(0,0,i,i);
    canvas->Refresh();
}

 
