//wxHatch CVS $Id: xpmedit.cpp,v 1.2 2002/05/10 15:49:31 biol75 Exp $
//Default frame.cpp for wxHatch

// For compilers that support precompilation, includes "wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include <wx/image.h>

class MyFrame ;


#include "canvas.h" 
#include "xpmedit.h"

BEGIN_EVENT_TABLE(MyFrame, wxFrame)
    EVT_MENU ( wxH_FILENEW_32, MyFrame::OnFileNew_32)
    EVT_MENU ( wxH_FILENEW_16, MyFrame::OnFileNew_16)
    EVT_MENU ( wxH_HELPABOUT, MyFrame::OnHelpAbout)
    EVT_MENU ( wxH_SELECTCOLOR, MyFrame::OnSelectColor)
    EVT_MENU ( wxH_FILEE_XIT, MyFrame::OnFileE_xit)
    EVT_MENU ( wxH_FILESAVE__AS, MyFrame::OnFileSave__As)
    EVT_MENU ( wxH_FILESAVE, MyFrame::OnFileSave)
    EVT_MENU ( wxH_FILEOPEN, MyFrame::OnFileOpen)
    EVT_CLOSE(MyFrame::OnClose)
END_EVENT_TABLE()

IMPLEMENT_APP(MyApp)

bool MyApp::OnInit()
{

    MyFrame *frame = new MyFrame (wxT("Built with wxHatch"),
                                  wxPoint(20,20), wxSize(600,450));

    frame->Show (TRUE);
    ::wxInitAllImageHandlers();
    wxIcon myIcon ;
    myIcon.CopyFromBitmap(wxBitmap(wxImage(wxT("xpmedit.ico"))));
    frame->SetIcon(myIcon);
    SetTopWindow (frame);
    return TRUE;
}

MyFrame::MyFrame(const wxString& title, const wxPoint& pos, const wxSize& size)
    : wxFrame((wxFrame *)NULL, -1, title, pos, size)
{
// create a child control here
    canvas = new MyCanvas(this);
    myColour = *wxWHITE ;
    DoNew(16);
    

//  menu setup goes here


    wxMenu * Help_menu = new wxMenu;
    wxMenu * Select_menu = new wxMenu;
    wxMenu * File_menu = new wxMenu;
    File_menu -> Append ( wxH_FILENEW_16, wxT("&New 16"), wxT("New toolbar item") );
    File_menu -> Append ( wxH_FILENEW_32, wxT("&New 32"), wxT("") );
    File_menu -> Append ( wxH_FILEOPEN, wxT("&Open"), wxT("") );
    File_menu -> Append ( wxH_FILESAVE, wxT("&Save"), wxT("") );
    File_menu -> Append ( wxH_FILESAVE__AS, wxT("Save &As"), wxT("") );
    File_menu -> Append ( wxH_FILEE_XIT, wxT("E&xit"), wxT("") );
    Select_menu -> Append ( wxH_SELECTCOLOR, wxT("&Color"), wxT("") );
    Help_menu -> Append ( wxH_HELPABOUT, wxT("&About"), wxT("") );
    wxMenuBar *menuBar = new wxMenuBar;

    menuBar->Append (File_menu, wxT("&File") );
    menuBar->Append (Select_menu, wxT("&Select") );
    menuBar->Append (Help_menu, wxT("&Help") );
    SetMenuBar (menuBar); 
    
}



void MyFrame::OnClose (wxCloseEvent& event)
{
    event.Skip();
    // or event.Veto();
}





void MyFrame::OnFileOpen (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 

}


void MyFrame::OnFileSave (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 

}


void MyFrame::OnFileSave__As (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 

}


void MyFrame::OnFileE_xit (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 

}


void MyFrame::OnSelectColor (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 

}


void MyFrame::OnHelpAbout (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 

}


void MyFrame::OnFileNew_16 (wxCommandEvent & WXUNUSED(event)) 
{

    //Respond to menu here 
DoNew(16);
}


void MyFrame::OnFileNew_32 (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
DoNew(32);
}



void MyFrame::DoNew (int i)
{
    myBitmap = wxBitmap ( i, i );

    wxMemoryDC temp_dc;
    temp_dc.SelectObject(myBitmap);
//draw it as a black square in memory
    temp_dc.SetBrush(*wxBLACK_BRUSH);
    temp_dc.SetPen(*wxBLACK_PEN);
    temp_dc.DrawRectangle(0,0,i,i);
    canvas->Refresh();
}

 
