//wxHatch CVS $Id: mcanvas.cpp,v 1.32 2004/05/04 15:10:01 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
// for drag and drop, we might be better to not have fixed x,y ??
// ===========================================================================
// declarations
// ===========================================================================

// ---------------------------------------------------------------------------
// headers
// ---------------------------------------------------------------------------

#ifdef __WXUNIVERSAL__
#define WXHNOCURSOR
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#include "wx/mdi.h"
#endif

#include <wx/gdicmn.h>
#include <wx/textdlg.h>
#include <wx/docview.h>
#include <wx/filename.h>
#include <wx/image.h>
#include <wx/html/helpctrl.h>
#include <wx/treectrl.h>
#include <wx/listctrl.h>
#include "wx/tooltip.h"

#include "bitmenu.h"
#include "projdefs.h"
#include "mcanvas.h"
#include "mchild.h"
#include "wx/stc/stc.h"
#include "mytext.h"
#include "tchild.h"
#include "trchild.h"
#include "dchild.h"
#include "wxhatch.h"

#ifndef WXHNOCURSOR
    #include "bitmaps/cursors/drag.xpm"
    #include "bitmaps/cursors/menu.xpm"
    #include "bitmaps/cursors/frame.xpm"
    #include "bitmaps/cursors/tool.xpm"
    #include "bitmaps/cursors/pen.xpm"
#endif 

BEGIN_EVENT_TABLE(MyCanvas, wxScrolledWindow)

EVT_ACTIVATE(MyChild::OnActivate)

EVT_MOTION(MyCanvas::OnMouseMove)
EVT_LEFT_DOWN(MyCanvas::OnLeft_down)
EVT_LEFT_UP(MyCanvas::OnLeft_up)
EVT_LEFT_DCLICK(MyCanvas::OnLeft_Dk)
EVT_RIGHT_UP(MyCanvas::OnRight_up)

EVT_UPDATE_UI(wxH_MOVEUP, MyCanvas::OnEnableUp)
EVT_UPDATE_UI(wxH_MOVEDOW,MyCanvas::OnEnableDown)

EVT_UPDATE_UI(wxH_MOVEL, MyCanvas::OnEnableL)
EVT_UPDATE_UI(wxH_MOVER, MyCanvas::OnEnableR)

EVT_UPDATE_UI(wxH_MOVE_MENU_L, MyCanvas::OnEnableMenuL)
EVT_UPDATE_UI(wxH_MOVE_MENU_R, MyCanvas::OnEnableMenuR)

EVT_IDLE(MyCanvas::OnIdle)
EVT_TIMER(-1, MyCanvas::OnTimer)

END_EVENT_TABLE()

// ===========================================================================
// implementation
// ===========================================================================

#include <wx/listimpl.cpp>
WX_DEFINE_LIST(TBitmapMenuList) ;
WX_DEFINE_LIST(TBitmapToolList) ;

// ---------------------------------------------------------------------------
// MyCanvas
// ---------------------------------------------------------------------------

// Define a constructor for my canvas
MyCanvas::MyCanvas(wxWindow *parent, const wxPoint& pos, const wxSize& size)
: wxScrolledWindow(parent, -1, pos, size,
wxSUNKEN_BORDER|wxVSCROLL|wxHSCROLL)
{
    SetBackgroundColour(wxColour(wxT("WHITE")));
    TopWin = ((MyChild *)parent)->frame ;
    xpos = -1 ;
    ypos = -1 ;
    iSelected = wxNOT_FOUND ; // -1
    selBmp = NULL ;
 
    bMouseIsDown = FALSE ;
    helpRectIsShown = FALSE;
    myTimer.SetOwner (this, -1);

    init ();


    menu_Base_popup_menu = new wxMenu (wxT("Whole Menu control"));
    menu_Base_popup_menu -> Append (wxH_MOVE_MENU_L, wxT("Move whole menu Le&ft"));
    menu_Base_popup_menu -> Append (wxH_MOVE_MENU_R, wxT("Move whole menu &Right"));
    menu_Base_popup_menu -> Append (wxH_DEL_MENU, wxT("De&lete whole menu "));

    sep_popup_menu = new wxMenu (wxT("Separator"));
    sep_popup_menu -> Append (wxH_MOVEUP, wxT("Move &up"));
    sep_popup_menu -> Append (wxH_MOVEDOW, wxT("Move &down"));
    sep_popup_menu -> Append (wxH_GOMNU, wxT("Go Menu &Insertion"));
    sep_popup_menu -> AppendSeparator();
    sep_popup_menu -> Append (wxH_DELETE, wxT("De&lete "));


    menu_popup_menu = new wxMenu (wxT("Menu control"));
    menu_popup_menu -> Append (wxH_MOVEUP, wxT("Move &up"));
    menu_popup_menu -> Append (wxH_MOVEDOW, wxT("Move &down"));
    menu_popup_menu -> Append (wxH_MOVEL, wxT("Move Le&ft"));
    menu_popup_menu -> Append (wxH_MOVER, wxT("Move &Right"));
    menu_popup_menu -> AppendSeparator();
    menu_popup_menu -> Append (wxH_ADDTOTOOLBAR, wxT("&Add to Toolbar"));
    menu_popup_menu -> AppendSeparator();
    menu_popup_menu -> Append (wxH_RENAMEITEM, wxT("&Change menu properties"),
        wxT("Modify the menu (help, accelerator, label)"));
    menu_popup_menu -> Append (wxH_DELETE, wxT("De&lete"));
    menu_popup_menu -> AppendSeparator();
    menu_popup_menu -> Append (wxH_GOBODY, wxT("Go &Body"));
    menu_popup_menu -> Append (wxH_GOID,  wxT("Go &Menu ID"));
    menu_popup_menu -> Append (wxH_GODEC, wxT("Go &Declaration"));
    menu_popup_menu -> Append (wxH_GOEVT, wxT("Go E&vent Table"));
    menu_popup_menu -> Append (wxH_GOMNU, wxT("Go Menu &Insertion"));
    menu_popup_menu -> Append (wxH_GOENABL, wxT("Go &Enable"));

    tool_popup_menu = new wxMenu (wxT("Toolbar Menu"));
    tool_popup_menu -> Append (wxH_TBMVERIGHT, wxT("Move &Right"));
    tool_popup_menu -> Append (wxH_TBMVELEFT, wxT("Move &Left"));
    tool_popup_menu -> Append (wxH_TBDEL, wxT("De&lete"));
    tool_popup_menu -> Append (wxH_TBSEP, wxT("&Add Separator After"));
    tool_popup_menu -> AppendSeparator();
    tool_popup_menu -> Append (wxH_TBCHANGE, wxT("&Change Image"));
    tool_popup_menu -> Append (wxH_TBEDIT, wxT("&Edit Image"));
    tool_popup_menu -> Append (wxH_TBCHANGETEXT, wxT("Change &ToolTip Help Text"));
    tool_popup_menu -> Append (wxH_TBGOBODY, wxT("Go &Body"));
    tool_popup_menu -> Append (wxH_TBGOENABL, wxT("Go &Enable"));
    tool_popup_menu -> AppendSeparator();
    tool_popup_menu -> Append (wxH_TBGOCODE, wxT("&Go Toolbar Code"));

    frame_popup_menu = new wxMenu (wxT("Frame Menu"));
    frame_popup_menu -> Append (wxH_GOFCONS, wxT("Go Frame &Constructor"));
    frame_popup_menu -> Append (wxH_GOFDEC, wxT("Go Frame &Declaration"));
    frame_popup_menu -> Append (wxH_GOFCLOSE, wxT("Go Frame C&lose"));
    frame_popup_menu -> Append (wxH_GOFDES, wxT("Go Frame De&structor"));

    frame_popup_menu -> AppendSeparator();
    frame_popup_menu -> Append (wxH_GOFSIZE, wxT("Go Frame &Resize"));
    frame_popup_menu -> AppendSeparator();
    frame_popup_menu -> Append (wxH_GOFNOGUI, wxT("Go/Add &Non GUI Method"));
    
    wxString sClass = TopWin->sClassName ;
    canv_popup_menu = new wxMenu (sClass + wxT(" Menu"));
    canv_popup_menu -> Append (wxH_GOCCONS, wxT("Go ") + sClass + wxT(" &Constructor"));
    canv_popup_menu -> Append (wxH_GOCDEC, wxT("Go ") + sClass + wxT(" &Declaration"));

    canv_popup_menu -> Append (wxH_GOCDES, wxT("Go ") + sClass + wxT(" De&structor"));
    canv_popup_menu -> AppendSeparator();
    canv_popup_menu -> Append (wxH_GOONDRAW, wxT("Go &OnDraw"), wxT("This is where the surface is painted"));
    canv_popup_menu -> AppendSeparator();
    canv_popup_menu -> Append (wxH_GOLCLICK, wxT("Go &Left Down"));
    canv_popup_menu -> Append (wxH_GOLCLICKUP, wxT("Go Left &Up"));
    canv_popup_menu -> Append (wxH_GORCLICK, wxT("Go &Right Click"));
    canv_popup_menu -> Append (wxH_GOLDBLCLICK, wxT("Go Left Double C&lick"));
    canv_popup_menu -> Append (wxH_GOMSEMOVE, wxT("Go &Mouse move"));
    canv_popup_menu -> AppendSeparator();
    canv_popup_menu -> Append (wxH_GOCNOGUI, wxT("Go/Add &Non GUI Method"));

    icon_popup_menu = new wxMenu (wxT("Icon Menu"));
    icon_popup_menu -> Append (wxH_CHANGE_ICON, wxT("&Change Icon"), wxT("Copy another icon to the project"));
    icon_popup_menu -> Append (wxH_EDIT_ICON, wxT("&Edit Icon"));

    Refresh();
}



void MyCanvas::init()
{
    menuList = new TBitmapMenuList ;
    toolList = new TBitmapToolList ;
    ChangeIcon ();
}

// Define the repainting behaviour
void MyCanvas::OnDraw(wxDC& dc)
{
    dc.SetFont(*wxSWISS_FONT);
    dc.SetBrush(*wxTheBrushList -> FindOrCreateBrush(*wxLIGHT_GREY, wxSOLID) );
    dc.SetPen(*wxThePenList -> FindOrCreatePen(*wxLIGHT_GREY, 1, wxSOLID) );
    int w, h ;
    dc.GetTextExtent (wxT("Toolbar:"), &w, &h);
    dc.DrawRectangle (1,iToolbarmax,1000,icoMax);
    if (myIcon.Ok())
    {
        dc.DrawIcon( myIcon, 1,iToolbarmax );
    }
    else
    {
        dc.SetBrush(*wxGREY_BRUSH) ;
        dc.SetPen(*wxBLACK_PEN);
        dc.DrawRectangle (1,iToolbarmax,icoMax,icoMax);
    }
    dc.DrawText (wxT("Toolbar:"), 1,1);

    TBitmapToolList::Node *tnode = toolList->GetFirst();
    int x = w + 3 ;
    while (tnode)
    {
        TBitmapTool *current = tnode->GetData();
                                 // just separate out
        if (current -> myID .IsEmpty() ) x = x + 10 ;
        else
        {
            if ( tnode == selBmp ) dc.DrawRectangle ( x-1, 1,
                        2 + current -> myBitmap.GetWidth(), 2 + current -> myBitmap.GetHeight() );
            dc.DrawBitmap (current -> myBitmap, x, 2, TRUE) ;
            x = x + 2 + current -> myBitmap.GetWidth();
        }

        tnode = tnode->GetNext() ;
    }
    TBitmapMenuList::Node *node = menuList->GetFirst();
    while (node)
    {
        TBitmapMenu *current = node->GetData();
        current -> DrawBitMenu ( dc, menuList->IndexOf(current) == iSelected ) ;
        node = node->GetNext() ;
    }
}


void MyCanvas::ClearLists()
{
//clear the lists
    menuList->DeleteContents(TRUE);
    delete menuList ;

    TBitmapToolList::Node *tnode = toolList->GetFirst();
    while (tnode)
    {
        TBitmapTool *current = tnode->GetData();
        delete current  ;
        delete tnode ;
        tnode = toolList->GetFirst();
    }
    delete  toolList ; 
}

MyCanvas::~MyCanvas()
{
    ClearLists() ;
    
    delete menu_popup_menu ;
    delete sep_popup_menu ;
    delete menu_Base_popup_menu ;
    delete tool_popup_menu ;
    delete frame_popup_menu ;
    delete canv_popup_menu ;
    delete icon_popup_menu ;

}


TBitmapMenu * MyCanvas::DoInsertMenu (int i, const wxString & sText, bool bBase, bool bIsPopup)
{
    return DoInsertMenu ( i, sText, wxEmptyString, wxEmptyString, bBase, bIsPopup) ;

}


TBitmapMenu * MyCanvas::DoInsertMenu (int i, const wxString & sText,
    const wxString &sAccel,const wxString & sHelp, bool bBase, bool bIsPopup)
{
    // called when interactively adding a menu item or a menubar
                                 // nothing selected so add at end
    if ( i == wxNOT_FOUND ) i = menuList -> GetCount () - 1 ;
    if (bBase)
    {
        sLastMenuBarText = sText + wxT("_menu");
    }
    else
    {
                                 //adding item to menubar
        sLastMenuBarText = menuList->Item(i) -> GetData()->GetMenuName() ;
    }
    TBitmapMenu * pBM = new TBitmapMenu ( sText, sAccel, sHelp, sLastMenuBarText, bBase, bIsPopup );
    if ((size_t)i+1 > menuList -> GetCount ()) menuList -> Append (pBM) ; else menuList->Insert(i+1,pBM);
    RefreshMenus ();
    return pBM;
}


TBitmapMenu *  MyCanvas:: DoInsertMenu (const wxString & sMenuName, const wxString & sMenuLabel, bool bIsPopup )

{
    // called from reading a project when it gets to a menubar item
    sLastMenuBarText = sMenuLabel ;
    TBitmapMenu *  m = new TBitmapMenu ( sMenuName, sMenuLabel, bIsPopup );
    menuList -> Append (m);
    RefreshMenus ();
    return m;
}


TBitmapMenu * MyCanvas::DoInsertMenu (const wxString & sIDin, const wxString & sMenuName, const wxString & sLabel, const wxString & sMethod, const wxString & sAccel, const wxString & sHelp)
{
    // called from reading a project when it gets to a menu item
    TBitmapMenu *  m = new TBitmapMenu ( sIDin, sMenuName, sLabel, sMethod, sAccel, sHelp );
    menuList -> Append (m);
    RefreshMenus ();
    return m;
}


void MyCanvas::RefreshMenus ()
{
    wxClientDC dc(this);
    PrepareDC(dc);

    TBitmapMenuList::Node *node = menuList->GetFirst();
    if (node)
    {
        TBitmapMenu * prev ;
        TBitmapMenu * current = node->GetData();
        current -> ReAlign ( NULL, dc );
        node = node->GetNext() ;
        while (node)
        {
            prev = current ;
            current = node->GetData();
            current -> ReAlign ( prev, dc );
            node = node->GetNext() ;
        }
        Refresh ();
    }
}


void MyCanvas::OnAddMenu (const wxString & sText, bool bIsPopup)
{
    //test if menubar item with same name already exists
    TBitmapMenuList::Node *node = menuList->GetFirst();
    while (node)
    {
        wxString sLabel = node->GetData()->GetLabel() ;
        if (sText == sLabel)
        {
            (void)wxMessageBox( wxT("Cannot add a second MenuBar item \nwith same label as existing - ") + sLabel, wxT("wxHatch warning"));
            return ;
        }
        node = node->GetNext();
    }

    //entering a menubaritem, always add before any popups
    int iPlace = -1 ;
    if (!bIsPopup)
    {
        TBitmapMenuList::Node *node = menuList->GetFirst();
        while (node && !(node->GetData()->IsPopup()))
        {
            iPlace ++ ;
            node = node->GetNext();
        }
    }
    TBitmapMenu *pBM = DoInsertMenu (iPlace, sText, TRUE, bIsPopup);

    TopWin -> DoMenuBarText (pBM);
    iSelected = menuList -> IndexOf(pBM);
    TopWin -> pMenuChild -> Activate();
    SetFocus ();
}


bool MyCanvas::OnAdd_Item (const wxString & sText, const wxString & sAccel, const wxString & sHelp)
{
    //test for macthing item
    // find base of list
    TBitmapMenuList::Node *node  ;
    if (iSelected == wxNOT_FOUND) node = menuList->GetLast();
    else node = menuList -> Item (iSelected) ;
        while (node && !(node->GetData()->IsBase()))
        {
            node = node->GetPrevious();
        }
    // find next one on lst which is base, checking for matching label
    node = node -> GetNext ();
    while (node && !(node->GetData()->IsBase()))
        {
            if ( node ->GetData() -> GetLabel() == sText )
            {
                (void)wxMessageBox( wxT("Cannot add a second Menu item \nwith same label as existing - ") + sText, wxT("wxHatch warning"));
                return FALSE ;
            }
            node = node->GetNext();
        }
    int iCppLine = -1 ;
    int iAdd = 1 ;
    int iStore = iSelected ;
    if (iSelected != wxNOT_FOUND)
    {
        TBitmapMenu *current = menuList->Item(iSelected) -> GetData();
        if (current->IsBase())
        {
            iSelected ++ ;
            iAdd -- ;
        }
        if ( iSelected >= (int)menuList->GetCount() )
        {
            iStore = -1 ;
            iCppLine = -1 ;
        }
        else
            iCppLine = TopWin -> DoGoMnu () + iAdd;
        iSelected = iStore ;
    }
    TBitmapMenu *pBM = DoInsertMenu (iSelected, sText, sAccel, sHelp, FALSE, FALSE);
    iSelected = menuList -> IndexOf(pBM);
                                 
    TopWin -> DoMenuText (pBM , iCppLine);
    return TRUE ;
}


void MyCanvas::OnSeparator (wxCommandEvent& WXUNUSED(event))
{
    int iCppLine = -1 ;
    int iAdd = 0 ;
    int iStore = iSelected ;
    if (iSelected != wxNOT_FOUND)
    {
        TBitmapMenu *current = menuList->Item(iSelected) -> GetData();
        if (current->IsBase())
        {
            iSelected ++ ;
            iAdd -- ;
        }
        if ( iSelected >= (int)menuList->GetCount() )
        {
            iStore = -1 ;
            iCppLine = -1 ;
        }
        else
            iCppLine = TopWin -> DoGoMnu () + iAdd;
        iSelected = iStore ;
    }
    TBitmapMenu *pBM = DoInsertMenu (iSelected, wxT("SEPARATOR"), FALSE, FALSE);

                                 //File
    TopWin -> DoSepText ( pBM -> GetMenuName(), iCppLine );
                                 
    iSelected = menuList -> IndexOf(pBM);
    Refresh ();
    TopWin -> pMenuChild -> Activate ();
    SetFocus ();

}



void MyCanvas::OnAddfilemenu (wxCommandEvent& WXUNUSED(event))
{
    OnAddMenu ( wxT("&File"),FALSE);
    OnAdd_Item  ( wxT("&New"));
    OnAdd_Item  ( wxT("&Open"));
    OnAdd_Item  ( wxT("&Save"));
    OnAdd_Item  ( wxT("Save &As"));

    OnAdd_Item  ( wxT("E&xit"));

    Refresh ();
    Update();

}

void MyCanvas::OnAddfileprintmenu (wxCommandEvent& event)
{
    OnAddMenu ( wxT("&File"),FALSE);
    OnAdd_Item  ( wxT("&New"));
    OnAdd_Item  ( wxT("&Open"));
    OnAdd_Item  ( wxT("&Save"));
    OnAdd_Item  ( wxT("Save &As"));
    OnSeparator(event);

    OnAdd_Item  ( wxT("&Print"));
    OnAdd_Item  ( wxT("Print set&up"));
    OnAdd_Item  ( wxT("Print pre&view"));
    OnSeparator(event);

    OnAdd_Item  ( wxT("E&xit"));

    Refresh ();
    Update();

}

void MyCanvas::OnAddeditmenu (wxCommandEvent& WXUNUSED(event))
{
    OnAddMenu ( wxT("&Edit"),FALSE);
    OnAdd_Item  ( wxT("&Cut"));
    OnAdd_Item  ( wxT("&Copy"));
    OnAdd_Item  ( wxT("&Paste"));

    Refresh ();
    Update();

}


void MyCanvas::OnAddHelpmenu (wxCommandEvent & WXUNUSED(event))
{
    OnAddMenu ( wxT("&Help"),FALSE);
    OnAdd_Item  ( wxT("&Contents"));
    OnAdd_Item  ( wxT("&Index"));
    OnAdd_Item  ( wxT("&About"));

    Refresh ();
    Update();
}

int MyCanvas::FindWhichMenu (int x, int y )
{
    int i = 0 ;
    if (!menuList) return wxNOT_FOUND ;
    //iSelected = wxNOT_FOUND ;    // -1
    TBitmapMenuList::Node *node = menuList->GetFirst();
    while (node)
    {
        TBitmapMenu *current = node->GetData();
        if (current -> Contains ( x, y ) )
        {
            if (this == FindFocus() )
            {
            sLastMenuBarText = current -> GetBaseString ();
            TopWin -> SetStatusText ( wxT("Menu ") + (current -> GetLabel()) + 
                                      wxT(" with Accelerator ") + current -> GetAccelString().Mid(1) +
                                      wxT(" with help string ") + current -> GetHelpString() ,1);            
            }
            return i ;
        }
        i ++;
        node = node->GetNext() ;
    }
    return wxNOT_FOUND ;
}


void MyCanvas::OnLeft_down (wxMouseEvent & event)
{
    selBmp = NULL ;
    bMouseIsDown = TRUE;
    iSelected = FindWhichMenu(event.GetX(), event.GetY());
//    if (iSelected != wxNOT_FOUND) SetCursor(wxCursor(wxImage(drag_xpm))) ;
    if (event.GetY() <  iToolbarmax) selBmp = GetTool(event.GetX());
    Refresh ();
}

void MyCanvas::OnLeft_up (wxMouseEvent & event)
{
    SetRelevantCursor(event) ;
    bMouseIsDown = FALSE;
/*
    wxString sDebug;
    sDebug.Printf (wxT("X corodinate is %d "), event.GetX() );
    TopWin -> SetStatusText (sDebug,1);
*/
    if (event.GetY() <  iToolbarmax)
    {
        //did we start in toolbar; if so move r/left
        if ( (selBmp) && (selBmp != GetTool(event.GetX()) )  )
        {
            int iTmp = menuList->IndexOf ( MatchTool (selBmp ) ) ;
            //save the help string... TODO make this kludge unnecessary
            wxString sTmpHelp = selBmp -> GetData() ->  myHelp ;
            TopWin->ProcessCommand (wxH_TBDEL);
            iSelected = iTmp ;
            selBmp = GetTool(event.GetX());
            selBmp -> GetData() -> myHelp = sTmpHelp ;
            TopWin->ProcessCommand (wxH_ADDTOTOOLBAR);
            return ;
        }
        //handle adding to toolbar...
        if (iSelected != wxNOT_FOUND)
        {
            //its in the toolbar, set a selection, go the implementation
            selBmp = GetTool(event.GetX());
            TopWin->ProcessCommand (wxH_ADDTOTOOLBAR);
            return ;
        }
    }
	// possibly a menu move - did we start in a menu??
	if (iSelected == wxNOT_FOUND) return ;
    //handle moving in menu
    // find the target, set it to selected
    int iNew = FindWhichMenu(event.GetX(), event.GetY());
	//ignore mouse ups which are not in a menu item, or in the same as westarted from
    if (iNew == iSelected) return ;
	if (iNew == wxNOT_FOUND) return ;
    // remove existing menu insertion
    long iLine = TopWin -> DoGoMnu () ;
    TopWin ->RemoveLine ( iLine-1, TopWin -> pMain_cpp -> textctrl );
    //move it in the list
	if (iNew < iSelected) iNew ++ ;
    MoveMenu ( iSelected, iNew ) ;
    //add the menu insertion back in after selected	
	TBitmapMenu * pBM = menuList->Item( iNew - 1 ) -> GetData();
    iLine = TopWin -> DoGoMnu (pBM) ;
	pBM = menuList->Item( iNew ) -> GetData();
    TopWin -> WriteLine (TopWin ->pMain_cpp, iLine, pBM -> GetMenuText () );
    
	//finally activate
	TopWin -> pMenuChild -> Activate();
}




void MyCanvas::OnLeft_Dk (wxMouseEvent & event)
{
    OnLeft_down(event);
    // find matching method body
    if (iSelected != wxNOT_FOUND)
    {
        TBitmapMenu *current = menuList->Item(iSelected) -> GetData();
        if (current -> Contains ( event.GetX(), event.GetY() ) )
        {
            if (!current->IsBase() && !current->IsSeparator())
            {
                // its a menu rectangle
                TopWin->ProcessCommand (wxH_GOBODY);
                return ;
            }
        }
        return ;
    }                            // end of selecting a menu item
    if (event.GetY() <  iToolbarmax)
    {
        //its in the toolbar, go the implementation
        selBmp = GetTool(event.GetX());
        if (selBmp) TopWin->ProcessCommand (wxH_GOBODY);
        return ;
    }
                                 // todo calculate this as a constant
    if (event.GetY() <  iToolbarmax + icoMax)
    {
        if (event.GetX() <  icoMax)
        {
            //its the icon
            TopWin->ProcessCommand (wxH_CHANGE_ICON);
            return ;
        }
        //its the frame
        TopWin->ProcessCommand (wxH_GOFCONS);
        return ;
    }
    //its the canvas, go OnDraw
    TopWin->ProcessCommand (wxH_GOONDRAW);
}


void MyCanvas::OnRight_up (wxMouseEvent & event)
{
    OnLeft_down (event);
    bMouseIsDown = FALSE;
    if (iSelected != wxNOT_FOUND)
    {
        TBitmapMenu *current = menuList->Item(iSelected) -> GetData();
        if (current -> Contains ( event.GetX(), event.GetY() ) )
        {
            if (current->IsBase())
            {                
                PopupMenu( menu_Base_popup_menu, event.GetX(), event.GetY() );
                return ;
            }
            if (current->IsSeparator())
            {                
                PopupMenu( sep_popup_menu, event.GetX(), event.GetY() );
                return ;
            }

            PopupMenu( menu_popup_menu, event.GetX(), event.GetY() );

        }
        return ;
    }                            // end of selecting a menu item
    if (event.GetY() <  iToolbarmax)
    {
        selBmp = GetTool(event.GetX());
        PopupMenu( tool_popup_menu, event.GetX(), event.GetY() );
        return ;
    }
                                 // todo calculate this as a constant
    if (event.GetY() <  iToolbarmax + icoMax)
    {
        if (event.GetX() <  icoMax)
        {
            PopupMenu( icon_popup_menu, event.GetX(), event.GetY() );
            return ;
        }

        PopupMenu( frame_popup_menu, event.GetX(), event.GetY() );
        return ;
    }
    if (TopWin -> pCanv_cpp) PopupMenu( canv_popup_menu, event.GetX(), event.GetY() );

}


void MyCanvas::DeleteCurrentNode (bool DeleteDataToo)
{
    TBitmapMenuList::Node *node = menuList->Item(iSelected) ;
    if (DeleteDataToo)
        {
        TBitmapMenu *current = node -> GetData();
        delete current ;
        }
    menuList->DeleteNode(node);
    RefreshMenus();
}




void MyCanvas::MoveMenu (int iStart, int iEnd)
{    
    TBitmapMenu *current = menuList->Item(iStart) -> GetData();
    DeleteCurrentNode (FALSE);            //this changes iSelected to -1
    menuList->Insert(iEnd, current);
    RefreshMenus();
    int xm, ym ;
    current->GetMidPoint(&xm,&ym);
    iSelected = FindWhichMenu (xm, ym);
}





void MyCanvas::OnEnableUp (wxUpdateUIEvent & event)
{
    event.Enable ( iSelected > 1 );
}


void MyCanvas::OnEnableDown (wxUpdateUIEvent & event)
{
    event.Enable (iSelected + 1 < (int)menuList->GetCount()) ;
}




void MyCanvas::ChangeIcon ()
{
    
    sIcoFile = TopWin -> sProjectDir + TopWin -> sName + sIconExt ;
    if (!wxFileExists(sIcoFile)) sIcoFile = TopWin -> sProjectDir + wxT("mondrian.ico"); //probably a wxWin sample ??

    if (wxFileExists(sIcoFile))
    {
        myIcon.LoadFile( sIcoFile, wxBITMAP_TYPE_ICO);
        icoMod = wxFileName(sIcoFile).GetModificationTime() ;
    }
}

bool MyCanvas::IconIsAlteredOnDisk()
{
    if (sIcoFile.IsEmpty()) return FALSE ;
    if (!icoMod.IsValid()) return FALSE ;
    wxDateTime fDT = wxFileName(sIcoFile).GetModificationTime();
    if (!fDT.IsValid()) return FALSE ;
    return icoMod.IsEarlierThan(fDT);    
}


void MyCanvas::SetIconModTime ()
{
    icoMod = wxDateTime::Now();
}

TBitmapToolList::Node * MyCanvas::GetTool (int Xin)
{
    wxClientDC dc(this);
    PrepareDC(dc);

    TBitmapTool *current ;
    int w, h ;
    dc.SetFont(*wxSWISS_FONT);
    dc.GetTextExtent (wxT("Toolbar:"), &w, &h);
    TBitmapToolList::Node *tnode = toolList->GetFirst();
    int x = w + 3 ;
    while (tnode) 
    {
        
        current = tnode->GetData();
                                 // just separate out
        if (current -> myID.IsEmpty() ) x = x + 10 ;
        else
        {
            x = x + 2 + current -> myBitmap.GetWidth();
        }
        if (x > Xin) return tnode ;
        tnode = tnode->GetNext() ;
    }
    return NULL ;
}

void MyCanvas::SetRelevantCursor(wxMouseEvent & event)
{     
#ifndef WXHNOCURSOR
    if (FindWhichMenu(event.GetX(), event.GetY()) != wxNOT_FOUND)
    {
        if (event.Dragging())  SetCursor(wxCursor(wxBitmap(drag_xpm).ConvertToImage() ));
        else SetCursor(wxCursor(wxBitmap(menu_xpm).ConvertToImage() ));
        return ;
    }

    if (event.GetY() < iToolbarmax) 
    {
        SetCursor(wxCursor(wxBitmap(tool_xpm).ConvertToImage() ));
        return ;
    }

    if (event.GetY() < iToolbarmax + icoMax )
    {
        if (event.GetX() > icoMax) SetCursor(wxCursor(wxBitmap(frame_xpm).ConvertToImage() ));
        else SetCursor ( * wxSTANDARD_CURSOR ); 
        return ;
    }

    SetCursor(wxCursor(wxBitmap(pen_xpm).ConvertToImage() ));
#endif    
}

void MyCanvas::OnMouseMove (wxMouseEvent & event)
{
    SetRelevantCursor(event);

    ptMouse = event.GetPosition();
    
    if (event.GetY() < iToolbarmax)
    {
        TBitmapToolList::Node * pTnode = GetTool (event.GetX());
        if (pTnode) 
        {
            TopWin -> SetStatusText(wxT("Help: " ) + pTnode->GetData()->myHelp,1);
        }
    }
    else TopWin -> SetStatusText(wxEmptyString,1);
}


TBitmapMenu *  MyCanvas::MatchTool (wxString sToolID)
{
    TBitmapMenuList::Node *node = menuList->GetFirst();
    while (node)
    {
        TBitmapMenu *current = node->GetData();
        if(current -> GetIDString () == sToolID) return current;
        node = node->GetNext() ;
    }
    return NULL ;
}

TBitmapMenu *  MyCanvas::MatchTool (TBitmapToolList::Node *tnode)
{
    if (!tnode) return NULL;
    return MatchTool(tnode->GetData()->myID) ;
}

void MyCanvas::OnActivate(wxActivateEvent& event)
{
    if ( event.GetActive() && TopWin -> pMain_cpp ) DoActivate () ;
}


void MyCanvas::DoActivate()
{
            mywxTextCtrl * pTC = TopWin -> pMain_cpp -> textctrl ;
            if ( pTC -> isUpdated ) 
                {
                long iPos = pTC -> GetInsertionPoint();
                int iSel = iSelected ;
                ClearLists() ;
                init ();
                TopWin -> DoLoadMenuWindow ();
                Refresh();
                pTC -> SetInsertionPoint (iPos);
                pTC -> ShowPosition (iPos);
                iSelected = iSel ;
                pTC -> isUpdated = FALSE ;
                }
                
}


void MyCanvas::OnEnableL (wxUpdateUIEvent & event)
{
    TBitmapMenu *pBM = menuList->Item(iSelected) -> GetData() -> GetRoot();
    event.Enable (menuList->IndexOf (pBM) > 0) ;
}

void MyCanvas::OnEnableR (wxUpdateUIEvent & event)
{
    TBitmapMenu *pBM = menuList->GetLast()->GetData() ;
    event.Enable (pBM -> GetRoot () != menuList->Item(iSelected) -> GetData() -> GetRoot()) ;
}

void MyCanvas::OnEnableMenuL (wxUpdateUIEvent & event)
{    
    event.Enable (iSelected > 0) ;
}

void MyCanvas::OnEnableMenuR (wxUpdateUIEvent & event)
{
    TBitmapMenu *pBM = menuList->GetLast()->GetData() -> GetRoot () ;
    event.Enable (pBM  != menuList->Item(iSelected) -> GetData() ) ;
}


void MyCanvas::OnIdle (wxIdleEvent & WXUNUSED(event))
{
    if (bMouseIsDown) 
        {
            if(helpRectIsShown) DoTimer();           
            return ;
        }

    int iNewMouse = FindWhichMenu ( ptMouse.x, ptMouse.y );
    if ( iNewMouse == wxNOT_FOUND) 
        {
            if ( ptMouse.y <  iToolbarmax)
            iNewMouse = menuList->IndexOf ( MatchTool (GetTool(ptMouse.x))) ;
        }
    if ( iNewMouse == wxNOT_FOUND) 
        {
            iLastMouse = iNewMouse ;
            if (helpRectIsShown) DoTimer();
            return ;
        }
    if ( iNewMouse == iLastMouse ) return ;
    iLastMouse = iNewMouse ;
    if (helpRectIsShown) DoTimer();
    
    TBitmapMenu *current = menuList->Item(iNewMouse) -> GetData() ;
 
    wxString sTmp ;
    wxString sHelp = wxT("Menu:") + (current -> GetLabel());
    sTmp = current -> GetAccelString().Mid(1) ;
    if (!sTmp.IsEmpty()) sHelp = sHelp + wxT("; with Accelerator:") + sTmp;
    sTmp = current -> GetHelpString() ;
    if (!sTmp.IsEmpty()) sHelp = sHelp +  wxT("; with Help String:") + sTmp;
   
    int x,y, w, h ;                                       
    wxClientDC dc(this);
    PrepareDC(dc);
    dc.SetFont ( *wxNORMAL_FONT ) ;
    dc.GetTextExtent ( sHelp, &h, &w ) ;                                  
    
    const int offset = 5 ;
    h = h + offset ;
    w = w + offset ;
    //FIXME 32 IS SUPPOSED CURSOR SIZE
    x = ptMouse.x + 32 + offset ;
    y = ptMouse.y + offset ;
    
    dc.SetBrush ( wxBrush (wxColour(255,255,192), wxSOLID ));
    dc.DrawRectangle (x,y,h,w);
    helpRect = wxRect (x,y,h,w);
    helpRectIsShown = TRUE ;
    dc.DrawText ( sHelp, x+2,y+1 ); 
    myTimer.Start(3000);
}

void MyCanvas::OnTimer(wxTimerEvent& WXUNUSED(event))
{
    DoTimer();
}

void MyCanvas::DoTimer()
{
    if (helpRectIsShown) Refresh (TRUE, &helpRect) ;    
    Update ();
    helpRectIsShown = FALSE ;
}



// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
// 
