//wxHatch CVS $Id: mcanvas.h,v 1.10 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
#ifndef _canvas_h
#define _canvas_h

class MyCanvas ;

class TBitmapTool
{
    public:
        wxString myFilename ;
        wxBitmap myBitmap ;
        wxString myID ;
        wxString myHelp ;
        wxDateTime modTime ;

        TBitmapTool (const wxString& s = wxEmptyString,
            const wxString& sI  = wxEmptyString,
            const wxString& sH  = wxEmptyString);
        wxString GetAddToolText (MyCanvas* pCanvas) ;
        wxString GetConCatString (MyCanvas* pCanvas) ;
        bool IsAlteredOnDisk ( ) ;
        void SetModTime();
		wxString Get_XPM_Name () ;
};

WX_DECLARE_LIST(TBitmapMenu, TBitmapMenuList);
WX_DECLARE_LIST(TBitmapTool, TBitmapToolList);

class MyCanvas : public wxScrolledWindow
{
    public:
        MyCanvas(wxWindow *parent, const wxPoint& pos, const wxSize& size);

        ~MyCanvas () ;
        TBitmapMenuList * menuList ;
        TBitmapToolList * toolList ;
        wxString sLastMenuBarText, sIcoFile  ;
        wxDateTime icoMod ;

        int xpos, ypos, iSelected;
        MyFrame *  TopWin ;
        wxIcon myIcon ;
        TBitmapToolList::Node * selBmp ;

        wxMenu * menu_Base_popup_menu, * menu_popup_menu, * tool_popup_menu, * frame_popup_menu,
            * canv_popup_menu, * icon_popup_menu, * sep_popup_menu  ;

        void OnActivate(wxActivateEvent& event);
        void DoActivate(); 
        void OnLeft_down (wxMouseEvent & event) ;
        void OnLeft_up (wxMouseEvent & event) ;
        void OnLeft_Dk (wxMouseEvent & event) ;
        void OnRight_up (wxMouseEvent & event);
        void OnMouseMove (wxMouseEvent & event);
        void SetRelevantCursor(wxMouseEvent & event) ;

        void OnIdle (wxIdleEvent & event);
        void OnTimer(wxTimerEvent& event) ;
        void DoTimer ();

        virtual void OnDraw(wxDC& dc);
        void OnAddMenu (const wxString & sText, bool bIsPopup) ;
        
        bool OnAdd_Item (const wxString & sText, const wxString & sAccel = wxEmptyString,
            const wxString & sHelp  = wxEmptyString);
        void OnRenameitem (wxCommandEvent& event) ;
        void OnAddfilemenu (wxCommandEvent& event) ;
        void OnAddfileprintmenu (wxCommandEvent& event) ;
        void OnAddeditmenu (wxCommandEvent& event) ;
        void OnAddHelpmenu (wxCommandEvent & event);
        void OnSeparator (wxCommandEvent& event) ;

        TBitmapMenu *  DoInsertMenu (int i, const wxString & sText, const wxString &sAccel, const wxString & sHelp, bool bBase, bool bIsPopup) ;
        TBitmapMenu *  DoInsertMenu (int i, const wxString & sText, bool bBase, bool bIsPopup) ;
        TBitmapMenu *  DoInsertMenu (const wxString & sMenuName, const wxString & sMenuLabel, bool bIsPopup = FALSE ) ;
        TBitmapMenu *  DoInsertMenu (const wxString & sIDin,
            const wxString & sMenuName,
            const wxString & sLabel,
            const wxString & sMethod,
            const wxString & sAcc,
            const wxString & sHlp) ;

        void RefreshMenus () ;
        void DeleteCurrentNode (bool DeleteDataToo) ;

        void MoveMenu (int iStart, int iEnd) ;

        void OnEnableUp (wxUpdateUIEvent & event) ;
        void OnEnableDown (wxUpdateUIEvent & event) ;
        void OnEnableL (wxUpdateUIEvent & event) ;
        void OnEnableR (wxUpdateUIEvent & event) ;
        void OnEnableMenuL (wxUpdateUIEvent & event) ;
        void OnEnableMenuR (wxUpdateUIEvent & event) ;

        int FindWhichMenu (int x, int y );

        void init () ;
        void ClearLists() ;
        void ChangeIcon ();
        bool IconIsAlteredOnDisk();
        void SetIconModTime();
        
        TBitmapToolList::Node * GetTool (int Xin) ;
        TBitmapMenu *  MatchTool (wxString sToolID);
        TBitmapMenu *  MatchTool (TBitmapToolList::Node *tnode);

    private:
//        bool m_dirty;
        wxPoint ptMouse ;
        int iLastMouse ;
        bool bMouseIsDown, helpRectIsShown ;
        wxRect helpRect ;
        wxTimer myTimer ;
        DECLARE_EVENT_TABLE()
};
#endif
