/////////////////////////////////////////////////////////////////////////////
// Name:        wx/generic/choicdgg.h
// Purpose:     Generic choice dialogs
// Author:      Julian Smart
// Modified by: 03.11.00: VZ to add wxArrayString and multiple sel functions
// Created:     01/02/97
// RCS-ID:      $Id: mcdlg.h,v 1.2 2004/03/20 09:36:16 biol75 Exp $
// Copyright:   (c) wxWidgets team
// Licence:     wxWidgets licence
/////////////////////////////////////////////////////////////////////////////

#ifndef __MCDLGH_G__
#define __MCDLGH_G__

// A custom modal dialog
class wxMultipleChoiceDialog : public wxDialog
{
public:
    wxMultipleChoiceDialog() {} ;
    
    wxMultipleChoiceDialog(wxWindow *parent,
            const wxString & caption,
            const bool * SetChecked, 
            int n, 
            const wxString * choices, 
            const bool * SetEnabled = NULL,
            long style = wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER ) ;

//same, but use wxArrays, see .cpp file
    wxMultipleChoiceDialog(wxWindow *parent,
                const wxString & caption,
                wxArrayInt & SetChecked, 
                int n, 
                const wxArrayString& choices,
                wxArrayInt * SetEnabled = NULL,
                long style = wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER ) ;            
            
    void Create (wxWindow *parent,
                const wxString & caption,
                const bool * SetChecked, 
                int n, 
                const wxString * choices, 
                const bool * SetEnabled,
                long style )  ;            
 
    void OnButton(wxCommandEvent& event);
    void SetSelection (const bool * SetChecked, int n, const wxString * choices, const bool * SetEnabled = NULL);
    int  GetSelection (bool * GetChecked, int n = -1);
    int  GetSelection (wxArrayInt & GetChecked) ;
    bool GetSelection (int n);

private:
    wxArrayInt m_checked, m_enabled ;
    int m_count ;
    wxBoxSizer * m_topsizer ;
    DECLARE_EVENT_TABLE()
};

#endif
