//wxHatch CVS $Id: mchild.cpp,v 1.7 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//

// ===========================================================================
// declarations
// ===========================================================================

// ---------------------------------------------------------------------------
// headers
// ---------------------------------------------------------------------------

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#include "wx/mdi.h"
#endif

#include <wx/docview.h>
#include <wx/treectrl.h>
#include <wx/listctrl.h>
#include <wx/html/helpctrl.h>


#include "projdefs.h"
#include "bitmenu.h"
#include "wx/stc/stc.h"
#include "mytext.h"
#include "mcanvas.h"
#include "mchild.h"
#include "trchild.h"
#include "dchild.h"
#include "wxhatch.h"

// Note that MDI_NEW_WINDOW and MDI_ABOUT commands get passed
// to the parent window for processing, so no need to
// duplicate event handlers here.
BEGIN_EVENT_TABLE(MyChild, wxMDIChildFrame)

EVT_ACTIVATE(MyChild::OnActivate)

EVT_SIZE(MyChild::OnSize)

EVT_CLOSE(MyChild::OnClose)
END_EVENT_TABLE()

// ---------------------------------------------------------------------------
// MyChild
// ---------------------------------------------------------------------------

MyChild::MyChild(wxMDIParentFrame *parent, const wxString& title,
const wxPoint& pos, const wxSize& size,
const long style)
: wxMDIChildFrame(parent, -1, title, pos, size, style)
{
    canvas = (MyCanvas *) NULL;
    frame = (MyFrame *) parent ;

}

void MyChild::OnActivate(wxActivateEvent& event)
{
    if ( event.GetActive() && canvas )
        canvas->OnActivate (event) ;
}


MyChild::~MyChild()
{
    //    frame -> my_children.DeleteObject(this);
}


void MyChild::OnQuit(wxCommandEvent& WXUNUSED(event))
{
    Close(TRUE);
}


void MyChild::OnRefresh(wxCommandEvent& WXUNUSED(event))
{
    if ( canvas )
        canvas->Refresh();
}



void MyChild::OnSize(wxSizeEvent& event)
{

    event.Skip();
}


void MyChild::OnClose(wxCloseEvent& event)
{

    frame -> pMenuChild = NULL ;

    frame -> nFrames--;

    event.Skip();
}
