//wxHatch CVS $Id: mnudlg.cpp,v 1.6 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
//A wxHatch file Copyright Chris Elliott and the University of York 2001

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include <wx/dialog.h>
#include <wx/button.h>
#include <wx/checkbox.h>
#include <wx/config.h>
#include "wxhcombo.h"
#include "mnudlg.h"

BEGIN_EVENT_TABLE(MyMenuDialog, wxDialog)
//EVT_BUTTON(-1, MyMenuDialog::OnButton)
END_EVENT_TABLE()

// ----------------------------------------------------------------------------
// MyMenuDialog
// ----------------------------------------------------------------------------

MyMenuDialog::MyMenuDialog(wxWindow *parent,
const wxString & myCaption,
const wxArrayString & myText, long WXUNUSED(myStyle))
: wxDialog(parent, -1, myCaption, wxDefaultPosition, wxDefaultSize,
wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER )

{
    boxName = myCaption ;
    iLen = myText[wxhMENU].Len () ;

    myMenuComboBox   = new wxHistoryComboBox   ( this, -1, myText[wxhMENU], wxDefaultPosition, wxDefaultSize,
        0, NULL, wxCB_DROPDOWN, wxDefaultValidator, wxT("Menu text"), 8 );
  

    myHelpComboBox   = new wxHistoryComboBox   ( this, -1, myText[wxhHELP], wxDefaultPosition, wxDefaultSize,
        0, NULL, wxCB_DROPDOWN, wxDefaultValidator, wxT("Help Text"), 8 ); 

    // now build the dialog
    wxBoxSizer *topsizer = new wxBoxSizer( wxVERTICAL  );
    myStaticText = new wxStaticText ( (wxWindow *)this, -1, wxT("Enter the menu label using an ampersand for the Alt Keypress\ne.g. &&Open"), wxDefaultPosition, wxDefaultSize);
    topsizer->Add(myStaticText, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    topsizer->Add(myMenuComboBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    myStaticText = new wxStaticText ( (wxWindow *)this, -1, wxT("Enter the help text"), wxDefaultPosition, wxDefaultSize);
    topsizer->Add(myStaticText, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    topsizer->Add(myHelpComboBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    myStaticText = new wxStaticText ( (wxWindow *)this, -1, wxT("Choose Accelerator"), wxDefaultPosition, wxDefaultSize);
    topsizer->Add(myStaticText, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    wxBoxSizer *accel_sizer = new wxBoxSizer( wxHORIZONTAL  );

    //do letters for accelerators
    ctrlCheckBox  = new wxCheckBox (this, -1, wxT("Ctrl")    );
    shiftCheckBox = new wxCheckBox (this, -1, wxT("Shift")    );

    pLetters = new wxString [27] ;

    pLetters[0] = wxT("NONE");
    int iAccel ;
    for (iAccel=0; iAccel<26; iAccel++)
    {
        pLetters[iAccel+1] = wxString(wxChar(iAccel+65));
    }

    wxString sInitialLetter = wxT("NONE");
    if ( ! myText[wxhACCEL].IsEmpty() )
    {
        sInitialLetter = myText[wxhACCEL].AfterLast(wxT('+'));
        ctrlCheckBox  -> SetValue ( myText[wxhACCEL].Contains(wxT("Ctrl")) );
        shiftCheckBox -> SetValue ( myText[wxhACCEL].Contains(wxT("Shift")) ); 
    }

    myAccelComboBox = new wxComboBox (this, -1, sInitialLetter, wxDefaultPosition, wxDefaultSize, 27, pLetters, wxCB_READONLY );


    accel_sizer->Add(ctrlCheckBox, 1, wxEXPAND | wxALL, 10 );
    accel_sizer->Add(shiftCheckBox, 1, wxEXPAND | wxALL, 10 );
    accel_sizer->Add(myAccelComboBox, 1, wxEXPAND | wxALL, 10 );

    topsizer->Add( accel_sizer,  0, wxALIGN_CENTER );  

    topsizer->Add(CreateButtonSizer( wxOK|wxCANCEL ), 0, wxCENTER|wxALL, 10); 

    SetSizerAndFit( topsizer );        // actually set the sizer
    
    
    myHelpComboBox -> SetSelection ( 0 ) ;
    myMenuComboBox -> SetSelection ( 0, iLen ) ;
    myMenuComboBox -> SetFocus ();
}


wxArrayString MyMenuDialog::GetValue ()
{
        wxString sTmp ;
        wxArrayString myResult ;
        
        myResult.Clear ();
        myResult.Add (myMenuComboBox->GetValue() );
        myResult.Add (myHelpComboBox->GetValue() );

        // now build the accelrator string
        sTmp = myAccelComboBox->GetValue ();
        if (sTmp.IsEmpty() || (sTmp.Len() > 1))
        {
            myResult.Add(wxEmptyString);
        }
        else
        {
            sTmp = wxT("\\t");
            if (ctrlCheckBox ->GetValue()) sTmp = sTmp + wxT("Ctrl+");
            if (shiftCheckBox->GetValue()) sTmp = sTmp + wxT("Shift+");
            sTmp = sTmp + myAccelComboBox->GetValue ();
            myResult.Add(sTmp);
        } 
    return myResult ;
}

MyMenuDialog::~MyMenuDialog ()
{
      delete [] pLetters ;
}
