//wxHatch CVS $Id: mytext.cpp,v 1.46 2004/03/30 09:40:26 biol75 Exp $
// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
#endif

#include <wx/file.h>
#include <wx/filename.h>
#include <wx/docview.h>
#include <wx/html/helpctrl.h>
#include <wx/textfile.h>
#include <wx/listctrl.h>

#include <wx/wfstream.h>
#include <wx/treectrl.h>
 

class MyFrame;
class TextChild ;

#include "projdefs.h"
#include "wx/stc/stc.h"
#include "mytext.h"
#include "bitmenu.h"
#include "tchild.h"
#include "trchild.h"
#include "dchild.h"
#include "wxhatch.h"

//#include "wx/msw/winundef.h" 

BEGIN_EVENT_TABLE(mywxTextCtrl, wxStyledTextCtrl)
EVT_CHAR(mywxTextCtrl::OnChar)
EVT_KEY_DOWN(mywxTextCtrl::OnKeyDown)
EVT_RIGHT_UP(mywxTextCtrl::OnRightMouseClick)
//EVT_CONTEXT_MENU(mywxTextCtrl::OnContextMenu) ??GTK ??

EVT_MENU(wxID_CUT,  mywxTextCtrl::OnPopupMenuEvent)
EVT_MENU(wxID_COPY,  mywxTextCtrl::OnPopupMenuEvent)
EVT_MENU(wxID_PASTE, mywxTextCtrl::OnPopupMenuEvent)
EVT_MENU(wxID_UNDO,  mywxTextCtrl::OnPopupMenuEvent)
EVT_MENU(wxID_REDO, mywxTextCtrl::OnPopupMenuEvent)
EVT_MENU(wxH_REFSEARCH, mywxTextCtrl::OnPopupMenuEvent)
EVT_MENU(wxH_EDIT_IMAGE, mywxTextCtrl::OnPopupMenuEvent)
END_EVENT_TABLE()

wxColour myStyles [12] = {
    wxColour(0x80, 0x80, 0x80),
    wxColour(0x00, 0x7f, 0x00),
    wxColour(0x00, 0x7f, 0x00),
    wxColour(0x7f, 0x7f, 0x7f),
    wxColour(0x00, 0x7f, 0x7f),
    wxColour(0x00, 0x00, 0x7f),
    wxColour(0x7f, 0x00, 0x7f),
    wxColour(0x7f, 0x00, 0x7f),
    wxColour(0x00, 0x7f, 0x7f),
    wxColour(0x7f, 0x7f, 0x7f),
    wxColour(0x00, 0x00, 0x00),
    wxColour(0x00, 0x00, 0x00) };



// const wxString& title,
mywxTextCtrl::mywxTextCtrl (wxWindow * parent, int id,
                            const wxPoint& pos, const wxSize& size,
                            //title,
                            const long style ) : wxStyledTextCtrl ( parent, id,
                                                                    pos, size,
                                                                    style | wxTE_PROCESS_TAB )
{
    isUpdated = FALSE ;
    isDlgUpDated = FALSE ;
    bHasNewClass = FALSE ;
    bNeedsEnableCheck = TRUE ;
    eDlgType = IsNotDialog ;

    SetIndent(4);
    SetTabWidth(4);
    SetUseTabs(FALSE);
    ParWin = (TextChild*)parent ;
    TopWin = ParWin -> frame;

    myTextPopupMenu = new wxMenu ;
    myTextPopupMenu->Append(wxID_CUT,  wxT("&Cut  \tCtrl-X"));
    myTextPopupMenu->Append(wxID_COPY,  wxT("&Copy  \tCtrl-C"));
    myTextPopupMenu->Append(wxID_PASTE, wxT("&Paste \tCtrl-V"));
    myTextPopupMenu->AppendSeparator();
    myTextPopupMenu->Append(wxID_UNDO,  wxT("&Undo  \tCtrl-Z"));
    myTextPopupMenu->Append(wxID_REDO, wxT("Re&do \tCtrl+Shift-Z"));
    myTextPopupMenu->AppendSeparator();
    myTextPopupMenu->Append(wxH_REFSEARCH, wxT("&Help\tCtrl+F1"));
    myTextPopupMenu->Append(wxH_EDIT_IMAGE, wxT("Edit &Image"));
    
}


mywxTextCtrl::~mywxTextCtrl()
{
    delete myTextPopupMenu ;
}

void mywxTextCtrl::OnKeyDown(wxKeyEvent& event)
{

    if (event.KeyCode() == WXK_RETURN)
    {
//#ifdef __WXGTK__
            OnChar(event);
//#endif
        return ;
    }

    event.Skip();
}

void mywxTextCtrl::OnChar(wxKeyEvent& event)
{
    long iPos = 0;
    long x =0 ;
    long y =0 ;
    switch ( event.KeyCode() )
    {
        case '{':
            iPos = GetInsertionPoint() ;
            PositionToXY ( iPos, &x, &y );
            if (x > 0)
            { 
                WriteText (wxT("     "));
                SetInsertionPoint (iPos+4);
            }
            break;
        case ';':
            bNeedsEnableCheck = TRUE;
            DoAnymenuOpen () ;
            break ; 

        case ':':
        // could check for previous char with : too
            bHasNewClass = TRUE ;
            break ;    
            
        case WXK_RETURN:
            if (   event.ControlDown()  )
            {
                TopWin -> ProcessCommand ( wxH_COMPILE );
                return ;
            }
            if ( ! event.ShiftDown() )
            {
                // 1 neded by styled text
                iPos = GetInsertionPoint() - 1;
                PositionToXY ( iPos, &x, &y );
                wxString sLine = GetLineText (y);
                int iSpace = 0 ;
                while ( (iSpace < (int)sLine.Len()) && (sLine.GetChar(iSpace) == space) ) iSpace++ ;
                
            if (sLine.Contains (wxT("}")) && sLine.Len() > 4) iSpace = iSpace - 4 ;
            WriteText (wxT("\n"));
            int i ;
            for (i=0; i < iSpace; i++) WriteText (space);
            SetInsertionPoint( GetInsertionPoint() ) ;
            isUpdated = TRUE ;
            isDlgUpDated = TRUE ;
            return;
        }
        
    }
    isUpdated = TRUE ;
    isDlgUpDated = TRUE ;
    event.Skip();
}


bool mywxTextCtrl::LoadFile ( const wxString & sFile )
{
    sFileName = sFile ;
    {
        // get file time
        //file may be locked by debuggfer so suppress errors
        wxLogNull myNullLog ;
        modTime = wxFileName(sFile).GetModificationTime();
    }
    //read text
    wxString st;
    wxFileInputStream stream(sFile);
    size_t sz = stream.GetSize();
    char* buf = new char[sz + 1];
    stream.Read((void*) buf, stream.GetSize());
    buf[sz] = 0;
    st = wxString::FromAscii(buf);
    delete[] buf;

    
    InsertText(0, st);
    EmptyUndoBuffer();
    DoStyle(sFile);

    CheckForDialog () ;
    bNeedsEnableCheck = TRUE ;
    DoAnymenuOpen () ;
    return TRUE;
}

void mywxTextCtrl::DoStyle(const wxString & sFile)
{
    StyleClearAll();
    int i ;
    for (i=0; i < 12 ; i++)
    {
        StyleSetForeground(i,  myStyles[i]);
    }


    wxString ext = sFile.AfterLast(wxT('.'));
    if ((ext.IsSameAs(wxT("cpp"),FALSE)) || (ext.IsSameAs(wxT("h"),  FALSE)) ||
        (ext.IsSameAs(wxT("c"),  FALSE)) || (ext.IsSameAs(wxT("cxx"),FALSE)) ||
        (ext.IsSameAs(wxT("inc"),FALSE)))
    {
        SetLexer(wxSTC_LEX_CPP);
        StyleSetBold(wxSTC_C_WORD,  TRUE);
        StyleSetBold(wxSTC_C_OPERATOR, TRUE);
        SetKeyWords(0,
                  wxT("asm auto bool break case catch char class const ")
                  wxT("const_cast continue default delete do double ")
                  wxT("dynamic_cast else enum explicit export extern ")
                  wxT("false float for friend goto if inline int long ")
                  wxT("mutable namespace new operator private protected ")
                  wxT("public register reinterpret_cast return short signed ")
                  wxT("sizeof static static_cast struct switch template this ")
                  wxT("throw true try typedef typeid typename union unsigned ")
                  wxT("using virtual void volatile wchar_t while")) ;
    }
    if ((ext.IsSameAs(wxT("htm"),FALSE)) || (ext.IsSameAs(wxT("html"),FALSE)) || (ext.IsSameAs(wxT("htt"),FALSE)) || (ext.IsSameAs(wxT("stm"),FALSE)))
    {
        SetLexer(wxSTC_LEX_HTML);
    StyleSetForeground (wxSTC_H_DEFAULT, wxColour(wxT("BLACK")));
    StyleSetBold( wxSTC_H_DEFAULT, TRUE) ;
    StyleSetForeground (wxSTC_H_TAG, wxColour(wxT("BLUE")));
    StyleSetForeground (wxSTC_H_TAGUNKNOWN, wxColour(wxT("STEEL BLUE")));
    StyleSetForeground (wxSTC_H_ATTRIBUTE, wxColour(wxT("RED")));
    StyleSetForeground (wxSTC_H_ATTRIBUTEUNKNOWN, wxColour(wxT("ORANGE RED")));
    StyleSetForeground (wxSTC_H_NUMBER, wxColour(wxT("GREY")));
    StyleSetForeground (wxSTC_H_DOUBLESTRING, wxColour(wxT("GREEN")));
    StyleSetForeground (wxSTC_H_SINGLESTRING, wxColour(wxT("SPRING GREEN")));
    StyleSetForeground (wxSTC_H_OTHER, wxColour(wxT("BLACK")));
    StyleSetForeground (wxSTC_H_COMMENT, wxColour(wxT("PLUM")));
    StyleSetForeground (wxSTC_H_ENTITY , wxColour(wxT("THISTLE")));
        SetKeyWords(0,
                  wxT("html HTML body BODY ")
                  wxT("A HREF")
                  wxT("p P pre PRE ul UL li LI ol OL ")
                  wxT("b B i I") ) ;

    }
}

void mywxTextCtrl::CheckForDialog ()
{
    if (wxNOT_FOUND != TopWin -> DoFindLine (wxT(": wxDialog(parent"), 0, ParWin) ) eDlgType = IsDialogCode ;
    if (wxNOT_FOUND != TopWin -> DoFindLine (wxT(": public wxDialog"), 0, ParWin) ) eDlgType = IsDialogHeader ;
}

bool mywxTextCtrl::SaveFile ( const wxString & sFile )
{
    wxFile file (sFile, wxFile::write);
    wxString st = GetText();
    SetSavePoint();
    isUpdated = FALSE;
    isDlgUpDated = FALSE ;
    CheckForDialog () ;
    sFileName = sFile ;
    bool Ok = file.Write (st);
    if (Ok)
    {
        file.Close();
        modTime = wxFileName(sFile).GetModificationTime();
    }
    return Ok ;
    

}

bool mywxTextCtrl::IsAlteredOnDisk ( )
{
    //the cpp file may be locked by a debugger, so suppress errors
    wxLogNull myNullLog ;
    if (sFileName.IsEmpty()) return FALSE ;
    if (!modTime.IsValid()) return FALSE ;
    wxDateTime fDT = wxFileName(sFileName).GetModificationTime() ;
    if (!fDT.IsValid()) return FALSE ;
    return modTime.IsEarlierThan(fDT);
}

void mywxTextCtrl::SetModTime ()
{
    modTime = wxDateTime::Now();
}

void mywxTextCtrl::Remove (int iStart, int iEnd)
{
    // no selection after removal
    SetSelection (iStart, iEnd);
    wxString sSel = GetSelectedText();
    if ( sSel.Contains(doublecolon) ) bHasNewClass = TRUE ;
    ReplaceSelection (wxEmptyString);
    isUpdated = TRUE;
    isDlgUpDated = TRUE ;
    bNeedsEnableCheck = TRUE ;
    DoAnymenuOpen () ;
}


bool mywxTextCtrl::PositionToXY (long pos, long *x, long * y)
{
    if ( pos < 0 ) return FALSE;
    if ( pos > GetLength()) return FALSE;

    int iLine = LineFromPosition (pos);
    int iStartPos = PositionFromLine(iLine);
    *x = pos - iStartPos ;
    *y = iLine ;
    return TRUE ;
}


void mywxTextCtrl::WriteText (const wxString & s)
{
    InsertText (GetCurrentPos(), s) ;
    SetCurrentPos ( GetCurrentPos() + s.Len() ) ;
    isUpdated = TRUE;
    isDlgUpDated = TRUE ;
    bNeedsEnableCheck = TRUE ;
    if ( s.Contains(doublecolon) ) bHasNewClass = TRUE ;

    DoAnymenuOpen () ;
    return;
};


void mywxTextCtrl::DoRightMouseClick (wxPoint pt)
{
    PopupMenu ( myTextPopupMenu, pt );
}

void mywxTextCtrl::OnPopupMenuEvent(wxCommandEvent & event)
{
    TopWin->ProcessEvent(event);
}


void mywxTextCtrl::OnCut (wxCommandEvent & WXUNUSED(event) ) 
{ 
    wxString sSel = GetSelectedText();
    if ( sSel.Contains(doublecolon) ) bHasNewClass = TRUE ;
    Cut(); 
    isUpdated = TRUE; 
    isDlgUpDated = TRUE ;
    bNeedsEnableCheck = TRUE ;
    DoAnymenuOpen () ;
    return ; 
};

//this is never called in GTK
void mywxTextCtrl::Clear ()
{
    wxString sSel = GetSelectedText();
    if ( sSel.Contains(doublecolon) ) bHasNewClass = TRUE ;
    wxStyledTextCtrl::Clear();
    isUpdated = TRUE;
    isDlgUpDated = TRUE ;
    bNeedsEnableCheck = TRUE ;
    DoAnymenuOpen () ;
    return ;
}

void mywxTextCtrl::OnModifySelection(const wxString & sBefore, const wxString & sAfter)
{
        
    if ( sBefore.Contains(doublecolon) ) bHasNewClass = TRUE ;
    if ( sAfter.Contains(doublecolon) ) bHasNewClass = TRUE ;
    
    int myStartPos = GetInsertionPoint ();    
    int myFarEnd = GetAnchor() ;
    if (myStartPos > myFarEnd)
    {
        //swap round
        int iTmp = myStartPos;
        myStartPos = myFarEnd ;
        myFarEnd = iTmp ;
    }
        
    InsertText (myStartPos, sBefore) ;
    InsertText (myFarEnd + sBefore.Len(), sAfter) ;

    if (myStartPos == myFarEnd)
        {
        //no selection
        SetSelectionStart( GetCurrentPos() + sBefore.Len() ) ;
        SetSelectionEnd( GetCurrentPos() ) ;
        } 

    isUpdated = TRUE; 
    isDlgUpDated = TRUE ;
    bNeedsEnableCheck = TRUE ;
    DoAnymenuOpen () ;
    return ;    
}

void mywxTextCtrl::OnCopy (wxCommandEvent & WXUNUSED(event) ) 
{ 
    Copy(); 
    isUpdated = TRUE; 
    isDlgUpDated = TRUE ;
    bNeedsEnableCheck = TRUE ;
    DoAnymenuOpen () ;
    return ; 
};

void mywxTextCtrl::OnPaste (wxCommandEvent & WXUNUSED(event) ) 
{ 
       Paste();
       bHasNewClass = TRUE ;
       isUpdated = TRUE; 
       isDlgUpDated = TRUE ;
    bNeedsEnableCheck = TRUE ;
    DoAnymenuOpen () ;
    return ; 
};

void mywxTextCtrl::OnRedo (wxCommandEvent & WXUNUSED(event) )
{ 
    Redo();
    bHasNewClass = TRUE ;
    isUpdated = TRUE; 
    isDlgUpDated = TRUE ;
    bNeedsEnableCheck = TRUE ;
    DoAnymenuOpen () ;
    return ; 
};

void mywxTextCtrl::OnUndo (wxCommandEvent & WXUNUSED(event) )
{ 
    Undo();
    bHasNewClass = TRUE ;
    isUpdated = TRUE; 
    isDlgUpDated = TRUE ;
    bNeedsEnableCheck = TRUE ;
    DoAnymenuOpen () ;
    return ; 
};

const wxString mywxTextCtrl::RenderAsHTML ()
{
const wxString sOO = wxT("00"); 
const wxString s8O = wxT("80");
const wxString sFF = wxT("FF"); 

    wxString htmlString ;
    htmlString << wxT("<HTML><BODY><TT>");
    
    int iPos, iStyle, iOldStyle, iMax ;
    wxChar c ;
    
    iOldStyle = -1 ;
    
    //force styling, then read document letter by letter
    iMax = GetLength() ;
    Colourise(0,iMax);
    for (iPos =0; iPos < iMax; iPos++)
    {
        iStyle = GetStyleAt (iPos) ;;// | 31;
        if (iStyle != iOldStyle)         
        {
            if  (iPos > 0)
            {
                htmlString << wxT("</FONT>");
            }
            wxString sR, sG, sB;
            sR.Printf ( wxT("%02X"), myStyles[iStyle].Red());
            sG.Printf ( wxT("%02X"), myStyles[iStyle].Green());
            sB.Printf ( wxT("%02X"), myStyles[iStyle].Blue());
            htmlString << wxT("<FONT COLOR = \"#") << sR << sG << sB << wxT("\">"); ;
        }
        c = GetCharAt(iPos);
        //translate <  & \n etc
        switch (c)
        {
            case wxT('\n') :
                htmlString << wxT("\n<BR>");
                break ;
            case wxT('<') :
                htmlString << wxT("&lt;");
                break ;
            case wxT('&') :
                htmlString << wxT("&amp;");
                break ;
            case wxT(' ') :
                htmlString << wxT("&nbsp;");
                break ;
                
            default:
                htmlString << c;
                break ;
        }
        iOldStyle = iStyle;
    }
    
    htmlString << wxT("</FONT></TT></BODY></HTML>");    
    return htmlString ;
}

void mywxTextCtrl::DoAnymenuOpen ()
{
//MSW does menuopen events
//TODO Fix this
//#ifndef __WXMSW__
    if ( !(TopWin -> pMain_cpp) ) return ;
    if ( TopWin -> pMain_cpp -> textctrl -> bNeedsEnableCheck )
    {
        TopWin -> DoAnymenuOpen() ;
        TopWin -> pMain_cpp -> textctrl -> bNeedsEnableCheck = FALSE;
    }
///#endif
}


int mywxTextCtrl::FindTxt(int minPos, int maxPos, const wxString& text, int flags)
{
// bug in 2.3.3 wxMSW : there is a #define FindText as FindTextA or FindTextW    
#ifdef FindText
struct CharacterRange {
	long cpMin;
	long cpMax;
};

struct TextToFind {
	struct CharacterRange chrg;
	char *lpstrText;
	struct CharacterRange chrgText;
};

    TextToFind  ft;
    ft.chrg.cpMin = minPos;
    ft.chrg.cpMax = maxPos;
    wxWX2MBbuf buf = (wxWX2MBbuf)wx2stc(text);
    ft.lpstrText = (char*)(const char*)buf;

    return SendMsg(2150, flags, (long)&ft);
    
#else
    
    return FindText (minPos, maxPos, text, flags) ;
    
#endif
};


void mywxTextCtrl::ReIndent ( int iStart, int iLong )
{
    wxString sLine ;
    int LastLine = LineFromPosition(iLong);
    int iLine = LineFromPosition (iStart) - 1 ;
    int iIndent ;
    
    if (iLine <= 0)
    {
        iIndent = 0;
    }
    else
    {
        iIndent = GetLineIndentation(iLine);
    }
    int iExtraIndentNextLine = 0 ;
    while ( iLine <= LastLine )
    {
        iLine ++ ;
        sLine = GetLine (iLine) ;
        if (sLine.Contains(wxT('}')) || sLine.Contains(wxT( "END_EVENT_TABLE" )) || sLine.Contains(wxT( "#endif" )) )
        {
            iIndent = iIndent - 4 ;
        }  
        sLine.Trim(FALSE).Trim(TRUE);
        
        SetLineIndentation(iLine, iIndent + iExtraIndentNextLine);
        iExtraIndentNextLine = 0; 
        
        if (sLine.StartsWith(wxT( "case" ) )) SetLineIndentation(iLine, iIndent - 4);
        if (sLine.Len () > 0 && sLine.Last() == comma ) iExtraIndentNextLine = 4;

        if (sLine.Contains(wxT('{')) || sLine.Contains(wxT( "BEGIN_EVENT_TABLE" )) || sLine.Contains(wxT( "#if" )) )
        {
            iIndent = iIndent + 4 ;
        } 
      
    } // end of while
    
}

wxString mywxTextCtrl::GetCurrentWord (bool bSelectIt)
    {
    int iPos = GetInsertionPoint();
    int iWordStart = WordStartPosition(iPos, TRUE);
    if (iPos == iWordStart) iWordStart = WordStartPosition(iPos -1, TRUE);
    int iWordEnd = WordEndPosition(iPos, TRUE);
    wxString sTmp =  GetTextRange (iWordStart, iWordEnd);
    if ( bSelectIt ) SetSelection (iWordStart, iWordEnd);
    TopWin -> SetStatusText (sTmp);
    return sTmp ;
    }
 

TextChild * mywxTextCtrl::GetDialogCodeFile()
{
    if (eDlgType == IsNotDialog) return NULL;

    if (eDlgType == IsDialogCode) return ParWin;

    if (eDlgType == IsDialogHeader) return ParWin -> alternateWin ;

    return NULL ;
}
