//wxHatch CVS $Id: srdlg.cpp,v 1.8 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
//A wxHatch file Copyright Chris Elliott and the University of York 2001

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include <wx/dialog.h>
#include <wx/button.h>
#include <wx/checkbox.h>
#include <wx/config.h>

#include "wxhcombo.h"
#include "srdlg.h"

BEGIN_EVENT_TABLE(MySearchReplaceDialog, wxDialog)

END_EVENT_TABLE()

// ----------------------------------------------------------------------------
// MySearchReplaceDialog
// ----------------------------------------------------------------------------

MySearchReplaceDialog::MySearchReplaceDialog(wxWindow *parent, const SRData & SRD, long WXUNUSED(myStyle))
: wxDialog(parent, -1, wxEmptyString, wxDefaultPosition, wxDefaultSize,
wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER )

{
    wxString myCaption ;
    
    if (SRD.bSR) myCaption = wxT("Find and replace") ; else myCaption = wxT("Find") ;
    SetTitle(myCaption) ;
    
    wxString mySearchText = SRD.sF ;
    wxString myReplaceText = SRD.sR ;

    myFromStartCheckBox = new wxCheckBox (this, -1, wxT("Search from start") );
    myCaseSensitiveCheckBox = new wxCheckBox (this, -1, wxT("Search is case sensitive") );
    myFromStartCheckBox -> SetValue ( SRD.bFS );
    myCaseSensitiveCheckBox -> SetValue ( SRD.bCS );
    
    mySearchComboBox = new wxHistoryComboBox   ( this, -1, mySearchText, wxDefaultPosition, wxDefaultSize,
        0, NULL, wxCB_DROPDOWN, wxDefaultValidator, wxT("Find"), 8 );
        
    myReplaceComboBox = NULL;
    if (SRD.bSR)
    {
    myReplaceComboBox = new wxHistoryComboBox   ( this, -1, mySearchText, wxDefaultPosition, wxDefaultSize,
        0, NULL, wxCB_DROPDOWN, wxDefaultValidator, wxT("Replace"), 8 );  
    }
    
     // now build the dialog
    wxBoxSizer *topsizer = new wxBoxSizer( wxVERTICAL  );
    myStaticText = new wxStaticText (this, -1, wxT("Find..."), wxDefaultPosition, wxDefaultSize);
    topsizer->Add(myStaticText, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    topsizer->Add(mySearchComboBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    if (myReplaceComboBox)
    {
        myStaticText = new wxStaticText (this, -1, wxT("Replace with..."), wxDefaultPosition, wxDefaultSize);
        topsizer->Add(myStaticText, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

        topsizer->Add(myReplaceComboBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    }

    topsizer->Add(myFromStartCheckBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    
    topsizer->Add(myCaseSensitiveCheckBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    
    topsizer->Add(CreateButtonSizer( wxOK|wxCANCEL), 0, wxCENTER|wxALL, 10); 

    SetSizerAndFit( topsizer );        // actually set the sizer

    mySearchComboBox -> SetSelection ( 0 ) ;
    if (myReplaceComboBox) myReplaceComboBox -> SetSelection ( 0 ) ;
    mySearchComboBox-> SetFocus();
}



SRData MySearchReplaceDialog::GetValue ()
{
    myResult.sF = mySearchComboBox->GetValue()  ;
    myResult.bFS = myFromStartCheckBox->IsChecked();
    myResult.bCS = myCaseSensitiveCheckBox->IsChecked();

    if (myReplaceComboBox) myResult.sR = myReplaceComboBox->GetValue() ;
    return myResult ;
}



