//wxHatch CVS $Id: startdlg.cpp,v 1.8 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
//A wxHatch file Copyright Chris Elliott and the University of York 2001

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include <wx/dialog.h>
#include <wx/button.h>
#include <wx/checkbox.h>
#include <wx/config.h>
#include "wxhcombo.h"

#include "projdefs.h"
#include "startdlg.h"


// ----------------------------------------------------------------------------
// MyModalDialog
// ----------------------------------------------------------------------------

MyStartDialog::MyStartDialog(wxWindow *parent,
const wxString & myName, const wxString & myCaption,
const wxString & WXUNUSED(myText), projectstyle e, long WXUNUSED(myStyle) )
: wxDialog(parent, -1, myCaption, wxDefaultPosition, wxDefaultSize,
wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER )

{
    wxBoxSizer *topsizer = new wxBoxSizer( wxVERTICAL  );

    myComboBox   = new wxHistoryComboBox   ( this, -1, wxEmptyString, wxDefaultPosition, wxDefaultSize,
        0, NULL, wxCB_DROPDOWN, wxDefaultValidator, myCaption, 8 );
    
    // these have to match with projdefs.h where projectstyle is an enum
    const int nStyles = 5 ;
    wxString sStyles [nStyles] = {wxT("Text"),wxT("Drawing"),wxT("List"), wxT("Frame Only"), wxT("New dialog")};    
    myRadioBox = new wxRadioBox ( this, -1, wxT("Choose one"), wxDefaultPosition,
        wxDefaultSize, nStyles, sStyles, 1, wxRA_SPECIFY_COLS) ;
    myRadioBox -> SetSelection(e);    

    topsizer->Add(myRadioBox, 0, wxEXPAND |  wxALL,  5 ); 

    wxStaticText * myStaticText = new wxStaticText ( (wxWindow *)this, -1, myName, wxDefaultPosition, wxDefaultSize);
    topsizer->Add(myStaticText,  0, wxEXPAND | wxALL, 5 );

    topsizer->Add(myComboBox, 0, wxEXPAND |  wxALL, 10 );                    

    topsizer->Add(CreateButtonSizer( wxOK|wxCANCEL), 0, wxCENTER|wxALL, 10);       

    SetSizerAndFit( topsizer );        
    
    myComboBox -> SetSelection ( 0 ) ;
    myComboBox -> SetFocus ();
}



wxString MyStartDialog::GetmyComboBoxValue ()
{
    return myComboBox->GetValue();
     
}

projectstyle MyStartDialog::GetmyRadioBoxValue ()
{
    return (projectstyle) myRadioBox -> GetSelection() ;
}



