//wxHatch CVS $Id: tchild.cpp,v 1.20 2004/04/27 07:51:27 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
// ===========================================================================
// declarations
// ===========================================================================

// ---------------------------------------------------------------------------
// headers
// ---------------------------------------------------------------------------

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#include "wx/mdi.h"
#endif

#include <wx/docview.h>
#include <wx/treectrl.h>
#include <wx/html/helpctrl.h>
#include <wx/listctrl.h>

#include "projdefs.h"
#include "wx/stc/stc.h"
#include "mytext.h"
#include "tchild.h"
#include "trchild.h"
#include "bitmenu.h"
#include "dchild.h"
#include "wxhatch.h"

// Note that MDI_NEW_WINDOW and MDI_ABOUT commands get passed
// to the parent window for processing, so no need to
// duplicate event handlers here.
BEGIN_EVENT_TABLE(TextChild, wxMDIChildFrame)
//    EVT_MENU(wxH_CHILD_QUIT, TextChild::OnQuit)
//    EVT_MENU(MDI_REFRESH, TextChild::OnRefresh)
EVT_ACTIVATE(TextChild::OnActivate)
EVT_SIZE(TextChild::OnSize)
//    EVT_MOVE(TextChild::OnMove)
EVT_IDLE(TextChild::OnIdle)
EVT_CLOSE(TextChild::OnClose)
END_EVENT_TABLE()

// ---------------------------------------------------------------------------
// TextChild
// ---------------------------------------------------------------------------

TextChild::TextChild(wxMDIParentFrame *parent, const wxString& title,
const wxPoint& pos, const wxSize& size,
const long style)
: wxMDIChildFrame(parent, -1, title, pos, size, style)
{

    frame = (MyFrame *) parent ;
    
                      
    textctrl = new mywxTextCtrl(this, -1, 
        wxDefaultPosition, wxDefaultSize,
        wxTE_MULTILINE | wxSUNKEN_BORDER | wxHSCROLL);

    textctrl -> SetFont (frame->myFont);
    
    textctrl -> StyleSetFont(wxSTC_STYLE_DEFAULT, frame->myFont);
           
    bIsPartOfProject = FALSE ;
    alternateWin = NULL ;

    sBar = frame -> GetStatusBar();
}


TextChild::~TextChild()
{
    frame -> textWinList -> DeleteObject(this);
}


void TextChild::OnQuit(wxCommandEvent& WXUNUSED(event))
{
    Close(TRUE);
}


void TextChild::OnRefresh(wxCommandEvent& WXUNUSED(event))
{
    //    if ( canvas )
    //        canvas->Refresh();
}


void TextChild::OnActivate(wxActivateEvent& event)
{
    if ( event.GetActive() && textctrl)     
	{
        textctrl->SetFocus();
		sStatusText = wxEmptyString ;
        DoShowTextPosition () ;
	}
}




void TextChild::OnSize(wxSizeEvent& event)
{
    textctrl->SetSize (GetClientSize()) ;
    event.Skip();
}


void TextChild::OnClose(wxCloseEvent& event)
{
    if (event.CanVeto())
    {
        if ( bIsPartOfProject )
        {
            long int iPos = textctrl->GetCurrentPos() ;
            //TODO ask if you want to minimise it
            if ( wxMessageBox(wxT("This file, ") + filename + wxT(" is part of the project and cannot be closed\nClose, Discarding any changes and Reload from disk?"),
                wxT("Please confirm"),
                wxICON_QUESTION | wxYES_NO) == wxYES )
            {
                
                textctrl->ClearAll() ;
                textctrl->LoadFile(filename) ;
                textctrl->ShowPosition(iPos) ;
                
            }
            
            event.Veto();
            return ;
            
        }
        if ( textctrl -> IsModified() )
        {
            if ( wxMessageBox(wxT("Unsaved file, ") + filename + wxT(" \nReally close?"), wxT("Please confirm"),
                wxICON_QUESTION | wxYES_NO) != wxYES )
            {
                event.Veto();

                return;
            }
        }
    }
    // get here if we really are closing....
    if (this == frame -> pMain_h   ) frame -> pMain_h  = NULL ;
    if (this == frame -> pMain_cpp ) frame -> pMain_cpp= NULL ;
    if (this == frame -> pCanv_h   ) frame -> pCanv_h  = NULL ;
    if (this == frame -> pCanv_cpp ) frame -> pCanv_cpp= NULL ;

    frame -> nFrames--;

    event.Skip();
}


void TextChild::OnIdle (wxIdleEvent & event)
{
    if ( textctrl == FindFocus() )
    {
    DoShowTextPosition ();
    }
    event.Skip();
} 

void TextChild::DoShowTextPosition ()
    { 
        long X,Y;
        textctrl->PositionToXY ( textctrl -> GetInsertionPoint(), &X,&Y);
        wxString sTmp;
        sTmp.Printf ( wxT("Line: %ld Pos: %ld"), Y, X );
        if (textctrl -> IsModified() ) sTmp = sTmp + wxT(" * ");
        if (sTmp != sStatusText)
        {
            sStatusText = sTmp;
            frame -> SetStatusText ( sTmp, 0 );
        }

}

wxString TextChild::GetLineText(int i)
{
    return textctrl -> GetLineText (i) ;
}

bool TextChild::SaveFile (const wxString & sFile)
    {
    bool bResult = textctrl -> SaveFile (sFile) ;
    DoShowTextPosition ();
	return bResult ;
    } 


