//wxHatch CVS $Id: tooldlg.cpp,v 1.6 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
//A wxHatch file Copyright Chris Elliott and the University of York 2001

#ifdef __GNUG__
#pragma implementation
#pragma interface
#endif

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#endif

#include <wx/dialog.h>
#include <wx/button.h>
#include <wx/checkbox.h>
#include <wx/config.h>
#include "tooldlg.h"
#include "projdefs.h"

BEGIN_EVENT_TABLE(MyToolDialog, wxDialog)
EVT_BUTTON(-1, MyToolDialog::OnButton)
END_EVENT_TABLE()

// ----------------------------------------------------------------------------
// MyToolDialog
// ----------------------------------------------------------------------------

MyToolDialog::MyToolDialog(wxWindow *parent,
    const wxString & myFirstLabel, const wxString & myFirstName,
    const wxString & mySecondLabel, const wxString & mySecondName,
    const wxString & myCaption,
const wxString & myCaptionText, const wxString & myCommandText,  long WXUNUSED(myStyle))
: wxDialog(parent, -1, myCaption, wxDefaultPosition, wxDefaultSize,
wxDEFAULT_DIALOG_STYLE | wxRESIZE_BORDER )

{
    boxName = myCaption ;
    sName1 = myFirstName ;
    sName2 = mySecondName ;
    iLen = myCaptionText.Len () ;

    const int nHistory = 8 ;
    wxConfig *pConfig = new wxConfig(wxT("wxHatch"));
    pConfig->SetPath(wxT("/dialog/")+sName1) ;

    myCaptionComboBox   = new wxComboBox   ( this, -1, wxEmptyString, wxDefaultPosition, wxDefaultSize,
        0, NULL, wxCB_DROPDOWN );
    // fill up the combo box
    if (!myCaptionText.IsEmpty()) myCaptionComboBox -> Append (myCaptionText);

    size_t i = 0;
    wxString sTmp, sRead ;
    sTmp.Printf (wxT("%d"),i);
    while ( ((int)i < nHistory) && ( pConfig->Read (sTmp, &sRead) ))
    {
        if (!sRead.IsEmpty() && (myCaptionComboBox->FindString (sRead) == wxNOT_FOUND)) myCaptionComboBox -> Append (sRead) ;
        i ++ ;
        sTmp.Printf (wxT("%d"),i);
    }

    pConfig->SetPath(wxT("/dialog/")+sName2) ;

    myCommandComboBox   = new wxComboBox   ( this, -1, wxEmptyString, wxDefaultPosition, wxDefaultSize,
        0, NULL, wxCB_DROPDOWN );
    // fill up the combo box
    if (!myCommandText.IsEmpty()) myCommandComboBox -> Append (myCommandText.BeforeFirst(wxT('%')));

    i = 0;

    sTmp.Printf (wxT("%d"),i);
    while ( ((int)i < nHistory) && ( pConfig->Read (sTmp, &sRead) ))
    {
        if (!sRead.IsEmpty() && (myCommandComboBox->FindString (sRead) == wxNOT_FOUND)) myCommandComboBox -> Append (sRead) ;
        i ++ ;
        sTmp.Printf (wxT("%d"),i);
    }

    pConfig -> Flush (FALSE);
    delete pConfig ;
    pConfig = NULL ;

//myParameterBox
    myParameterBox   = new wxComboBox   ( this, -1, wxEmptyString, wxDefaultPosition, wxDefaultSize,
        0, NULL, wxCB_READONLY );
    // fill up the combo box
    myParameterBox -> Append (wxT("no parameters"));
    myParameterBox -> Append (wxT("project directory"));
    myParameterBox -> Append (wxT("project name"));
    myParameterBox -> Append (wxT("current code file"));
    myParameterBox -> Append (wxT("executable file"));
    myParameterBox -> Append (wxT("wxWidgets directory"));

    myParameterBox -> SetSelection (0);
    if (myCommandText.Contains(wxT("%d"))) myParameterBox -> SetSelection (1);
    if (myCommandText.Contains(wxT("%n"))) myParameterBox -> SetSelection (2);
    if (myCommandText.Contains(wxT("%f"))) myParameterBox -> SetSelection (3);
    if (myCommandText.Contains(wxT("%e"))) myParameterBox -> SetSelection (4);
    if (myCommandText.Contains(wxT("%w"))) myParameterBox -> SetSelection (5);

    // now build the dialog
    wxBoxSizer *topsizer = new wxBoxSizer( wxVERTICAL  );
    myStaticText = new wxStaticText ( (wxWindow *)this, -1, myFirstLabel, wxDefaultPosition, wxDefaultSize);
    topsizer->Add(myStaticText, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    topsizer->Add(myCaptionComboBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    topsizer->Add(new wxStaticText ( (wxWindow *)this, -1, mySecondLabel, wxDefaultPosition, wxDefaultSize), 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    wxBoxSizer *mid_sizer = new wxBoxSizer( wxHORIZONTAL  );
    mid_sizer->Add(myCommandComboBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round
    mid_sizer->Add(new wxButton( this, wxh_DIR, wxT("&Browse") ), 0,  wxALL, 10 );                    // set border width to 10
    topsizer->Add(mid_sizer, 0, wxALIGN_CENTER );        // no border and centre horizontally
    
    topsizer->Add(new wxStaticText ( this, -1, wxT("with parameters"), wxDefaultPosition, wxDefaultSize), 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    topsizer->Add(myParameterBox, 1, wxEXPAND | wxALL, 10 ); //horiz stretch, border 10 all round

    topsizer->Add(CreateButtonSizer( wxOK|wxCANCEL), 0, wxCENTER|wxALL, 10); 

    SetSizerAndFit( topsizer );        // actually set the sizer
    
    myCaptionComboBox -> SetSelection ( 0 ) ;
    myCommandComboBox -> SetSelection ( 0 ) ;
}


void MyToolDialog::OnButton(wxCommandEvent& event)
{
    int id = event.GetId() ;

    if (id == wxh_DIR)
    {
        wxString sTmp = myCommandComboBox -> GetStringSelection() ;

        wxFileDialog dialog(this, wxT("Open"), wxPathOnly(sTmp), wxFileNameFromPath(sTmp),
            sPrograms + wxT( "| All Files (*.*)|*.*" )  ,
            wxOPEN);
        if (dialog.ShowModal() == wxID_OK)
        {
            myCommandComboBox -> SetValue(dialog.GetPath()) ;
        }
        return ;
    }
    if (id == wxID_OK )
    {
        int i ;
        myResult.Clear ();
        myResult.Add (myCaptionComboBox->GetValue() );
        wxString sTmp = myCommandComboBox->GetValue() ;
        switch (myParameterBox->GetSelection())
        {
        default :
        case 0: sTmp = sTmp + wxT(" "); break ;
        case 1: sTmp = sTmp + wxT(" %d"); break ;
        case 2: sTmp = sTmp + wxT(" %n"); break ;
        case 3: sTmp = sTmp + wxT(" %f"); break ;
        case 4: sTmp = sTmp + wxT(" %e"); break ;
        case 5: sTmp = sTmp + wxT(" %w"); break ;
	}
        myResult.Add ( sTmp );

        wxConfig *pConfig = new wxConfig(wxT("wxHatch"));
        pConfig->SetPath(wxT("/dialog/")+sName1) ;

        // see if the current value is already in the list and delete if so...
        int index = myCaptionComboBox->FindString (myCaptionComboBox->GetValue ());
        if (wxNOT_FOUND != index)
        {
            myCaptionComboBox->Delete(index) ;
        }
        pConfig->Write (wxT("0"), myCaptionComboBox->GetValue ()) ;
        for (i=0; i < myCaptionComboBox->GetCount(); i++)
        {
            sTmp.Printf (wxT("%d"),i+1);
            pConfig->Write (sTmp, myCaptionComboBox->GetString(i)) ;
        }
        // nw do it for replace
        pConfig->SetPath(wxT("/dialog/")+sName2) ;

        // see if the current value is already in the list and delete if so...
        index = myCommandComboBox->FindString (myCommandComboBox->GetValue ());
        if (wxNOT_FOUND != index)
        {
            myCommandComboBox->Delete(index) ;
        }
        pConfig->Write (wxT("0"), myCommandComboBox->GetValue ()) ;
        for (i=0; i < myCommandComboBox->GetCount(); i++)
        {
            sTmp.Printf (wxT("%d"),i+1);
            pConfig->Write (sTmp, myCommandComboBox->GetString(i)) ;
        }
        pConfig -> Flush (FALSE);
        delete pConfig ;
        pConfig = NULL ;
    }
    EndModal (id) ;
}


wxArrayString MyToolDialog::GetValue ()
{

    return myResult ;
}


int MyToolDialog::ShowModal ()
{
    myCaptionComboBox -> SetSelection ( 0, iLen ) ;
    myCaptionComboBox -> SetFocus ();
    return  wxDialog::ShowModal ();
}
