//wxHatch CVS $Id: trchild.cpp,v 1.24 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
// ===========================================================================
// declarations
// ===========================================================================

// ---------------------------------------------------------------------------
// headers
// ---------------------------------------------------------------------------

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
#pragma hdrstop
#endif

#ifndef WX_PRECOMP
#include "wx/wx.h"
#include "wx/mdi.h"
#endif

#include <wx/docview.h>
#include <wx/html/helpctrl.h>
#include <wx/treectrl.h>
#include <wx/listctrl.h>
#include <wx/treebase.h>



#include "projdefs.h"
#include "bitmenu.h"
#include "wx/stc/stc.h"
#include "mytext.h"
#include "tchild.h"
#include "trchild.h"
#include "dchild.h"
#include "wxhatch.h"


BEGIN_EVENT_TABLE(TreeChild, wxMDIChildFrame)
EVT_MENU(wxH_CHILD_QUIT, TreeChild::OnQuit)
EVT_ACTIVATE(TreeChild::OnActivate)
EVT_TREE_ITEM_ACTIVATED(-1, TreeChild::OnTreeBoxDClick)
EVT_CLOSE(TreeChild::OnClose)
END_EVENT_TABLE()

BEGIN_EVENT_TABLE(wxClassTreeCtrl, wxTreeCtrl)
    EVT_MENU ( wxH_GOTOFIRST_USE,   wxClassTreeCtrl::OnGotoFirst_use)
    EVT_MENU ( wxH_GOTOBODY,        wxClassTreeCtrl::OnGotoBody)
    EVT_MENU ( wxH_GOTODECLARATION, wxClassTreeCtrl::OnGotoDeclaration)
EVT_RIGHT_DOWN(wxClassTreeCtrl::OnRightDown)
END_EVENT_TABLE()



wxClassTreeCtrl::wxClassTreeCtrl(TreeChild* parent, wxWindowID id, const wxString & Caption) :
 wxTreeCtrl(parent, id, wxDefaultPosition, wxDefaultSize, wxTR_HAS_BUTTONS, wxDefaultValidator, Caption )
{
    tchild = parent ;
    Goto_menu = new wxMenu  (wxT("Goto"));
    Goto_menu -> Append ( wxH_GOTODECLARATION, wxT("&Declaration"), wxT("") );
    Goto_menu -> Append ( wxH_GOTOBODY, wxT("&Body"), wxT("") );
    Goto_menu -> Append ( wxH_GOTOFIRST_USE, wxT("&Find first"), wxT("") );
}

wxClassTreeCtrl::~wxClassTreeCtrl()
{
    delete Goto_menu ;
}

void wxClassTreeCtrl::OnRightDown(wxMouseEvent & event )
{
    //no popups on root item
    wxTreeItemId ClassID = GetSelection();
   	if ( ClassID == GetRootItem() ) return ;
    wxTreeItemId ParentID = GetItemParent(ClassID);
	if ( ParentID == GetRootItem() ) return ;

    // no popups on empty seletions please	
    wxString sClass = GetItemText(ClassID);
    if (sClass.IsEmpty()) return ;
    Goto_menu->SetTitle(wxT( "Go " ) + sClass.BeforeFirst(wxT('(') ) + wxT( " code for:" )  );
    PopupMenu (Goto_menu, event.GetPosition());
}


void wxClassTreeCtrl::OnGotoDeclaration (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
    tchild->OnGotoDeclaration();
}


void wxClassTreeCtrl::OnGotoBody (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
    tchild -> OnGotoBody() ;
}


void wxClassTreeCtrl::OnGotoFirst_use (wxCommandEvent & WXUNUSED(event)) 
{
    //Respond to menu here 
    tchild->OnGotoFirst_use();
}

// ---------------------------------------------------------------------------
// TreeChild
// ---------------------------------------------------------------------------

TreeChild::TreeChild(wxMDIParentFrame *parent, const wxString& title,
const wxPoint& pos, const wxSize& size,
const long style)
: wxMDIChildFrame(parent, -1, title, pos, size, style)
{

    frame = (MyFrame *) parent ;

    TreeBox = new wxClassTreeCtrl (this, -1, wxT("Tree Box"));
    TreeBox -> SetSize (800,600);
    //TreeBox ->  SetFont (frame->myFont);
    //MemberList = new TTreeDataList ;
    DoActivate();
	frame -> SetStatusText (wxT( "Class list Built" ), 1) ;
}


TreeChild::~TreeChild()
{
    //    frame -> my_children.DeleteObject(this);
    //MemberList -> DeleteContents (TRUE) ;
    //delete MemberList ;
}


void TreeChild::OnQuit(wxCommandEvent& WXUNUSED(event))
{
    Close(TRUE);
}




void TreeChild::OnActivate(wxActivateEvent& event)
{
    if ( event.GetActive() )
    {
        bool bNeedsActivate = FALSE;
        TTextChildList::Node *node = frame ->textWinList->GetFirst();
        while (node && ! bNeedsActivate)
        {
            TextChild * tc = node->GetData() ;
            if (tc  -> bIsPartOfProject  && tc -> textctrl -> bHasNewClass)  bNeedsActivate = TRUE ;
			node = node->GetNext();
        }
        if (bNeedsActivate) 
        {
            DoActivate() ;
            frame -> SetStatusText (wxT( "Class list rebuilt" ), 1 ) ;
        }
        else     
        {
            frame -> SetStatusText (wxT( "Class list reused" ), 1) ;
        } 
    }
}

void TreeChild::DoActivate()
{
const wxString strClass = wxT("class");
const wxString strDLL = wxT("WXDLLEXPORT");
wxArrayString ClassArray, ExpandedArray ;
long myCookie = 123 ;

    if (TreeRootId.IsOk())
    {
        wxTreeItemId ClassID = TreeBox -> GetFirstChild(TreeRootId, myCookie);
        while (ClassID.IsOk())
        {
            if (TreeBox->IsExpanded(ClassID))
            {
                wxString sTmp = TreeBox->GetItemText(ClassID);
                ExpandedArray.Add(sTmp);
            }
            ClassID = TreeBox -> GetNextSibling(ClassID);
        }
    }
    TreeBox ->  DeleteAllItems ();
    TreeRootId = TreeBox->AddRoot(frame -> sName + wxT(" Class List"));
    ClassArray.Clear();
    TTextChildList::Node *node = frame ->textWinList->GetFirst();
    while (node)
        {
        TextChild * tc = node->GetData() ;
        if (tc  -> bIsPartOfProject )
        {
            long iLine = 0;
            iLine = frame->DoFindLine ( strClass, iLine, tc );
            while ( iLine != wxNOT_FOUND )
            {
                wxString sLine = tc -> textctrl -> GetLineText (iLine-1);
                sLine.Trim(TRUE).Trim(FALSE);

                //ignore possible filenames containg the word class
                if (!sLine.Contains(wxT('"')) && !sLine.Contains(wxT('<')))
                {
                    //TreeBox->Append(sLine);
                    //class MyFrame : wxFrame
                    //class MyUnderivedClass {
                    //class MyOtherClas //comment etc etc
                    
                    wxString sClass = sLine.Mid(sLine.Find(strClass) + strClass.Len());
					if (sClass.Contains(strDLL) ) sClass = sLine.Mid(sLine.Find(strDLL) + strDLL.Len());
                    sClass.Trim(TRUE).Trim(FALSE);
                    
                    sClass = sClass.BeforeFirst(wxT(':')) ;
                    sClass = sClass.BeforeFirst(wxT(';')) ;
                    sClass = sClass.BeforeFirst(wxT('{')) ;
                    sClass = sClass.BeforeFirst(wxT(' ')) ;
                    sClass = sClass.BeforeFirst(wxT('/')) ;
                                        
                    if (sClass.Len() > 1)
                    {
                        if ( ClassArray.Index(sClass) == wxNOT_FOUND )
                        {
                            ClassArray.Add(sClass) ;
                            wxTreeItemId CurrentId = TreeBox->AppendItem(TreeRootId, sClass);
                            BuildClassList (CurrentId, sClass);
							TreeBox->SortChildren(CurrentId) ;
                            if (ExpandedArray.Index(sClass) != wxNOT_FOUND) TreeBox->Expand(CurrentId);
                        }
                    }
                } // end of if
                iLine = frame->DoFindLine ( strClass, iLine, tc );
            } // end of while
			tc -> textctrl -> bHasNewClass = FALSE ;
        }
        node = node->GetNext();
        } // end of while
    TreeBox->SortChildren(TreeRootId) ;
    TreeBox->Expand(TreeRootId);
    TreeBox->SetFocus();
    
}

void TreeChild::BuildClassList(wxTreeItemId myID, const wxString & myClass)
{
    
TTextChildList::Node *node ;

    node = frame ->textWinList->GetFirst();
    while (node)
        {
        TextChild * tc = node->GetData() ;
        if (tc  -> bIsPartOfProject )
        {
            long iLine = 0;
            iLine = frame->DoFindLine ( myClass + wxT("::"), iLine, tc );
            while ( iLine != wxNOT_FOUND )
            {
                wxString sLine = tc -> textctrl -> GetLineText (iLine-1);
                sLine.Trim(TRUE).Trim(FALSE);
                //also finds EVT_ macros with ::
                if (sLine.Find(wxT(':')) < sLine.Find(wxT('(')))
                    {
                    wxString sInfo = sLine.AfterFirst(wxT(':')).AfterFirst(wxT(':')) ;
                    TreeBox->AppendItem (myID, sInfo) ;
      //              TTreeData * td  = new TTreeData (tc->filename, sLine, iLine -1 );
      //              MemberList -> Append (td);
                    }
                iLine = frame->DoFindLine ( myClass + wxT("::"), iLine, tc );
            } // end of while
        }
        node = node->GetNext();
        } // end of while
       

}






void TreeChild::OnClose(wxCloseEvent& event)
{
    if (this == frame -> pTreeWin) frame -> pTreeWin = NULL ;
    event.Skip();

}


void TreeChild::OnTreeBoxDClick(wxTreeEvent & event)
{
    OnGotoBody();
    event.Skip();
}


void TreeChild::OnGotoBody()
{
    wxTreeItemId ClassID = TreeBox->GetSelection();
    wxTreeItemId ParentID = TreeBox->GetItemParent(ClassID);
	if ( ParentID == TreeBox->GetRootItem() ) return ;
    
    wxString sParent = TreeBox->GetItemText(ParentID) ; 
    wxString sClass = TreeBox->GetItemText(ClassID);
     
    TextChild * pChild = NULL ;
    wxString sSearch = sParent + wxT("::") + sClass ;
    long iLine = wxNOT_FOUND ;
    TTextChildList::Node *node = frame ->textWinList->GetFirst();
    while (node && iLine == wxNOT_FOUND)
        {
        pChild = node->GetData() ;
        if (pChild  -> bIsPartOfProject )
            {
            iLine = frame->DoFindLine ( sSearch, 0, pChild );
            }
        node = node->GetNext();
     }
    if (iLine != wxNOT_FOUND)
    {
        int iPos = frame -> DoShowLine ( pChild, iLine-1 );
        pChild -> textctrl -> SetSelection ( iPos, iPos + pChild -> textctrl -> GetLine (iLine-1).Len() );
        pChild -> Activate() ;
    }

       
}

void TreeChild::OnGotoDeclaration ()  
{
    wxTreeItemId ClassID = TreeBox->GetSelection();
    wxTreeItemId ParentID = TreeBox->GetItemParent(ClassID);
	if ( ParentID == TreeBox->GetRootItem() ) return ;
    
    wxString sParent = TreeBox->GetItemText(ParentID) ; 
    wxString sClass = TreeBox->GetItemText(ClassID);
	sClass = sClass.BeforeFirst(wxT('(') ) ;
    sClass.Trim(TRUE).Trim(FALSE);
	
	long iLine = wxNOT_FOUND ;
    TextChild * pChild = NULL ;
    wxString sSearch =  wxT("class") + sParent ;
    
    TTextChildList::Node *node = frame ->textWinList->GetFirst();
    while (node && iLine == wxNOT_FOUND)
        {
        pChild = node->GetData() ;
        if (pChild  -> bIsPartOfProject )
            {
            iLine = frame->DoFindLine ( sSearch, 0, pChild );
			//test for forward declarations?
			wxString sLine = pChild -> textctrl -> GetLineText (iLine-1);
			if ( sLine.Contains(wxT(";")) ) iLine = frame->DoFindLine ( sSearch, iLine, pChild ); 
            }
        node = node->GetNext();
     }
     
    if (iLine != wxNOT_FOUND)
    {
        iLine = frame->DoFindLine ( sClass, iLine, pChild );
        if (iLine != wxNOT_FOUND)
        {
            int iPos = frame -> DoShowLine ( pChild, iLine-1 );
            pChild -> textctrl -> SetSelection ( iPos, iPos + pChild -> textctrl -> GetLine (iLine-1).Len() );
            pChild -> Activate() ;
        }
    else
    {
        frame -> SetStatusText (sParent + wxT(" class member declaration of ") + sClass + wxT(" Not Found"), 1);
    }
    }
    else frame -> SetStatusText (sSearch + wxT(" Not Found"), 1);  
} 
    
void TreeChild::OnGotoFirst_use ()
{
    wxTreeItemId ClassID = TreeBox->GetSelection();
    wxTreeItemId ParentID = TreeBox->GetItemParent(ClassID);
	if ( ParentID == TreeBox->GetRootItem() ) return ;
    
    wxString sParent = TreeBox->GetItemText(ParentID) ; 
    wxString sClass = TreeBox->GetItemText(ClassID);
	sClass = sClass.BeforeFirst(wxT('(') ) ;
	sClass.Trim(TRUE).Trim(FALSE);
     
    TextChild * pChild = NULL ;
    wxString sSearch = sParent + wxT("::") + sClass ;
    long iLine = wxNOT_FOUND ;
    TTextChildList::Node *node = frame ->textWinList->GetFirst();
    while (node && iLine == wxNOT_FOUND)
        {
        pChild = node->GetData() ;
        if (pChild  -> bIsPartOfProject )
            {
            iLine = frame->DoFindLine ( sSearch, 0, pChild );
            }
        node = node->GetNext();
    }     
    if (iLine != wxNOT_FOUND)
    {
        frame->sFind = sClass;
		frame->bLastSearchCS=FALSE;
        frame->iCurrent = frame->DoFindExactly (frame->sFind, 0, pChild, frame->bLastSearchCS);
        if ( frame->iCurrent != wxNOT_FOUND)
        {
			//so we search onwards correctly
			frame->iCurrent ++ ;
        
        pChild -> Activate() ;
        frame -> SetStatusText (wxT("press Ctrl + Shift + F or F3 to search again") ,1);
        }
    }
    else frame -> SetStatusText (sSearch + wxT(" Not Found"), 1);  

}


