
//wxHatch CVS $Id: trchild.h,v 1.13 2004/03/20 09:36:16 biol75 Exp $

//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
#ifndef _trchild_h
#define _trchild_h


#include <wx/treebase.h>

enum
{
    // menu IDs these two are needed by wxHatch 
    wxH_GOTODECLARATION,
    wxH_GOTOBODY,
    wxH_GOTOFIRST_USE
   
};


class TTreeData
{
    public :
    wxString FileName, sLine ;
    long iLine ;
    TTreeData ( const wxString & f,  const wxString & s, int i )
    {
        FileName = f ;
        sLine = s;
        iLine = i ;
    };
};

WX_DECLARE_LIST(TTreeData, TTreeDataList);

class TreeChild ;

class wxClassTreeCtrl: public wxTreeCtrl
{
    public:
    wxMenu * Goto_menu ;
    TreeChild * tchild ;
    
    wxClassTreeCtrl(TreeChild* parent, wxWindowID id, const wxString & Caption) ;
	~wxClassTreeCtrl ();
    void OnRightDown(wxMouseEvent & event );
    void OnGotoDeclaration (wxCommandEvent & event);
    void OnGotoBody (wxCommandEvent & event);
    void OnGotoFirst_use (wxCommandEvent & event);
    
    
    DECLARE_EVENT_TABLE()
    } ;

class TreeChild: public wxMDIChildFrame
{
    public:

        MyFrame *frame;

        wxTreeCtrl * TreeBox;
//        wxArrayString ClassArray ;
//        TTreeDataList * MemberList ;
        wxTreeItemId TreeRootId  ;

        TreeChild(wxMDIParentFrame *parent, const wxString& title, const wxPoint& pos,
        const wxSize& size, const long style);
        ~TreeChild();

        void OnActivate(wxActivateEvent& event);
        void DoActivate ();
        void BuildClassList(wxTreeItemId myId, const wxString & myString);
        void OnQuit(wxCommandEvent& event);

        void OnClose(wxCloseEvent& event);
        void OnTreeBoxDClick(wxTreeEvent& event) ;
        void OnGotoDeclaration ();
        void OnGotoBody  ();
        void OnGotoFirst_use  ();
        
        DECLARE_EVENT_TABLE()
};
#endif
