//wxHatch CVS $Id: wxhatch.h,v 1.63 2004/05/04 08:03:29 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
#ifndef _project_h
#define _project_h


// Define a new application
class MyApp : public wxApp
{
    public:
        bool OnInit();
		wxString FindSupportDir (const wxString & sStart);
		wxString DoFindSupportDir (const wxString & sStart, const wxString & sSubDir);
};



WX_DECLARE_LIST(TextChild, TTextChildList);
//WX_DEFINE_ARRAY(int, wxMyArrayInts);

// Define a new frame
class MyFrame : public wxMDIParentFrame
{
    public:

        MyFrame(wxWindow *parent, const wxWindowID id, const wxString& title,
            const wxPoint& pos, const wxSize& size, const long style);

        long nFrames, iCurrent, iCompiler;
        int iAutoTexts ;
        projectstyle eLastMode ;
        wxString sImage, sEdit, sFind, sReplace, sExeRoot, sProjectRoot, sProjectDir,
			sAutoTextFile, sClassName, sName, sWXWIN, shPath, sStartPath, 
			sTextImage ;

        
        bool bProjectLoaded, bPreLoad, bAlreadyWarning, bLastSearchFS, bLastSearchCS, bSetEnv, bCanUseConfigure ;
        
        wxArrayString sAutoTexts, SurroundBeforeStrings, SurroundAfterStrings, saTools, DisableArrays,
            compilerStrings, Platforms, Make24FileEndings, Make25FileEndings, MakeIncludes, MakeTargetNames,
            ObjectEndings, makeProgStrings, make24ParamStrings, make25ParamStrings, debugStrings, sWxDirStrings, sExtraLibs, 
            s24ExtraLibPattern, s25ExtraLibPattern, sLibNames, sLibIncludes,
            sControlNames, sConstructors, sGetValues, sSetValues, sControlIncludes, sEvents,
            Paths ;
        
        wxArrayInt DisableIndexes, iReusePaths ;
        wxTimer myFrameTimer ;
        
        
        TextChild * pMain_h, * pMain_cpp, * pCanv_h, * pCanv_cpp, *pInc;
        ListChild * pOutputWin ;
        MyChild * pMenuChild ;
        TreeChild * pTreeWin ;
        dlgChild * pDlgWin ;
        wxHtmlHelpController * pHTMLHelpFrame ;
        wxConfig *pConfig ;

        TTextChildList * textWinList ;
	
        wxFont myFont  ;
        wxColour myFontColour ;
        wxFileHistory * lastFiles ;

        wxHtmlEasyPrinting * m_Prn ;

        ~MyFrame () ;
        void InitToolBar(wxToolBar* toolBar);

        void OnSize(wxSizeEvent& event);
        void OnAbout(wxCommandEvent& event);
        void OnAnymenuOpen (wxMenuEvent & event) ;
        void DoAnymenuOpen () ;

        void OnNewProject(wxCommandEvent& event );
        void DoNewProject (const wxString & sDest);
        void DoNewProject (const wxString & sDest, projectstyle eMode);
        void OnReOpenProject(wxCommandEvent& event );
        void OnOpenTextWindow (wxCommandEvent& event) ;
        void DoReOpenProject(const wxString & s );
        void OnMRUFile(wxCommandEvent& event) ;
        void OnNewTextWindow(wxCommandEvent& event);
        TextChild * DoNewTextWindow(const wxString & sPath, bool bAddToProject, bool bUseControlsMenu = FALSE ) ;
        ListChild * DoNewListWindow()  ;
        MyChild * DoNewMenuWindow();
        void DoLoadMenuWindow () ;
        TreeChild * DoNewTreeWindow()  ;
        dlgChild * DoNewDlgWindow(TextChild * pChild) ;
        void OnProjectCopy (wxCommandEvent& event) ;

        void OnNewMenuWindow(wxCommandEvent& event);
        void OnSwitchWindow (wxCommandEvent & event);
        void OnAllowSwitchWindow  (wxUpdateUIEvent & event);
        void OnQuit(wxCommandEvent& event);

        void OnAllowNewProject  (wxUpdateUIEvent & event) ;

        void OnEdit(wxCommandEvent& event);
        void OnClose(wxCloseEvent& event);
        void OnFileBackup (wxCommandEvent & event );
        void OnSaveProject (wxCommandEvent & event );
        bool DoSaveProject ();
        bool SaveProjectFile (TextChild * pChild) ;
        void OnChildClose (wxCommandEvent & event) ;
        void OnProjectClose (wxCommandEvent & event) ;
        bool DoCloseProject () ;

        void OnUpdateFileBackup   (wxUpdateUIEvent & event) ;
        void OnUpdateProjectSave  (wxUpdateUIEvent & event) ;
        void OnUpdateCopy (wxUpdateUIEvent & event);
        void OnUpdatePaste (wxUpdateUIEvent & event);
        void OnUpdateUndo (wxUpdateUIEvent & event);
        void OnUpdateRedo (wxUpdateUIEvent & event);
        void OnUpdateFindmenu (wxUpdateUIEvent & event);
        void OnUpdateDlgmenu (wxUpdateUIEvent & event);
        void OnUpdateCompile (wxUpdateUIEvent & event);
        void OnUpdateRun (wxUpdateUIEvent & event);
        void OnUpdateDebug(wxUpdateUIEvent & event);
        void OnUpdateRebuild(wxUpdateUIEvent & event) ;
        void OnUpdateConfigure(wxUpdateUIEvent & event) ;

        void OnUpdatePopup (wxUpdateUIEvent & event);
        void OnUpdateAdd_Item (wxUpdateUIEvent & event);
        void OnUpdateSeparator (wxUpdateUIEvent & event) ;

        void OnTextImageEdit (wxCommandEvent & event) ;
        void OnUpdateTextImageEdit (wxUpdateUIEvent & event) ;

        void OnUpdateNextErr (wxUpdateUIEvent & event) ;
        void OnNextErr (wxCommandEvent & event );
        
        void OnCopy (wxCommandEvent & event );
        void OnCut (wxCommandEvent & event );
        void OnPaste (wxCommandEvent & event );
        void OnRedo (wxCommandEvent & event );
        void OnUndo (wxCommandEvent & event );
        void OnAutoText (wxCommandEvent & event );
        void OnAddAutoText (wxCommandEvent & event );
		void DoAddAutoText (const wxString & sAbbr, const wxString & sExpand );

        void OnFind (wxCommandEvent & event);
        void OnFindagain (wxCommandEvent & event);
        void OnReplace (wxCommandEvent & event);
        void OnReplaceAgain (wxCommandEvent & event);
        void OnSelBrace(wxCommandEvent & event) ;
        void OnIndentThisBrace (wxCommandEvent & event);
        void OnUpdateSelBrace (wxUpdateUIEvent & event) ;

        void OnUpdateFind (wxUpdateUIEvent & event) ;

        void OnFindMenu (wxCommandEvent & event );
        void OnFindTree (wxCommandEvent & event );
        void OnFindDlg (wxCommandEvent & event );
        void OnChangeFont(wxCommandEvent& event);
        void OnChangeImageEditor(wxCommandEvent& event);
        void OnChangeEditor   (wxCommandEvent& event);
        void OnChangeCompiler (wxCommandEvent& event);
        void OnChangeProjectRoot (wxCommandEvent& event);
        void OnChangeWxHatchRoot (wxCommandEvent& event);
        wxString SelectLibrary () ;
        wxString SelectwxWinSource ();
        void OnChangeWxWinDir (wxCommandEvent& event) ;
		void OnAddPath (wxCommandEvent& event) ;

        void OnTogglePreload (wxCommandEvent & event) ;
        void OnUpdatePreLoad (wxUpdateUIEvent & event) ;

        void OnAddMenu (wxCommandEvent& event) ;
        bool DoAddMenu (bool bIsPopup) ;
        void OnAddPopup (wxCommandEvent& event) ;
        void OnAdd_Item (wxCommandEvent& event) ;
        void OnSeparator (wxCommandEvent& event) ;
        void OnRenameitem (wxCommandEvent& event) ;
        void OnAddfilemenu (wxCommandEvent& event) ;
        void OnAddfileprintmenu (wxCommandEvent& event) ;
        void OnAddeditmenu (wxCommandEvent& event) ;
        void OnAddHelpmenu (wxCommandEvent & event);

        void OnCompile (wxCommandEvent & event) ;
        bool Is25() ;
        void GetObjects (wxString * sObjList, wxString * sLibList, bool bIs25) ;
        wxString GetMakeFileName (const wxString & sDir, bool bNeedIn);
        wxString GetMakeCommand ();
        bool GenerateMakefile ();
        bool Generate24Makefile ();
        bool Generate25Makefile ();

        bool LoadMakeCmds (const wxString & sCmds) ;

        void OnMoveup (wxCommandEvent & event);
        void OnMovedown (wxCommandEvent & event);
        void OnMoveL (wxCommandEvent & event);
        void OnMoveR (wxCommandEvent & event);
        
        void OnMenuL (wxCommandEvent & event);
        void OnMenuR (wxCommandEvent & event);
        void OnMenuDel (wxCommandEvent & event);
        
        void OnAddToToolbar (wxCommandEvent & event);

        void OnDelete (wxCommandEvent & event);
        void OnGobody (wxCommandEvent & event);
        int DoGobody ();
        void OnGodec (wxCommandEvent & event);
        int DoGodec  ();
        void OnGoevt (wxCommandEvent & event);
        int DoGoevt  ();
        void OnGoenable (wxCommandEvent & event);
        int DoGoenable ();
        void OnGoId (wxCommandEvent & event);
        int DoGoId ();
        void OnGoMnu (wxCommandEvent & event);
        int DoGoMnu (TBitmapMenu * current = NULL);
        int DoFindmenuBarLine ( TBitmapMenu * pBM );

        void OnAnyDialog (wxCommandEvent & event);
//        void OnUpdateAnyDialog(wxUpdateUIEvent & event);        
        void wxHSetEnv (const wxString & cmd) ;
        void GetShPath () ;
        void OnAnyTool(wxCommandEvent & event);
        void OnUpdateAnyTool(wxUpdateUIEvent & event);

        void OnToolConfigure(wxCommandEvent & event);
        void OnToolAdd(wxCommandEvent & event);
        void OnUpdateToolConfigure (wxUpdateUIEvent & event) ;
        
        void OnGoFDec (wxCommandEvent & event) ;
        void OnGoFCons (wxCommandEvent & event) ;
        void OnGoFDes (wxCommandEvent & event) ;
        int  DoGoFDes () ;
        void OnGoFSize (wxCommandEvent & event) ;
        void OnGoFClose (wxCommandEvent & event) ;
        void OnGoFNoGUI (wxCommandEvent& event) ;

        void OnTBMveright (wxCommandEvent & event) ;
        void OnTBMveleft (wxCommandEvent & event) ;
        void OnTBDel (wxCommandEvent & event) ;
        void OnTBSep (wxCommandEvent & event) ;
        void OnTBChange (wxCommandEvent & event) ;
        void OnTBEdit (wxCommandEvent & event) ;
        void OnTBChangetext (wxCommandEvent & event) ;
        void OnTBGocode (wxCommandEvent & event ) ;
        void OnTBGoBody (wxCommandEvent & event) ;
        void OnTBGoenable (wxCommandEvent & event);
        void OnUpdateToolMove (wxUpdateUIEvent & event) ;
        void OnUpdateToolbar  (wxUpdateUIEvent & event) ;
        void OnUpdateGoToolbarCode (wxUpdateUIEvent & event) ;
        void OnGoCDec (wxCommandEvent & event) ;
        void OnGoCCons (wxCommandEvent & event) ;
        void OnGoCDes (wxCommandEvent & event) ;
        int  DoGoEvent (const wxString & myclassstring, 
                const wxString & mymethodstring, 
                const wxString & myeventstring,
                const wxString & mytablestring) ;
        void OnGoOnDraw (wxCommandEvent & event) ;
        void OnGoLClick (wxCommandEvent & event) ;
        void OnGoLClickUp (wxCommandEvent & event) ;
        void OnGoRClick (wxCommandEvent & event) ;
        void OnGoLdblClick (wxCommandEvent & event) ;
        void OnGoMsemove (wxCommandEvent & event) ;
        void OnGoCNoGUI (wxCommandEvent& event) ;
        void OnUpdateGoCNoGUI (wxUpdateUIEvent & event) ;

        void OnChange_icon (wxCommandEvent & event);
        void OnEdit_icon (wxCommandEvent & event);
        void OnGoline   (wxCommandEvent & event) ;

        void OnTimer(wxTimerEvent& event) ;

        void OnHelp(wxCommandEvent& event) ;
        void OnSearchHelp(wxCommandEvent& event) ;
        bool LoadHelp ( bool bUsewxWin = FALSE, bool bShowWaitMsg = TRUE ) ;

        void CreateBaseMenu (wxMenu * my_menu);
        void CreatePrefsMenu (wxMenu * my_menu);
        void CreateToolsMenu (wxMenu * my_menu, bool bAllowConfigure = FALSE );
        void CreateEditMenu (wxMenu * my_menu);
        void CreateHelpMenu (wxMenu * my_menu);
        void CreateMenuMenu (wxMenu * my_menu);
        void CreateRunMenu (wxMenu * my_menu);
        void CreateCtrlMenu (wxMenu * my_menu, dlgChild * pDlgChild);
        void CreateDlgMenu (wxMenu * my_menu, int iBegin, const wxString & sFile);
        void CreateCodeMenu (wxMenu * my_menu, int iBegin, const wxString & sFile);
        void CreateFileMenu (wxMenu * my_menu) ;
        void InsertOwnDialog (wxCommandEvent& WXUNUSED(event)) ;

        void DoCode (const wxString & sText, const wxString & sFile) ;

                                 // line to add menuto or -1
        void DoMenuText (TBitmapMenu * pBM, const long iInsertionLine ) ;
        void DoMenuBarText (TBitmapMenu * pBM) ;
        void DoSepText (const wxString & sBaseText, const int iInsertionLine) ;

        wxString RemoveLine ( int iLine, mywxTextCtrl * pTC ) ;
        wxString RemoveLine ( int iLine , TextChild * pChild ) ;
        void WriteLine ( mywxTextCtrl * pTC, int iLine , const wxString & s  ) ;
        void WriteLine ( TextChild * pChild, int iLine , const wxString & s  ) ;
        void AppendText ( TextChild * pChild,  const wxString & s  ) ;
        void AppendText ( mywxTextCtrl * pTC,  const wxString & s  ) ;

        wxString GetSelectedText() ;

        long DoShowLine (TextChild * pChild, int iLine) ;
        long DoShowLine (mywxTextCtrl * tc, int iLine) ;
        long DoFindLine (const wxString & s, int iStart, TextChild * pChild, bool bShowErrorText = TRUE) ;
		long DoFindLineBetween (const wxString &  s, int iStart, int iEnd, TextChild * pChild, bool bShowErrorText = TRUE) ;
        long DoReverseFindLine (const wxString &  s, int iStart, TextChild * pChild, bool bShowErrorText = TRUE) ;
		long DoReverseFindLineBetween (const wxString &  s, int iStart, int iEnd, TextChild * pChild, bool bShowErrorText = TRUE) ;

//        long DoFindExactly (const wxString & s, long iStart, TextChild * pChild) ;
        void DoItemFind(const wxString & sMenuName, const wxString & sLabel, int iStart, int iEnd, TextChild * pChild ) ;
        long DoFindExactly (const wxString & s, long iStart, TextChild * pChild, bool bCaseSensitive = TRUE) ;
//        void DoItemFind(const wxString & sMenuName, const wxString & sLabel, int iStart ) ;

//        long DoReplaceLine (const wxString & s, const wxString & r, long iStart, TextChild * pChild) ;
        long DoReplaceExactText (const wxString & s, const wxString & r, long iStart, TextChild * pChild) ;

        void FindError ( const wxString & sFilename, const int lineno,
            const wxString  & errorMessage )    ;
            
        void CheckXPM ( const wxString & sFile ) ;		
        wxString GetBitmap (const wxString & sIn) ;
//        void ModifyIndexHtml ();
        void ChangeMenus ( );
        void DoChangeMenus ( wxFrame * pFrame );

        
        void OnPrintSetup(wxCommandEvent& WXUNUSED(event));
        void OnPageSetup(wxCommandEvent& WXUNUSED(event));
        void OnPrint(wxCommandEvent& WXUNUSED(event));
        void OnPreview(wxCommandEvent& WXUNUSED(event));


        void OnModifySelection(wxCommandEvent& event);

        bool LoadSurrounds (const wxString & sPath) ;
        bool LoadAutoTexts (const wxString & sPath) ;
        
        void OnAddAnyCtrl (wxCommandEvent& WXUNUSED(event));
        void OnUpdateAddAnyCtrl (wxUpdateUIEvent & event) ;
        bool IsSizer (const wxString & s, TextChild * tc) ;
        void OnCtrlUp (wxCommandEvent& WXUNUSED(event));
        void OnCtrlDown (wxCommandEvent& WXUNUSED(event));
        void OnCtrlLeft (wxCommandEvent& WXUNUSED(event));
        void OnCtrlRight (wxCommandEvent& WXUNUSED(event));
        void OnUpdateCtrlMove (wxUpdateUIEvent & event);
        void OnUpdateCtrlDel  (wxUpdateUIEvent & event) ;
        void OnUpdateCtrlRen  (wxUpdateUIEvent & event) ;
         
        bool DoDlgSanityCheck (TextChild * tc, int iLevel) ;
		void OnCtrlDel(wxCommandEvent& event) ;
		void OnCtrlRen(wxCommandEvent& event) ;
        void OnCtrl_Tab_Down (wxCommandEvent& WXUNUSED(event)) ;
        void OnCtrl_Tab_Up (wxCommandEvent& WXUNUSED(event)) ;
        void OnUpdateCtrl_Tab_Down (wxUpdateUIEvent & event) ;
        void OnUpdateCtrl_Tab_Up (wxUpdateUIEvent & event) ;
        
        bool DoChildTest (const wxString & sTest, const wxString & sTestFileName) ; 

        void DoAddAnyControl (int iLine, int iD, TextChild * tc, const wxString & sControl) ; 

        DECLARE_EVENT_TABLE()
};

#if wxUSE_DRAG_AND_DROP    
class DnDFile : public wxFileDropTarget
{
	public:
		DnDFile(MyFrame *pOwner) { m_pOwner = pOwner; }
		virtual bool OnDropFiles(wxCoord x, wxCoord y, const wxArrayString& filenames);
	private:
		MyFrame *m_pOwner;

};
#endif // drag and drop
#endif
