//wxHatch CVS $Id: wxhcombo.h,v 1.3 2004/03/20 09:36:16 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001,2002
//NO WARRANTY
//Licenced under wxWidgets Licence; commercail redisrtibution forbidden
//
//wxhcombo.h

#ifndef _WX_HISTCOMBOBOX_H_
#define _WX_HISTCOMBOBOX_H_

#ifdef __GNUG__
    #pragma interface "wxhcombo.h"
#endif

#include "wx/wx.h"
#include "wx/combobox.h"

#if wxUSE_COMBOBOX


// ----------------------------------------------------------------------------
// A custom combobox with history
// ----------------------------------------------------------------------------

class wxHistoryComboBox : public wxComboBox
{        
    public:
        wxHistoryComboBox () {} ;
        
        wxHistoryComboBox(wxWindow* parent,
            wxWindowID id,
            const wxString& value = wxEmptyString,
            const wxPoint& pos = wxDefaultPosition,
            const wxSize& size = wxDefaultSize,
            int n = 0,
            const wxString choices[] = NULL,
            long style = 0,
            const wxValidator& validator = wxDefaultValidator,
            const wxString& name = wxEmptyString,
            int HistoryLimit = 8) ;
        
        bool Create(wxWindow* parent,
            wxWindowID id,
            const wxString& value = wxEmptyString,
            const wxPoint& pos = wxDefaultPosition,
            const wxSize& size = wxDefaultSize,
            int n = 0,
            const wxString choices[] = NULL,
            long style = 0,
            const wxValidator& validator = wxDefaultValidator,
            const wxString& name = wxEmptyString,
            int HistoryLimit = 8);

        ~wxHistoryComboBox();
        
        void Load (const wxString & name, int HistoryLimit);
        void Save () ;

    private:
        wxString m_ConfigPath ;

DECLARE_DYNAMIC_CLASS(wxHistoryComboBox)

};

#endif  // wxUSE_COMBOBOX
#endif  //_WX_HISTCOMBOBOX_H_
