//wxHatch CVS $Id: wxhatch.cpp,v 1.217 2004/05/27 14:18:53 biol75 Exp $
//part of the wxhatch project; copyright Chris Elliott
//and the University of York 2001
//NO WARRANTY
//Licenced under wxWidgets Licence; commercial redistribution forbidden
//
#ifdef __BIDE__
    #define _NO_VCL
    #include "condefs.h"
    USEUNIT("tchild.cpp");
    USEUNIT("dchild.cpp");
USEUNIT("trchild.cpp");
USEUNIT("lchild.cpp");
USEUNIT("mchild.cpp");
USEUNIT("mcanvas.cpp");
USEUNIT("textdlg.cpp");
USEUNIT("startdlg.cpp");
USEUNIT("srdlg.cpp");
USEUNIT("raddlg.cpp");
USEUNIT("mytext.cpp");
USERC("wxhatch.rc");
USEUNIT("bitmenu.cpp");
//---------------------------------------------------------------------------
#define WinMain WinMain
#endif

//#define __WXHSUPPORTTEST__

// ===========================================================================
// declarations
// ===========================================================================

// ---------------------------------------------------------------------------
// headers
// ---------------------------------------------------------------------------

// For compilers that support precompilation, includes "wx/wx.h".
#include "wx/wxprec.h"

#ifdef __BORLANDC__
    #pragma hdrstop
#endif

#ifndef WX_PRECOMP
    #include "wx/wx.h"
    #include "wx/mdi.h"
#endif
#include "rebldlg.h"

#include <wx/toolbar.h>
#include <wx/image.h>
#include <wx/file.h>
#include <wx/dir.h>
#include <wx/splash.h>
#include <wx/docview.h>
#include <wx/config.h>

#include <wx/textfile.h>
#include <wx/cmdline.h>
#include <wx/fontdlg.h>
#include <wx/filename.h>
#include <wx/busyinfo.h>
#include <wx/mimetype.h>
#include <wx/html/helpctrl.h>
#include <wx/tokenzr.h>
#include <wx/dnd.h>
#include <wx/treectrl.h>
#include <wx/listctrl.h>
#include <wx/imaglist.h>
#include <wx/statline.h>

#include "wx/wxhtml.h"
#include <wx/html/htmprint.h>

#include "wx/fs_zip.h"
#include <wx/fs_inet.h>
#include <wx/fs_mem.h>

#include <wx/dynarray.h>
#include <wx/fileconf.h>
//#include "wx/generic/dirdlgg.h"


#include "bitmaps/new.xpm"
#include "bitmaps/open.xpm"
#include "bitmaps/save.xpm"
#include "bitmaps/copy.xpm"
#include "bitmaps/cut.xpm"
#include "bitmaps/paste.xpm"
#include "bitmaps/find.xpm"
#include "bitmaps/menu.xpm"
#include "bitmaps/help.xpm"
#include "bitmaps/make.xpm"
#include "bitmaps/run.xpm"
#include "bitmaps/redo.xpm"
#include "bitmaps/undo.xpm"
#include "bitmaps/logo16.xpm"
#include "bitmaps/listview.xpm"

#include "bitmaps/dlg.xpm"
#include "bitmaps/blank.xpm"
#include "bitmaps/label.xpm"
#include "bitmaps/ok.xpm"

#include "projdefs.h"

#include "wxhcombo.h"
#include "bitmenu.h"
#include "mcanvas.h"
#include "wx/stc/stc.h"
#include "mytext.h"
#include "tchild.h"
#include "trchild.h"
#include "lchild.h"
#include "mchild.h"
#include "autotxtdlg.h"
#include "dchild.h"
#include "wxhatch.h"
#include "raddlg.h"
#include "textdlg.h"
#include "startdlg.h"
#include "srdlg.h"
#include "mnudlg.h"
#include "cfgdlg.h"
#include "tooldlg.h"
#include "mcdlg.h"
#include "pathcfg.h" 

//#include "hlpcontexts.h"
IMPLEMENT_APP(MyApp)

#ifdef __XXX__
bool FileInUse(const wxString & FileName)
{
//this doesn't work at all
#ifdef __WXMSW__
    // try open the file with exclusive access
    HANDLE fileHandle = CreateFile( "c:\\wxwind~1.0\\lib\\wx32d.dll",
        0,
        0,    // exclusive access does the trick
        0,    // default security attributes
        OPEN_EXISTING,
        FILE_ATTRIBUTE_NORMAL,
        0 );    // no template

    if ( fileHandle != INVALID_HANDLE_VALUE )
    {
        // opened the file, so it's not in use elsewhere AT THE MOMENT
        CloseHandle( fileHandle );

        // not in use
        return false;
    }

    // file is in use, if we have a sharing violation
    return ( GetLastError() == ERROR_SHARING_VIOLATION );
#else
return FALSE;
#endif
}
#endif

// ---------------------------------------------------------------------------
// global variables
// ---------------------------------------------------------------------------


MyFrame *frame = (MyFrame *) NULL;

// ---------------------------------------------------------------------------
// event tables
// ---------------------------------------------------------------------------

BEGIN_EVENT_TABLE(MyFrame, wxMDIParentFrame)
//Only for MSW
EVT_MENU_HIGHLIGHT_ALL(MyFrame::OnAnymenuOpen)

EVT_MENU(wxH_ABOUT, MyFrame::OnAbout)
EVT_MENU(wxH_NEW_PROJECT, MyFrame::OnNewProject)
EVT_MENU(wxH_REOPEN, MyFrame::OnReOpenProject)
EVT_MENU(wxH_NEW_TEXT_WINDOW, MyFrame::OnNewTextWindow)
EVT_MENU(wxH_OPEN_TEXT_WINDOW, MyFrame::OnOpenTextWindow)
EVT_MENU(wxH_NEW_MENU_WINDOW, MyFrame::OnNewMenuWindow)
EVT_MENU(wxH_SWITCH, MyFrame::OnSwitchWindow)
EVT_UPDATE_UI(wxH_SWITCH, MyFrame::OnAllowSwitchWindow)

EVT_MENU(wxH_CHILD_QUIT, MyFrame::OnChildClose )
EVT_MENU(wxH_PROJECT_QUIT,MyFrame::OnProjectClose )

EVT_MENU(wxH_QUIT, MyFrame::OnQuit)

EVT_MENU(wxH_EDIT, MyFrame::OnEdit)
EVT_MENU(wxH_PROJECT_SAVE, MyFrame::OnSaveProject)
EVT_MENU(wxH_PROJECT_COPY, MyFrame::OnProjectCopy)
EVT_MENU(wxH_FILE_BACKUP,  MyFrame::OnFileBackup)
EVT_UPDATE_UI(wxH_NEW_PROJECT, MyFrame::OnAllowNewProject)
EVT_UPDATE_UI(wxH_REOPEN, MyFrame::OnAllowNewProject)

EVT_UPDATE_UI(wxH_PROJECT_SAVE, MyFrame::OnUpdateProjectSave)
EVT_UPDATE_UI(wxH_PROJECT_COPY, MyFrame::OnUpdateProjectSave)
EVT_UPDATE_UI(wxH_FILE_BACKUP,  MyFrame::OnUpdateFileBackup)

EVT_UPDATE_UI (wxID_CUT, MyFrame::OnUpdateCopy )
EVT_UPDATE_UI (wxID_COPY, MyFrame::OnUpdateCopy )
EVT_UPDATE_UI (wxID_PASTE, MyFrame::OnUpdatePaste )
EVT_UPDATE_UI (wxID_UNDO, MyFrame::OnUpdateUndo )
EVT_UPDATE_UI (wxID_REDO, MyFrame::OnUpdateRedo )
EVT_UPDATE_UI (wxH_FINDMENU, MyFrame::OnUpdateFindmenu )
EVT_UPDATE_UI (wxH_FINDTREE, MyFrame::OnUpdateFindmenu )
EVT_UPDATE_UI (wxH_FINDDLG, MyFrame::OnUpdateDlgmenu)
EVT_UPDATE_UI (wxH_COMPILE, MyFrame::OnUpdateCompile )
EVT_UPDATE_UI (wxH_NEXTERROR, MyFrame::OnUpdateNextErr )

EVT_UPDATE_UI (wxH_RUN, MyFrame::OnUpdateRun )
EVT_UPDATE_UI (wxH_DEBUG, MyFrame::OnUpdateDebug)
EVT_UPDATE_UI (wxH_REBUILD, MyFrame::OnUpdateRebuild)
EVT_UPDATE_UI (wxH_CONFIGURE, MyFrame::OnUpdateConfigure)

EVT_UPDATE_UI (wxH_ITEM, MyFrame::OnUpdateAdd_Item )
EVT_UPDATE_UI (wxH_SEP, MyFrame::OnUpdateSeparator )
//EVT_UPDATE_UI (wxH_NEWPOPUP, MyFrame::OnUpdatePopup )

// edit menu

EVT_MENU(wxID_COPY, MyFrame::OnCopy)
EVT_MENU(wxID_CUT, MyFrame::OnCut)
EVT_MENU(wxID_PASTE, MyFrame::OnPaste)
EVT_MENU(wxID_REDO, MyFrame::OnRedo)
EVT_MENU(wxID_UNDO, MyFrame::OnUndo)

EVT_MENU_RANGE(wxH_SURROUND_MIN, wxH_SURROUND_MAX, MyFrame::OnModifySelection)

EVT_MENU(wxH_FIND, MyFrame::OnFind )
EVT_MENU(wxH_FINDAGAIN,MyFrame::OnFindagain)
EVT_MENU(wxH_REPLACE,MyFrame::OnReplace)
EVT_MENU(wxH_REPLACEAGAIN,MyFrame::OnReplaceAgain)
EVT_MENU (wxH_GOLINE, MyFrame::OnGoline  )
EVT_UPDATE_UI(wxH_FIND, MyFrame::OnUpdateFind)
EVT_MENU (wxH_MATCHBRACE, MyFrame::OnSelBrace  )
EVT_MENU (wxH_INDENTBRACE, MyFrame::OnIndentThisBrace  )
EVT_UPDATE_UI(wxH_MATCHBRACE, MyFrame::OnUpdateSelBrace)

EVT_MENU(wxH_FINDMENU, MyFrame::OnFindMenu )
EVT_MENU(wxH_FINDTREE, MyFrame::OnFindTree )
EVT_MENU(wxH_FINDDLG, MyFrame::OnFindDlg )

EVT_MENU(wxH_FONT_SEL,MyFrame::OnChangeFont)
EVT_MENU(wxH_EDITOR,MyFrame::OnChangeEditor)
EVT_MENU(wxH_IMAGE, MyFrame::OnChangeImageEditor)
EVT_MENU(wxH_COMPILER, MyFrame::OnChangeCompiler)
EVT_MENU(wxH_PROJECTROOT, MyFrame::OnChangeProjectRoot)
EVT_MENU(wxH_WXHATCHROOT, MyFrame::OnChangeWxHatchRoot)
EVT_MENU(wxH_WXWINDIR, MyFrame::OnChangeWxWinDir)
EVT_MENU(wxH_SETPATH, MyFrame::OnAddPath)
EVT_MENU(wxH_PRELOAD, MyFrame::OnTogglePreload)

EVT_UPDATE_UI (wxH_PRELOAD, MyFrame::OnUpdatePreLoad)

EVT_MENU (wxH_BLANK, MyFrame::OnAddMenu )
EVT_MENU (wxH_ITEM, MyFrame::OnAdd_Item )
EVT_MENU (wxH_SEP, MyFrame::OnSeparator )
EVT_MENU (wxH_NEWPOPUP, MyFrame::OnAddPopup )
EVT_MENU (wxH_RENAMEITEM, MyFrame::OnRenameitem )
EVT_MENU (wxH_FILEMENU, MyFrame::OnAddfilemenu )
EVT_MENU (wxH_FILEPRINTMENU, MyFrame::OnAddfileprintmenu )
EVT_MENU (wxH_EDITMENU, MyFrame::OnAddeditmenu )
EVT_MENU (wxH_HELPMENU, MyFrame::OnAddHelpmenu )
EVT_MENU (wxH_AUTOTEXT, MyFrame::OnAutoText )
EVT_MENU (wxH_ADDAUTOTEXT, MyFrame::OnAddAutoText )


EVT_MENU_RANGE(wxID_FILE1, wxID_FILE9, MyFrame::OnMRUFile)
EVT_MENU_RANGE (wxH_COMPILE, wxH_REBUILD, MyFrame::OnCompile )

EVT_MENU (wxH_NEXTERROR, MyFrame::OnNextErr )

//now handled by OnAnYMenuOpen
//EVT_UPDATE_UI_RANGE (wxH_MAX, wxH_MAX + 59, MyFrame::OnUpdateAnyDialog)
EVT_MENU (wxH_MAX-1, MyFrame::InsertOwnDialog)
EVT_MENU_RANGE (wxH_MAX, wxH_MAX + 59, MyFrame::OnAnyDialog)
EVT_MENU_RANGE (wxH_MAX+60, wxH_MAX + 90, MyFrame::OnAnyTool)
EVT_UPDATE_UI_RANGE (wxH_MAX+60, wxH_MAX + 90, MyFrame::OnUpdateAnyTool)

EVT_MENU (wxH_TOOL_CONFIGURE, MyFrame::OnToolConfigure)
EVT_UPDATE_UI (wxH_TOOL_CONFIGURE, MyFrame::OnUpdateToolConfigure)
EVT_MENU (wxH_TOOL_ADD, MyFrame::OnToolAdd)

EVT_MENU (wxH_MOVEUP, MyFrame::OnMoveup)
EVT_MENU (wxH_MOVEDOW, MyFrame::OnMovedown)
EVT_MENU (wxH_MOVEL, MyFrame::OnMoveL)
EVT_MENU (wxH_MOVER, MyFrame::OnMoveR)

EVT_MENU(wxH_MOVE_MENU_L, MyFrame::OnMenuL)
EVT_MENU(wxH_MOVE_MENU_R, MyFrame::OnMenuR)
EVT_MENU(wxH_DEL_MENU, MyFrame::OnMenuDel)

EVT_MENU (wxH_ADDTOTOOLBAR, MyFrame::OnAddToToolbar)
EVT_MENU (wxH_DELETE, MyFrame::OnDelete)
EVT_MENU (wxH_GOBODY, MyFrame::OnGobody)
EVT_MENU (wxH_GOID,  MyFrame::OnGoId)
EVT_MENU (wxH_GODEC,  MyFrame::OnGodec)
EVT_MENU (wxH_GOEVT,  MyFrame::OnGoevt)
EVT_MENU (wxH_GOMNU,  MyFrame::OnGoMnu)
EVT_MENU (wxH_GOENABL, MyFrame::OnGoenable)

EVT_MENU (wxH_GOFDEC,  MyFrame::OnGoFDec)
EVT_MENU (wxH_GOFCONS, MyFrame::OnGoFCons)
EVT_MENU (wxH_GOFDES, MyFrame::OnGoFDes)
EVT_MENU (wxH_GOFSIZE, MyFrame::OnGoFSize)
EVT_MENU (wxH_GOFCLOSE, MyFrame::OnGoFClose)
EVT_MENU (wxH_GOFNOGUI, MyFrame::OnGoFNoGUI)

EVT_MENU (wxH_TBMVERIGHT, MyFrame::OnTBMveright)
EVT_MENU (wxH_TBMVELEFT, MyFrame::OnTBMveleft)
EVT_MENU (wxH_TBDEL, MyFrame::OnTBDel)
EVT_MENU (wxH_TBSEP, MyFrame::OnTBSep)
EVT_MENU (wxH_TBCHANGE, MyFrame::OnTBChange)
EVT_MENU (wxH_TBEDIT, MyFrame::OnTBEdit)
EVT_MENU (wxH_TBCHANGETEXT, MyFrame::OnTBChangetext)
EVT_MENU (wxH_TBGOCODE, MyFrame::OnTBGocode)
EVT_MENU (wxH_TBGOBODY, MyFrame::OnTBGoBody)
EVT_MENU (wxH_TBGOENABL, MyFrame::OnTBGoenable)

EVT_UPDATE_UI_RANGE(wxH_TBMVERIGHT, wxH_TBMVELEFT, MyFrame::OnUpdateToolMove)
EVT_UPDATE_UI_RANGE(wxH_TBDEL, wxH_TBGOBODY, MyFrame::OnUpdateToolbar)
EVT_UPDATE_UI(wxH_TBGOCODE, MyFrame::OnUpdateGoToolbarCode)

EVT_MENU (wxH_GOCDEC, MyFrame::OnGoCDec)
EVT_MENU (wxH_GOCCONS, MyFrame::OnGoCCons)
EVT_MENU (wxH_GOCDES, MyFrame::OnGoCDes)
EVT_MENU (wxH_GOONDRAW, MyFrame::OnGoOnDraw)
EVT_MENU (wxH_GOLCLICK, MyFrame::OnGoLClick)
EVT_MENU (wxH_GOLCLICKUP, MyFrame::OnGoLClickUp)
EVT_MENU (wxH_GORCLICK, MyFrame::OnGoRClick)
EVT_MENU (wxH_GOLDBLCLICK, MyFrame::OnGoLdblClick)
EVT_MENU (wxH_GOMSEMOVE, MyFrame::OnGoMsemove)
EVT_MENU (wxH_GOCNOGUI, MyFrame::OnGoCNoGUI)
EVT_UPDATE_UI (wxH_GOCNOGUI, MyFrame::OnUpdateGoCNoGUI)

EVT_MENU (wxH_CHANGE_ICON, MyFrame::OnChange_icon)
EVT_MENU (wxH_EDIT_ICON, MyFrame::OnEdit_icon)
EVT_MENU (wxH_EDIT_IMAGE, MyFrame::OnTextImageEdit)
EVT_UPDATE_UI (wxH_EDIT_IMAGE, MyFrame::OnUpdateTextImageEdit)

EVT_MENU_RANGE(wxH_CONTENTS, wxH_REFERENCE, MyFrame::OnHelp)
EVT_MENU (wxH_REFSEARCH,  MyFrame::OnSearchHelp)

EVT_MENU (wxH_CTRL_LEFT, MyFrame::OnCtrlLeft)
EVT_MENU (wxH_CTRL_RIGHT, MyFrame::OnCtrlRight)
EVT_MENU (wxH_CTRL_DOWN, MyFrame::OnCtrlDown)
EVT_MENU (wxH_CTRL_UP, MyFrame::OnCtrlUp)
EVT_UPDATE_UI_RANGE (wxH_CTRL_UP, wxH_CTRL_RIGHT, MyFrame::OnUpdateCtrlMove) 

EVT_MENU_RANGE(wxH_CTRL, wxH_CTRL_MAX, MyFrame::OnAddAnyCtrl)
EVT_UPDATE_UI_RANGE (wxH_CTRL, wxH_CTRL_MAX, MyFrame::OnUpdateAddAnyCtrl)

EVT_MENU (wxH_CTRL_DEL, MyFrame::OnCtrlDel)
EVT_MENU (wxH_CTRL_RENAME, MyFrame::OnCtrlRen)
EVT_UPDATE_UI (wxH_CTRL_DEL, MyFrame::OnUpdateCtrlDel)
EVT_UPDATE_UI (wxH_CTRL_DEL, MyFrame::OnUpdateCtrlRen)

EVT_UPDATE_UI (wxH_CTRL_TAB_UP, MyFrame::OnUpdateCtrl_Tab_Up)
EVT_UPDATE_UI (wxH_CTRL_TAB_DOWN, MyFrame::OnUpdateCtrl_Tab_Down)
EVT_MENU (wxH_CTRL_TAB_UP, MyFrame::OnCtrl_Tab_Up)
EVT_MENU (wxH_CTRL_TAB_DOWN, MyFrame::OnCtrl_Tab_Down)

    EVT_MENU(Minimal_Print, MyFrame::OnPrint)
    EVT_MENU(Minimal_Preview, MyFrame::OnPreview)
    EVT_MENU(Minimal_PageSetup, MyFrame::OnPageSetup)
    EVT_MENU(Minimal_PrintSetup, MyFrame::OnPrintSetup)

EVT_CLOSE(MyFrame::OnClose)
EVT_TIMER(-1, MyFrame::OnTimer)
EVT_SIZE(MyFrame::OnSize)
END_EVENT_TABLE()

// ===========================================================================
// implementation
// ===========================================================================

// ---------------------------------------------------------------------------
// MyApp
// ---------------------------------------------------------------------------

// Initialise this in OnInit, not statically
bool MyApp::OnInit()
{
    ::wxInitAllImageHandlers ();
    wxFileSystem::AddHandler(new wxZipFSHandler);
    wxFileSystem::AddHandler(new wxInternetFSHandler);
    wxFileSystem::AddHandler(new wxMemoryFSHandler);


	// test for command line params;
    static const wxCmdLineEntryDesc cmdLineDesc[] =
    {

        { wxCMD_LINE_SWITCH, wxT("h"), wxT("help"),  wxT("show this message"), wxCMD_LINE_VAL_NONE, wxCMD_LINE_OPTION_HELP },

        { wxCMD_LINE_OPTION, wxT("d"), wxT("dir"),   wxT("open existing project directory") },
        { wxCMD_LINE_OPTION, wxT("n"), wxT("newcanvas"),   wxT("new canvas (drawing) project") },
        { wxCMD_LINE_OPTION, wxT("t"), wxT("newtext"),   wxT("new text project") },
        { wxCMD_LINE_OPTION, wxT("b"), wxT("newlistbox"),   wxT("new listbox project") },
        { wxCMD_LINE_OPTION, wxT("p"), wxT("prefix-dir"),   wxT("look for files in this dir") },

        { wxCMD_LINE_OPTION, wxT("l"), wxT("last"),  wxT("Last or recent file number"), wxCMD_LINE_VAL_NUMBER },

        { wxCMD_LINE_NONE }
    };

    wxCmdLineParser parser(cmdLineDesc, argc, argv);

    int iParser = parser.Parse() ;
    if (iParser > 0) parser.Usage();

    bool bReuse ;
    wxConfig *pAppConfig = new wxConfig(wxT("wxHatch")) ;
    pAppConfig->SetPath(RegKey) ;

    wxString sArgV ;
// temporary test
//	sArgV = pAppConfig->Read(wxT("wxHatch Directory"), wxEmptyString );
    //now search for template dir in likely places
    if (sArgV.IsEmpty())
	{
		sArgV = FindSupportDir(wxGetCwd() + wxFILE_SEP_PATH );
	}
    if (sArgV.IsEmpty())
	{
		sArgV = FindSupportDir(argv[0]);
	}

    if (iParser == 0 && parser.Found(wxT("p"), &sArgV) )
	{
        // this overrides any registry entry
		sArgV = FindSupportDir(sArgV);
	}

    // splash screen
    wxString sBitMapPath = sArgV + sBmp ;
    if ( wxFile::Exists(sBitMapPath) && (argc == 1) )
    {
        wxBitmap Mybitmap ( sBitMapPath, wxBITMAP_TYPE_PNG );
        (void) new wxSplashScreen(Mybitmap, wxSPLASH_CENTRE_ON_SCREEN|wxSPLASH_TIMEOUT,
                                  2000, NULL, -1, wxDefaultPosition, wxDefaultSize,
                                  wxSIMPLE_BORDER|wxSTAY_ON_TOP);
        wxYield();
    }

    pAppConfig->Read (wxT("ReuseWindowPosition"), &bReuse, FALSE ) ;
    long x = -1;
    long y = -1 ;
    long w = 500 ;
    long h = 400 ;

    if (bReuse)
    {
        pAppConfig->Read (wxT("X"), &x, x );
        pAppConfig->Read (wxT("Y"), &y, y );
        pAppConfig->Read (wxT("W"), &w, w );
        pAppConfig->Read (wxT("H"), &h, h );
    }
    //deal with off-screen windows
    wxScreenDC sDC;
    int sw = 640;
    int sh = 480;
    sDC.GetSize (&sw,&sh);
    if (x > (long)sw) x = -1 ;
    if (y > (long)sh) y = -1 ;
    // Create the main frame window

    frame = new MyFrame((wxFrame *)NULL, -1, wxT("wxHatch"),
                        wxPoint(x, y), wxSize(w, h),
                        wxDEFAULT_FRAME_STYLE | wxHSCROLL | wxVSCROLL);

    wxString sWD ;
    frame->bSetEnv = TRUE;
    frame->sWXWIN = pAppConfig->Read(wxT("wxWinDir"), wxEmptyString);
    if (wxGetEnv (wxT("WXWIN"), &sWD ))
    {
        frame -> sWXWIN = wxFileName(sWD).GetShortPath() ;
        frame -> bSetEnv = FALSE ;
    }

    // opened registry already
    frame->sImage = pAppConfig->Read(wxT("Image App"), wxEmptyString);
    frame->sEdit = pAppConfig->Read(wxT("Edit App"), wxEmptyString);
    frame->sFind = pAppConfig->Read(wxT("Last Find"), wxEmptyString);
    frame->eLastMode = (projectstyle) pAppConfig->Read(wxT("Last Project Type"), 0L);
    frame->sProjectRoot = pAppConfig->Read(wxT("Project Directory"), wxFileName::GetHomeDir() + wxFILE_SEP_PATH + wxT("projects"));
    frame->sExeRoot = sArgV ;
    frame->iCompiler = pAppConfig->Read (wxT("Compiler Index"),-1L);
    frame->bPreLoad =  pAppConfig->Read (wxT("PreLoad Help"), 0L) !=0 ;
    frame->bLastSearchFS = pAppConfig->Read (wxT("SearchAtStart"),0L)!=0 ;
    frame->bLastSearchCS = pAppConfig->Read (wxT("SearchCase"),0L)!=0 ;

    int i = 0;
    wxString sTmp ;
    sTmp.Printf (wxT("Tool%d"),i);
    wxString sTool = pAppConfig->Read(sTmp, wxEmptyString);
    while (!sTool.IsEmpty())
    {
        //prevent logging of failure to expand environment vars
        wxLogNull logNo;
        frame->saTools.Add(sTool);
        //now increment
        i++;
        sTmp.Printf (wxT("Tool%d"),i);
        sTool = pAppConfig->Read(sTmp, wxEmptyString);
    }
    wxString sCmd = frame -> sExeRoot + sCodeDir ;
    if (! wxDirExists(sCmd) )
    {
        //files did not exist
		sTmp = wxT("The essential help directory  \nwxHatch") + wxFILE_SEP_PATH ;
		sTmp = sTmp + wxT("help \nwas not found\nPlease select the wxHatch help directory now?") ;
        if (wxYES == wxMessageBox( sTmp, wxT("wxHatch Warning"),  wxCENTRE | wxYES_NO ) )
            {
            wxCommandEvent event ;
            frame -> OnChangeWxHatchRoot (event);
            }

    }
	frame->sAutoTextFile = wxGetHomeDir() + wxFILE_SEP_PATH + wxT(".wxh_autotexts.csv");
    //    SaveDir = pAppConfig->Read (wxT("Save Directory"),wxT("")) ;
    frame->sAutoTextFile = pAppConfig->Read(wxT("AutoTextDir"), frame->sAutoTextFile);

	wxString sAutoTextSrc = frame -> sExeRoot + sCodeDir + wxFILE_SEP_PATH + wxT("autotext.csv");
	if (wxFileExists( sAutoTextSrc ) && !wxFileExists(frame->sAutoTextFile))
	{
		wxCopyFile (sAutoTextSrc, frame->sAutoTextFile);
	}


	frame -> LoadMakeCmds(sCmd) ;
    frame -> LoadSurrounds(sCmd) ;
    frame -> LoadAutoTexts(frame->sAutoTextFile) ;


    long fontFamily = pAppConfig->Read (wxT("Font Family"),0L);
    if (fontFamily == 0) fontFamily = wxMODERN ;
    long fontStyle = pAppConfig->Read (wxT("Font Style"),0L);
    if (fontStyle == 0) fontStyle = wxNORMAL ;
    long fontWeight = pAppConfig->Read (wxT("Font Weight"),0L);
    if (fontWeight == 0) fontWeight = wxNORMAL ;
    long fontSize = pAppConfig->Read (wxT("Font Size"),10L);
    wxString sFont = pAppConfig->Read (wxT("Font Face"),wxEmptyString );
    wxFontEncoding fontEncoding = (wxFontEncoding) pAppConfig->Read (wxT("Font Encoding"),(long)wxFONTENCODING_SYSTEM);

    frame->myFont = wxFont((int)fontSize,(int)fontFamily,(int)fontStyle,(int)fontWeight,FALSE,sFont,fontEncoding);
    frame->myFont.SetDefaultEncoding(fontEncoding);

    // Give it an icon
    wxIcon myIcon ;
    wxString sIconPath = frame->sExeRoot + wxT("wxhatch.ico") ;
    if (wxFile::Exists(sIconPath))
    {
        myIcon.CopyFromBitmap(wxBitmap(wxImage(sIconPath)));
        if (!myIcon.Ok())
        {
            (void)wxMessageBox( wxT("Icon not loaded\nIcon file malformed"), wxT("wxHatch Warning"));
        }
        else frame->SetIcon(myIcon);
    }
    else
    {
        (void)wxMessageBox( wxT("Icon path not found"), wxT("wxHatch Warning"));
    }

    // Make a menubar
    wxMenu *file_menu = new wxMenu;
    wxMenu *option_menu = new wxMenu;
    wxMenu *tools_menu = new wxMenu;
    wxMenu *help_menu = new wxMenu;

    frame -> CreateBaseMenu (file_menu);
    frame -> CreatePrefsMenu (option_menu);
    frame -> CreateToolsMenu (tools_menu, TRUE);
    frame -> CreateHelpMenu (help_menu);

    wxMenuBar *menu_bar = new wxMenuBar;

    menu_bar->Append(file_menu, wxT("&File"));
    menu_bar->Append(option_menu, wxT("&Choose"));
    menu_bar->Append(tools_menu, wxT("&Tools"));
    menu_bar->Append(help_menu, wxT("&Help"));

    // Associate the menu bar with the frame
    frame->SetMenuBar(menu_bar);

    //accelerators (in addition to Menu shortcuts)
    const int nEntries = 6 ;
    wxAcceleratorEntry entries[nEntries];
    entries[0].Set(wxACCEL_NORMAL,  WXK_F3,    wxH_FINDAGAIN );
    entries[1].Set(wxACCEL_CTRL,    WXK_F9,    wxH_RUN );
    entries[2].Set(wxACCEL_ALT,     WXK_F4,    wxH_QUIT );
    entries[3].Set(wxACCEL_NORMAL,  WXK_F9,    wxH_COMPILE);
    entries[4].Set(wxACCEL_CTRL,    WXK_F1,    wxH_REFSEARCH);
    entries[5].Set(wxACCEL_NORMAL,  WXK_F1,    wxH_CONTENTS);

    wxAcceleratorTable accel(nEntries, entries);
    frame->SetAcceleratorTable(accel);

    if (frame->bPreLoad)
    {
        frame -> LoadHelp (FALSE, FALSE);
        frame -> LoadHelp ( TRUE, FALSE);
    }

    // file history
    frame -> lastFiles = new wxFileHistory (5) ;
    frame -> lastFiles -> UseMenu ( file_menu ) ;
    frame -> lastFiles -> Load (*pAppConfig);

    delete pAppConfig ;
    pAppConfig = NULL ;

    const int nMax = 2;
    wxStatusBar * pBar = frame -> CreateStatusBar(nMax);
    int widths [nMax] = {180,-1};  //-1 indicates that the field varies
    pBar -> SetStatusWidths (nMax, widths);
    frame->Show(TRUE);
    SetTopWindow(frame);

    // now test for command line options ....
    if (iParser == 0)
    {
        wxString strVal, s ;
        long lVal;
        if ( parser.Found(wxT("n"), &strVal) ) frame->DoNewProject ( strVal, eImgStyle  ) ;
        if ( parser.Found(wxT("t"), &strVal) ) frame->DoNewProject ( strVal, eTextStyle ) ;
        if ( parser.Found(wxT("b"), &strVal) ) frame->DoNewProject ( strVal, eListStyle ) ;
        if ( parser.Found(wxT("d"), &strVal) )
            {
                if ( wxIsAbsolutePath(strVal) )
                    frame->DoReOpenProject ( strVal ) ;
                else
                    frame->DoReOpenProject ( frame->sProjectRoot + wxFILE_SEP_PATH + strVal ) ;
            }
        if ( parser.Found(wxT("l"), &lVal  ) ) frame->DoReOpenProject(frame->lastFiles->GetHistoryFile(lVal-1));
    }
    return TRUE;
}

wxString MyApp::DoFindSupportDir(const wxString & sStart, const wxString & sSubDir)
{

	wxString sTest ;

    wxFileName ff = sStart ;
	ff.Normalize(wxhNORMALISE);

     // search up the path, VC ide generates exe in file under source
	 while (ff.GetDirCount() > 0)
	 {

         sTest = ff.GetPath(wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR) ;
         if (!sSubDir.IsEmpty())  sTest = sTest + sSubDir + wxFILE_SEP_PATH ;
         if ( wxFileName::DirExists ( sTest + sCodeDir) )
			{
#ifdef __WXHSUPPORTTEST__
            wxLogWarning (wxT("Codedir found in ") + sTest);
#endif
            return sTest ;
			}
#ifdef __WXHSUPPORTTEST__
         wxLogWarning (wxT("Codedir not found in ") + sTest);
#endif
		 ff.RemoveDir(ff.GetDirCount() -1) ;
	 }

    return wxEmptyString ;
}

wxString MyApp::FindSupportDir(const wxString & sStart)
{
	//returns wxEmptyString or directory containing files and dirs
    wxString sResult = DoFindSupportDir (sStart, wxEmptyString) ;

#if defined( __UNIX__ ) || defined( __MINGW32__ )
#ifdef __WXHSUPPORTTEST__
    wxLogWarning (wxT("UNIX tests ") );
#endif
	//look in /opt/wxhatch/share /usr.local/share etc and and ../share  (UNIX)
    if ( sResult.IsEmpty() )  sResult = DoFindSupportDir (wxT("/usr/local/share/wxhatch/"), wxEmptyString) ;
    if ( sResult.IsEmpty() )  sResult = DoFindSupportDir (wxT("/opt/wxhatch/bin/"), wxT("share")) ;
    if ( sResult.IsEmpty() )  sResult = DoFindSupportDir (wxT("/usr/share/wxhatch/"), wxEmptyString) ;
    if ( sResult.IsEmpty() )  sResult = DoFindSupportDir (sStart , wxT("share/wxhatch/")) ;

#endif

	//look in HOMEDIR/wxHatch
    if ( sResult.IsEmpty() )  sResult = DoFindSupportDir ( wxFileName::GetHomeDir() , wxT("wxhatch") + wxFILE_SEP_PATH ) ;

    return sResult ;

}

#include <wx/listimpl.cpp>
WX_DEFINE_LIST(TTextChildList) ;



// ---------------------------------------------------------------------------
// MyFrame
// ---------------------------------------------------------------------------

// Define my frame constructor
MyFrame::MyFrame(wxWindow *parent,
                 const wxWindowID id,
                 const wxString& title,
                 const wxPoint& pos,
                 const wxSize& size,
                 const long style)
: wxMDIParentFrame(parent, id, title, pos, size, style)
{

    pMain_h   = NULL ;
    pMain_cpp = NULL ;
    pCanv_h   = NULL ;
    pCanv_cpp = NULL ;
    pMenuChild = NULL ;
    pOutputWin = NULL ;
    pInc = NULL ;
    pTreeWin = NULL;
    pDlgWin = NULL ;
    pHTMLHelpFrame = NULL;
    iCurrent = wxNOT_FOUND ;

    m_Prn = new wxHtmlEasyPrinting(wxT("wxHatch printing"), this);

    bProjectLoaded = FALSE ;
    bAlreadyWarning = FALSE ;

    pConfig = new wxConfig(wxT("wxHatch")) ;
    pConfig->SetPath(RegKey) ;
    wxString sTmp, aString ;
    int i = 0 ;
    iCompiler = 0 ;
    bool bReadOk = TRUE ;
    while (bReadOk)
        { 
        //Read compiler paths
        sTmp = wxEmptyString ;
        sTmp << i ; 
        i ++ ;
		// stop reading when we find either no entry or an empty string 
        bReadOk = pConfig->Read ( wxT( "Path" ) + sTmp, &aString );
		if (bReadOk) bReadOk = ! aString.IsEmpty() ;
		if (bReadOk)
        {            
            long aLong ;
            pConfig->Read ( wxT( "Reuse" ) + sTmp, &aLong, iThisSession ) ;
            if (aLong != iThisSession && !aString.IsEmpty())
            {
                iReusePaths.Add(aLong);
                Paths.Add(aString);
            }
        } 

    } ; 
    wxGetEnv(wxT("PATH"), &sStartPath);
    GetShPath ();
    
    textWinList = new TTextChildList (wxKEY_STRING) ;
    myFrameTimer.SetOwner (this, -1);
    myFrameTimer.Start(6000);

    CreateToolBar(wxNO_BORDER | wxTB_FLAT | wxTB_HORIZONTAL);
    InitToolBar(GetToolBar());
#if wxUSE_DRAG_AND_DROP
    SetDropTarget(new DnDFile(this));
#endif
    nFrames = 0 ;
	iAutoTexts = 0;

}


void MyFrame::OnClose(wxCloseEvent& event)
{
    //Closing will check if project is saved
    if (pHTMLHelpFrame)
        {
        pConfig->SetPath(RegKey) ;
        pHTMLHelpFrame -> WriteCustomization(pConfig);
        }
    if ( (nFrames > 0) && !DoCloseProject () && event.CanVeto() )
    {
        event.Veto();
    }
    else
    {
        event.Skip();
    }
}


MyFrame::~MyFrame ()
{
    //save Autotexts
    if  (int(sAutoTexts.GetCount ()) > iAutoTexts)
    {
        wxTextFile fCmds ;
        if (wxFileExists(sAutoTextFile))
        {
            wxCopyFile (sAutoTextFile, sAutoTextFile + tilde);
            fCmds.Open( sAutoTextFile ) ;
        }
        size_t i ;
        for (i = iAutoTexts; i < sAutoTexts.GetCount (); i++)
        {
            fCmds.AddLine (sAutoTexts[i]) ;
        }
        fCmds.Write();
    }
    // Save values to the registry which is already open
    pConfig->SetPath(RegKey) ;
    lastFiles->Save (*pConfig);

    bool bReuse = TRUE ;
    pConfig->Write (wxT("ReuseWindowPosition"), bReuse ) ;
    pConfig->Write (wxT("Preload Help"), bPreLoad ) ;
    pConfig->Write (wxT("Image App"), sImage);
    pConfig->Write (wxT("Edit App"), sEdit);
    pConfig->Write (wxT("Last Find"), sFind);
    pConfig->Write (wxT("wxWinDir"), sWXWIN);
    pConfig->Write (wxT("Project Directory"), sProjectRoot);
    pConfig->Write (wxT("wxHatch Directory"), sExeRoot);
    pConfig->Write (wxT("AutoTextDir"), sAutoTextFile);
    pConfig->Write (wxT("Last Project Type"), eLastMode);
    pConfig->Write (wxT("SearchAtStart"),bLastSearchFS);
    pConfig->Write (wxT("SearchCase"),bLastSearchCS);
    /*
    wxString sTmp;
    for (size_t i=0; i < saTools.GetCount(); i++)
    {
        sTmp.Printf(wxT("Tool%d"),i) ;
        pConfig->Write (sTmp, saTools.Item(i));
    }
    */
    pConfig->Write (wxT("Compiler Index"),long(iCompiler));
    wxString sTmp ;
    int iIndex = 0;
    for (iIndex =0; iIndex < (int)Paths.GetCount(); iIndex++ )
    { 
        sTmp = wxEmptyString ;
        sTmp << iIndex ; 
        pConfig -> Write ( wxT( "Path"  ) + sTmp , Paths[iIndex] );  //string
        pConfig -> Write ( wxT( "Reuse" ) + sTmp , (long)iReusePaths[iIndex] );//int
    }
    // limit paths so we really delete them
    iIndex ++ ;
    sTmp = wxEmptyString ;
    sTmp << iIndex ; 
    pConfig -> Write ( wxT( "Path"  ) + sTmp , wxEmptyString);  //string
    pConfig -> Write ( wxT( "Reuse" ) + sTmp , 0L );//int    
    
    pConfig->Write (wxT("Font Size"),long(myFont.GetPointSize()));
    pConfig->Write (wxT("Font Family"),long(myFont.GetFamily()));
    pConfig->Write (wxT("Font Style"),long(myFont.GetStyle()));
    pConfig->Write (wxT("Font Weight"),long(myFont.GetWeight()));
    pConfig->Write (wxT("Font Face"), myFont.GetFaceName());
    pConfig->Write (wxT("Font Encoding"), myFont.GetEncoding());

    if (bReuse)
    {
        int x,y, w, h ;
        GetPosition (&x,&y) ;
        GetSize (&w,&h) ;
        if (!IsIconized())
        {
            pConfig->Write (wxT("X"),long(x));
            pConfig->Write (wxT("Y"),long(y));
            pConfig->Write (wxT("H"),long(h));
            pConfig->Write (wxT("W"),long(w));
        }
        if (pHTMLHelpFrame)
        {
            delete pHTMLHelpFrame  ;
        }
    }
    DisableArrays.Clear();
    delete pConfig ;
    delete lastFiles ;
    if (textWinList)  delete textWinList ;

    delete m_Prn;
    m_Prn = (wxHtmlEasyPrinting *) NULL;

}


void MyFrame::OnQuit(wxCommandEvent& WXUNUSED(event))
{
    Close();
}


void MyFrame::OnAbout(wxCommandEvent& WXUNUSED(event) )
{
    wxString sTmp = wxT("Usage: wxHatch") + sPrgExt ;
    (void)wxMessageBox(wxT("wxHatch: ") + wxH_VersionString + 
                       wxT("\nmade with wxWidgets version: ") + wxVERSION_STRING + 
                       wxT("\nAuthor: Chris Elliott (c) 2001-2004\n") +
                       sTmp, wxT("About wxHatch"));
}


void MyFrame::OnNewProject(wxCommandEvent& event )
{
	if (!wxDirExists(sExeRoot + sCodeDir))
    {
        // no wxhatch files found
        SetStatusText(wxT("Project creation cancelled, Please try again"),1);
        if (wxYES == wxMessageBox (wxT("Essential wxhatch files were not found\nDo you want to locate them now?"),
            wxT("wxHatch Warning"),  wxCENTRE | wxYES_NO ) )
            {
            OnChangeWxHatchRoot (event);
			return;
            }


    }
    // will be appended to project root
    wxString sDest = wxEmptyString;

    MyStartDialog dialog(this,
                        wxT("Enter the name of the new project\nTo be created in ") + sProjectRoot,
                        wxT("New project"),
                        sDest, eLastMode,
                        wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;

    eLastMode = dialog.GetmyRadioBoxValue();
    DoNewProject ( dialog.GetmyComboBoxValue(), eLastMode ) ;
}

void MyFrame::DoNewProject (const wxString & sDest, projectstyle e)
{
    eLastMode = e;
    DoNewProject(sDest);
}

void MyFrame::DoNewProject (const wxString & sDest)
{
 if (!wxDirExists(sProjectRoot))
    {
        // no project directory found
        SetStatusText(wxT("Project creation cancelled, Please try again"),1);
        if (wxYES == wxMessageBox (wxT("project directory does not exist \nDo You want to choose one now?"),
            wxT("wxHatch Warning"),  wxCENTRE | wxYES_NO ) )
            {
            wxCommandEvent event ;
            OnChangeProjectRoot (event);
            }

        return;
    }
    if ( eLastMode == eNewDialog)
    {
        sName = wxT("dlg_test") ;
    }
    else
    {
        sName = sDest ;
    }
    wxString sCode = sExeRoot + sCodeDir;
    sCode = sCode + wxFILE_SEP_PATH ;
    sProjectDir = sProjectRoot + wxFILE_SEP_PATH + sDest ;

    if (!wxDirExists(sProjectDir))
    {
        wxMkdir (sProjectDir.c_str()) ;
    }
    else
    {
        if (wxDir(sProjectDir).HasFiles(sName+wxT(".*")) )
        {
        if (wxYES != wxMessageBox (wxT("Directory already exists and contains project files\nReally Overwrite existing files?"),
            wxT("wxHatch Warning"),
            wxCENTRE | wxYES_NO ) )
        {
            SetStatusText(wxT("Project creation cancelled, Please try again"),1);
            return ;
        }
        }
    }

    SetTitle ( wxT("wxHatching ") + sDest ) ;
    lastFiles -> AddFileToHistory (sProjectDir);
    sProjectDir = sProjectDir + wxFILE_SEP_PATH ;

    wxString sSource = wxT("frame");
    if (eLastMode == eNewDialog)
    {
        sSource = wxT("dlg_test");
    }

    wxCopyFile ( sCode + wxT("mondrian.ico"), sProjectDir + sName + wxT(".ico") );
    wxCopyFile ( sCode + sSource + wxT(".h" ), sProjectDir + sName + wxT(".h"));
    wxCopyFile ( sCode + sSource + wxT(".cpp" ), sProjectDir + sName + wxT(".cpp"));

    wxTextFile myRCfile ;
    myRCfile.Create (sProjectDir + sName + wxT(".rc"));
    myRCfile.AddLine (wxT("anIcon ICON ") + sName + wxT(".ico"));
    myRCfile.AddLine (wxT("#include \"wx/msw/wx.rc\""));
    myRCfile.Write();

    pMain_h   = DoNewTextWindow (sProjectDir + sName + wxT(".h"), TRUE);
    RemoveLine ( 0, pMain_h );
    pMain_cpp = DoNewTextWindow (sProjectDir + sName + wxT(".cpp"), TRUE);
    RemoveLine ( 0, pMain_cpp );
    pMain_cpp -> alternateWin = pMain_h ;
    pMain_h -> alternateWin = pMain_cpp ;

    //now create subwindows
    wxString sSubWinH, sSubWinCpp,sSubWinH_src, sSubWinCpp_src, sIns, sIns_src  ;
    bool bNeedsSubWindow = FALSE ;
    switch (eLastMode)
    {
        case eImgStyle: // canvas MyCanvas * canvas ;
            sSubWinH = sSubWinH_src = wxT("canvas.h") ;
            sSubWinCpp = sSubWinCpp_src = wxT("canvas.cpp") ;
            bNeedsSubWindow = TRUE ;
            break ;
        case eTextStyle: // text
            sSubWinH = sSubWinH_src = wxT("txtctrl.h") ;
            sSubWinCpp = sSubWinCpp_src = wxT("txtctrl.cpp") ;
            bNeedsSubWindow = TRUE ;
            break ;
        case eListStyle :// listbox
            sSubWinH = sSubWinH_src = wxT("lstctrl.h") ;
            sSubWinCpp = sSubWinCpp_src = wxT("lstctrl.cpp") ;
            bNeedsSubWindow = TRUE ;
            break ;
        case eNewDialog :// new dialog
            sSubWinH = sDest + wxT(".h") ;
            sSubWinH_src = wxT("dlg.h");
            sSubWinCpp = sDest + wxT(".cpp") ;
            sSubWinCpp_src = wxT("dlg.cpp");
            sIns = sDest + wxT(".inc") ;
            sIns_src = wxT("dlg.inc");
            bNeedsSubWindow = TRUE ;
            break ;
		default	 :
		    break ;
    }
    if (bNeedsSubWindow)
    {
        wxCopyFile ( sCode + sSubWinCpp_src, sProjectDir + sSubWinCpp);
        wxCopyFile ( sCode + sSubWinH_src, sProjectDir + sSubWinH);
        if ( eLastMode == eNewDialog ) wxCopyFile ( sCode + sIns_src, sProjectDir + sIns);

        pCanv_h   = DoNewTextWindow (sProjectDir + sSubWinH, TRUE);
        RemoveLine ( 0, pCanv_h   );
        pCanv_cpp = DoNewTextWindow (sProjectDir + sSubWinCpp, TRUE, (eLastMode == eNewDialog));
        RemoveLine ( 0, pCanv_cpp );
        if ( eLastMode == eNewDialog )
            {
                pInc = DoNewTextWindow (sProjectDir + sIns, TRUE);
                pInc -> textctrl -> eDlgType = IsDialogInclude ;
            }

        if (pCanv_cpp)
        {
            pCanv_h -> alternateWin = pCanv_cpp ;
            pCanv_cpp -> alternateWin = pCanv_h ;
        }
    }
    // now modify code to reflect project name
/*    wxSize m_size = pMain_cpp -> textctrl ->  GetSize ();
    wxSize h_size = pMain_h -> textctrl ->  GetSize ();
    pMain_cpp -> textctrl -> SetSize ( 800,-1) ;
*/
    int iDeclareLine = 1 + DoFindLine ( wxT("MyFrame(const wxString& title"), 0, pMain_h  );
    int iConstrLine  = 3 + DoFindLine ( wxT("MyFrame::MyFrame(const"), 0, pMain_cpp  );

    switch (eLastMode)
    {
        case eImgStyle: // canvas MyCanvas * canvas ;
            WriteLine ( pMain_h, iDeclareLine,  wxT("    MyCanvas * canvas ;"));
            WriteLine ( pMain_cpp, iConstrLine, wxT("    canvas = new MyCanvas(this);"));
            sClassName = wxT("MyCanvas");
            break ;
        case eTextStyle: // text
            WriteLine ( pMain_h, iDeclareLine,  wxT("    MyTxtCtrl * textctrl ;"));
            WriteLine ( pMain_cpp, iConstrLine, wxT("    textctrl = new MyTxtCtrl (this);"));
            sClassName = wxT("MyTxtCtrl");
            break ;
        case eListStyle :// listbox
            WriteLine ( pMain_h, iDeclareLine,  wxT("    MyLstCtrl * listbox ;"));
            WriteLine ( pMain_cpp, iConstrLine, wxT("    listbox = new MyLstCtrl(this);"));
            sClassName = wxT("MyLstCtrl");
            break ;
		default:
			break ;
    }
    if (bNeedsSubWindow)
    {
        WriteLine ( pMain_cpp, DoFindLine ( wxT("frame.h"), 0, pMain_cpp ) - 1,
            wxT("#include \"") + sSubWinH + wxT("\" "));
    }

    DoReplaceExactText (wxT("frame.h"), sName + wxT(".h"), 0, pMain_cpp) ;
    DoReplaceExactText (wxT("anIcon"), sName, 0, pMain_cpp) ;
    DoReplaceExactText (wxT("a Program"), sName, 0, pMain_cpp) ;
    pMain_cpp -> textctrl -> GoStartOfCurrentLine ();

    if (bNeedsSubWindow)
    {
    DoReplaceExactText (wxT("frame.h"), sDest + wxT(".h"), 0, pCanv_cpp) ;
    }

    if (eLastMode == eNewDialog)
    {
        //replace MyDlg with name
        int iFound = 0;
        while (iFound != wxNOT_FOUND) iFound = DoReplaceExactText (wxT("MyDlg"), sDest, 0, pCanv_cpp) ;
        iFound = 0;
        while (iFound != wxNOT_FOUND) iFound = DoReplaceExactText (wxT("MyDlg"), sDest, 0, pMain_cpp) ;
        iFound = 0;
        while (iFound != wxNOT_FOUND) iFound = DoReplaceExactText (wxT("MyDlg"), sDest, 0, pCanv_h) ;
        iFound = 0;
        while (iFound != wxNOT_FOUND) iFound = DoReplaceExactText (wxT("MyDlg"), sDest, 0, pInc) ;
        //copy bitmpas
        wxString sBmp = wxT( "bitmaps") ;
        if (!wxDirExists( sProjectDir + sBmp )) wxMkdir((sProjectDir + sBmp).c_str());
        sBmp = sBmp + wxFILE_SEP_PATH ;
        sBmp = sBmp + wxT("test_show_dialog.xpm" );

        wxCopyFile ( sCode + sBmp, sProjectDir + sBmp );
        int iLine = DoFindLine ( wxT( "CreateButtonSizer" ) , 0, pCanv_cpp ) ;
        DoShowLine ( pCanv_cpp , iLine - 1 ) ;
    }

    DoSaveProject () ;

    if (eLastMode == eNewDialog)
    {
        pCanv_cpp -> Activate ();
        pDlgWin = DoNewDlgWindow (pCanv_cpp);
        pDlgWin -> Activate ();
    }
    else
    {
        pMenuChild = DoNewMenuWindow ();
        pMenuChild -> Activate ();
    }
    SetStatusText ( wxT( "Project Loaded" )   ) ;

    bProjectLoaded = TRUE ;
}


void MyFrame::OnNewTextWindow(wxCommandEvent& WXUNUSED(event) )
{
    wxString sText ;
    MyTextDialog MyDialog(this,
                        wxT("please type a name for the new files"),
                        wxT("Add a new pair of .h and .cpp files"),
                        sText,
                        wxOK | wxCANCEL);
    if (MyDialog.ShowModal() != wxID_OK) return ;
    sText = MyDialog.GetValue() ;

    wxString sFile = sProjectDir + sText + wxT(".cpp") ;
    if (wxFileExists(sFile))
    {
        if (wxYES != wxMessageBox (wxT("File Already exists") + sFile + wxT("\nDo You want to overwrite it now?"),
        wxT("wxHatch Warning"),
        wxCENTRE | wxYES_NO ) )
        return ;
    }
    sFile = sProjectDir + sText + wxT(".h") ;
    if (wxFileExists(sFile))
    {
        if (wxYES != wxMessageBox (wxT("File Already exists") + sFile + wxT("\nDo You want to overwrite it now?"),
        wxT("wxHatch Warning"),
        wxCENTRE | wxYES_NO ) )
        return ;
    }

    sFile = sProjectDir + sText + wxT(".cpp") ;
    TextChild *textframe_h, * textframe_cpp;
    textframe_cpp= DoNewTextWindow ( sFile, TRUE);
    textframe_cpp->textctrl->ClearAll();
    textframe_cpp->textctrl->DoStyle (sFile);

    AppendText (textframe_cpp, wxT( "#include \"wx/wxprec.h\" \n" ));

    AppendText (textframe_cpp, wxT( "#ifdef __BORLANDC__ " )   );
    AppendText (textframe_cpp, wxT( "#pragma hdrstop " )   );
    AppendText (textframe_cpp, wxT( "#endif \n\n" )   );

    AppendText (textframe_cpp, wxT( "#ifndef WX_PRECOMP " )   );
    AppendText (textframe_cpp, wxT( "#include \"wx/wx.h\" " )   );
    AppendText (textframe_cpp, wxT( "#endif \n\n" )   );
    AppendText (textframe_cpp, wxT("#include \"") + sText + wxT(".h\" ") );

    wxString sMainName;
    wxSplitPath ( pMain_cpp->filename, NULL, &sMainName, NULL );
    AppendText (textframe_cpp, wxT("#include \"") + sMainName + wxT(".h\" \n") );
    textframe_cpp->SaveFile(sFile);

    //now do .h file
    sFile = sProjectDir + sText + wxT(".h");
    textframe_h = DoNewTextWindow ( sFile, TRUE );
    textframe_h->textctrl->ClearAll();
    textframe_cpp->textctrl->DoStyle (sFile);
    
    AppendText (textframe_h, wxT("#ifndef _") + sText + wxT("_h\n#define _") + sText + wxT("_h\n//insert new code here\n\n#endif") );
    textframe_h->SaveFile(sFile);
    textframe_cpp -> alternateWin = textframe_h ;
    textframe_h   -> alternateWin = textframe_cpp ;

    // add reference to new.h file to main file
    int iLine = DoFindLine (wxT("#include \"") + sMainName, 0, pMain_cpp) ;
    if (iLine != wxNOT_FOUND)
            {
                wxString sInsertText = wxT("\n\n#include \"") ;
                sInsertText = sInsertText+ sText + wxT(".h\" ");
                WriteLine (pMain_cpp, iLine-2, sInsertText );
            }
        else
        {
            iLine = DoFindLine (wxT("#include \""), 0, pMain_cpp) ;
            if ( iLine != wxNOT_FOUND)
            {
                wxString sInsertText = wxT("\n\n#include \"") + sText + wxT(".h\" ");
                WriteLine (pMain_cpp, iLine+2, sInsertText );
            }
            else
            {

                //fix what should happen here
                wxMessageBox (wxT("Header not added to main file"),wxT("wxHatch Warning"));
            }

        }

    //overwrite makefile
    //test for iCompiler selected
    if ((iCompiler < 0) || (iCompiler > (int)Make24FileEndings.GetCount()))
    {
        if (wxYES == wxMessageBox (wxT("No External Compiler chosen\nDo You want to choose one now?"),
        wxT("wxHatch Warning"),
        wxCENTRE | wxYES_NO ) )
        {
            ProcessCommand (wxH_COMPILER) ;
        }
        return  ;
    }

    GenerateMakefile() ;
    return ;

}


//defaults to : bAddtoProject = FALSE
TextChild * MyFrame::DoNewTextWindow(const wxString & sPath, bool bAddToProject, bool bUseControlsMenu)
{
    // Make another frame,
    TextChild *textframe = new TextChild(frame, wxT("Code Frame"),
                                         wxPoint(-1, -1), wxSize(-1, -1),
                                         wxDEFAULT_FRAME_STYLE);
    ++nFrames;

    // Make a menubar
    wxMenu *file_menu = new wxMenu;
    wxMenu *edit_menu = new wxMenu;
    wxMenu *option_menu = new wxMenu;
    wxMenu *ctrl_menu = NULL ;
    wxMenu *dlg_menu = NULL ;
    wxMenu *code_menu = NULL ;
        dlg_menu = new wxMenu;
        code_menu = new wxMenu;
        if (bUseControlsMenu)
        {
        ctrl_menu = new wxMenu;
        }
    wxMenu *tool_menu = new wxMenu;
    wxMenu *run_menu = new wxMenu;
    wxMenu *help_menu = new wxMenu;

    CreateFileMenu (file_menu);
    CreateEditMenu (edit_menu);
    CreatePrefsMenu (option_menu);
    DisableIndexes.Clear();
    DisableArrays.Clear();


        CreateDlgMenu  (dlg_menu,  wxH_MAX,  wxT("snipdlgs.cpp"));
        dlg_menu->AppendSeparator ();
        dlg_menu->Append (wxH_MAX - 1, wxT("Choose Own Dialog"), wxT("Call a dialog you have cretaed in wxHatch"));

        CreateCodeMenu (code_menu, wxH_MAX + 30,  wxT("snipcode.cpp"));
        if (bUseControlsMenu)
        {
        CreateCtrlMenu (ctrl_menu, NULL);
        }


    CreateToolsMenu (tool_menu);
    CreateHelpMenu (help_menu);
    CreateRunMenu (run_menu);

    wxMenuBar *menu_bar = new wxMenuBar;

    menu_bar->Append(file_menu, wxT("&File"));
    menu_bar->Append(edit_menu, wxT("&Edit"));
    menu_bar->Append(option_menu, wxT("Choo&se"));
    // this will be searched for later , don't change !!


    menu_bar->Append(dlg_menu, wxT("Insert &Dialog"));
    menu_bar->Append(code_menu, wxT("Insert &Code"));
    if (bUseControlsMenu)
    {
		menu_bar->Append(ctrl_menu, wxT("&Insert Ctrl"));
    }

    menu_bar->Append(run_menu, wxT("&Make"));
    menu_bar->Append(tool_menu, wxT("&Tools"));
    menu_bar->Append(help_menu, wxT("&Help"));

    // Associate the menu bar with the frame
    textframe->SetMenuBar(menu_bar);
    //textframe->CreateStatusBar();
    textframe->bIsPartOfProject = bAddToProject ;
#ifdef __WXMSW__
    textWinList->Append(sPath.Lower(), textframe);
#else
    textWinList->Append(sPath, textframe);
#endif
    int width, height;
    textframe->GetClientSize(&width, &height);

        if (!sPath.IsEmpty () && wxFileExists(sPath))
        {
        textframe->textctrl->LoadFile(sPath);
        }
        textframe -> filename = sPath ;
        textframe -> SetTitle (wxFileNameFromPath(sPath)) ;


    textframe->Show(TRUE);
    #ifndef __WXGTK__
        // Give it an icon, if its a real MDI system
        textframe->SetIcon(wxIcon(wxT("wxhatch")));
    #endif
    return textframe ;
}


ListChild * MyFrame::DoNewListWindow()
{
    // Make another frame,
    ListChild *listframe = new ListChild(frame, wxT("Output Frame"),
                                         wxPoint(-1, -1), wxSize(-1, -1),
                                         wxDEFAULT_FRAME_STYLE);

    #ifndef __WXGTK__
        // Give it an icon, if its a real MDI system
        listframe->SetIcon(wxIcon(wxT("wxhatch")));
    #endif

    // Make a menubar
    wxMenu *file_menu = new wxMenu;
    wxMenu *edit_menu = new wxMenu;
    wxMenu *option_menu = new wxMenu;
    wxMenu *tools_menu = new wxMenu;
    wxMenu *run_menu = new wxMenu;
    wxMenu *help_menu = new wxMenu;

    CreateBaseMenu (file_menu);
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_QUIT, wxT("&Close Project\tCtrl+Shift+F4"), wxT("Close all project windows")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_CHILD_QUIT, wxT("C&lose child\tCtrl+F4"), wxT("Close current window")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_COPY, wxT("Copy &Project To..."), wxT("Copy essential project files to a new directory")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_FILE_BACKUP, wxT("Sa&ve child"), wxT("Save Compiler Output as text File")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_SAVE, wxT("&Save project\tCtrl+S"), wxT("Save all project files")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_OPEN_TEXT_WINDOW, wxT("&Open File"), wxT("Open a text file")));

    edit_menu->Append(wxID_COPY,  wxT("&Copy  \tCtrl-C"));
    CreatePrefsMenu (option_menu);
    CreateToolsMenu (tools_menu);
    CreateHelpMenu (help_menu);
    CreateRunMenu (run_menu);

    wxMenuBar *menu_bar = new wxMenuBar;

    menu_bar->Append(file_menu, wxT("&File"));
    menu_bar->Append(edit_menu, wxT("&Edit"));
    menu_bar->Append(option_menu, wxT("&Choose"));
    menu_bar->Append(run_menu,  wxT("&Make"));
    menu_bar->Append(tools_menu, wxT("&Tools"));
    menu_bar->Append(help_menu, wxT("&Help"));

    // Associate the menu bar with the frame
    listframe->SetMenuBar(menu_bar);

    listframe->Show(TRUE);
    return listframe ;
}

TreeChild * MyFrame::DoNewTreeWindow()
{
    // Make another frame,
    TreeChild *treeframe = new TreeChild(frame, wxT("Class List"),
                                         wxPoint(-1, -1), wxSize(-1, -1),
                                         wxDEFAULT_FRAME_STYLE);

    #ifndef __WXGTK__
        // Give it an icon, if its a real MDI system
        treeframe->SetIcon(wxIcon(wxT("wxhatch")));
    #endif

    // Make a menubar
    wxMenu *file_menu = new wxMenu;
    wxMenu *option_menu = new wxMenu;
    wxMenu *tools_menu = new wxMenu;
    wxMenu *run_menu = new wxMenu;
    wxMenu *help_menu = new wxMenu;

    CreateBaseMenu (file_menu);
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_QUIT, wxT("&Close Project\tCtrl+Shift+F4"), wxT("Close all project windows")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_CHILD_QUIT, wxT("C&lose child\tCtrl+F4"), wxT("Close current window")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_COPY, wxT("Copy &Project To..."), wxT("Copy essential project files to a new directory")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_SAVE, wxT("&Save project\tCtrl+S"), wxT("Save all project files")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_OPEN_TEXT_WINDOW, wxT("&Open File"), wxT("Open a text file")));

    CreatePrefsMenu (option_menu);
    CreateToolsMenu (tools_menu);
    CreateHelpMenu (help_menu);
    CreateRunMenu (run_menu);

    wxMenuBar *menu_bar = new wxMenuBar;

    menu_bar->Append(file_menu, wxT("&File"));
    menu_bar->Append(option_menu, wxT("&Choose"));
    menu_bar->Append(run_menu,  wxT("&Make"));
    menu_bar->Append(tools_menu, wxT("&Tools"));
    menu_bar->Append(help_menu, wxT("&Help"));

    // Associate the menu bar with the frame
    treeframe->SetMenuBar(menu_bar);

    treeframe->Show(TRUE);
    return treeframe ;
}

dlgChild * MyFrame::DoNewDlgWindow(TextChild * pChild)
{
    // Make another frame,
    dlgChild *treeframe = new dlgChild(frame, wxT("Dialog Control Tree"), pChild);

    #ifndef __WXGTK__
        // Give it an icon, if its a real MDI system
        treeframe->SetIcon(wxIcon(wxT("wxhatch")));
    #endif

    // Make a menubar
    wxMenu *file_menu = new wxMenu;
    wxMenu *option_menu = new wxMenu;
    wxMenu *ctrl_menu = new wxMenu;
    wxMenu *ctrl_sub_menu = new wxMenu;
    wxMenu *tools_menu = new wxMenu;
    wxMenu *run_menu = new wxMenu;
    wxMenu *help_menu = new wxMenu;

    CreateBaseMenu (file_menu);
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_QUIT, wxT("&Close Project\tCtrl+Shift+F4"), wxT("Close all project windows")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_CHILD_QUIT, wxT("C&lose child\tCtrl+F4"), wxT("Close current window")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_COPY, wxT("Copy &Project To..."), wxT("Copy essential project files to a new directory")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_SAVE, wxT("&Save project\tCtrl+S"), wxT("Save all project files")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_OPEN_TEXT_WINDOW, wxT("&Open File"), wxT("Open a text file")));


    ctrl_menu -> Append ( wxH_SUB_MENU, wxT("Insert"), ctrl_sub_menu, wxT("Choose a Control to Insert") ) ;
    ctrl_menu -> AppendSeparator();
    ctrl_menu->Append(wxH_CTRL_UP, wxT("Move Ctrl &Up"), wxT("Move Control Up the Tree") );
    ctrl_menu->Append(wxH_CTRL_DOWN, wxT("Move Ctrl &Down"), wxT("Move Control Down the Tree") );
    ctrl_menu->Append(wxH_CTRL_RIGHT, wxT("Move Ctrl &Right"), wxT("Move Control to SubSizer") );
    ctrl_menu->Append(wxH_CTRL_LEFT, wxT("Move Ctrl &Left"), wxT("Move Control Up to Ouside sizer") );
    ctrl_menu -> AppendSeparator();
    ctrl_menu->Append(wxH_CTRL_TAB_UP, wxT("Tab Earlier"), wxT("Move Control Up the Tab order") );
    ctrl_menu->Append(wxH_CTRL_TAB_DOWN, wxT("Tab Later"), wxT("Move Control Down the Tab order") );
    ctrl_menu -> AppendSeparator();
    ctrl_menu->Append(wxH_CTRL_RENAME, wxT("Rename Control"), wxT("Rename Control in Tree") );
    ctrl_menu->Append(wxH_CTRL_DEL, wxT("De&lete Control"), wxT("Remove Control from the Tree") );

    CreatePrefsMenu (option_menu);
    CreateCtrlMenu (ctrl_sub_menu, treeframe);

    CreateToolsMenu (tools_menu);
    CreateHelpMenu (help_menu);
    CreateRunMenu (run_menu);

    wxMenuBar *menu_bar = new wxMenuBar;

    menu_bar->Append(file_menu, wxT("&File"));
    menu_bar->Append(option_menu, wxT("&Choose"));
    menu_bar->Append(ctrl_menu, wxT("&Controls"));
    menu_bar->Append(run_menu,  wxT("&Make"));
    menu_bar->Append(tools_menu, wxT("&Tools"));
    menu_bar->Append(help_menu, wxT("&Help"));

    // Associate the menu bar with the frame
    treeframe->SetMenuBar(menu_bar);

    treeframe->Show(TRUE);
//    treeframe->Refresh() ;
	treeframe->DoActivate();
    return treeframe ;
}


void MyFrame::OnNewMenuWindow(wxCommandEvent& WXUNUSED(event) )
{
    DoNewMenuWindow ();
}


MyChild * MyFrame::DoNewMenuWindow()
{
    // Make another frame,
    MyChild *menuframe = new MyChild(frame, wxT("Menu Zone"),
                                     wxPoint(-1, -1), wxSize(-1, -1),
                                     wxDEFAULT_FRAME_STYLE );

    ++nFrames;

    #ifndef __WXGTK__
        // Give it an icon
        menuframe->SetIcon(wxIcon(wxT("wxhatch")));
    #endif
    // Make a menubar
    wxMenu *file_menu = new wxMenu;
    wxMenu *option_menu = new wxMenu;
    wxMenu *tools_menu = new wxMenu;
    wxMenu *run_menu = new wxMenu;
    wxMenu *menu_menu = new wxMenu;
    wxMenu *help_menu = new wxMenu;

    CreateBaseMenu (file_menu);
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_QUIT, wxT("&Close Project\tCtrl+Shift+F4"), wxT("Close all project windows")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_CHILD_QUIT, wxT("C&lose child\tCtrl+F4"), wxT("Close current window")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_COPY, wxT("Copy &Project To..."), wxT("Copy essential project files to a new directory")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_PROJECT_SAVE, wxT("&Save project\tCtrl+S"), wxT("Save all project files")));
    file_menu->Insert(2,new wxMenuItem(file_menu,wxH_OPEN_TEXT_WINDOW, wxT("&Open File"), wxT("Open a text file")));

    CreatePrefsMenu (option_menu);
    CreateToolsMenu (tools_menu);
    CreateHelpMenu (help_menu);
    CreateMenuMenu (menu_menu);
    CreateRunMenu (run_menu);

    wxMenuBar *menu_bar = new wxMenuBar;

    menu_bar->Append(file_menu, wxT("&File"));
    menu_bar->Append(option_menu, wxT("&Choose"));
    menu_bar->Append(menu_menu, wxT("&Add Menu"));
    menu_bar->Append(run_menu, wxT("&Make"));
    menu_bar->Append(tools_menu, wxT("&Tools"));
    menu_bar->Append(help_menu, wxT("&Help"));

    // Associate the menu bar with the frame
    menuframe->SetMenuBar(menu_bar);

    menuframe->CreateStatusBar();

    int width, height;
    menuframe->GetClientSize(&width, &height);
    MyCanvas *canvas = new MyCanvas(menuframe, wxPoint(0, 0), wxSize(width, height));
    menuframe->canvas = canvas;

    menuframe->Show(TRUE);
    return menuframe ;
}



#ifdef __WXUNIVERSAL__
void MyFrame::OnSize(wxSizeEvent& event)
#else
void MyFrame::OnSize(wxSizeEvent& WXUNUSED(event))
#endif
{
    int w, h;
    GetClientSize(&w, &h);
    GetClientWindow()->SetSize(0, 0, w, h);

//fix needed in X11
#ifdef __WXUNIVERSAL__
    event.Skip();
#endif

}


void MyFrame::InitToolBar(wxToolBar* toolBar)
{

    toolBar->AddTool( wxH_NEW_PROJECT,  wxBitmap( new_xpm ),   wxT("New project"));
    toolBar->AddTool( wxH_REOPEN,       wxBitmap( open_xpm ),   wxT("Open Project"));
    toolBar->AddTool (wxH_PROJECT_SAVE, wxBitmap( save_xpm ),   wxT("Save all project files"));
    toolBar->AddSeparator();
    toolBar->AddTool (wxID_CUT,        wxBitmap( cut_xpm ),   wxT("Cut"));
    toolBar->AddTool (wxID_COPY,       wxBitmap( copy_xpm ),   wxT("Copy"));
    toolBar->AddTool( wxID_PASTE,      wxBitmap( paste_xpm ),   wxT("Paste"));
    toolBar->AddTool( wxID_UNDO,       wxBitmap( undo_xpm ),   wxT("Undo"));
    toolBar->AddTool( wxID_REDO,       wxBitmap( redo_xpm ),   wxT("Redo"));
    toolBar->AddTool( wxH_FIND,        wxBitmap( find_xpm ),   wxT("Find Word"));
    toolBar->AddSeparator();
    toolBar->AddTool( wxH_FINDMENU,     wxBitmap( menu_xpm ),   wxT("GoTo Menu Window"));
    toolBar->AddTool( wxH_FINDTREE,     wxBitmap( listview_xpm ),  wxT("GoTo Class Tree Window"));
    toolBar->AddTool( wxH_FINDDLG,     wxBitmap( dlg_xpm ),  wxT("GoTo Dialog Control Tree Window"));

    toolBar->AddSeparator();
    toolBar->AddTool( wxH_COMPILE,      wxBitmap( make_xpm ),  wxT("Make the project"));
    toolBar->AddTool( wxH_RUN,          wxBitmap( run_xpm ),  wxT("Run the program"));
    toolBar->AddSeparator();
    toolBar->AddTool( wxH_CONTENTS,     wxBitmap( help_xpm ),  wxT("Help"));
    toolBar->AddTool( wxH_REFERENCE,    wxBitmap( logo16_xpm ),  wxT("wxWidgets reference"));

    toolBar->Realize();

}


void MyFrame::OnFileBackup (wxCommandEvent & WXUNUSED(event) )
{
    wxString sFile, sDir, sPattern ;

    wxMDIChildFrame * pChild = GetActiveChild ();
    if (pChild == pOutputWin)
    {
        // compiler output
        sFile = wxT("CompilerOutput");
        sDir = sProjectDir ;
        sPattern = wxT("Text files (*.txt)|*.txt|All files (*.*)|*.*");
    }
    else
    {
        //most likely a code file
        sFile = ((TextChild *) pChild) -> filename ;
        sDir = wxPathOnly(sFile);
        sPattern = wxT("Source code files (*.cpp)|*.cpp|Header files (*.h)|*.h|Text files (*.txt)|*.txt|All files (*.*)|*.*") ;
    }

    wxFileDialog dialog(this, wxT("Save as"), sDir, sFile, sPattern, wxSAVE|wxOVERWRITE_PROMPT);

    if (dialog.ShowModal() == wxID_OK)
    {
        sFile = dialog.GetPath() ;
        if (pChild == pOutputWin)
        {
            ((ListChild *) pChild) -> SaveFile ( sFile );
        }
        else
        {
            ((TextChild *) pChild) -> SaveFile( sFile );
        }

    }
}


bool MyFrame::SaveProjectFile (TextChild * pChild)
{
    if (!pChild) return FALSE;

    if (pChild  -> textctrl -> IsModified ())
    {
        wxRenameFile( pChild   -> filename, pChild   -> filename + wxT('~') );
        return pChild   -> SaveFile ( pChild  -> filename );
    }
    return TRUE ;                //wasn't modified..
}


void MyFrame::OnSaveProject (wxCommandEvent & WXUNUSED(event) )
{
    DoSaveProject () ;
}

void MyFrame::OnProjectCopy (wxCommandEvent & WXUNUSED(event) )
{
    DoSaveProject () ;
    wxString sNewProjectDir = sProjectRoot ;
    bool bOldMsw = FALSE ;
#ifdef __WXMSW__
    if (wxApp::GetComCtl32Version() <= 500) bOldMsw = TRUE ;
#endif

    if (bOldMsw)
    {
    wxString sText = sNewProjectDir ;

    MyTextDialog MyDialog(this,
                        wxT("Copying project"),
                        wxT("Choose a new directory"),
                        sText,
                        wxOK | wxCANCEL);

    if (MyDialog.ShowModal() != wxID_OK) return ;
    sNewProjectDir = MyDialog.GetPath() ;
    }
    else
    {
    wxDirDialog MyDialog ((wxWindow *)this, wxT("Choose a directory to hold the copy"), sNewProjectDir, wxDD_NEW_DIR_BUTTON );
    if (MyDialog.ShowModal() != wxID_OK) return ;
    sNewProjectDir = MyDialog.GetPath() ;
    }

        if (!wxDirExists(sNewProjectDir))
            {
                wxMkdir(sNewProjectDir.c_str());
            }
        if (wxDir(sNewProjectDir).HasFiles(wxT("*.cpp")) )
        {
        if (wxNO == wxMessageBox (wxT("Directory exists and contains code files\nReally Overwrite existing files?"),
            wxT("wxHatch Please confirm"),
            wxCENTRE | wxYES_NO ) )
          {
          // answer was no
          return ;
          }
        }

        wxString sFails ;
        int iFailed = 0;
        int iCopied = 0;
        //add the files from the list;
        TTextChildList::Node *node = textWinList->GetFirst();
        while (node)
        {
            if ( node->GetData() -> bIsPartOfProject )
            {
                wxFileName fFile (node->GetData()->filename);
                fFile.MakeRelativeTo(sProjectDir);
                fFile.Normalize(wxhNORMALISE,sNewProjectDir);
                wxString sFile = fFile.GetFullPath() ;
                if (wxCopyFile ( node->GetData()->filename, sFile  ))
                    iCopied ++ ;
                  else
                  {
                    iFailed ++ ;
                    sFails  = sFails + node->GetData()->filename + newline ;
                  }
            }
            node = node->GetNext();
        }
        //copy icon
        if (wxCopyFile ( sProjectDir + sName + wxT(".ico"), sNewProjectDir + wxFILE_SEP_PATH + sName + wxT(".ico") ))
            iCopied ++ ;
          else
          {
            iFailed ++ ;
            sFails  = sFails + sProjectDir + sName + wxT(".ico") + newline ;
          }
        if (wxCopyFile ( sProjectDir + sName + wxT(".rc"),  sNewProjectDir + wxFILE_SEP_PATH + sName + wxT(".rc")))
            iCopied ++ ;
          else
          {
            iFailed ++ ;
            sFails  = sFails + sProjectDir + sName + wxT(".rc") + newline ;
          }

        //copy any bitmaps for the toolbar...
        if ( pMenuChild )
        {
        TBitmapToolList::Node *tnode = pMenuChild->canvas->toolList->GetFirst();
        while (tnode)
        {
            wxFileName fFile (tnode->GetData()->myFilename);
            if ( ! ( tnode->GetData() -> myID.IsEmpty() ) ) // otherwise a separator with no bitmap !
            {
                fFile.MakeRelativeTo(sProjectDir);
                fFile.Normalize(wxhNORMALISE,sNewProjectDir);
                wxFileName fDir = fFile ;
                fDir.SetFullName(wxEmptyString);
                fDir.Mkdir((int)0777, (bool)TRUE);
				// if writing from case insensitive platform to case-sensitive platform force correct XPM filename
                wxString sFile = fDir.GetFullPath() + wxFILE_SEP_PATH + tnode->GetData()->Get_XPM_Name();
                if (wxCopyFile ( tnode->GetData()->myFilename, sFile ))
                    iCopied ++ ;
                  else
                  {
                    iFailed ++ ;
                    sFails  = sFails + tnode->GetData()->myFilename + newline ;
                  }
            }
            tnode = tnode->GetNext();
        }
        } // if pMenuChild
    wxString sMessage, sCaption ;
    if ( iFailed > 0 )
    {
        sCaption = wxT("wxHatch Warning");
        sMessage.Printf (wxT("Failed to backup all files\n%d files successfully copied\n%d Files not copied"), iCopied, iFailed);
        sMessage = sMessage + sFails ;
    }
    else
    {
        sCaption = wxT("wxHatch Success");
        sMessage.Printf (wxT("All %d files successfully copied"), iCopied);
    }

    wxMessageBox ( sMessage, sCaption );

}


bool MyFrame::DoSaveProject ()
{
    bool bSaveFailed = FALSE;

    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( !SaveProjectFile(node->GetData()) ) bSaveFailed = TRUE;
        node = node->GetNext();
    }

    if (bSaveFailed) SetStatusText(wxT("Project files NOT saved"),1);
    else SetStatusText(wxT("Project files saved"),1);
    return !bSaveFailed ;
}


void MyFrame::OnUpdateFileBackup  (wxUpdateUIEvent & event)
{
    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            event.Enable(TRUE);
            return ;
        }
        node = node->GetNext();
    }
    // now permit saving compiler output
    if (pChild == pOutputWin)
    {
        event.Enable((ListChild *)pOutputWin -> ListBox -> GetCount() > 0);
        return ;
    }

    event.Enable(FALSE);
}


void MyFrame::OnUpdateProjectSave  (wxUpdateUIEvent & event)
{
    event.Enable (bProjectLoaded);
}


void MyFrame::OnUpdateFind (wxUpdateUIEvent & event)
{
    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            event.Enable(TRUE);
            return ;
        }
        node = node->GetNext();
    }
    event.Enable(FALSE);
}


void MyFrame::OnChangeEditor(wxCommandEvent& WXUNUSED(event))
{
    wxString sText = sEdit ;

    wxFileDialog dialog(this, wxT("Select a Text Editor"), wxPathOnly(sText), wxFileNameFromPath(sText),
                        sPrograms, wxSAVE);

    if (dialog.ShowModal() == wxID_OK)
    {
        sEdit = dialog.GetPath() ;
    }

}


void MyFrame::OnChangeImageEditor(wxCommandEvent& WXUNUSED(event))
{
    wxString sText = sImage ;

    wxFileDialog dialog(this, wxT("Select an Image Editor"), wxPathOnly(sText), wxFileNameFromPath(sText),
                        sPrograms, wxSAVE);

    if (dialog.ShowModal() == wxID_OK)
    {
        sImage = dialog.GetPath() ;
    }

}


void MyFrame::OnAddMenu (wxCommandEvent& WXUNUSED(event))
{
    DoAddMenu(FALSE);
}


bool MyFrame::DoAddMenu (bool bIsPopup)
{
    wxString sText = wxEmptyString ;

    wxString sTmp = wxT("Enter the menubar text");
    if (bIsPopup) sTmp = wxT("Enter the popup menu label ");

    MyTextDialog dialog(this,
                        wxT("Use an && before Alt key"),
                        sTmp,
                        sText,
                        wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return FALSE;
    sText = dialog.GetValue() ;

    pMenuChild -> canvas -> OnAddMenu (sText, bIsPopup) ;
    return TRUE ;
}


void MyFrame::OnAddPopup (wxCommandEvent& WXUNUSED(event))
{
    if (DoAddMenu(TRUE))
    {
        int iLine ;
        wxString sInsertText ;
        wxString sMenu = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected ) -> GetData() -> GetMenuName();

        //Add a delete menu to the destructor
        iLine = DoGoFDes ();
        sInsertText = wxT("    delete ") + sMenu + wxT(" ;");
        WriteLine (pMain_cpp, iLine+1, sInsertText );

        //Add a popup menu command
        iLine = DoGoEvent (wxT("MyFrame"), wxT("OnRightUp"), wxT("wxMouseEvent & event"), wxT("    EVT_RIGHT_UP(") );

        sInsertText = wxT("    PopupMenu (") + sMenu + wxT(", event.GetPosition());");
        WriteLine (pMain_cpp, iLine+2, sInsertText );

        if (pCanv_cpp)
        {
            iLine = DoGoEvent (sClassName, wxT("OnRightUp"), wxT("wxMouseEvent & event"), wxT("    EVT_RIGHT_UP(") );
            if (DoFindLine (wxT("pFrame -> OnRightUp"), iLine, pCanv_cpp) == wxNOT_FOUND)
            {
                sInsertText = wxT("    pFrame -> OnRightUp(event) ;");
                WriteLine (pCanv_cpp, iLine+2, sInsertText );
            }
        }
    }
    pMenuChild -> Activate ();
}


void MyFrame::OnAdd_Item (wxCommandEvent& WXUNUSED(event))
{
    wxString sText = wxEmptyString ;

    MyTextDialog dialog(this,
                        wxT("Use an && before Alt key"),
                        wxT("Enter the menu text"),
                        sText,
                        wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;
    sText = dialog.GetValue() ;

    pMenuChild -> canvas -> OnAdd_Item (sText) ;
    pMenuChild -> Activate();
    // this will, in turn call DoNewMenuText
}


void MyFrame::OnAddfilemenu (wxCommandEvent& event)
{
    pMenuChild -> canvas -> OnAddfilemenu (event) ;
    pMenuChild -> Activate ();
}

void MyFrame::OnAddfileprintmenu (wxCommandEvent& event)
{
    pMenuChild -> canvas -> OnAddfileprintmenu (event) ;
    pMenuChild -> Activate ();
}


void MyFrame::OnAddeditmenu (wxCommandEvent& event)
{
    pMenuChild -> canvas -> OnAddeditmenu (event) ;
    pMenuChild -> Activate ();
}


void MyFrame::OnAddHelpmenu (wxCommandEvent& event)
{
    pMenuChild -> canvas -> OnAddHelpmenu (event) ;
    pMenuChild -> Activate ();
}


void MyFrame::OnSeparator (wxCommandEvent& event)
{
    pMenuChild -> canvas -> OnSeparator (event) ;
    pMenuChild -> Activate ();
}


// line before which to insert menu, defaults to zero
void MyFrame::DoMenuText (TBitmapMenu * pBM, const long iInsertionLine )

{
    /* now ....
        i)   add the event id       frame.h
        ii)  declare the method     frame.h
        iii) add a method           frame.cpp
        iv)  update the event table frame.cpp
        v)   add it to the menu     frame.cpp
        possibly add an updateUI event and context event
        */

    wxString sTmp = wxT("Error in Code at DoMenuText");

    //i) Insert the ID above the last one (wxH_QUIT)
    mywxTextCtrl * tc = pMain_h -> textctrl ;
    int i = DoFindLine (wxT("wxH_QUIT"), 0, pMain_h);
    wxString sInsertText = pBM -> GetIDText () + wxT(",");

    //if not found ...
    if (i == wxNOT_FOUND)
    {
        //possibly a wxWidgets sample
        wxString sIDwanted ;
        TBitmapMenuList::Node *node = pMenuChild -> canvas -> menuList->GetLast();
        while (node && sIDwanted.IsEmpty())
        {
            TBitmapMenu *current = node->GetData();
            if (current != pBM) sIDwanted = current -> GetIDText ();
            node = node->GetPrevious() ;
        }
        i = DoFindLine (sIDwanted, 0, pMain_h);
        wxString s = tc -> GetLineText (i-1);

        if (s.Contains(wxT("#define")) || s.Contains(wxT("int")))
        {
            //try and get a number from the line
            // #define CONST INT
            // const int CONST = INT ;
            bool bFailure = TRUE ;
            long int myLong = 0 ;
            wxStringTokenizer tkz(s, wxT(" =;"));
            while ( bFailure && tkz.HasMoreTokens() )
            {
                wxString token = tkz.GetNextToken();
                bFailure = !token.ToLong (&myLong);
            }
            myLong ++ ;
            sInsertText = wxT("#define ") + pBM -> GetIDText () + wxT(" ");
            sInsertText << int (myLong);
        }
        // No previous menu items found
        if (i == wxNOT_FOUND)
        {
            wxMessageBox(wxT("Error in Inserting ID in frame header\nAdding new ID block"), sTmp);
            i = DoFindLine (wxT("#define _frame_h"), 0, pMain_h);
            WriteLine (tc, i+1, wxT("enum \n{wxH_QUIT\n};")  );
            i = DoFindLine (wxT("wxH_QUIT"), 0, pMain_h);
        }
    }
    //    wxH_FILE_OPEN,
    WriteLine (tc, i-1, sInsertText );

    // now declare method before MyFrame's DECLARE_EVENT_TABLE()
    i = DoFindLine (wxT("public wxFrame"), 0, pMain_h);
    if (i != wxNOT_FOUND)
        i = DoFindLine (wxT("DECLARE_EVENT_TABLE"), i, pMain_h);

    if (i == wxNOT_FOUND)
    {
        wxMessageBox( wxT("Event Table declaration Not found")
                      wxT("Error in Inserting Method in frame header"),
                      sTmp);
        return ;
    }
    WriteLine (tc, i-1, pBM -> GetDeclarationText() );
    // finished with frame.h

    tc = pMain_cpp -> textctrl ;
    i = DoFindLine (wxT("BEGIN_EVENT_TABLE(MyFrame"), 0, pMain_cpp);

    if (i == wxNOT_FOUND)
    {
        wxMessageBox( wxT("Event Table Start Not found")
                      wxT("Error in Inserting into Event table in frame cpp"),
                      sTmp);
        return ;
    }
    WriteLine (tc, i, pBM -> GetEventTableText() );

    //Append Method at end (it would be nice to put the methods in the same order as the menus...
    AppendText ( tc, pBM -> GetBodyText() );

    //Add to menu
    if (iInsertionLine > 0) i = iInsertionLine ;
    else i = DoFindLine (wxT("wxMenuBar"), 0, pMain_cpp) - 1;

    if (i == wxNOT_FOUND)
    {
        wxMessageBox( wxT("wxMenuBar code line not found")
                      wxT("Error in Inserting into Menu in frame.cpp"),
                      sTmp);
        return ;
    }
    WriteLine (tc, i, pBM -> GetMenuText () );
//    pMenuChild -> Activate ();
}


void MyFrame::DoSepText (const wxString & sBaseText, const int iInsertionLine)
{

    mywxTextCtrl * tc = pMain_cpp -> textctrl ;
    long iInsert;
    if (iInsertionLine > 0)  iInsert = iInsertionLine ;
    else iInsert = DoFindLine (wxT("wxMenuBar"), 0, pMain_cpp) - 1;

    wxString sTmp ;
    sTmp.Printf(wxT("    %s -> AppendSeparator () ;" ), sBaseText.c_str() );
    WriteLine (tc, iInsert, sTmp);
    pMenuChild -> Activate ();

}


void MyFrame::DoMenuBarText (TBitmapMenu *pBM)
{
    wxString sActionText = pBM -> GetLabel() ;
    wxString sBaseText = pBM -> GetMenuName();

    mywxTextCtrl * tc = pMain_cpp -> textctrl ;
    int i ;
    i = DoFindLine (wxT("wxMenu *"), 0, pMain_cpp) ;
    if (i == wxNOT_FOUND) i = DoFindLine (wxT("wxMenuBar"), 0, pMain_cpp) ;

    wxString sTmp;
    if (!pBM->IsPopup())
    {
        sTmp << wxT("    wxMenu * ") << sBaseText << wxT(" = new wxMenu ; ") ;
    }
    else
    {
        sTmp << wxT("    ") << sBaseText << wxT(" = new wxMenu  ") << wxT("(wxT(\"") << sActionText << wxT("\"));") ;
    }

    //TODO what do we really do if the marker is not found ??
    if (i==wxNOT_FOUND)
    {
        wxMessageBox(sTmp, wxT("Error in Inserting new menu in frame.cpp"));
        return ;
    }
    WriteLine (tc, i-1, sTmp);

    if (! pBM->IsPopup())
    {
        i = DoFindLine (wxT("SetMenuBar"), 0, pMain_cpp) - 1;

        //indent 4 spaces
        sTmp.Printf(wxT("    menuBar->Append (%s, wxT(\"%s\") );"),sBaseText.c_str(), sActionText.c_str());
        //TODO what do we really do if the marker is not found ??
        if (i==wxNOT_FOUND)
        {
            wxMessageBox(sTmp, wxT("Error in Inserting new menubar in frame.cpp"));
            return ;
        }
        WriteLine (tc, i, sTmp);
    }
    else
    {
        i = DoFindLine (wxT("class MyFrame: public wxFrame"), 0, pMain_h) + 4;
        tc = pMain_h -> textctrl  ;
        sTmp = wxEmptyString ;

        sTmp << wxT("    wxMenu * ") << sBaseText << wxT(" ; ") ;

        //indent 4 spaces
        //TODO what do we really do if the marker is not found ??
        if (i==wxNOT_FOUND)
        {
            wxMessageBox(sTmp, wxT("Error in Inserting new menubar in frame.cpp"));
            return ;
        }
        WriteLine (tc, i, sTmp);
    }
}


void MyFrame::OnChangeCompiler (wxCommandEvent& WXUNUSED(event))
{
    MyRadioDialog RadioDlg (this, iCompiler, compilerStrings);
    if (RadioDlg.ShowModal() == wxID_OK)
    {
        iCompiler = RadioDlg.GetValue ();
        if (!sProjectDir.IsEmpty())
            GenerateMakefile ();
    }

}


void MyFrame::OnChangeProjectRoot (wxCommandEvent& WXUNUSED(event))
{
    wxDirDialog MyDialog ((wxWindow *)this, wxT("Choose a root directory for future projects"), sProjectRoot);
    if (MyDialog.ShowModal() == wxID_OK)
    {
        sProjectRoot = MyDialog.GetPath() ;
    }
}


void MyFrame::OnAddPath (wxCommandEvent& WXUNUSED ( event ) )
{
    wxString sTmp ;
    if ((iCompiler >= 0) && (iCompiler < (int)Make24FileEndings.GetCount())) sTmp = compilerStrings [iCompiler];
    pathcfg dialog(this, Paths, iReusePaths, iCompiler,  sTmp );
    if (dialog.ShowModal() == wxID_OK)
    {
        size_t iCount ;
        Paths.Clear();
        for (iCount=0; iCount < (size_t)dialog.pListBox -> GetCount(); iCount++)
        {
            Paths.Add(dialog.pListBox -> GetString(iCount));
        } 
        iReusePaths.Clear();
        for ( iCount=0; iCount < dialog.iReuse.GetCount(); iCount ++)  
        {
            iReusePaths.Add(dialog.iReuse[iCount]);        
        }
        GetShPath();
    }
}

void MyFrame::OnChangeWxHatchRoot (wxCommandEvent& WXUNUSED(event))
{
    wxDirDialog MyDialog ((wxWindow *)this, wxT("Choose the directory contaning the main wxHatch help files"), sExeRoot + wxT("help"));
    if (MyDialog.ShowModal() == wxID_OK)
    {
        wxString sTest = MyDialog.GetPath() + wxFILE_SEP_PATH ;
	    wxFileName ff = sTest ;
		while (ff.GetDirCount() > 0)
		{
			if ( wxFileName::DirExists ( sTest + sCodeDir) )
			{
			sExeRoot = sTest ;
			LoadMakeCmds(sExeRoot + sCodeDir) ;
            LoadSurrounds(sExeRoot + sCodeDir) ;
			LoadAutoTexts(sExeRoot + sCodeDir) ;
			return ;
			}
			ff.RemoveDir(ff.GetDirCount() -1) ;
			sTest = ff.GetPath(wxPATH_GET_VOLUME | wxPATH_GET_SEPARATOR) ;

		}

    }
}

wxString MyFrame::SelectwxWinSource ()
{
    wxString sLibPath = sWXWIN ;
    //Unix and mingw and cygwin compile source in wxWidgets 
    //other msw compilers in either src/msw or build/msw
    if (Make25FileEndings[iCompiler].Contains('.'))
    { 
        #ifdef __WXMSW__
        if (Is25())
        {
            sLibPath = sLibPath + wxFILE_SEP_PATH + wxT("build");
        }
        else
        { 
            sLibPath = sLibPath + wxFILE_SEP_PATH + wxT("src");
        }
        sLibPath = sLibPath + wxFILE_SEP_PATH + wxT("msw") ;
        #endif
        #ifdef __WXOS2__
        sLibPath = sLibPath +  wxT("\\src\\os2") ;
        #endif
    }
    return sLibPath ;
}

wxString MyFrame::SelectLibrary ()
{
    wxString sLibPath = sWXWIN + wxFILE_SEP_PATH + wxT("contrib") ;
    //25 needs the build, except for configure builds
    if (Is25() && !Make25FileEndings[iCompiler].IsEmpty())
    {
        sLibPath = sLibPath + wxFILE_SEP_PATH + wxT("build");
    }
    else
    { 
        sLibPath = sLibPath + wxFILE_SEP_PATH + wxT("src");
    }
    sLibPath = wxFileName(sLibPath).GetLongPath();
    wxDirDialog MyDialog ((wxWindow *)this, wxT("Select The Library to compile"), sLibPath);
    if (MyDialog.ShowModal() == wxID_OK)
    {
        sLibPath = MyDialog.GetPath() ;
        return sLibPath ;
    }
    return wxEmptyString ;
}


void MyFrame::OnEdit(wxCommandEvent& event)
{
    TextChild * pChild = (TextChild *) GetActiveChild () ;
    if (!sEdit.IsEmpty())
    {
        wxRenameFile ( pChild->filename, pChild->filename + wxT('~') );
        pChild -> SaveFile (pChild->filename);
        wxExecute ( sEdit + space + pChild->filename );
        return ;
    }
    // no editor chosen
    if (wxYES == wxMessageBox (wxT("No Text Editor chosen\nDo You want to choose one now?"),
        wxT("wxHatch Warning"),
        wxCENTRE | wxYES_NO ) )

    OnChangeEditor (event);
}

bool MyFrame::LoadMakeCmds (const wxString & sCmds)
{
//clear out any existing commands
    compilerStrings.Clear();
    Platforms.Clear();
    Make24FileEndings.Clear();
    Make25FileEndings.Clear();
    MakeIncludes.Clear();
    MakeTargetNames.Clear();
    ObjectEndings.Clear();
    makeProgStrings.Clear();
    make24ParamStrings.Clear();
    make25ParamStrings.Clear();
    debugStrings.Clear();
    sWxDirStrings.Clear();
    sExtraLibs.Clear();
    s24ExtraLibPattern.Clear();
    s25ExtraLibPattern.Clear();

    sLibNames.Clear();    
    sLibIncludes.Clear();

    wxTextFile fCmds (sCmds + wxFILE_SEP_PATH + wxT("cmds.csv") );
	bool bResult = fCmds.Exists();
    if (bResult)
    {
        fCmds.Open ();
        wxString str ;
        size_t i ;
        for ( i=0; i < fCmds.GetLineCount(); i ++ )
        {
            str = fCmds[i] ;
            if ( ! ( str.StartsWith(wxT("//")) || str.StartsWith(wxT("\"//")) || str.StartsWith(wxT("#")))  )
            {
//// wxString   compilerStrings	 Platforms	 Make24FileEndings	 Make25FileEndings	 MakeIncludes	 MakeTargetNames
//// ObjectEndings	make program	make parameters	  debugStrings	sWxDirStrings  extralibs 2.4extralibpattern	2.5extralibpattern	
                
                wxStringTokenizer tkz(str, wxT(","), wxTOKEN_RET_EMPTY_ALL);
                compilerStrings.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                Platforms.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                Make24FileEndings.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                Make25FileEndings.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                MakeIncludes.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                MakeTargetNames.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                ObjectEndings.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                makeProgStrings.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                make24ParamStrings.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                make25ParamStrings.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                debugStrings.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                sWxDirStrings.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));                
                sExtraLibs.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                s24ExtraLibPattern.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                s25ExtraLibPattern.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                

            } //end of if
        }//end of for
    fCmds.Close() ;
    //now read the libary
    bResult = wxFileExists(sCmds + wxFILE_SEP_PATH + wxT("libs.csv") );
    if (bResult)
    {
        fCmds.Open(sCmds + wxFILE_SEP_PATH + wxT("libs.csv") ) ;
        wxString str ;
        size_t i ;
        for ( i=0; i < fCmds.GetLineCount(); i ++ )
        {
            str = fCmds[i] ;
            if ( !str.StartsWith(wxT("//")) )
            {
                wxStringTokenizer tkz(str, wxT(":"), wxTOKEN_RET_EMPTY_ALL);
                sLibNames.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
                sLibIncludes.Add(tkz.GetNextToken().Trim(TRUE).Trim(FALSE));
            }
        }


    }//end of if library
   else
    {
        wxString sTmp ;
        sTmp << wxT( "The file containing the names of the wxWidgets Libraries \n" ) << sCmds
             << wxFILE_SEP_PATH << wxT("cmds.csv \nwas not found on disk")
             << wxT( "\nPlease download a fresh copy" )  ;
        (void)wxMessageBox( sTmp, wxT("wxHatch warning"));
    }

}// end of if cmds
   else
    {
        wxString sTmp ;
        sTmp << wxT( "The file containing the details of makefiles \n" ) << sCmds
        << wxFILE_SEP_PATH << wxT("libs.csv \nwas not found on disk")
        << wxT( "\nPlease download a fresh copy" )  ;
        (void)wxMessageBox( sTmp, wxT("wxHatch warning"));
    }
	if (iCompiler > (int)compilerStrings.GetCount() ) iCompiler = -1 ;
	return bResult ;
    
}



bool MyFrame::Is25()
{

    //FIX ME cache this result
    wxString sFile = sWXWIN ;
    if ( sFile.IsEmpty() && Make24FileEndings[iCompiler].Lower().Contains(wxT("unx")) )
    {
        //default install location
        //FIX this
        sFile = wxT("/usr/local"); 
    }
    sFile = sFile + wxFILE_SEP_PATH + wxT( "include" ) +
        wxFILE_SEP_PATH + wxT( "wx" ) + wxFILE_SEP_PATH + wxT( "version.h" ) ;
    if (!wxFileExists( sFile ))
    {
        if (wxYES == wxMessageBox (wxT("wxWidgets Version file not found at\n") + sFile +
            wxT("\nDo You want to choose one now?"),
            wxT("wxHatch Warning"),
            wxCENTRE | wxYES_NO ) )

        ProcessCommand (wxH_WXWINDIR) ;          
        return FALSE ;
        
    } 
    wxTextFile versionFile (sFile);
    versionFile.Open();
    wxString sLine = versionFile.GetFirstLine ();
    while (!versionFile.Eof())
        {
        if (sLine.Contains(wxT( "2.4" ) ) ) return FALSE;
        sLine = versionFile.GetNextLine () ;
        } 
    return TRUE ;
}

wxString MyFrame::GetMakeFileName (const wxString & sDir, bool bNeedIn )
{
    wxString sResult ;
    if (Is25())
    {
        sResult = sDir + wxT("Makefile") + Make25FileEndings[iCompiler];
        if ( bNeedIn ) sResult = sResult + wxT(".in");
    }
    else
    {
        sResult = sDir + wxT("Makefile") + Make24FileEndings[iCompiler];
    }
    return sResult ;
}

wxString MyFrame::GetMakeCommand ()
{
    if ((iCompiler < 0) || (iCompiler > (int)Make24FileEndings.GetCount()))
    {
        if (wxYES == wxMessageBox (wxT("No External Compiler chosen\nDo You want to choose one now?"),
        wxT("wxHatch Warning"),
        wxCENTRE | wxYES_NO ) )
        {
            ProcessCommand (wxH_COMPILER) ;
        }
        return wxEmptyString ;
    }   
    // wmake nmake etc
    wxString sCommand = makeProgStrings[iCompiler] + wxT(" -f Makefile") ;
    if (Is25())
    {
        sCommand = sCommand + Make25FileEndings[iCompiler];
		sCommand = sCommand + space + make25ParamStrings[iCompiler] ;
    }
    else
    {
        sCommand = sCommand + Make24FileEndings[iCompiler];
		sCommand = sCommand + space + make24ParamStrings[iCompiler] ;
    }
    
    return sCommand  ;
}

void MyFrame::GetObjects (wxString * sObjList, wxString * sLibList, bool bIs25)
{    //add the files from the list;
    TTextChildList::Node *node = textWinList->GetFirst();
    TextChild * tc ;
    while (node)
    {
        tc = node->GetData();
        wxString p,f,e ;
        wxSplitPath (tc -> filename, &p,&f,&e);
        if ( ( e == wxT("cpp")) && node->GetData() -> bIsPartOfProject )
        {
            // exclude main file as it is TARGET
            if (f != sName) *sObjList = *sObjList + f + ObjectEndings[iCompiler] + space ;
            size_t i = 0;
            for (i=0; i < sLibNames.GetCount(); i++)
            {
                if (DoFindLine(sLibIncludes[i],0,tc, FALSE) != wxNOT_FOUND)
                {
                    if (! sLibList->Contains(sLibNames[i]))
                    {
                        if (bIs25)
                        {  
                            * sLibList= * sLibList + space + wxString::Format(  s25ExtraLibPattern[iCompiler].c_str(), sLibNames[i].c_str() );
                        }
                        else
                        {
                            * sLibList= * sLibList + space + wxString::Format(  s24ExtraLibPattern[iCompiler].c_str(), sLibNames[i].c_str() );
                        } 
                    }
                } 
            }
            
        }
        node = node->GetNext();
    }
}


bool MyFrame::Generate24Makefile ()
{
    wxTextFile myMakeFile;
    wxString sFile = GetMakeFileName(sProjectDir, FALSE);
    if (wxFileExists(sFile)) wxRenameFile(sFile, sFile + wxT("~"));
    if (!myMakeFile.Create(sFile))
    {
            wxMessageBox (wxT("Makefile ") + sFile + wxT("creation failed\nOut of disk space?\nRead Only drive?\nRead Only Makefile already exists?"),
        wxT("wxHatch Warning"));
        return FALSE;
    }
    myMakeFile.AddLine(wxT("#Makefile from wxHatch for ") + compilerStrings[iCompiler] + wxT(" compiler "));
    
    bool bNeedWXDIR = ! MakeIncludes[iCompiler].Contains ( wxT("wx-config") );
    
    if (bNeedWXDIR)
    {
        wxFileName fPath = sWXWIN ;
        fPath.MakeRelativeTo(sProjectDir);
        wxPathFormat pf = wxPATH_UNIX ;
        if (Platforms [iCompiler].Contains(wxT("\\"))) pf = wxPATH_DOS ;
        myMakeFile.AddLine(wxT("WXDIR=") + fPath.GetFullPath(pf) ) ;
    }
    
    myMakeFile.AddLine(MakeTargetNames[iCompiler] + wxT("=") + sName );
    //add the project components to the makefile
    wxString sTmp, sLib ;
    sLib = sExtraLibs[iCompiler];
    sTmp = wxT("OBJECTS = $(") + MakeTargetNames[iCompiler] + wxT(")") + ObjectEndings[iCompiler] + space ;
    GetObjects (&sTmp, &sLib, FALSE);
    myMakeFile.AddLine (sTmp);
    myMakeFile.AddLine (sLib);
    
    sTmp = MakeIncludes[iCompiler];
    sTmp.Replace (wxT("\\n"), wxT("\n"));
    sTmp.Replace (wxT("\\t"), wxT("\t"));
    if (bNeedWXDIR)
    {
        sTmp = sTmp  + wxT(" $(WXDIR)") ;
        sTmp = sTmp  + Platforms [iCompiler] ;
        sTmp = sTmp  + wxT("src") ;
        sTmp = sTmp  + Platforms [iCompiler] ;
        sTmp = sTmp  + wxT("makeprog") ;
        sTmp = sTmp  + Make24FileEndings[iCompiler];
        if (Make24FileEndings[iCompiler].IsEmpty()) sTmp = sTmp  + wxT(".env");
    }
    myMakeFile.AddLine(sTmp);
    return myMakeFile.Write();
}

bool MyFrame::Generate25Makefile ()
{
    // 2.4 makefile.unx should still work
    if (MakeIncludes[iCompiler].Contains ( wxT("wx-config") )) return Generate24Makefile () ;
    
    bool bUsingConfigure = Make25FileEndings[iCompiler].IsEmpty() ;
    
    wxString sMakeFile = GetMakeFileName(sProjectDir, bUsingConfigure) ;
    wxString sSampleFilename = GetMakeFileName(sExeRoot + sCodeDir + wxFILE_SEP_PATH + wxT("bake") + wxFILE_SEP_PATH, bUsingConfigure) ;

    if (!wxFileExists(sSampleFilename))
    {
           //
        wxMessageBox (wxT("Cannot Generate Makefile!! \nMakefile template does not exist at \n")
        + sSampleFilename
        + wxT("\nPlease check wxhatch download and notify Chris Elliott \nif still missing"),
            wxT("wxHatch Warning"));
        return FALSE;
    }
   
    wxTextFile mySrcFile ;
    mySrcFile.Open(sSampleFilename);

    if (wxFileExists(sMakeFile)) wxRenameFile(sMakeFile, sMakeFile + wxT("~"));
    wxTextFile myMakeFile;
    if (!myMakeFile.Create(sMakeFile))
    {
            wxMessageBox (wxT("Makefile ") + sMakeFile + wxT("creation failed\nOut of disk space?\nRead Only drive?\nRead Only Makefile already exists?"),
        wxT("wxHatch Warning"));
        return FALSE;
    }
    bool bCatchNextLine = FALSE ;
    wxString sObjectNames, sLibList, sCppCompileLine ;
    GetObjects (&sObjectNames, &sLibList, TRUE);

//start writing makefile
    myMakeFile.AddLine(wxT("# Makefile from wxHatch for ") + compilerStrings[iCompiler] + wxT(" compiler "));
    myMakeFile.AddLine(wxEmptyString);

//find relative pathand place near top
    wxFileName fPath = sWXWIN ;
    fPath.MakeRelativeTo(sProjectDir);
    wxPathFormat pf = wxPATH_UNIX ;
    if (Platforms [iCompiler].Contains(wxT("\\"))) pf = wxPATH_DOS ;
    myMakeFile.AddLine(wxT("WXWIN=") + fPath.GetFullPath(pf) ) ;
    myMakeFile.AddLine(wxEmptyString);

    if (bUsingConfigure)
    {
        myMakeFile.AddLine(wxT("# You can generate a Makefile from this Makefile.in without wxhatch by running"));
        myMakeFile.AddLine(wxT("# in a bash or similar shell (not tcsh)"));
        myMakeFile.AddLine(wxT("#      CONFIG_HEADERS= CONFIG_COMMANDS= CONFIG_FILES=Makefile ") + fPath.GetFullPath(pf) + wxT("/config.status "));
        myMakeFile.AddLine(wxEmptyString);
    }

    myMakeFile.AddLine(wxT("# based on "));
    //copy minimal sample
    wxString sLine = mySrcFile.GetFirstLine() ;
    while (!mySrcFile.Eof())
    {        
        sLine = mySrcFile.GetNextLine() ;
        if (bCatchNextLine)
        { 
            sCppCompileLine = sLine;
            bCatchNextLine = FALSE ;
        }     
        if (sLine.Contains(wxT( ".cpp" )  ))
        {
            bCatchNextLine = TRUE;
        }
        if (sLine.Contains(wxT( "top_srcdir =" )  ))
        {
            sLine.Replace (wxT("@top_srcdir@"), sWxDirStrings[iCompiler] + Platforms[iCompiler]) ;
        }
        if (sLine.Contains(wxT( "top_builddir =" )  ))
        {
            sLine.Replace (wxT("@top_builddir@"), sWxDirStrings[iCompiler] + Platforms[iCompiler]) ;
        }  

        sLine.Replace (wxT(".\\..\\.."), sWxDirStrings[iCompiler] ) ;
        sLine.Replace (wxT("./../.."), sWxDirStrings[iCompiler] ) ;
        sLine.Replace (wxT("..\\.."), sWxDirStrings[iCompiler] ) ;
        sLine.Replace (wxT("../.."), sWxDirStrings[iCompiler] ) ;

        sLine.Replace (wxT("$(srcdir)/$(WXWIN)"),wxT("$(WXWIN)"));

        sLine.Replace ( wxT("$(CPPFLAGS) "), wxT("$(CPPFLAGS) -I")+ sWxDirStrings[iCompiler] +
            Platforms[iCompiler] + wxT("contrib") + Platforms[iCompiler] + wxT("include ") ) ;
        
        sLine.Replace (wxT("$(OBJS)\\"), wxEmptyString ) ;
        sLine.Replace (wxT("minimal"), sName) ;
        sLine.Replace (wxT("_OBJECTS ="), wxT( "_OBJECTS = " ) + sObjectNames  ) ;
        sLine.Replace (wxT("$(__WXLIB_CORE_p)"), sLibList + wxT(" $(__WXLIB_CORE_p)") );
        
        //next line is a DMC hack until makefiles are properly sorted
        sLine.Replace (wxT("$(LIBDIRNAME)\\ "), wxT("$(LIBDIRNAME)\\ ") + sLibList + wxT( " " )   );

        //next line is a BSD hack for configure
        if (sLine.Contains(wxT("$(CXXC) -c"))) sLine.Replace (wxT("$<"), wxT("$(srcdir)/") + sName + wxT(".cpp")) ;
        
        //hack for setting version to 2.5 hard coded
        if (Is25())
        {
            sLine.Replace ( wxT("$(WX_MAJOR_VERSION_NUMBER)"), wxT("2"));            
            sLine.Replace ( wxT("$(WX_MINOR_VERSION_NUMBER)"), wxT("5"));
        }
        
        bool bNeedLine = TRUE ;
        if (sLine.Contains(wxT("all : $(OBJS)"))) bNeedLine = FALSE;
        if (sLine.Contains(wxT("all: $(OBJS)"))) bNeedLine = FALSE;
        if (sLine.Contains(wxT("all :$(OBJS)"))) bNeedLine = FALSE;
        if (sLine.Contains(wxT("all:$(OBJS)"))) bNeedLine = FALSE;
        
        if (sLine.Contains(wxT("$(OBJS) :"))) bNeedLine = FALSE;
        if (sLine.Contains(wxT("$(OBJS):"))) bNeedLine = FALSE;
        
        if (sLine.Contains(wxT("not exist"))) bNeedLine = FALSE;
        
        if (bNeedLine) myMakeFile.AddLine(sLine);
        
    }

    myMakeFile.AddLine(wxEmptyString);
    // now add commands to compile individual objs
    wxStringTokenizer tkz(sObjectNames, wxT(" "));
    while ( tkz.HasMoreTokens() )
    {
        wxString sObj = tkz.GetNextToken();
        sObj.Trim(TRUE).Trim(FALSE) ;
        wxString sCpp = sObj.BeforeLast(wxT('.'));
        sCpp = sCpp + wxT( ".cpp" )  ;
        sLine = sObj + wxT( ": " )  + sCpp;
        myMakeFile.AddLine(sLine);

        //for BSD (and some solaris, need exact name
        sLine = sCppCompileLine;
        sLine.Replace(wxT("$<"), sCpp );
        myMakeFile.AddLine(sLine);
    }
    myMakeFile.AddLine(wxEmptyString);
    bool bResult = myMakeFile.Write();
    
    if (bUsingConfigure && bCanUseConfigure)
    {
    // makefile.in exists but makefile doesn't..
         wxSetEnv (wxT("CONFIG_FILES"), wxT( "Makefile" )  );
         wxSetEnv (wxT("CONFIG_HEADERS"), wxEmptyString  );
         wxSetEnv (wxT("CONFIG_COMMANDS"), wxEmptyString  );
         wxSetWorkingDirectory (sProjectDir);
         //substitute as required to generate Makefile
         wxString cmd = sWXWIN + wxFILE_SEP_PATH + wxT( "config.status" ) ;
         cmd.Replace (wxT( "\\" )  , wxT( "/" )  );
         wxHSetEnv (GetMakeCommand()) ;
            
#ifdef __WXMSW__

        //running under cygwin or msys
        cmd = shPath + wxT(" -c '") + cmd + wxT("'");

#endif
         if (!pOutputWin)
         {
             pOutputWin = DoNewListWindow ();
             pOutputWin -> SetSize (600,300);
         }

         pOutputWin -> ListBox-> Clear ();
         pOutputWin -> Activate ();
         pOutputWin -> SetTitle ( wxT ("Configure Output") );
         wxArrayString output, errors;
         wxBusyInfo * BusyInfo =  new wxBusyInfo ( wxT("Configuring ") + sName + wxT(" \nThis may take a long time \nPlease wait"), this );
         wxExecute ( cmd, output, errors );
         delete BusyInfo ;
         pOutputWin -> ListBox-> Append (wxT("Output from ") + cmd + newline + newline );
         size_t i;
         for (i=0; i < output.GetCount(); i++)
         {
             pOutputWin -> ListBox-> Append ( output[i] );
         }
         for (i=0; i < errors.GetCount(); i++)
         {
             pOutputWin -> ListBox-> Append ( errors[i] );
         }
         pOutputWin -> ListBox-> Append ( wxT("Configured - new makefile created") );
         pOutputWin -> ListBox-> Append ( wxEmptyString );
         pOutputWin -> Activate ();
         pOutputWin -> SetFocus ();
    }
    return bResult ;
}

bool MyFrame::GenerateMakefile ()
{
    //test for iCompiler selected
    if ((iCompiler < 0) || (iCompiler > (int)Make24FileEndings.GetCount()))
    {
            if (wxYES == wxMessageBox (wxT("No External Compiler chosen\nDo You want to choose one now?"),
            wxT("wxHatch Warning"),
        wxCENTRE | wxYES_NO ) )
        {
            ProcessCommand (wxH_COMPILER) ;
        }
        return FALSE ;
    }
    
    if (sWXWIN.IsEmpty() && !Make24FileEndings[iCompiler].Lower().Contains(wxT("unx")) ) 
    {
        // abort compilation
        wxSetCursor ( * wxSTANDARD_CURSOR );
            if (wxYES == wxMessageBox (wxT("No wxWidgets directory chosen\nDo You want to choose one now?"),
            wxT("wxHatch Warning"),
        wxCENTRE | wxYES_NO ) )
        {
            ProcessCommand (wxH_WXWINDIR) ;
        }
        return FALSE ;
    }
    
    
    if ( Is25 () )
    {
        return Generate25Makefile ();

    }
    else return Generate24Makefile ();
}

    
void MyFrame::OnCompile (wxCommandEvent & event)
    {
        if (!bProjectLoaded) return ;
        //test for iCompiler selected
        if ((iCompiler < 0) || (iCompiler > (int)Make24FileEndings.GetCount()))
        {
                if (wxYES == wxMessageBox (wxT("No External Compiler chosen\nDo You want to choose one now?"),
                wxT("wxHatch Warning"),
            wxCENTRE | wxYES_NO ) )
            {
                ProcessCommand (wxH_COMPILER) ;
            }
            return ;
        }
        
        OnSaveProject (event);
        
        wxString cmd, sMakefile;
        wxArrayString output, errors;
        int code = 0;
        wxDateTime myTime ;
        bool bReBuildAll = FALSE ;
        bool b = wxSetWorkingDirectory ( sProjectDir.BeforeLast(wxFILE_SEP_PATH) );
        if (!b)
        {
            wxString cwd = wxGetCwd();
            (void)wxMessageBox( wxT("Could not change directory to \n") + cwd, wxT("wxHatch warning"));
        }
        
        // first deal with actually running the code
        if ( event.GetId() == wxH_RUN )
        {
            cmd = sProjectDir + sName + sPrgExt ;
            SetStatusText(wxT("About to execute ") + cmd ,1);
            wxHSetEnv(GetMakeCommand());
            code = wxExecute(cmd) ;
            return ;
        }
        
        if ( event.GetId() == wxH_DEBUG )
        {
            cmd = debugStrings[iCompiler] + space + sName + sPrgExt;
            SetStatusText(wxT("About to debug ") + cmd ,1);
            wxHSetEnv(GetMakeCommand());
            code = wxExecute(cmd) ;
            return ;
        }
        
        // check dialog sanity
        wxSetCursor ( * wxHOURGLASS_CURSOR );
        // check for makefile
        sMakefile = GetMakeFileName (sProjectDir, FALSE) ;
        if (!wxFileExists(sMakefile))
        {
            if (!GenerateMakefile()) return ;
        }
        if (!pOutputWin)
        {
            pOutputWin = DoNewListWindow ();
            pOutputWin -> SetSize (600,300);
        }
    myTime = wxDateTime::Now();
    pOutputWin -> ListBox-> Clear ();
    pOutputWin -> Activate ();
    pOutputWin -> SetTitle ( wxT ("Compiler Output") );

    wxBusyInfo  * BusyInfo = NULL ;
    switch (event.GetId())
    {
    case wxH_CONFIGURE:
        {
            int i ;
            wxSetWorkingDirectory ( sWXWIN );
			if ( ! wxFileExists ( sWXWIN + wxFILE_SEP_PATH + wxT("configure") ) )
			{
			    wxMessageBox ( wxT("The configure script was not found in the selected wxWidgets directory \n")
					+ sWXWIN + wxT("\nPlease Choose another wxWidgets directory"), wxT("wxHatch warning"));
			    return ;
			}
#ifndef __WXMSW__
			int iPlatform = 0;
			wxArrayString PlatStrings;
			PlatStrings.Add(wxT("--with-gtk"));
			PlatStrings.Add(wxT("--with-motif"));
			PlatStrings.Add(wxT("--with-x11"));			
            MyRadioDialog RadioDlg (this, iPlatform, PlatStrings);
            if (RadioDlg.ShowModal() != wxID_OK) return ;
	    iPlatform = RadioDlg.GetValue();
            // use iPlatform later ...

#endif
            const int nOpts = 3 ;
            wxString choices [nOpts] = {
                    wxT("--enable-shared"),
                    wxT("--enable-debug"),
                    wxT("--enable-debug_gdb"),
            };
            bool * newSetChecked = new bool [nOpts];
			newSetChecked[0] = TRUE;
            for ( i = 1; i < nOpts; i++ )
            {
                newSetChecked[i] = FALSE;
            }
            wxMultipleChoiceDialog dialog(this, wxT("Choose configure options"), newSetChecked, nOpts, choices);
            if (dialog.ShowModal() != wxID_OK)
            {
                pOutputWin -> Close ();
                return ;
            }
            dialog.GetSelection (newSetChecked);
            cmd = wxT("./configure") ;
#ifndef __WXMSW__            
            cmd = cmd + space + PlatStrings[iPlatform];
#endif
            for ( i = 0; i < nOpts; i++ )
            {
                cmd = cmd + space + choices [i] ;
                if (newSetChecked[i] == FALSE) cmd = cmd + wxT("=no");
            }     
            BusyInfo =  new wxBusyInfo ( wxT("Configuring, \nThis may take a very long time \nPlease wait"), this );
        }
        break ;

    case  wxH_COMLIB:
        {
            wxSetCursor ( * wxSTANDARD_CURSOR );
            wxString slibpath = SelectLibrary () ;
            if (slibpath.IsEmpty())
            {
                pOutputWin -> Close ();
                return ;
            }
            wxSetWorkingDirectory (slibpath) ;
            pOutputWin -> ListBox-> Append (wxT("Compiling library in ") +  slibpath) ;
            
            cmd = GetMakeCommand ();
              
            rebldlg dialog(this, wxT("wxHatch - Please choose...")); 
        
            dialog.ReBuild_SetValue ( /* const bool */ TRUE);
            dialog.Update_SetValue ( /* const bool */ FALSE);
            dialog.m_StaticText_SetLabel ( /* const wxString& */ wxT("Compiling library in ") +  slibpath );
            if (dialog.ShowModal() != wxID_OK) return ;
            bReBuildAll = dialog.ReBuild_GetValue() ;
            
            BusyInfo =  new wxBusyInfo ( wxT("Compiling, \nPlease wait"), this );
            break ;
        }
        
    case  wxH_COMPILE :
        BusyInfo =  new wxBusyInfo ( wxT("Compiling, \nPlease wait"), this );
        cmd = GetMakeCommand ();
        // bug with Watcom sometime not knowing to make all
        if ( cmd.Contains(wxT("wmake"))) cmd = cmd + space + wxT("all");
        break ;

    case  wxH_CLEAN :
        cmd = GetMakeCommand () + wxT(" clean");
        break ;

    case  wxH_REBUILD:
        {
            wxString slibpath = SelectwxWinSource() ;
            wxSetWorkingDirectory ( slibpath );
          
            rebldlg dialog(this, wxT("wxHatch - Please choose..."));         
            dialog.ReBuild_SetValue ( /* const bool */ TRUE);
            dialog.Update_SetValue ( /* const bool */ FALSE);
            dialog.m_StaticText_SetLabel ( /* const wxString& */ wxT("Compiling wxWidgets library in ") +  slibpath );
            if (dialog.ShowModal() != wxID_OK) return ;
            bReBuildAll = dialog.ReBuild_GetValue() ;
            
            pOutputWin -> ListBox-> Append (wxT("Compiling wxWidgets library in ") +  slibpath) ;
            cmd = GetMakeCommand ()  ;            
            if (!Is25())
			{
				cmd.Replace(wxT("WXUSINGDLL"),wxT("DLL"));
				if (cmd.Contains(wxT("nmake"))) cmd.Replace(wxT("DLL=1"),wxT("DLL"));
			}
            
            BusyInfo =  new wxBusyInfo ( wxT("ReBuilding Library, \nPlease wait"), this );
        }
        break ;

        default :
        wxSetCursor ( * wxSTANDARD_CURSOR );
        return ;
    }
    wxSetCursor ( * wxHOURGLASS_CURSOR );
	myFrameTimer.Stop();

    wxHSetEnv (cmd) ;
#ifdef __WXMSW__
    if (bCanUseConfigure)
    {
        //running under cygwin or msys
        cmd = shPath + wxT(" -c '") + cmd + wxT("'");
    }
#endif
    
    pOutputWin -> ListBox-> Append (cmd) ;
    pOutputWin -> ListBox-> Append  (wxT("Started at ") + myTime.FormatTime() );
    if (bReBuildAll)  
	{
		code = wxExecute(cmd + wxT(" clean"), output, errors);
		pOutputWin -> ListBox-> Append (wxT("Rebuilding all...")) ;
	}
    if ( code != -1 ) code = wxExecute(cmd, output, errors);
    wxYield () ;

    wxSetCursor ( * wxSTANDARD_CURSOR );
    if (BusyInfo) delete BusyInfo ;
    myFrameTimer.Start(6000);

    wxString sTmp;
    sTmp.Printf(wxT("command '%s' terminated with exit code %d."), cmd.c_str(), code);

    SetStatusText (cmd,1) ;

    if ( code != -1 )
    {

        pOutputWin -> ListBox-> Append (wxT("Output from ") + cmd + newline + newline );
        size_t i;
        for (i=0; i < output.GetCount(); i++)
        {
            pOutputWin -> ListBox-> Append ( output[i] );
        }
        for (i=0; i < errors.GetCount(); i++)
        {
            pOutputWin -> ListBox-> Append ( errors[i] );
        }
        pOutputWin -> Activate ();
        pOutputWin -> SetFocus ();
    }
    pOutputWin -> ListBox-> Append (sTmp);
    pOutputWin -> ListBox-> Append (wxT("Time taken ") + wxDateTime::Now().Subtract(myTime).Format());
    if (event.GetId() == wxH_COMPILE)
    {
        wxString sOutName = sProjectDir + sName + sPrgExt;
        if ( wxFileExists(sOutName) )
        {
            //add size of exe
            wxFile fTemp (sOutName);
            if ( fTemp.IsOpened() )
            {
                sTmp.Printf (wxT("Executable File ") + sName + sPrgExt + wxT(": size is %ld kBytes"), fTemp.Length()/1024L );
                pOutputWin -> ListBox-> Append (sTmp);
            }
        }
    }
}


void MyFrame::OnFind (wxCommandEvent & WXUNUSED(event))
{
    wxString sText = GetSelectedText() ;
    if (!sText.IsEmpty() ) sFind = sText ;

    MySearchReplaceDialog dialog(this, SRData (sFind, sReplace, FALSE, bLastSearchFS, bLastSearchCS), wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;
    SRData srd = dialog.GetValue() ;
    sFind = srd.sF ;
    bLastSearchFS = srd.bFS ;
    bLastSearchCS = srd.bCS ;

    TextChild * pChild = (TextChild *) GetActiveChild();
    int iStart = 0;
    if (!bLastSearchFS) iStart = 1 + pChild -> textctrl -> GetInsertionPoint() ;
    iCurrent = DoFindExactly (sFind, iStart, pChild, bLastSearchCS);
    if ( iCurrent != wxNOT_FOUND) pChild -> textctrl -> SetSelection ( iCurrent, iCurrent + sFind.Len() );
}

long MyFrame::DoShowLine (TextChild * pChild, int iLine)
{
    if (pChild == NULL) pChild = (TextChild *) GetActiveChild();
    return DoShowLine(pChild -> textctrl, iLine) ;
}

long MyFrame::DoShowLine (mywxTextCtrl * tc, int iLine)
{
    // show the line 4 above or below;
    int templine = iLine - 4 ;
    if ( iLine > tc -> GetCurrentLine() ) templine = iLine + 4 ;

    long iChar = tc -> XYToPosition ( 0, templine );
    tc -> SetInsertionPoint (iChar) ;
    tc -> ShowPosition (iChar) ;
//now show proper line
    iChar = tc -> XYToPosition ( 0, iLine );
    tc -> SetInsertionPoint (iChar) ;
    tc -> ShowPosition (iChar) ;

    return iChar ;
}


long MyFrame::DoFindLine (const wxString & s, int iStart, TextChild * pChild, bool bShowErrorText)
{
    // returns the number of the line the text was found in or wxNOT_FOUND
    // hightlights requested text if found
    // iStart is the line to begin with
	return DoFindLineBetween (s, iStart, -1, pChild, bShowErrorText) ;
}


long MyFrame::DoFindLineBetween (const wxString & s, int iStart, int iEnd, TextChild * pChild, bool bShowErrorText)
{
    // returns the number of the line the text was found in or wxNOT_FOUND
    // hightlights requested text if found
    // iStart is the line to begin with
	// if iEnd < 0 search entire document
	// if istart < iEnd reverse the search direction

    if (iEnd > 0 && iEnd < iStart) return DoFindLineBetween (s, iEnd, iStart, pChild, bShowErrorText) ;

    wxString sSearch = s ;
    sSearch.Replace ( wxT(" "), wxT("") ); // strip any spaces so we don't need to worry about exact syntax

    if (!pChild) pChild = (TextChild *) GetActiveChild();
    mywxTextCtrl * tc = pChild -> textctrl ;

    int iMax = tc -> GetNumberOfLines ();
	if (iEnd < iMax && iEnd > 0) iMax = iEnd ;
    int i = iStart;
    int iOffset = 0 ;
    wxString sLine ;
    bool bNotFound = TRUE ;
    while (( i < iMax ) && bNotFound )
    {
        //look for the line containg the string s
        sLine = tc -> GetLineText (i);
        sLine.Replace ( wxT(" "), wxT("") ); // strip any spaces and then compare
        iOffset = sLine.Find(sSearch);
        if ( iOffset >=0 ) bNotFound = FALSE ;
        i++ ;
    }
    if ( bNotFound )
    {
        if (bShowErrorText) SetStatusText(wxT("Text not found ") + s,1);
        else SetStatusText(wxEmptyString,1);
        return wxNOT_FOUND ;
    }
    SetStatusText(wxEmptyString,1);
    return i ;
}


long MyFrame::DoReverseFindLine (const wxString & s, int iStart, TextChild * pChild, bool bShowErrorText)
{
    // returns the number of the line the text was found in or wxNOT_FOUND
    // hightlights requested text if found
    // iStart is the line to begin with
	return DoReverseFindLineBetween (s, iStart, 0, pChild, bShowErrorText);
}

long MyFrame::DoReverseFindLineBetween (const wxString & s, int iStart, int iEnd, TextChild * pChild, bool bShowErrorText)
{

	if (iEnd < 0) iEnd = 0;
    wxString sSearch = s ;
    sSearch.Replace ( wxT(" "), wxT("") ); // strip any spaces so we don't need to worry about exact syntax

    if (!pChild) pChild = (TextChild *) GetActiveChild();
    mywxTextCtrl * tc = pChild -> textctrl ;
    int i = iStart;
    int iOffset = 0 ;
    wxString sLine ;
    bool bNotFound = TRUE ;
    while (( i >= iEnd ) && bNotFound )
    {
        //look for the line containg the string s
        sLine = tc -> GetLineText (i);
        sLine.Replace ( wxT(" "), wxT("") ); // strip any spaces and then compare
        iOffset = sLine.Find(sSearch);
        if ( iOffset >=0 ) bNotFound = FALSE ;
        i-- ;
    }
    if ( bNotFound )
    {
        if (bShowErrorText) SetStatusText(wxT("Text not found ") + s,1);
        else SetStatusText(wxEmptyString,1);
        return wxNOT_FOUND ;
    }
    SetStatusText(wxEmptyString,1);
    return i ;
}


void MyFrame::OnFindagain (wxCommandEvent & WXUNUSED(event))
{
    iCurrent = DoFindExactly (sFind,iCurrent+1,NULL, bLastSearchCS);
    TextChild * pChild = (TextChild *) GetActiveChild();
    if (iCurrent != wxNOT_FOUND) pChild -> textctrl -> SetSelection ( iCurrent, iCurrent + sFind.Len() );
}


void MyFrame::CreateBaseMenu (wxMenu * my_menu)
{
    my_menu->Append(wxH_NEW_PROJECT, wxT("&New Project\tCtrl-N"));
    my_menu->Append(wxH_REOPEN, wxT("&Open Project\tCtrl-O"),wxT("Reopen a closed project"));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_QUIT, wxT("E&xit\tAlt-X"), wxT("Quit the program"));
}


void MyFrame::CreateFileMenu (wxMenu * my_menu)
{

    my_menu->Append(wxH_NEW_PROJECT, wxT("&New Project"));
    my_menu->Append(wxH_REOPEN, wxT("&Reopen Project"),wxT("Reopen a closed project window"));
    my_menu->Append(wxH_OPEN_TEXT_WINDOW, wxT("&Open File"), wxT("Open a text file")) ;
    my_menu->AppendSeparator();
    my_menu->Append(wxH_PROJECT_SAVE, wxT("&Save project\tCtrl+S"), wxT("Save all project files"));
    my_menu->Append(wxH_PROJECT_COPY, wxT("Copy Project &To..."), wxT("Copy essential project files to a new directory"));
    my_menu->Append(wxH_NEW_TEXT_WINDOW, wxT("Add new pair of code files"), wxT("Add new .cpp and .h code files to this project"));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_EDIT, wxT("&Edit child Externally"),wxT("Edit this file in the external editor"));
    my_menu->Append(wxH_FILE_BACKUP, wxT("Sa&ve child"), wxT("Backup just this file with new name"));
    my_menu->Append(wxH_SWITCH, wxT("Switc&h cpp / h\tCtrl-H"), wxT("Switch between code and header windows"));
    my_menu->Append(wxH_FINDMENU, wxT("Vie&w Menu\tCtrl-W"), wxT("Switch to menu view"));
    my_menu->Append(wxH_FINDTREE, wxT("View &Tree\tCtrl-T"), wxT("Switch to tree view"));
    my_menu->Append(wxH_FINDDLG, wxT("View Dialog\tCtrl-D"), wxT("Switch to Dialog Control List view"));

    my_menu->AppendSeparator();
    my_menu->Append(Minimal_PageSetup, wxT("Pa&ge Setup"));
    my_menu->Append(Minimal_PrintSetup, wxT("Pr&inter Setup"));
    my_menu->Append(Minimal_Print, wxT("&Print...\tCtrl-P"));
    my_menu->Append(Minimal_Preview, wxT("P&review...\tCtrl-Shift-P"));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_CHILD_QUIT, wxT("C&lose child\tCtrl+F4"), wxT("Close current window"));
    my_menu->Append(wxH_PROJECT_QUIT, wxT("&Close Project\tCtrl+Shift+F4"), wxT("Close all project windows"));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_QUIT, wxT("E&xit\tAlt+X"));

}


void MyFrame::CreatePrefsMenu (wxMenu * my_menu)
{
    my_menu->Append(wxH_FONT_SEL, wxT("Select &Font"), wxT("Select the font size and Font Encoding") );
    my_menu->AppendSeparator();
    my_menu->Append(wxH_EDITOR, wxT("Select &External Editor"), wxT("Select an external editor") );
    my_menu->Append(wxH_IMAGE,  wxT("Select External &Image Editor"), wxT("Select an external image editor") );
    my_menu->Append(wxH_COMPILER,  wxT("Select External &Compiler"), wxT("Select an external Compiler") );
	my_menu->Append(wxH_SETPATH,  wxT("Select Additional &Path"), wxT("Select a Folder to add to the Path") );

    my_menu->AppendSeparator();
    my_menu->Append(wxH_PROJECTROOT,  wxT("Select Project Root &Directory"), wxT("Select Root Directory for future projects") );
    my_menu->Append(wxH_WXWINDIR,  wxT("Select &wxWidgets Directory") );
    my_menu->Append(wxH_WXHATCHROOT,  wxT("Check wxHatch Directory"), wxT("Select Directory that contains wxHatch files") );
    my_menu->AppendSeparator();
    my_menu->Append(wxH_PRELOAD, wxT("AutoLoad wxWidgets Help"), wxT("Loads wxWidgets help during splash screen"), (bool)TRUE );
}


void MyFrame::CreateEditMenu (wxMenu * my_menu)
{
    my_menu->Append(wxID_CUT,  wxT("&Cut  \tCtrl-X"));
    my_menu->Append(wxID_COPY,  wxT("&Copy  \tCtrl-C"));
    my_menu->Append(wxID_PASTE, wxT("&Paste \tCtrl-V"));


    my_menu->AppendSeparator();
    my_menu->Append(wxID_UNDO,  wxT("&Undo  \tCtrl-Z"));
    my_menu->Append(wxID_REDO, wxT("Re&do \tCtrl+Shift-Z"));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_FIND, wxT("&Find  \tCtrl-F"));
    my_menu->Append(wxH_FINDAGAIN, wxT("&Repeat Last Find  \tCtrl+Shift+F"));
    my_menu->Append(wxH_MATCHBRACE, wxT("&Find matching brace  \tCtrl-B"));
    my_menu->Append(wxH_INDENTBRACE, wxT("&Indent from this brace \tCtrl+Shift-B"));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_REPLACE, wxT("Rep&lace \tCtrl-L"));
    my_menu->Append(wxH_REPLACEAGAIN, wxT("Repea&t Last Replace\tCtrl+Shift-L"));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_GOLINE, wxT("&GoTo Line \tCtrl-G"));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_AUTOTEXT, wxT("&Expand AutoText \tF2"));
    my_menu->Append(wxH_ADDAUTOTEXT, wxT("&Insert AutoText \tAlt+F2"));
    my_menu->AppendSeparator();

}


void MyFrame::CreateHelpMenu (wxMenu * my_menu)
{
    my_menu->Append(wxH_CONTENTS, wxT("&Introduction\tF1"));
    my_menu->Append(wxH_WXHREF, wxT("&Reference")) ;
    my_menu->Append(wxH_TUTORIAL, wxT("wxHatch &Tutorials"));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_REFERENCE, wxT("&wxWin Reference"));
    my_menu->Append(wxH_REFSEARCH, wxT("&Search wxWin Reference\tCtrl+F1"));

    my_menu->AppendSeparator();
    my_menu->Append(wxH_ABOUT, wxT("&About"));
}


void MyFrame::CreateMenuMenu (wxMenu * my_menu)
{
    my_menu->Append(wxH_BLANK, wxT("&New menu"), wxT("Add a new menu to the menubar"));
    my_menu->Append(wxH_ITEM, wxT("Add &Item"), wxT("Add a new Item to the selected menubar"));
    my_menu->Append(wxH_SEP, wxT("Add &Separator"), wxT("Add a separator to the selected menu"));
    my_menu->Append(wxH_NEWPOPUP, wxT("&New Popup menu"), wxT("Add a new popup menu "));
    my_menu->AppendSeparator();
    my_menu->Append(wxH_FILEMENU, wxT("&File menu"), wxT("Add a file menu to the menubar"));
    my_menu->Append(wxH_FILEPRINTMENU, wxT("File and &Print menu"), wxT("Add a file with print menu to the menubar"));
    my_menu->Append(wxH_EDITMENU, wxT("&Edit menu"), wxT("Add an edit menu to the menubar"));
    my_menu->Append(wxH_HELPMENU, wxT("&Help menu"), wxT("Add a help menu to the menubar"));
}


void MyFrame::CreateRunMenu (wxMenu * my_menu)
{
    my_menu->Append( wxH_COMPILE, wxT("&Make \tCtrl-M"), wxT("Compile and link"));
    my_menu->Append( wxH_NEXTERROR, wxT("&Find Next Error \tCtrl+N"), wxT("Finds Source line for next error"));
    my_menu->Append( wxH_CLEAN, wxT("Make &Clean"), wxT("Remove objects etc"));
    my_menu->AppendSeparator();
    my_menu->Append( wxH_CONFIGURE, wxT("Configure wxWidgets"), wxT("Run configure in wxWidgets after selecting options"));
    my_menu->Append( wxH_REBUILD,wxT("Re&Build wxWidgets Library"),wxT("ReBuild wxWidgets Library"));
    my_menu->Append( wxH_COMLIB, wxT("ReBuild Contrib or other &Library"), wxT("Choose a library eg in the contrib directory and build it for current compiler"));
    my_menu->AppendSeparator();
    my_menu->Append( wxH_RUN, wxT("&Run \tCtrl-R"), wxT("Run the program"));
    my_menu->Append( wxH_DEBUG, wxT("&Debug "), wxT("Run the program under the debugger"));

}

void MyFrame::CreateCtrlMenu (wxMenu * my_menu, dlgChild * pdlgChild)
{
    wxString sFile = sExeRoot + sCodeDir + wxFILE_SEP_PATH + wxT( "controls.ini" )  ;
    wxFileConfig controlcfg (wxEmptyString, wxEmptyString, sFile, wxEmptyString, wxCONFIG_USE_LOCAL_FILE);

    wxString str ;
    long dummy;
    int i = wxH_CTRL ;
    wxImageList * pCtrlImageList = NULL ;
    wxBoxSizer * pToolBar = NULL ;

    sControlNames.Clear();
    sConstructors.Clear();
    sGetValues.Clear();
    sSetValues.Clear();
    sEvents.Clear();

	if (pdlgChild)
	{
        pCtrlImageList = pdlgChild -> TreeBox -> GetImageList();
        pToolBar = pdlgChild -> ButtonSizer ;
        pCtrlImageList -> Add ( wxBitmap ( dlg_xpm ) ) ;
        pCtrlImageList -> Add ( wxBitmap ( label_xpm ) );
	}

    bool bAnotherGroup = controlcfg.GetFirstGroup(str, dummy);
    while (bAnotherGroup)
    {
        wxString sEntry ;
        wxString sCaption = str ;
        controlcfg.Read(str + wxT( "/Constructor" ), &sEntry, wxEmptyString );

        if ( !sEntry.IsEmpty() )
        {
            my_menu->Append( i, sCaption ) ;
            sControlNames.Add(str) ;
            sConstructors.Add(sEntry);

            controlcfg.Read(str + wxT( "/Get" ), &sEntry, wxEmptyString );
            sGetValues.Add(sEntry);

            controlcfg.Read(str + wxT( "/Set" ), &sEntry, wxEmptyString );
            sSetValues.Add(sEntry);

            controlcfg.Read(str + wxT( "/Include" ), &sEntry, wxEmptyString );
            sControlIncludes.Add(sEntry);

            controlcfg.Read(str + wxT( "/Event" ), &sEntry, wxEmptyString );
            sEvents.Add(sEntry);
            if (pdlgChild)
            {
                controlcfg.Read(str + wxT( "/Bmp" ), &sEntry, wxEmptyString );
                wxBitmap bmp ;
                wxString sBmpFile = sExeRoot + sCodeDir + wxFILE_SEP_PATH + wxT("bitmaps") + wxFILE_SEP_PATH + sEntry ;
                if (!sEntry.IsEmpty() && wxFileExists(sBmpFile))
                { 
                    bmp = wxBitmap (sBmpFile, wxBITMAP_TYPE_XPM) ;
                    wxBitmapButton * bButton = new wxBitmapButton (pdlgChild, i, bmp);
#if wxUSE_TOOLTIPS
                    bButton -> SetToolTip (str);
#endif                    
                    pToolBar->Add(bButton);

                }
                else
                {
                    bmp = wxBitmap(blank_xpm) ;
                }
                pCtrlImageList -> Add ( bmp ) ;
            }
            i ++ ;
        }
        bAnotherGroup = controlcfg.GetNextGroup(str, dummy);
    }
    // add buttonsizer here, but note it makes the count of the controlnames one more than the others
    sControlNames.Add(wxT("CreateButtonSizer"));
    if (pdlgChild)
        {
            pCtrlImageList -> Add ( wxBitmap ( ok_xpm ) );
            pdlgChild -> mainsizer -> Layout (); 
        }



}

void MyFrame::CreateDlgMenu (wxMenu * my_menu, int iBegin, const wxString & sFile)
{
    int iLine = 0;
//    int iMenu = 0;

    wxTextFile snipfile;
    wxString sTmp = sExeRoot + sCodeDir + wxFILE_SEP_PATH + sFile;
    if (!snipfile.Open(sTmp))
    {
        wxMessageBox ( sTmp + wxT(" file not found"), wxT("Error!"));
        return;
    }
    wxString sLine;

    int iMax = snipfile.GetLineCount() ;

    while ( iLine < iMax )
    {
        sLine = snipfile.GetLine(iLine);
        if ( sLine.StartsWith(wxT("//") ) )
        {
            if (! sLine.Contains(wxT("//end")) )
            {
                // either a separator or a potential menu item
                if (sLine.Contains(wxT("Separator")    ))
                    my_menu->AppendSeparator ();
                else
                {
                    my_menu->Append (iBegin, sLine.AfterLast(wxT('/') ) );
                    iBegin ++ ;
  //                  iMenu ++ ;
                }
            }
        }
        if ( sLine.StartsWith(wxT("Disable:") )  )
        {
            DisableArrays.Add(sLine.AfterFirst(wxT(':')));
            int iTemp = iBegin - 1 ;
            DisableIndexes.Add(iTemp,1);
        }
        iLine ++ ;
    }
    snipfile.Close();

}


void MyFrame::CreateCodeMenu (wxMenu * my_menu, int iBegin, const wxString & sFile)
{
    wxMenu * my_sub_menu = new wxMenu (wxT("Surround with..."));
    int i ;
    for (i=0; i < (int) SurroundBeforeStrings.GetCount(); i ++)
    {
        my_sub_menu->Append(wxH_SURROUND_MIN + i, SurroundBeforeStrings[i] + wxT("...") +
        SurroundAfterStrings[i] ) ;
    }

    my_menu->Append(wxH_SUB, wxT("&Surround Selection"),my_sub_menu);

    CreateDlgMenu (my_menu, iBegin, sFile) ;
    my_menu->AppendSeparator();
    my_menu->Append (wxH_GOFNOGUI, wxT("Go/Add Frame &Non GUI Method"));
    switch (eLastMode)
    {
        case eTextStyle : my_menu->Append (wxH_GOCNOGUI, wxT("Go/Add TextCtrl Non &GUI Method"));
            break ;
        case eImgStyle : my_menu->Append (wxH_GOCNOGUI, wxT("Go/Add Canvas Non &GUI Method"));
            break ;
        case eListStyle : my_menu->Append (wxH_GOCNOGUI, wxT("Go/Add ListCtrl Non &GUI Method"));
            break ;
        case eNewDialog : my_menu->Append (wxH_GOCNOGUI, wxT("Go/Add Dialog Non &GUI Method"));
            break ;
        default :
            break ;
    }
}

void MyFrame::CreateToolsMenu (wxMenu * my_menu, bool bAllowConfigure /* = FALSE */)
{
    for (size_t i=0; i < saTools.GetCount(); i++)
    {
        my_menu->Append (i + wxH_MAX + 60, saTools[i].BeforeFirst(wxT(';') ) );
    }
    if (bAllowConfigure)
    {
        my_menu->AppendSeparator();
        my_menu->Append(wxH_TOOL_CONFIGURE, wxT("&Configure tools"), wxT("Amend the tools to this menu"));
        my_menu->Append(wxH_TOOL_ADD, wxT("&Add tool"), wxT("Runs a dialog to add a new tool to this menu"));
    }
}

void MyFrame::OnReOpenProject(wxCommandEvent& event )
{
	if (!wxDirExists(sExeRoot + sCodeDir))
    {
        // no wxhatch files found
        SetStatusText(wxT("Project creation cancelled, Please try again"),1);
        if (wxYES == wxMessageBox (wxT("Essential wxhatch files were not found\nDo you want to locate them now?"),
            wxT("wxHatch Warning"),  wxCENTRE | wxYES_NO ) )
            {
            OnChangeWxHatchRoot (event);
			return;
            }


    }

    wxDirDialog MyDialog (this, wxT("Choose the directory containing the project you wish to open"),
                          sProjectRoot);
    if (MyDialog.ShowModal() != wxID_OK)
    {
        return ;
    }
    DoReOpenProject(MyDialog.GetPath());
}

bool MyFrame::DoChildTest (const wxString & sTest, const wxString & sTestFileName)
{
    if (DoFindLine ( sTest + wxT("::") + sTest, 0, pMain_cpp ) != wxNOT_FOUND )
    {
        pCanv_h = pCanv_cpp = pMain_cpp ;
        sClassName = sTest ;
        return TRUE ;
    }

    if (DoFindLine ( wxT("#include \"") + sTestFileName + wxT(".h"), 0, pMain_cpp ) != wxNOT_FOUND )
    {
        pCanv_h   = DoNewTextWindow (sProjectDir + sTestFileName + wxT(".h"), TRUE);
        pCanv_cpp = DoNewTextWindow (sProjectDir + sTestFileName + wxT(".cpp"), TRUE, (eLastMode == eNewDialog));
        pCanv_h -> alternateWin = pCanv_cpp ;
        pCanv_cpp -> alternateWin = pCanv_h ;
        sClassName = sTest ;
        return TRUE ;
    }
    return FALSE ;
}

void MyFrame::DoReOpenProject (const wxString & s)
{
    pCanv_h = pCanv_cpp = NULL ;
    pMain_h = pMain_cpp = NULL ;
    wxString sDlgName ;

    //test for existence of directory
    sProjectDir = s ;
    if (! wxDirExists(s) )
    {
        wxMessageBox (wxT("Project directory not found"), wxT("Searched for ") + s);
        SetStatusText (wxEmptyString,1) ;
        return ;
    }
    //find and reopen the main window; then look for the others
    wxString sFile = wxFindFirstFile(sProjectDir + wxFILE_SEP_PATH + wxT("*.cpp"));
    bool bMainFound = FALSE ;
    while ( !sFile.IsEmpty() && !bMainFound )
    {
        //work round apparent bug with MS-windows in which .cpp~ matches as well as .cpp
        //this could be less clumsily done
        wxString sExt ;
        wxSplitPath (sFile, &sProjectDir, &sName, &sExt);
        if (sExt.Len() <= 3)
        {
            wxTextFile tf ;
            tf.Open(sFile);
            wxString sTmp = tf.GetFirstLine();
            while (!bMainFound && !tf.Eof())
            {
                if ( sTmp.Contains(wxT("::OnInit")) )
                {
                    bMainFound = TRUE;
                }
                sTmp = tf.GetNextLine();
            }
        }    //if (sExt.Len() <= 3)

        if (!bMainFound) sFile = wxFindNextFile();
    } // end of while
    if (!bMainFound)
        {
            (void)wxMessageBox( wxT("This does not look like a wxWidgets project directory \n")
                wxT("No cpp code files containing ::OnInit found in directory\n") + sProjectDir,
            wxT("wxHatch Error"));
            return ;
        }
    // minimal project wxHatch can deal with is just a frame
    eLastMode = eFrameOnly ;

    // sFile holds name of main program, containing OnInit

    //if its a dialog project we should find an insertion window with .inc
    wxString  sIncludeFile = wxFindFirstFile(sProjectDir + wxFILE_SEP_PATH +  wxT("*.inc")) ;
    wxString sExt ;
    wxSplitPath (sIncludeFile, NULL, NULL, &sExt);
    while (sExt.Len() > 3 && !sIncludeFile.IsEmpty())
        {
            sIncludeFile = wxFindNextFile();
            wxSplitPath (sIncludeFile, NULL, NULL, &sExt);
        }
    // note that 2.4.2 and 2.5.1 leak memory if we don't finsih the search with 
	// a non-existent file    
    wxString sTestFile = sIncludeFile ;
	while (! sTestFile.IsEmpty() ) sTestFile = wxFindNextFile();
    if (!sIncludeFile.IsEmpty())
    {
    // we have a dialog project
        eLastMode = eNewDialog ;

        pInc = DoNewTextWindow (sIncludeFile, TRUE);
        pInc -> textctrl -> eDlgType = IsDialogInclude ;

        // get the name of the dialog project out of the include file path
        wxSplitPath (sIncludeFile, NULL, &sDlgName, &sExt);

        //load mydlg.cpp into pCanv_cpp
        wxString s_File = sProjectDir + wxFILE_SEP_PATH + sDlgName + wxT(".cpp") ;
        if ( wxFileExists(s_File) ) pCanv_cpp = DoNewTextWindow (s_File, TRUE, TRUE);
        //test for header window
        s_File = sProjectDir + wxFILE_SEP_PATH + sDlgName + wxT(".h") ;
        if ( wxFileExists(s_File) )
        {
            pCanv_h = DoNewTextWindow (s_File, TRUE);
            pCanv_h -> alternateWin = pCanv_cpp ;
            pCanv_cpp -> alternateWin = pCanv_h ;
        }
    }
    //sFile must exist to get here
    pMain_cpp = DoNewTextWindow (sFile, TRUE);
    //is it a wxHatch project ?
    bool bHasFrame = TRUE;
    if (wxNOT_FOUND == DoFindLine( wxT("MyFrame::MyFrame"), 0, pMain_cpp))
    {
        if ( wxMessageBox( wxT("This does not look like a wxWidgets project that wxHatch can parse \n")
        wxT("The required main frame constructor MyFrame::MyFrame ")
        wxT("was not found in the Main code file\n") + sFile +
            wxT("\n\nDo you really want to try and load this project??"),
            wxT("wxHatch Error"),
        wxICON_QUESTION | wxYES_NO | wxNO_DEFAULT) == wxNO )
        {
            pMain_cpp -> bIsPartOfProject = FALSE ;
            pMain_cpp -> Close();
            pMain_cpp = NULL ;
            return ;
        }
        bHasFrame = FALSE;

    }


    lastFiles -> AddFileToHistory (sProjectDir);
    sProjectDir = sProjectDir + wxFILE_SEP_PATH ;

    pMain_h = pMain_cpp;
    // is the header and cpp seprate, or all in one ?
    if (DoFindLine ( wxT("#include \"") + sName + wxT(".h"), 0, pMain_cpp ) != wxNOT_FOUND )
    {
        pMain_h   = DoNewTextWindow (sProjectDir + sName + wxT(".h"), TRUE);
        pMain_h -> alternateWin = pMain_cpp ;
        pMain_cpp -> alternateWin = pMain_h ;
    }

    if (eLastMode == eFrameOnly)
    {
    // assign subwindow to pCanv_cpp and or pCanv_h
        //test for a LstCtrl
        if (DoChildTest( wxT("MyLstCtrl"), wxT( "lstctrl" )   ) ) eLastMode = eListStyle ;
        //test for a TxtCtrl in the main file
        if (DoChildTest( wxT("MyTxtCtrl"), wxT( "txtctrl" )   ) ) eLastMode = eTextStyle ;
        //test for a canvas in the main file
        if (DoChildTest( wxT("MyCanvas"), wxT( "canvas" )   ) ) eLastMode = eImgStyle ;
    }

    //iterate around the windows and look for other include and matching cpp files
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        TextChild * ptext = node->GetData() ;
        int iLine = DoFindLine (wxT("#include"), 0, ptext ) ;
        while ( iLine != wxNOT_FOUND )
        {
            wxString sLine = pMain_cpp -> textctrl -> GetLineText (iLine-1);

            if (sLine.Contains(wxT(".h")) && !sLine.Contains(wxT("wx/"))  )
            {
                //probably an include "file.h" in local dir
                wxString sOtherFile = sLine.AfterFirst(wxT('"')).BeforeLast(wxT('"')) ;
                TextChild * hdr = NULL;
                TextChild * cpp = NULL;
                sOtherFile = sProjectDir + sOtherFile ;
                wxString sKey = sOtherFile;
#ifdef __WXMSW__
                sKey.MakeLower();
#endif
                if (wxFileExists(sOtherFile) && !textWinList -> Find(sKey))
                    {
                        hdr = DoNewTextWindow (sOtherFile, TRUE);
                    }
                if (wxFileExists(sOtherFile) && !textWinList -> Find(sKey)) hdr = DoNewTextWindow (sOtherFile, TRUE);
                //try for a .cpp version
                sOtherFile.Replace (wxT(".h"), wxT(".cpp")) ;
                sKey = sOtherFile;
                #ifdef __WXMSW__
                sKey.MakeLower();
                #endif
                if (wxFileExists(sOtherFile) && !textWinList -> Find(sKey)) cpp = DoNewTextWindow (sOtherFile, TRUE);
				sKey = sOtherFile;
#ifdef __WXMSW__
                sKey.MakeLower();
#endif
                if (wxFileExists(sOtherFile) && !textWinList -> Find(sKey)) cpp = DoNewTextWindow (sOtherFile, TRUE);
                if (hdr && cpp)
                {
                    hdr -> alternateWin = cpp ;
                    cpp -> alternateWin = hdr ;
                }
            }
            iLine = DoFindLine (wxT("#include"), iLine, ptext ) ;
        }
        node = node->GetNext();
    }


    SetTitle ( wxT("wxHatching ") + sName ) ;
    if ( eLastMode == eNewDialog )
    {
        int iLine = DoFindLine ( wxT( "CreateButtonSizer" ) , 0, pCanv_cpp ) ;
        DoShowLine ( pCanv_cpp , iLine - 1 ) ;
        pCanv_cpp -> Activate ();
        pDlgWin = DoNewDlgWindow (pCanv_cpp);
        pDlgWin -> Activate ();

    }
    else
    if (bHasFrame)
    {
        pMenuChild = DoNewMenuWindow ();
        DoLoadMenuWindow () ;
        pMenuChild -> Activate ();
    }

    bProjectLoaded = TRUE ;
    SetStatusText (wxT( "Project loaded" )  ,1) ;

}


void MyFrame::DoLoadMenuWindow ()
{
// find the menubars and them get the labels
int iBar = DoFindLine ( wxT("wxMenuBar *"), 0, pMain_cpp );
if (iBar != wxNOT_FOUND )
{
    //wxMenuBar *menuBar = new wxMenuBar;
    wxString sTmp = pMain_cpp -> textctrl -> GetLineText (iBar-1);
    sTmp = sTmp.AfterFirst (wxT('*'));
    sTmp = sTmp.BeforeFirst (wxT('='));
    sTmp.Trim(TRUE).Trim(FALSE);
    //menuBar
    wxString  sMenuBarName = sTmp ;

    // limit searches to lines before setting the menu
    wxString sSearch ;
    sSearch =wxT("SetMenuBar(") + sMenuBarName ;
    int iSearchMax = DoFindLine (sSearch, iBar, pMain_cpp );

    sSearch = sMenuBarName + wxT("->Append") ;
    int iMenu = DoFindLineBetween (sSearch, iBar, iSearchMax, pMain_cpp );
    while ( iMenu != wxNOT_FOUND && iMenu < iSearchMax )
    {
        // menuBar->Append (File_menu, "&File");
        wxString sLine = pMain_cpp -> textctrl -> GetLineText (iMenu-1);
        // "&File");
        sTmp = sLine.AfterFirst (wxT('\"'));
        sTmp = sTmp.BeforeFirst (wxT('\"'));
        wxString sLabel = sTmp;

        // File_menu, "&File");
        sTmp = sLine.AfterFirst (wxT('('));

            // File_menu
            sTmp = sTmp.BeforeFirst (wxT(','));
            sTmp.Trim(TRUE).Trim(FALSE);
            wxString sMenuName = sTmp;

            //File_menu, &File
            pMenuChild->canvas->DoInsertMenu (sMenuName, sLabel);
            //now find the menu items for this menubar position ...
			int iSearchMin = DoReverseFindLine (wxT("wxMenu *") + sMenuName, iSearchMax, pMain_cpp);
            DoItemFind (sMenuName, sLabel, iSearchMin, iSearchMax, pMain_cpp);
            iMenu = DoFindLineBetween (sSearch, iMenu, iSearchMax, pMain_cpp );
        }
    } // end of dealing with wxMenuBar

    TextChild * pChild = pMain_cpp ;
    //TODO handle popup in canvas window
    int iPopup = DoFindLine (wxT("PopupMenu"), 0, pMain_cpp );
    while (iPopup != wxNOT_FOUND)
    {
        //PopupMenu (pMenu, event.GetPosition());;
        wxString sTmp = pMain_cpp -> textctrl -> GetLineText (iPopup-1);
        sTmp = sTmp.AfterFirst (wxT('('));
        sTmp = sTmp.BeforeFirst (wxT(','));
        sTmp.Trim(TRUE).Trim(FALSE);
        //pMenu
        wxString  sMenuBarName = sTmp ;


        // pMenu = new wxMenu(wxT("title")) ;
        wxString sSearch = sMenuBarName + wxT("= new wxMenu") ;
        int iMenu = DoFindLine (sSearch, 0, pChild );
        if (iMenu == wxNOT_FOUND)
        {
            sSearch = wxT("wxMenu ") + sMenuBarName ;
            DoFindLine (sSearch, 0, pChild );
        }
//TODO handle not found
        wxString sLine = pChild -> textctrl -> GetLineText (iMenu-1);
        sTmp = sLine.AfterFirst (wxT('"'));
            // File_menu
        sTmp = sTmp.BeforeFirst (wxT('"'));
        sTmp.Trim(TRUE).Trim(FALSE);
        wxString sLabel = sTmp;

        pMenuChild->canvas->DoInsertMenu (sMenuBarName, sLabel, TRUE);

        // now do the items ...
        DoItemFind (sMenuBarName, sLabel, iMenu, -1 ,pChild);

        iPopup = DoFindLine (wxT("PopupMenu"), iPopup, pMain_cpp );
    }
    //find the toolbar items
    TBitmapTool * pTool = NULL ;
    int iRealize = DoFindLine ( wxT("toolBar->Realize()"), 0, pMain_cpp );

    iBar = DoFindLine ( wxT("toolBar->Add"), 0, pMain_cpp );
    while (( iBar != wxNOT_FOUND ) &&  (iBar < iRealize) )
    {
        wxString sLine = pMain_cpp -> textctrl -> GetLineText (iBar-1);
        if (sLine.Contains(wxT("AddTool")))
        {
            wxString sID = sLine.AfterFirst(wxT('('));
            sID = sID.BeforeFirst(wxT(','));
            wxString sFile = sLine.AfterFirst(wxT('('));
            sFile = sFile.AfterFirst(wxT('('));
            sFile = sFile.BeforeFirst(wxT(')'));
            sFile.Trim(TRUE).Trim(FALSE);
            // last underscore
            size_t iUscore = sFile.Find(wxT('_'), TRUE);
            if (int(iUscore) != wxNOT_FOUND) sFile [iUscore] = wxT('.');
            //find help string
            wxString sHelp = sLine.AfterFirst(wxT('"'));
            sHelp = sHelp.BeforeFirst(wxT('"'));
            //try the bitmaps dir and then the project dir for the bitmaps
            // look for include path
            sLine = pMain_cpp -> textctrl -> GetLineText (DoFindLine ( sFile, 0, pMain_cpp ) - 1);
            sLine = sLine.AfterFirst(wxT('"'));
            sLine = sLine.BeforeFirst(wxT('"'));
            sLine = sProjectDir /*+ wxFILE_SEP_PATH */ + sLine ;
#ifdef __WXMSW__
            sLine.Replace(wxT("/"),  wxT("\\"), TRUE);
#else
            sLine.Replace(wxT("\\"), wxT("/"), TRUE);
#endif
            if ( wxFileExists (sLine) ) pTool = new TBitmapTool ( sLine, sID, sHelp );
               else
                {
                    (void)wxMessageBox( wxT("A required XPM bitmap file - ") + sLine + wxT("\nwas not found; \nplease check your directory tree."), wxT("wxHatch Warning"));
                    pTool = new TBitmapTool ( wxEmptyString, sID, sHelp );
                }
        }
        else
        {
            // its a separator
            pTool = new TBitmapTool (  );
        }
        pMenuChild->canvas->toolList->Append( pTool );

        iBar = DoFindLine ( wxT("toolBar->Add"), iBar, pMain_cpp );
    }
    pMenuChild->canvas->Refresh();
}


void MyFrame::DoItemFind(const wxString & sMenuName, const wxString & WXUNUSED(sLabel), int iStart, int iEnd, TextChild * pChild )
{
    // two parameters File and &File, and starting index
    // first look for this  File_menu -> Append ( wxH_OPEN, wxT("&Open\Ctrl+O"), wxT("Help") );
    // though we might also need to catch forms with no wxT, no help and no accelerator

    int iItem = DoFindLineBetween ( sMenuName + wxT(" -> Append"), iStart, iEnd, pChild );
    while ( iItem != wxNOT_FOUND )
    {
        wxString sTmp = pChild -> textctrl -> GetLineText (iItem-1);
        if ( sTmp.Contains (wxT("AppendSeparator")) )
        {
            pMenuChild->canvas->DoInsertMenu (-1, wxT("SEPARATOR"), FALSE, FALSE);
        }
        else
        {
            sTmp = sTmp.AfterFirst(wxT('('));
            //wxH_OPEN, wxT("&Open\Ctrl+O"), wxT("Help")
            sTmp = sTmp.BeforeLast(wxT(')'));
            wxString sID = sTmp.BeforeFirst(wxT(','));
            // &Open\Ctrl+O"), wxT("Help")
            sTmp = sTmp.AfterFirst(wxT('\"'));
            wxString sLabel = sTmp.BeforeFirst(wxT('\"'));
            // returns \Ctrl+O
            wxString sAccel = sLabel.AfterFirst  (wxT('\\'));
            // this will return &Open whether it has an accelerator or not;
            sLabel = sLabel.BeforeFirst (wxT('\\'));

            //  wxT("Help")
            sTmp = sTmp.AfterFirst(wxT(','));
            // Help")
            sTmp = sTmp.AfterFirst(wxT('\"'));
            // Help
            wxString sHlp = sTmp.BeforeFirst(wxT('\"'));

            //command events always in main cpp file
            int iID = DoFindLine ( wxT("EVT_MENU(") + sID + wxT(",") , 0, pMain_cpp );
            //     EVT_MENU (wxH_OPEN, MyFrame::OnOpen)
            sTmp = pMain_cpp -> textctrl -> GetLineText (iID-1);
            sTmp = sTmp.AfterLast(':');
            wxString sMethod = sTmp.BeforeLast(')');
            pMenuChild->canvas->DoInsertMenu (sID, sMenuName, sLabel, sMethod, sAccel, sHlp);
        }
        iItem = DoFindLineBetween ( sMenuName + wxT(" -> Append"), iItem, iEnd, pChild );
    }

}


void MyFrame::OnMRUFile(wxCommandEvent& event)
{
    wxString s ;
    int itmp = event.GetId()  - wxID_FILE1 ;
    s = lastFiles->GetHistoryFile(itmp);
    DoReOpenProject(s) ;

}

//use same function for all these !!
void MyFrame::OnModifySelection(wxCommandEvent& event)
{
    TextChild * pChild = (TextChild *)GetActiveChild();
    int  i = event.GetId() - wxH_SURROUND_MIN;
    pChild -> textctrl -> OnModifySelection (SurroundBeforeStrings[i],
		SurroundAfterStrings[i].BeforeFirst(wxT('\t')));
}

void MyFrame::OnCopy (wxCommandEvent & event )
{
    wxMDIChildFrame * pChild = GetActiveChild();
    if (pChild == pOutputWin)
    {
        ((ListChild *)pChild) -> OnCopy (event);
    }
    else
    {
        ((TextChild *)pChild) -> textctrl -> OnCopy (event);
    }
}

void MyFrame::OnCut (wxCommandEvent & event )
{
    TextChild * pChild = (TextChild *)GetActiveChild();
    pChild -> textctrl -> OnCut (event);
}


void MyFrame::OnPaste (wxCommandEvent & event )
{
    TextChild * pChild = (TextChild *)GetActiveChild();
    pChild -> textctrl -> OnPaste (event);
}


void MyFrame::OnRedo (wxCommandEvent & event )
{
    TextChild * pChild = (TextChild *)GetActiveChild();
    pChild -> textctrl -> OnRedo (event);
}


void MyFrame::OnUndo (wxCommandEvent & event )
{
    TextChild * pChild = (TextChild *)GetActiveChild();
    pChild -> textctrl -> OnUndo (event);
}



void MyFrame::OnAutoText (wxCommandEvent & WXUNUSED ( event )  )
{
    TextChild * pChild = (TextChild *)GetActiveChild();
    if (!pChild) return ;
    wxString sAbbr = pChild -> textctrl -> GetCurrentWord (TRUE);
    if (sAbbr.IsEmpty()) return ;
    sAbbr.MakeLower();
    sAbbr.Trim(TRUE).Trim(FALSE);
    int i = 0 ;
    bool bFound = FALSE ;
    while (i < int(sAutoTexts.GetCount()) && !bFound)
        {
        wxString sStart = sAutoTexts[i].BeforeFirst(comma);
        sStart.Trim(TRUE).Trim(FALSE);
        sStart.MakeLower();
        if (sAbbr == sStart) bFound = TRUE;
        i++ ;
        }
    if (bFound)
    {
        wxString sExpand = sAutoTexts[i-1].AfterFirst(comma);
        sExpand.Trim(TRUE).Trim(FALSE);
        sExpand << space ;
        pChild -> textctrl -> ReplaceSelection(sExpand) ;
        return ;
    }
    // not an existing autotext entry
    DoAddAutoText(sAbbr, wxEmptyString) ;
}

void MyFrame::OnAddAutoText (wxCommandEvent & WXUNUSED ( event )  )
{
    TextChild * pChild = (TextChild *)GetActiveChild();
    if (!pChild) return ;
    wxString sExpand = pChild -> textctrl -> GetCurrentWord (FALSE);
	DoAddAutoText (wxEmptyString, sExpand) ;
}

void MyFrame::DoAddAutoText (const wxString & sAbbr, const wxString & sExpand )
{
    MyAutoTextDialog dialog (this);
    dialog.SetAbbrValue (sAbbr);
    dialog.SetExpandValue (sExpand);

    if (dialog.ShowModal() != wxID_OK) return ;

    sAutoTexts.Add ( dialog.GetAbbrValue() + comma + space + dialog.GetExpandValue() );
}



void MyFrame::OnFindMenu (wxCommandEvent & WXUNUSED(event) )
{
    if (!bProjectLoaded) return ;
    if (!pMenuChild)
    {
        pMenuChild = DoNewMenuWindow ();
        DoLoadMenuWindow () ;
    }
    pMenuChild -> Activate ();

}

void MyFrame::OnFindDlg (wxCommandEvent & WXUNUSED(event) )
{
    if (!bProjectLoaded) return ;
    TextChild * pChild = (TextChild *)GetActiveChild();
    if (!pChild) return ;
    
    if ( pChild -> textctrl -> eDlgType == IsDialogInclude ) pChild = pCanv_cpp ;
    if ( pChild -> textctrl -> eDlgType == IsDialogHeader ) pChild = pChild -> alternateWin ;

    if (!pDlgWin)
    {
        pDlgWin = DoNewDlgWindow (pChild);
    }
    else
    {
        if ( pChild != pDlgWin -> myTextChild ) pDlgWin -> myTextChild = pChild ;
        pDlgWin -> myTextChild->textctrl->isDlgUpDated = TRUE ;
    }
    pDlgWin -> Activate ();
}

void MyFrame::OnFindTree (wxCommandEvent & WXUNUSED(event) )
{
    if (!bProjectLoaded) return ;
    if (!pTreeWin)
    {
        pTreeWin = DoNewTreeWindow ();
    }
    pTreeWin -> Activate ();

}

void MyFrame::OnChildClose (wxCommandEvent & WXUNUSED(event))
{
    GetActiveChild () -> Close ();
    bProjectLoaded = TRUE;
    if (nFrames == 0) bProjectLoaded = FALSE ;
}


bool MyFrame::DoCloseProject ()
{

    bool bDoesProjectNeedSaving = FALSE ;

    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData()->textctrl->IsModified() ) bDoesProjectNeedSaving = TRUE ;
        node = node->GetNext();
    }
    wxString msg = wxT("Unsaved windows still open, close anyhow?") ;
    if ( bDoesProjectNeedSaving )
    {
        if ( wxMessageBox(msg, wxT("wxHatch:  Please confirm"),
            wxICON_QUESTION | wxYES_NO | wxNO_DEFAULT) == wxNO )
        {
            SetStatusText (wxT( "Project not saved" )  ,1) ;
            return FALSE ;
        }
    }
    if (pMenuChild) pMenuChild -> Close ();
    if (pOutputWin) pOutputWin -> Close ();
    if (pTreeWin  ) pTreeWin   -> Close ();
    if (pDlgWin   ) pDlgWin    -> Close ();

    // closing will NULL the pointer
    node = textWinList->GetFirst();
    while (node)
    {
        TextChild *win = node->GetData();
        win -> bIsPartOfProject = FALSE ;
        win -> Close (TRUE);
        delete node ;
        node = textWinList->GetFirst();
    }
    // need to NULL this one
    if (pInc) pInc = NULL ;
    SetStatusText (wxEmptyString,1) ;
    return TRUE ;
}


void MyFrame::OnProjectClose (wxCommandEvent & WXUNUSED(event))
{
    DoCloseProject ();
    bProjectLoaded = TRUE;
    if (nFrames == 0) bProjectLoaded = FALSE ;

}


void MyFrame::WriteLine ( TextChild * pChild, int iLine , const wxString & s  )
{
    WriteLine ( pChild -> textctrl, iLine, s );
}


void MyFrame::WriteLine ( mywxTextCtrl * pTC, int iLine , const wxString & s  )
{
    // automatically adds the newline on
    pTC -> SetInsertionPoint (pTC -> XYToPosition (0, iLine) );
    pTC -> WriteText (s + newline);
}


void MyFrame::AppendText ( TextChild * pChild,  const wxString & s  )
{
    AppendText ( pChild -> textctrl, s );
}


void MyFrame::AppendText ( mywxTextCtrl * pTC,  const wxString & s  )
{
    // automatically adds a newline on
    pTC -> SetInsertionPointEnd ();
    pTC -> WriteText (s + newline);
}


wxString MyFrame::RemoveLine ( int iLine , TextChild * pChild )
{
   return RemoveLine ( iLine , pChild -> textctrl );

}
wxString MyFrame::RemoveLine ( int iLine , mywxTextCtrl * pTC )
{
    if (iLine == wxNOT_FOUND) return wxEmptyString ;

    long iLineMax = pTC -> GetLineLength (iLine);
    wxString sLine = pTC -> GetLineText (iLine);
    sLine.Replace( wxT("\n"), wxT(" ") );
    // 2 for msw, 1 for unix (not for styled text)
//    #ifdef __WXMSW__
//        const int nEnd = 2;
//    #else
//        const int nEnd = 1;
//    #endif
    int nEnd = 0 ;
    pTC -> Remove ( pTC -> XYToPosition (0, iLine), pTC -> XYToPosition (iLineMax, iLine) + nEnd) ;
    return sLine ;
}


void MyFrame::OnMoveup (wxCommandEvent & event)
{

    int iSel = pMenuChild -> canvas -> iSelected ;
    if (iSel < 2) return ; // ignore it
    //target menu, will insert before
    TBitmapMenu * pBM = pMenuChild -> canvas -> menuList->Item(iSel - 1) -> GetData();
    if ( pBM -> IsBase () )
    {
        OnMoveL (event );
        return ;
    }

    long iLine = DoGoMnu () ;
    wxString sLine = RemoveLine ( iLine-1, pMain_cpp -> textctrl );

    iLine = DoGoMnu (pBM) ;
    pBM = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected ) -> GetData();
    if (! pBM -> IsBase() ) WriteLine (pMain_cpp, iLine-1, pBM -> GetMenuText () );

    pMenuChild -> Activate ();  // forces reload of menu
}





void MyFrame::OnMovedown (wxCommandEvent & event)
{
    int iSel = pMenuChild -> canvas -> iSelected ;
    //target menu, will insert after !!
    TBitmapMenu * pBM = pMenuChild -> canvas -> menuList->Item(iSel + 1) -> GetData();
    if ( pBM -> IsBase () )
    {
        OnMoveR (event );
        return ;
    }
    long iLine = DoGoMnu () ;
    wxString sLine = RemoveLine ( iLine-1, pMain_cpp -> textctrl );

    iLine = DoGoMnu (pBM) ;
    pBM = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected ) -> GetData();
    if (! pBM -> IsBase() ) WriteLine (pMain_cpp, iLine , pBM -> GetMenuText () ); //NB there is a +1 here

    pMenuChild -> Activate ();

}



void MyFrame::OnMoveR (wxCommandEvent & WXUNUSED(event))
{
    // find menu item in next menu
    int iNew = pMenuChild -> canvas -> iSelected ;
    while (! pMenuChild -> canvas -> menuList->Item(iNew) -> GetData() -> IsBase () )
    {
        iNew ++ ;
    }
    iNew ++ ; // first member of next menu

    if (iNew < (int) pMenuChild -> canvas -> menuList-> GetCount ())
    {
        long iLine = DoGoMnu () ;
        wxString sLine = RemoveLine ( iLine-1, pMain_cpp -> textctrl );

        pMenuChild -> canvas -> MoveMenu ( pMenuChild -> canvas -> iSelected, iNew ); // change the menu to which the item is attached

        TBitmapMenu * pBM = pMenuChild -> canvas -> menuList->Item( iNew ) -> GetData();
        WriteLine (pMain_cpp, iLine-1, pBM -> GetMenuText () );

        pMenuChild -> Activate ();
    }

}


void MyFrame::OnMoveL (wxCommandEvent & WXUNUSED(event))
{
    // find menu item in previous menu
    int iNew = pMenuChild -> canvas -> iSelected ;
    while (! pMenuChild -> canvas -> menuList->Item(iNew) -> GetData() -> IsBase () )
    {
        iNew -- ;
    }
    iNew -- ; // find last member of previous menu

    if (iNew > 0)
    {
        long iLine = DoGoMnu () ;
        wxString sLine = RemoveLine ( iLine-1, pMain_cpp -> textctrl );

        pMenuChild -> canvas -> MoveMenu ( pMenuChild -> canvas -> iSelected, iNew ); // change the menu to which the item is attached

        TBitmapMenu * pBM = pMenuChild -> canvas -> menuList->Item( iNew ) -> GetData();
        WriteLine (pMain_cpp, iLine-1, pBM -> GetMenuText () );

        pMenuChild -> Activate ();
    }

}


void MyFrame::OnDelete (wxCommandEvent & event)
{
    //If it is a separator, we can remove it
    // delete the menu insertion
    long iLine = DoGoMnu ();
    if (iLine == wxNOT_FOUND)
    {
        wxMessageBox (wxT("Menu not found in ") + pMain_cpp->filename );
        return;
    }
    RemoveLine ( iLine -1, pMain_cpp -> textctrl );
    // if not a separator do all the rest...
    if (!pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected ) -> GetData() -> IsSeparator() )
    {
    // delete the declaration
    iLine = DoGodec () ;
    if (iLine == wxNOT_FOUND)
    {
        wxMessageBox (wxT("Declaration not found in ") + pMain_h->filename );
        return;
    }
    RemoveLine ( iLine -1, pMain_h -> textctrl );

    // delete the ID
    iLine = DoGoId ();
    if (iLine == wxNOT_FOUND)
    {
        wxMessageBox (wxT("Menu ID not found in ") + pMain_h->filename );
        return;
    }
    RemoveLine ( iLine -1, pMain_h -> textctrl );

    // delete the event table entry
    iLine = DoGoevt ();
    if (iLine == wxNOT_FOUND)
    {
        wxMessageBox (wxT("Event Table not found in ") + pMain_cpp->filename );
        return;
    }
    RemoveLine ( iLine -1, pMain_cpp -> textctrl );


    // Delete the body
    iLine = DoGobody () ;
    if (iLine == wxNOT_FOUND)
    {
        wxMessageBox (wxT("Body not found in ") + pMain_cpp->filename );
        return;
    }

    // select & delete matching text
    OnSelBrace(event);
    pMain_cpp->textctrl->ReplaceSelection (wxEmptyString);
    RemoveLine ( iLine-1, pMain_cpp -> textctrl );
    pMenuChild -> canvas -> DeleteCurrentNode (TRUE);
    }
    pMenuChild -> Activate ();
}


void MyFrame::OnGobody (wxCommandEvent & WXUNUSED(event))
{
    DoGobody ();
}


int MyFrame::DoGobody ()
{
    pMain_cpp -> Activate ();

    TBitmapMenu *current = NULL;
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    if (pNode)
    {
        TBitmapTool *currenttool = pNode->GetData();
        // on a separator already
        if (currenttool -> myID.IsEmpty() ) return wxNOT_FOUND ;
        current = pMenuChild -> canvas -> MatchTool (currenttool-> myID);
    }
    int iSel = pMenuChild -> canvas -> iSelected;
    if (iSel != wxNOT_FOUND)  current = pMenuChild -> canvas -> menuList->Item(iSel) -> GetData();
    if (current == NULL) return wxNOT_FOUND ;

    wxString sTmp = current->GetOnString() ;
    sTmp = wxT("void MyFrame::") + sTmp + wxT(" (");
    int iLine = DoFindLine ( sTmp, 0, pMain_cpp) ;

    DoShowLine (pMain_cpp, iLine + 2);
    mywxTextCtrl * tc = pMain_cpp -> textctrl ;
    tc -> SetInsertionPoint (tc -> GetInsertionPoint() + 4) ;

    //TODO if not found, add it & declaration
    return iLine ;
}


void MyFrame::OnGodec (wxCommandEvent & WXUNUSED(event))
{
    DoGodec ();
}


int MyFrame::DoGodec ()
{
    pMain_h -> Activate ();
    // no check for invalid iSelected !!
    TBitmapMenu *current = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected) -> GetData();
    wxString sTmp = current->GetOnString() + wxT(" ("); ;
    int iLine = DoFindLine ( sTmp ,0, pMain_h)  ;

    DoShowLine (pMain_h, iLine );

    //TODO if not found, add it & declaration
    return iLine ;
}


void MyFrame::OnGoevt (wxCommandEvent & WXUNUSED(event))
{
    DoGoevt ();
}


int MyFrame::DoGoevt ()
{
    pMain_cpp -> Activate ();
    // no check for invalid iSelected !!
    TBitmapMenu *current = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected) -> GetData();
    // we need the comma for filesave versus filesaveas
    wxString sTmp = wxT("EVT_MENU(") + current->GetIDString() + wxT(",");

    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    DoShowLine (pMain_cpp, iLine );
    //TODO if not found, add it
    return iLine ;
}


void MyFrame::OnGoMnu (wxCommandEvent & WXUNUSED(event))
{
    DoGoMnu ();
}


int MyFrame::DoGoMnu (TBitmapMenu * pBM /* =NULL */ )
{
    pMain_cpp -> Activate ();
    // no check for invalid iSelected !!
    TBitmapMenu * current ;
    if (pBM == NULL)
    {
        current = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected) -> GetData();
    }
    else
    {
        current = pBM ;
    }
    if (current->IsSeparator())
        {
            //find the menu item before it
            // test for root being the one before it Unlikely but possible?
            int iLine = 0;
            int i;
            for (i=0; i < pMenuChild -> canvas -> menuList->IndexOf(current); i++)
                {
                TBitmapMenu * test = pMenuChild -> canvas -> menuList->Item(i) -> GetData() ;
                if ( !test -> IsSeparator()  && !test -> IsBase ()) iLine = DoGoMnu(test);
                }
            iLine = DoFindLine ( wxT("AppendSeparator"), iLine, pMain_cpp );
            return iLine ;
        }
	wxString sTmp ;
	if (current -> IsBase())
		{
		sTmp = current->GetBaseString();
		sTmp = wxT("wxMenu *") + sTmp + wxT("= new wxMenu") ;
		}

    else
	{
		sTmp = current->GetIDString() ;
        sTmp = wxT("Append ( ") + sTmp + wxT(",") ;
	}
    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    if (iLine > wxNOT_FOUND)
    {
        DoShowLine (pMain_cpp, iLine );
    }
    return iLine ;

}


void MyFrame::OnGoenable (wxCommandEvent & WXUNUSED(event))
{
    DoGoenable ();
}


int MyFrame::DoGoenable ()
{
    pMain_cpp -> Activate ();
    // no check for invalid iSelected !!
    TBitmapMenu *current = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected) -> GetData();
    wxString sTmp =  wxT("MyFrame::") + current -> GetOnEnableString() + wxT("(");

    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    if (iLine == wxNOT_FOUND)
    {
        // add to header
        iLine = DoFindLine ( wxT("DECLARE_EVENT_TABLE") ,0, pMain_h) ;
        WriteLine (pMain_h, iLine-1, current -> GetEnableDeclarationText());
        iLine = DoFindLine ( wxT("END_EVENT_TABLE") ,0, pMain_cpp) ;
        WriteLine (pMain_cpp,iLine-1,current->GetEventTableEnableText());
        AppendText (pMain_cpp, current -> GetEnableText());
        iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;

    }
    DoShowLine (pMain_cpp, iLine + 2);
    return iLine ;

}


void MyFrame::OnGoId (wxCommandEvent & WXUNUSED(event))
{
    DoGoId ();
}


int MyFrame::DoGoId ()
{
    pMain_h -> Activate ();
    // no check for invalid iSelected !!
    TBitmapMenu *current = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected) -> GetData();
    wxString sTmp = current->GetIDString() ;
    sTmp = sTmp + wxT(",") ;
    int iLine = DoFindLine ( sTmp, 0, pMain_h) ;
    DoShowLine (pMain_h, iLine );
    if (iLine == wxNOT_FOUND)
    {
        // might be #define
        sTmp = current->GetIDString() ;
        int iLine = DoFindLine ( sTmp, 0, pMain_h) ;
        DoShowLine (pMain_h, iLine );
    }
    //TODO if not found, add it
    return iLine ;
}


void MyFrame::OnAllowNewProject  (wxUpdateUIEvent & event)
{
    event.Enable (!bProjectLoaded) ;
}

wxString MyFrame::GetSelectedText()
{
    wxMDIChildFrame* pChild = GetActiveChild() ;
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            return node->GetData()->textctrl->GetSelectedText();
        }
        node = node->GetNext();
    }
    return wxEmptyString ;

}


void MyFrame::OnSearchHelp (wxCommandEvent& WXUNUSED(event))
{
    if (sWXWIN.IsEmpty())
    {
        if (wxYES == wxMessageBox (wxT("No wxWidgets directory chosen\nDo You want to choose one now?"),
                wxT("wxHatch Warning"),
                wxCENTRE | wxYES_NO ) )

            ProcessCommand (wxH_WXWINDIR) ;
        return ;
    }

    wxString sText = GetSelectedText ();
    wxString sRest ;
    if (sText.StartsWith(wxT("my"), &sRest)) sText = wxT("wx") + sRest ;
    if (sText.StartsWith(wxT("My"), &sRest)) sText = wxT("wx") + sRest ;
    if (sText.StartsWith(wxT("m_"), &sRest)) sText = wxT("wx") + sRest ;

    MyTextDialog dialog(this,
    wxT("Enter a single keyword"),
    wxT("Search the wx Documentation"),
    sText,
    wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;
    sText = dialog.GetValue() ;

    bool bUsewxWin = TRUE ;
    if (LoadHelp(bUsewxWin)) pHTMLHelpFrame -> KeywordSearch ( sText );
}


void MyFrame::OnHelp(wxCommandEvent& event)
{

    wxString s ;
    bool bUsewxWin = FALSE;
    switch ( event.GetId () )
    {
        case  wxH_REFERENCE :

            if (sWXWIN.IsEmpty())
            {
                if (wxYES == wxMessageBox (wxT("No wxWidgets directory chosen\nDo You want to choose one now?"),
                        wxT("wxHatch Warning"),
                        wxCENTRE | wxYES_NO ) )

                    ProcessCommand (wxH_WXWINDIR) ;
                return ;
            }
            bUsewxWin = TRUE ;
            s = wxT("wx26.htm") ;
            break ;

        case  wxH_TUTORIAL :
            s = sExeRoot + wxT("help") + wxFILE_SEP_PATH + wxT("tutorial.html") ;
            break ;
        case  wxH_CONTENTS :
            default :
            s = sExeRoot + wxT("help") + wxFILE_SEP_PATH + wxT("index.html") ;
            break ;
        case  wxH_WXHREF :
            s = sExeRoot + wxT("help") + wxFILE_SEP_PATH + wxT("reference.html") ;
            break ;
        case  wxH_WXHTOOLS :
            s = sExeRoot + wxT("help") + wxFILE_SEP_PATH + wxT("reference") + wxFILE_SEP_PATH + wxT("tools.html") ;
            break ;

    }
    if (LoadHelp(bUsewxWin)) pHTMLHelpFrame -> Display ( s );

}


bool MyFrame::LoadHelp (bool bUsewxWin /*= FALSE */, bool bShowWaitMsg /*=TRUE*/ )
{
    if (!pHTMLHelpFrame)
        {
            pHTMLHelpFrame = new wxHtmlHelpController(wxHF_DEFAULT_STYLE | wxHF_OPEN_FILES);

            pConfig->SetPath(RegKey) ;
            pHTMLHelpFrame -> UseConfig (pConfig) ;
            wxString sTempDir = wxFileName::GetHomeDir() + wxFILE_SEP_PATH + wxT(".wxh_hlpcache") ;
            if (!wxDirExists(sTempDir)) wxFileName::Mkdir (sTempDir, 0777, wxPATH_MKDIR_FULL) ; 
            pHTMLHelpFrame -> SetTempDir( sTempDir );

            wxString sBook = sExeRoot + wxT("help") + wxFILE_SEP_PATH + wxT("wxhatch.hhp");
            if (!wxFileExists(sBook))
                {
                wxMessageBox (wxString(wxT("Sorry the help file requested \n") + sBook +
				    wxT("\n does not exist, \nLook at http://biolpc22.york.ac.uk/wx/wxhatch/download.html \nfor a fresh download" )));

                return FALSE ;
                }
            else pHTMLHelpFrame -> AddBook (sBook , bShowWaitMsg) ;
        }

        if (bUsewxWin)
        {
            wxString sBook ;
            bool bBookNotFound = TRUE ;
            wxString sBadLocations = wxT("Sorry the help file was not found at \n");
            wxArrayString sLocations ;
            sLocations.Add(sWXWIN);
            sLocations.Add(sExeRoot);            
            sLocations.Add(wxT("/usr/local/share/wx"));
            size_t iIndex = 0 ;
            
            while ( bBookNotFound  && iIndex < sLocations.GetCount() )
            {
            sBook = sLocations[iIndex] ;
            sBook = sBook + wxT("/docs/htb/wx.htb") ;
            if (wxFileExists(sBook))
                {
                bBookNotFound = FALSE ;
                sBadLocations = sBadLocations + sBook + newline ;
                }
                iIndex ++ ;
            }
            if (bBookNotFound)
            {
                wxMessageBox (sBadLocations +
				    wxT("\n \nPlease install the wxWidgets documentation from \nhttp://biolpc22.york.ac.uk/wx/wxhatch/download_doc.html \nfor a fresh download" ));

                return FALSE ;
            }
            else pHTMLHelpFrame -> AddBook (sBook , bShowWaitMsg) ;
        }
        return TRUE ;
}

/*
void MyFrame::OnUpdateAnyDialog (wxUpdateUIEvent & event)
{

    wxMDIChildFrame * pChild = (wxMDIChildFrame * ) event.GetEventObject ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }
    if (pChild == (wxMDIChildFrame * )GetActiveChild())
    {
        event.Skip();
        return ;
    }

    if ((pChild == pMenuChild) || (pChild == pOutputWin) ||  (pChild == pTreeWin))
    {
        event.Enable(FALSE);
        return ;
    }

    TextChild * tc = (TextChild *) pChild ;

    int iD = event.GetId();
    if (iD < wxH_MAX + 30)
    {
        event.Enable(TRUE);
        return ;
    }
    if (!(tc -> textctrl-> bNeedsEnableCheck))
    {
        event.Skip();
        return ;
    }

    iD = iD - (wxH_MAX + 30) ;
    int iMax = DisableArrays.GetCount() - 1;
    iD = iD % iMax ;

    wxString sTest = DisableArrays.Item(iD);
    if (sTest.IsEmpty())
    {
        event.Enable(TRUE);
        if (iD == iMax-1) tc -> textctrl-> bNeedsEnableCheck = FALSE ;
        return ;
    }
//    int iAlreadyFound = DoFindLine (sTest, 0, pMain_cpp ) ;
    int iAlreadyFound ;
    iAlreadyFound = pMain_cpp->textctrl->FindTxt (0, pMain_cpp->textctrl->GetTextLength(), sTest, TRUE);
    event.Enable(iAlreadyFound == wxNOT_FOUND);
    if (iD == iMax-1) tc -> textctrl-> bNeedsEnableCheck = FALSE ;

}
*/


void MyFrame::OnAnyDialog (wxCommandEvent & event)
{
    TextChild * tc = (TextChild *) GetActiveChild ();
    int iD = event.GetId();
    wxMenuBar * myMenubar = tc -> GetMenuBar() ;
    int iMenus = myMenubar -> GetMenuCount() ;
    int i = 0 ;
    wxMenu * myMenu = NULL;
    wxMenuItem * myMenuItem = NULL ;
    while ( (i < iMenus) && !myMenuItem )
    {
        myMenu = myMenubar -> GetMenu (i);
        myMenuItem = myMenu -> FindItem (iD);
        i ++ ;
    }

    wxString sTmp =  myMenu -> GetLabel(iD);
    sTmp.Replace(wxT("_"),wxT("&"));


    if (iD < wxH_MAX + 30) DoCode ( sTmp, sExeRoot + sCodeDir + wxFILE_SEP_PATH + wxT("snipdlgs.cpp") );
    else DoCode (sTmp, sExeRoot + sCodeDir + wxFILE_SEP_PATH + wxT("snipcode.cpp")) ;

    DoAnymenuOpen();
}


void MyFrame::DoCode (const wxString & sText, const wxString & sFile )
{
    wxTextFile snipfile;
    if (!snipfile.Open(sFile))
    {
        wxMessageBox ( sFile + wxT(" file not found"), wxT("Error!"));
        return;
    }
    //default is to write to the current file
    TextChild * pChild = (TextChild *) GetActiveChild() ;
    pChild -> textctrl -> WriteText ( newline );
    wxString sLine;
    int i = 0 ;
    int iMax = snipfile.GetLineCount() ;

    bool bNotFound = TRUE ;
    while (( i < iMax ) && bNotFound )
    {
        sLine = snipfile.GetLine(i);
        if ( sLine.StartsWith(wxT("//") + sText)) bNotFound = FALSE ;
        i ++ ;
    }

    sLine = snipfile.GetLine(i);
    i ++ ;
    if (  bNotFound )
    {
    (void)wxMessageBox( wxT("Code File \n") + sFile + wxT( "did not contain the dialog " ) +
        sText + wxT("\nCannot add Dialog" )  , wxT("wxHatch warning"));
    return ;
    }
    bNotFound = TRUE ;
    bool bLineProcessed ;
    int iLine = 0;
    while (( i < iMax ) && bNotFound )
    {
        bLineProcessed = FALSE;
        if ( sLine.Contains(wxT("#include")))
        {
            long iCppPos ;
            iCppPos = pChild -> textctrl -> GetInsertionPoint () ;
            iLine = DoFindLine ( wxT("WX_PRECOMP"), 0,  pChild );
            WriteLine ( pChild, iLine + 3, sLine );
            pChild -> textctrl -> SetInsertionPoint  ( iCppPos + sLine.Len() + 1 ) ;
            iLine = 0 ;

            if (pCanv_cpp && (pCanv_cpp != pChild) )
            {
            iCppPos = pCanv_cpp -> textctrl -> GetInsertionPoint () ;
            iLine = DoFindLine ( wxT("WX_PRECOMP"), 0,  pCanv_cpp );
            WriteLine ( pCanv_cpp, iLine + 3, sLine );
            pCanv_cpp -> textctrl -> SetInsertionPoint  ( iCppPos + sLine.Len() + 1 ) ;
            iLine = 0 ;
            }
            bLineProcessed = TRUE;
        }
        if ( sLine.StartsWith ( wxT("/*") ) )
        {
            bLineProcessed = TRUE;
        }
        if (sLine.StartsWith ( wxT("Find:")) )
        {
            iLine = DoFindLine ( sLine.AfterFirst (wxT(':')), iLine,  pChild );
            if (iLine != wxNOT_FOUND) pChild -> textctrl -> SetInsertionPoint  ( pChild -> textctrl -> XYToPosition ( 0, iLine ) ) ;
            bLineProcessed = TRUE;
        }
        if (sLine.StartsWith ( wxT("Execute:")) )
        {
	        sLine = sLine.AfterFirst (wxT(':')) ;
	        long iCommand = -1 ;
	        if (sLine.ToLong(&iCommand)) ProcessCommand ( iCommand );
            bLineProcessed = TRUE;
        }
        if (sLine.StartsWith ( wxT("Append:")) )
        {
	    AppendText (pChild, wxT('\n'));
            bLineProcessed = TRUE;
        }
        if (sLine.StartsWith ( wxT("cpp:")) )
        {
            pChild = pMain_cpp ;
            bLineProcessed = TRUE;
        }
        if (sLine.StartsWith ( wxT("h:")) )
        {
            pChild = pMain_h ;
            bLineProcessed = TRUE;
        }
        if (sLine.StartsWith ( wxT("Reset:")) )
        {
            iLine = 0 ;
            bLineProcessed = TRUE;
        }
        if (sLine.StartsWith ( wxT("Disable:")) )
        {
            bLineProcessed = TRUE;
        }
        if (!bLineProcessed) pChild -> textctrl -> WriteText ( sLine + newline );
        sLine = snipfile.GetLine(i);
        if ( sLine.StartsWith(wxT("//end of"))) bNotFound = FALSE ;
        i ++ ;
    }
    snipfile.Close ();
    pChild -> Activate ();
}

void MyFrame::InsertOwnDialog (wxCommandEvent& WXUNUSED(event))
{
    wxMDIChildFrame * oldChild ;
    oldChild = GetActiveChild();
        
    wxString myFilename ;
    wxFileDialog dialog(this, wxT("Open"), sProjectRoot, wxEmptyString,
        wxT("Dialog include files (*.inc)|*.inc|All files (*.*)|*.*"),
    wxOPEN); // for opening files
    
    if (dialog.ShowModal() == wxID_OK)
    {
        myFilename = dialog.GetPath() ;
        
        wxFileName ff (myFilename);
        wxString fnameOnly = ff.GetName() ;
        ff.SetExt(wxT( "cpp" ));
        wxString fCpp  = ff.GetFullPath();  
        if (!wxFileExists(fCpp))
        {
            (void)wxMessageBox( wxT("Expected Code File \n") + fCpp + wxT( "not found \nCannot add Dialog" )  , wxT("wxHatch warning"));
            return ;
        } 
        
        ff.SetExt(wxT( "h" ));
        wxString fHead  = ff.GetFullPath();   
        if (!wxFileExists(fHead))
        {
            (void)wxMessageBox( wxT("Expected Code File \n") + fHead + wxT( "not found \nCannot add Dialog" )  , wxT("wxHatch warning"));
            return ;
        } 
        DoCode (wxT("wx ") + fnameOnly, myFilename);
        wxCopyFile ( fCpp,  sProjectDir + fnameOnly + wxT(".cpp")) ;
        wxCopyFile ( fHead, sProjectDir + fnameOnly + wxT(".h")) ;
        
        TextChild *textframe_h, * textframe_cpp ;
        textframe_h= DoNewTextWindow ( fHead, TRUE);
        textframe_h->textctrl->DoStyle (fHead);
        textframe_cpp= DoNewTextWindow ( fCpp, TRUE);
        textframe_cpp->textctrl->DoStyle (fCpp);

        GenerateMakefile() ;
        oldChild -> SetFocus() ;
    }
    
    
}
void MyFrame::OnGoFDec (wxCommandEvent & WXUNUSED(event))
{
    pMain_h -> Activate ();
    wxString sTmp = wxT("class MyFrame")  ;
    int iLine = DoFindLine ( sTmp ,0, pMain_h ) ;
    if (iLine != wxNOT_FOUND) DoShowLine (pMain_h, iLine );
    //should always be there !!
    else
    {
        wxMessageBox (wxT("The declaration of class MyFrame has disappered from the file,\n")
                      wxT("where it was found on opening the project \n")
                      + pMain_h -> filename + wxT(" Please restore from a backup "),
                      wxT("wxHatch Warning"));
        return ;
    }
}


void MyFrame::OnGoFCons (wxCommandEvent & WXUNUSED(event))
{
    pMain_cpp -> Activate ();
    wxString sTmp = wxT("MyFrame::MyFrame")  ;
    int iLine = DoFindLine ( sTmp ,0, pMain_cpp ) ;
    if (iLine != wxNOT_FOUND) DoShowLine (pMain_cpp, iLine );
        //should always be there !!
    else
    {
        wxMessageBox (wxT("The constructor MyFrame::MyFrame has disappered from the file,\n")
                      wxT("where it was found on opening the project \n")
                      + pMain_cpp -> filename + wxT(" Please restore from a backup "),
                      wxT("wxHatch Warning"));
        return ;
    }
}


void MyFrame::OnGoFDes (wxCommandEvent & WXUNUSED(event))
{
    DoGoFDes () ;
}

int MyFrame::DoGoFDes ()
{
    pMain_cpp -> Activate ();
    wxString sTmp = wxT("MyFrame::~MyFrame")  ;
    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    if (iLine != wxNOT_FOUND) DoShowLine (pMain_cpp, iLine );
    //if not found, add it
    else
    {
        // add to header after constructor
        iLine = DoFindLine ( wxT("MyFrame(") ,0, pMain_h) ;
        WriteLine ( pMain_h, iLine, wxT("\n    ~MyFrame ();" ));
        AppendText (pMain_cpp, wxT( "\nMyFrame::~MyFrame ()\n{\n\n}\n\n "));
        iLine = 1+ DoFindLine ( sTmp ,0, pMain_cpp) ;
        DoShowLine (pMain_cpp, iLine + 1);

    }
    return iLine ;
}


void MyFrame::OnGoFSize (wxCommandEvent & WXUNUSED(event))
{
    pMain_cpp -> Activate ();
    //    pMain_cpp -> SetFocus ();
    wxString sTmp = wxT(" MyFrame::OnSize")  ;
    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    if (iLine != wxNOT_FOUND) DoShowLine (pMain_cpp, iLine );
    //if not found, add it
    else
    {
        // add to header
        iLine = DoFindLine ( wxT("DECLARE_EVENT_TABLE") ,0, pMain_h) ;
        WriteLine (pMain_h,iLine-1,wxT("\n    void OnSize (wxSizeEvent& event);" ));
        iLine = DoFindLine ( wxT("END_EVENT_TABLE") ,0, pMain_cpp) ;
        WriteLine (pMain_cpp,iLine-1,wxT( "    EVT_SIZE(MyFrame::OnSize)"));
        AppendText (pMain_cpp, wxT( "\nvoid MyFrame::OnSize (wxSizeEvent& event)\n{\n//something like \n//canvas->SetSize(event.GetSize()) ;\n}\n\n "));
        iLine = 1+ DoFindLine ( sTmp ,0, pMain_cpp) ;
        DoShowLine (pMain_cpp, iLine + 1);
    }

}


void MyFrame::OnGoFClose (wxCommandEvent & WXUNUSED(event))
{
    pMain_cpp -> Activate ();
    //    pMain_cpp -> SetFocus ();
    wxString sTmp = wxT("MyFrame::OnClose(")  ;
    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    if (iLine != wxNOT_FOUND) DoShowLine (pMain_cpp, iLine );
    //if not found, ?? should always be there

}


void MyFrame::OnSwitchWindow (wxCommandEvent & WXUNUSED(event))
{
    TextChild * pChild = (TextChild *)GetActiveChild ();
    if (pChild -> alternateWin)
        pChild -> alternateWin -> Activate ();
}


void MyFrame::OnAllowSwitchWindow  (wxUpdateUIEvent & event)
{
    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            event.Enable(node->GetData()->alternateWin != NULL);
            return ;
        }
        node = node->GetNext();
    }
    TextChild * tc = (TextChild *) pChild ;
    event.Enable(tc -> alternateWin != NULL);
}


void MyFrame::OnGoCCons (wxCommandEvent & WXUNUSED(event))
{
    pCanv_cpp -> Activate ();
    wxString sTmp = sClassName + wxT("::") + sClassName  ;
    int iLine = DoFindLine ( sTmp ,0, pCanv_cpp ) ;
    if (iLine != wxNOT_FOUND) DoShowLine (pCanv_cpp, iLine );
    //TODO; should alwayd be there !! if not found, add it  ??
}


void MyFrame::OnGoCDes (wxCommandEvent & WXUNUSED(event))
{
    pCanv_cpp -> Activate ();
    wxString sTmp = sClassName + wxT("::~") + sClassName  ;
    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    if (iLine != wxNOT_FOUND) DoShowLine (pCanv_cpp, iLine );
    //if not found, add it
    else
    {
        // add to header after constructor
        iLine = DoFindLine ( sClassName + wxT("(") ,0, pCanv_h) ;
        WriteLine (pCanv_h, iLine, wxT("\n    ~") + sClassName + wxT(" (); " ));
        AppendText (pCanv_cpp, wxT( "\n") + sClassName + wxT("::~") + sClassName + wxT(" ()\n{\n\n}\n\n "));
        iLine = DoFindLine ( sTmp ,0, pCanv_cpp) ;
        if (iLine != wxNOT_FOUND) DoShowLine (pCanv_cpp, iLine  + 1);

    }

}


void MyFrame::OnGoCDec (wxCommandEvent & WXUNUSED(event))
{
    if (!pCanv_h) return ;
    pCanv_h -> Activate ();
    wxString sTmp = wxT("class ") + sClassName  ;
    int iLine = DoFindLine ( sTmp ,0, pCanv_h ) ;
    if (iLine != wxNOT_FOUND) DoShowLine (pCanv_h, iLine + 1);
    //TODO; should alwayd be there !! if not found, add it  ??
}


void MyFrame::OnGoOnDraw (wxCommandEvent & WXUNUSED(event))
{
    if (!pCanv_cpp) return ;

    pCanv_cpp  -> Activate ();
    wxString sTmp = sClassName + wxT("::OnDraw")  ;
    int iLine = DoFindLine ( sTmp ,0, pCanv_cpp) ;
    if (iLine != wxNOT_FOUND) DoShowLine (pCanv_cpp, iLine );
    //if not found, add it
    else
    {
        if ( sClassName == wxT("MyLstCtrl") || sClassName == wxT("MyTxtCtrl") )
        {
            wxString sQuestion = wxT("Overwrite existing draw method anyhow?") ;
            if ( wxMessageBox(sQuestion, wxT("WxHatch warning - Please confirm"),  wxICON_QUESTION | wxYES_NO) == wxNO )
            {
                // answer was no
                return ;
            }
            else
            {
                //answer was yes
            }
        }
        // add to header after constructor
        iLine = DoFindLine ( sClassName + wxT("(") ,0, pCanv_h) ;
        WriteLine (pCanv_h, iLine, wxT("\n    void OnDraw (wxDC& dc);" ));
        AppendText (pCanv_cpp, wxT( "\nvoid ") + sClassName + wxT("::OnDraw (wxDC& dc)\n{\n    \n}\n\n "));
        iLine = DoFindLine ( sTmp ,0, pCanv_cpp) ;
        if (iLine != wxNOT_FOUND) DoShowLine (pCanv_cpp, iLine + 1 );
    }

}
void MyFrame::OnGoRClick (wxCommandEvent & WXUNUSED(event))
{
    DoGoEvent (sClassName, wxT("OnRightUp"), wxT("wxMouseEvent & event"), wxT("    EVT_RIGHT_UP(") );
}


void MyFrame::OnGoLClickUp (wxCommandEvent & WXUNUSED(event))
{
    DoGoEvent (sClassName, wxT("OnLeftUp"), wxT("wxMouseEvent & event"), wxT("    EVT_LEFT_UP(") );
}

void MyFrame::OnGoLClick (wxCommandEvent & WXUNUSED(event))
{
    DoGoEvent (sClassName, wxT("OnLeftDown"), wxT("wxMouseEvent & event"), wxT("    EVT_LEFT_DOWN(") );
}

void MyFrame::OnGoLdblClick (wxCommandEvent & WXUNUSED(event))
{
    DoGoEvent (sClassName, wxT("OnLeft_Dbl_Click"), wxT("wxMouseEvent & event"), wxT("    EVT_LEFT_DCLICK(") );
}

void MyFrame::OnGoMsemove (wxCommandEvent & WXUNUSED(event))
{
    DoGoEvent (sClassName, wxT("OnMouseMove"), wxT("wxMouseEvent & event"), wxT("    EVT_MOTION(") );
}

int MyFrame::DoGoEvent (const wxString & myclassstring,
                const wxString & mymethodstring,
                const wxString & myeventstring,
                const wxString & mytablestring)
{
    TextChild * p_cpp = pCanv_cpp ;
    TextChild * p_h = pCanv_h ;

    if ( myclassstring.Contains(wxT("rame")))
    {
        p_cpp = pMain_cpp ;
        p_h = pMain_h ;
    }

    p_cpp -> Activate ();
    //    p_cpp -> SetFocus ();
    wxString sTmp = wxT("void") + myclassstring + wxT("::") + mymethodstring  ;
    int iLine = DoFindLine ( sTmp ,0, p_cpp) ;
    if (iLine != wxNOT_FOUND) DoShowLine (p_cpp, iLine );
    //if not found, add it
    else
    {
        // add to header after constructor
        iLine = DoFindLine ( myclassstring + wxT("(") ,0, p_h) ;
        WriteLine (p_h, iLine, wxT("\n    void ") + mymethodstring + wxT(" (") + myeventstring+ wxT("); " ));
        iLine = DoFindLine ( wxT("BEGIN_EVENT_TABLE(") + myclassstring, 0, p_cpp) ;
        iLine = DoFindLine ( wxT("END_EVENT_TABLE"), iLine, p_cpp) ;
        WriteLine (p_cpp, iLine-1, mytablestring + myclassstring + wxT("::") +
                mymethodstring + wxT(")"));
        AppendText (p_cpp, wxT( "\nvoid ") + myclassstring + wxT("::") + mymethodstring +
                wxT(" (") + myeventstring + wxT(")\n{\n    \n}\n\n "));
        iLine = DoFindLine ( sTmp ,0, p_cpp) ;
        if (iLine != wxNOT_FOUND) DoShowLine (p_cpp, iLine + 1 );

    }
    return iLine ;
}

void MyFrame::OnChange_icon (wxCommandEvent & WXUNUSED(event))
{
    wxString myFilename = sProjectDir + sName + sIconExt;
    wxFileDialog dialog(this, wxT("Open"), wxPathOnly(myFilename), myFilename,
    wxT("Icons (*") + sIconExt + wxT(")|*") + sIconExt +
    wxT("|All files (*.*)|*.*"),
    wxOPEN);                 // for opening files

    if (dialog.ShowModal() == wxID_OK)
    {
        myFilename = dialog.GetPath() ;
        wxCopyFile ( myFilename, sProjectDir + sName + sIconExt );

        // for wxMSW force recompilation of .rc file
        wxExecute (wxT("touch ") + sProjectDir + sName + wxT(".rc") );
        pMenuChild->canvas->ChangeIcon();
        pMenuChild->canvas->Refresh();
    }
}


void MyFrame::OnEdit_icon (wxCommandEvent & event)
{

    if (!sImage.IsEmpty())
    {
        wxCopyFile ( sProjectDir + sName + sIconExt, sProjectDir + sName + sIconExt + wxT('~') );
        wxExecute ( sImage + space + sProjectDir + sName + sIconExt );
        pMenuChild->Close();
        pMenuChild=NULL ;
        return ;
    }
    // no editor chosen
    if (wxYES == wxMessageBox (wxT("No Image Editor chosen\nDo You want to choose one now?"),
        wxT("wxHatch Warning"),
    wxCENTRE | wxYES_NO ) )

    OnChangeImageEditor (event);
}


void MyFrame::OnGoline   (wxCommandEvent & event)
{

    wxString sTmp ;
    TextChild * pChild = (TextChild *) GetActiveChild() ;

    MyTextDialog dialog(this,
    wxT("Enter the line number required "),
    wxT("Finding Line.."),
    sTmp,
    wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;
    sTmp = dialog.GetValue() ;

    long iLine ;
    if (!sTmp.ToLong(&iLine))
    {
        if (wxYES == wxMessageBox (wxT("Bad line Number entered \nDo you want to try again now?"),
            wxT("wxHatch Warning"), wxCENTRE | wxYES_NO ) )
            AddPendingEvent (event) ;
        return;
    }

    long iPos = DoShowLine ( pChild, iLine );
    pChild -> textctrl -> SetSelection ( iPos, iPos + pChild -> textctrl -> GetLine (iLine).Len() );

}


void MyFrame::OnAddToToolbar (wxCommandEvent & WXUNUSED(event))
{

    wxString sTmp = wxT("CreateToolBar")  ;
    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    if (iLine == wxNOT_FOUND)
    {
        //
        //add the body to the frame constructor
        sTmp = wxT("SetMenuBar");
        iLine = DoFindLine ( sTmp, 0, pMain_cpp) ;
        //TODO handle not found error
        WriteLine (pMain_cpp, iLine, wxT("    CreateToolBar(wxNO_BORDER | wxTB_FLAT | wxTB_HORIZONTAL);\n    InitToolBar(GetToolBar());"));
        // add the inittoolbar function
        //  const int maxbitmaps = 0 ;\n\n"));
        AppendText (pMain_cpp, wxT("void MyFrame::InitToolBar(wxToolBar* toolBar)\n{\n  "));
        AppendText (pMain_cpp, wxT("    toolBar->Realize();\n} \n\n"));
        //add the declaration to the header file
        iLine = DoFindLine ( wxT("DECLARE_EVENT_TABLE") ,0, pMain_h) ;
        WriteLine (pMain_h, iLine-1,  wxT("\n    void InitToolBar(wxToolBar* toolBar); " ));
    }
    // create the  bitmap directory if needed
    sTmp = sProjectDir + wxFILE_SEP_PATH + wxT("bitmaps") ;
    if (!::wxDirExists(sTmp)) wxMkdir (sTmp.c_str()) ;

    // now insert an item...

    //get the data
    TBitmapMenu *current = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected) -> GetData();
    wxString sID = current->GetIDString() ;
    wxString sHelp = current->GetHelpString();
    wxString sTool = current->GetConCatString();
    wxString sBMFile = sTool + wxT(".xpm");
    wxString sBMPath = sProjectDir + wxT("bitmaps") + wxFILE_SEP_PATH + sBMFile ;

    //Now do an include of mondrian or appropriate bitmap

    iLine = DoFindLine ( wxT("class MyFrame;") ,0, pMain_cpp) - 2;
    WriteLine (pMain_cpp,  iLine+1, wxT("#include \"bitmaps/") + sBMFile + wxT("\" "));

    wxCopyFile ( sExeRoot + wxT("bitmaps") + wxFILE_SEP_PATH + GetBitmap(sTool), sBMPath );
    CheckXPM ( sBMPath );

    //actually add to the list
    TBitmapTool * pTool = new TBitmapTool ( sBMPath, sID, sHelp );
    if (pMenuChild->canvas->selBmp)
    {
        pMenuChild->canvas->toolList->Insert( pMenuChild->canvas->selBmp, pTool );
        TBitmapTool * pLastTool = pMenuChild->canvas->selBmp -> GetData ();
        iLine = DoFindLine ( wxT("toolBar->AddTool(") + pLastTool->myID, 0, pMain_cpp) ;
        WriteLine (pMain_cpp->textctrl, iLine-1, pTool -> GetAddToolText (pMenuChild->canvas)  );
    }
    else
    {
        pMenuChild->canvas->toolList->Append( pTool );
        iLine = DoFindLine ( wxT("toolBar->Realize();"), 0, pMain_cpp) ;
        WriteLine (pMain_cpp->textctrl, iLine-1, pTool -> GetAddToolText (pMenuChild->canvas)  );
    }
    pMenuChild->canvas->Refresh();
}


void MyFrame::OnTBMveright (wxCommandEvent & WXUNUSED(event))
{

    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    TBitmapTool *current = pNode->GetData();
    int iTool = pMenuChild->canvas->toolList->IndexOf (current);

    int iLine ;
    if (current -> myID.IsEmpty() )
    {
        //its a separator
        return ;
        /*        TBitmapTool *current = pNode->GetPrevious()->GetData();
                            wxString sTmp = wxT("toolBar->AddTool(") + current -> myID ;
                         iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
                */
    }
    else
    {
        //delete from the code
        wxString sTmp = wxT("toolBar->AddTool(") + current -> myID ;
        iLine = DoFindLine ( sTmp ,0, pMain_cpp) - 1 ;
    }
    wxString sLine = RemoveLine (iLine, pMain_cpp -> textctrl);
    WriteLine (pMain_cpp, iLine+1, sLine );

    pMenuChild->canvas->toolList->DeleteNode(pNode) ;
    pMenuChild->canvas->toolList->Insert(iTool+1, current);
    pMenuChild->canvas->Refresh();

}


void MyFrame::OnTBMveleft (wxCommandEvent & WXUNUSED(event))
{
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    TBitmapTool *current = pNode->GetData();
    int iTool = pMenuChild->canvas->toolList->IndexOf (current);

    int iLine ;
    if (current -> myID.IsEmpty() )
    {
        //its a separator
        return ;

    }
    else
    {
        //delete from the code
        wxString sTmp = wxT("toolBar->AddTool(") + current -> myID ;
        iLine = DoFindLine ( sTmp ,0, pMain_cpp) - 1 ;
    }
    wxString sLine = RemoveLine (iLine, pMain_cpp -> textctrl);
    WriteLine (pMain_cpp, iLine-1, sLine   );

    pMenuChild->canvas->toolList->DeleteNode(pNode) ;
    pMenuChild->canvas->toolList->Insert(iTool-1, current);
    pMenuChild->canvas->Refresh();
}


void MyFrame::OnTBDel (wxCommandEvent & WXUNUSED(event))
{
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    TBitmapTool *current = pNode->GetData();

    int iLine ;
    wxString sTmp ;
    if (current -> myID.IsEmpty() )
    {
        //its a separator
        TBitmapTool *current = pNode->GetPrevious()->GetData();
        sTmp = wxT("toolBar->AddTool(") + current -> myID ;
        iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    }
    else
    {
        //delete from the code
        sTmp = wxT("toolBar->AddTool(") + current -> myID ;
        iLine = DoFindLine ( sTmp ,0, pMain_cpp) - 1 ;
    }
    RemoveLine ( iLine, pMain_cpp -> textctrl) ;

    // remove the include for the bitmap
    sTmp = current->GetConCatString(pMenuChild->canvas);
    sTmp = sTmp + wxT(".xpm");

    iLine = DoFindLine ( sTmp, 0, pMain_cpp) - 1 ;
    RemoveLine ( iLine, pMain_cpp -> textctrl) ;


    //delete from the list
    delete current ;
    pMenuChild->canvas->toolList->DeleteNode(pNode) ;

    pMenuChild->canvas->Refresh();
}


void MyFrame::OnTBSep (wxCommandEvent & WXUNUSED(event))
{
    //TODO check if already has a separator ...
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    TBitmapTool *current = pNode->GetData();
    // on a separator already
    if (current -> myID.IsEmpty() ) return ;

    //find the code
    wxString sTmp = wxT("toolBar->AddTool(") + current -> myID ;
    int iLine = DoFindLine ( sTmp ,0, pMain_cpp)  ;
    WriteLine (pMain_cpp, iLine, wxT("    toolBar->AddSeparator() ;"));

    //add to the list
    TBitmapTool * pTool = new TBitmapTool ( wxEmptyString, wxEmptyString );

    pMenuChild->canvas->toolList->Insert( pNode->GetNext(), pTool );
    pMenuChild->canvas->Refresh();

}


void MyFrame::OnTBChange (wxCommandEvent & WXUNUSED(event))
{
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    TBitmapTool *current = pNode->GetData();
    // on a separator already
    if (current -> myID.IsEmpty() ) return ;
    wxString sFile = current -> myFilename ;

    wxFileDialog dialog(this, wxT("Open"), wxPathOnly(sFile), sFile,
    wxT("XPM bitmaps files (*.xpm)|*.xpm|All files (*.*)|*.*"),
    wxOPEN);                 // for opening files

    if (dialog.ShowModal() == wxID_OK)
    {
        wxCopyFile ( dialog.GetPath(), sFile ) ;
        CheckXPM (sFile);
        pMenuChild->Close();
        pMenuChild = NULL ;
        pMenuChild = DoNewMenuWindow ();
        DoLoadMenuWindow () ;

    }

}

void MyFrame::OnUpdateTextImageEdit (wxUpdateUIEvent & event)
{
    sTextImage = GetSelectedText ();
    if (sTextImage.IsEmpty())
        {
        event.Enable(FALSE);
        return ;
        }
    wxString ext = sTextImage.AfterLast(dot).Lower();
    if (ext.IsEmpty())
        {
        event.Enable(FALSE);
        return ;
        }
    event.Enable(ext == wxT("ico") || ext == wxT("bmp") || ext == wxT("png")
              || ext == wxT("jpg") || ext == wxT("xpm") || ext == wxT("cur")
              || ext == wxT("xbm") || ext == wxT("tif") || ext == wxT("tiff")) ;
}


void MyFrame::OnTextImageEdit (wxCommandEvent & event)
{
    if ( sTextImage.IsEmpty() ) return ;

    if (sImage.IsEmpty())
    {
    // no editor chosen
    if (wxYES == wxMessageBox (wxT("No Image Editor chosen\nDo You want to choose one now?"),
        wxT("wxHatch Warning"), wxCENTRE | wxYES_NO ) )

    OnChangeImageEditor (event);
    else return ;
    }

    wxFileName fPath = sTextImage ;
    if (!fPath.IsAbsolute())
        {
        fPath.Normalize ( wxhNORMALISE, sProjectDir );
//        fPath.MakeRelativeTo(sExeRoot);
        sTextImage = fPath.GetFullPath()  ;
        }

    if (! wxFileExists (sTextImage) )
    {
        if (wxNO == wxMessageBox (wxT("File ") + sTextImage + wxT("\nnot found.\nDo You want to create one now?"),
            wxT("wxHatch Warning"), wxCENTRE | wxYES_NO ) )
        {
            sTextImage = wxEmptyString ;
            return ;
        }
    // create a new image with give filename
    int xMax = 200;
    int yMax = 150;
    wxImage newImage (xMax,yMax) ;
    for (int i=0; i < xMax; i++)
        for (int j=0; j<yMax; j++)
            newImage.SetRGB(i,j,128,128,128);
    newImage.SaveFile(sTextImage);
    }
    else
    {
        wxCopyFile ( sTextImage, sTextImage + wxT('~') );
    }
    wxExecute ( sImage + space + sTextImage);
    sTextImage = wxEmptyString ;
    return ;

}

void MyFrame::OnTBEdit (wxCommandEvent & event)
{
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    TBitmapTool *current = pNode->GetData();
    // on a separator already
    if (current -> myID.IsEmpty() ) return ;

    if (!sImage.IsEmpty())
    {
        wxCopyFile ( current -> myFilename, current -> myFilename + wxT('~') );
        wxExecute ( sImage + space + current -> myFilename );
        pMenuChild->Close();
        pMenuChild=NULL ;
        return ;
    }
    // no editor chosen
    if (wxYES == wxMessageBox (wxT("No Image Editor chosen\nDo You want to choose one now?"),
        wxT("wxHatch Warning"),
    wxCENTRE | wxYES_NO ) )

    OnChangeImageEditor (event);
}


void MyFrame::OnTBChangetext (wxCommandEvent & WXUNUSED(event))
{
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    TBitmapTool *current = pNode->GetData();

    int iLine ;
    if (current -> myID.IsEmpty() )
    {
        //its a separator
        return ;
    }

    wxString sHelp = current -> myHelp ;

    MyTextDialog dialog(this,
    wxT("Enter the new help text"),
    wxT("Change help text for ") + current -> GetConCatString (pMenuChild->canvas),
    sHelp,
    wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;
    current -> myHelp = dialog.GetValue () ;

    wxString sTmp = wxT("toolBar->AddTool(") + current -> myID ;
    iLine = DoFindLine ( sTmp ,0, pMain_cpp) - 1 ;
    RemoveLine ( iLine, pMain_cpp -> textctrl );
    WriteLine (  pMain_cpp, iLine, current -> GetAddToolText (pMenuChild->canvas) );

    pMenuChild->canvas->Refresh();

}


void MyFrame::OnTBGocode (wxCommandEvent & WXUNUSED(event))
{
    wxString sTmp = wxT("MyFrame::InitToolBar");
    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    DoShowLine(pMain_cpp, iLine );
    pMain_cpp -> Activate ();

}


void MyFrame::OnTBGoBody (wxCommandEvent & WXUNUSED(event))
{
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    if (!pNode) return ;
    TBitmapTool *current = pNode->GetData();
    // on a separator already
    if (current -> myID.IsEmpty() ) return ;

    TBitmapMenu * currentMenuItem = pMenuChild->canvas->MatchTool (current-> myID);
    if (!currentMenuItem) return ;

    pMain_cpp -> Activate ();
    //    pMain_cpp -> SetFocus ();

    wxString sTmp = currentMenuItem->GetOnString() ;
    sTmp = wxT("void MyFrame::") + sTmp + wxT(" (");
    int iLine = 1+ DoFindLine ( sTmp ,0, pMain_cpp) ;
    DoShowLine(pMain_cpp, iLine );
    //TODO if not found, add it & declaration
    return  ;
}

void MyFrame::OnTBGoenable (wxCommandEvent & WXUNUSED(event))
{
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    if (!pNode) return ;
    TBitmapTool *current = pNode->GetData();
    // on a separator already
    if (current -> myID.IsEmpty() ) return ;

    TBitmapMenu * currentMenuItem = pMenuChild->canvas->MatchTool (current-> myID);
    if (!currentMenuItem) return ;

    pMain_cpp -> Activate ();

    wxString sTmp =  wxT("MyFrame::") + currentMenuItem -> GetOnEnableString() + wxT("(");

    int iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;
    if (iLine == wxNOT_FOUND)
    {
        // add to header
        iLine = DoFindLine ( wxT("DECLARE_EVENT_TABLE") ,0, pMain_h) ;
        WriteLine (pMain_h, iLine-1, currentMenuItem -> GetEnableDeclarationText());
        iLine = DoFindLine ( wxT("END_EVENT_TABLE") ,0, pMain_cpp) ;
        WriteLine (pMain_cpp,iLine-1,currentMenuItem->GetEventTableEnableText());
        AppendText (pMain_cpp, currentMenuItem -> GetEnableText());
        iLine = DoFindLine ( sTmp ,0, pMain_cpp) ;

    }
    DoShowLine (pMain_cpp, iLine + 2);
    return ;
}

void MyFrame::CheckXPM ( const wxString & sFile )
{
    wxTextFile XPMfile ;
    size_t i = 0 ;
    bool bNotFound = TRUE ;
    wxString sLine ;
    XPMfile.Open (sFile);
    while (( i < XPMfile.GetLineCount () ) && (bNotFound) )
    {
        sLine = XPMfile [i];
        if (sLine.Contains(wxT("char"))) bNotFound = FALSE ;
        else i ++ ;
    }
    if (bNotFound) return ;
    wxString p, f, e ;
    wxSplitPath (sFile, &p, &f, &e ) ;
    sLine = wxT("static char *") + f + wxT("_") + e + wxT("[] = {") ;
    XPMfile [i] = sLine ;
    XPMfile.Write();
}


long MyFrame::DoReplaceExactText (const wxString & s, const wxString & r, long iStart, TextChild * pChild)
{

    long iPos = DoFindExactly (s , iStart, pChild, bLastSearchCS) ;
    if (iPos !=wxNOT_FOUND )
    {
        int iEnd = iPos + s.Len() ;
        pChild -> textctrl -> Remove ( iPos, iEnd );

        pChild -> textctrl -> SetInsertionPoint (iPos);
        pChild -> textctrl -> WriteText ( r );
    }
    return iPos ;
}


void MyFrame::OnReplace (wxCommandEvent & WXUNUSED(event))
{
    wxString sText = GetSelectedText() ;
    if (!sText.IsEmpty() ) sFind = sText ;
    if (sReplace.IsEmpty()) sReplace = sFind ;

    MySearchReplaceDialog dialog(this, SRData (sFind, sReplace, TRUE, bLastSearchFS, bLastSearchCS), wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;

    SRData srd = dialog.GetValue() ;
    sFind = srd.sF ;
    sReplace = srd.sR ;
    bLastSearchFS = srd.bFS ;
    bLastSearchCS = srd.bCS ;

    TextChild * pChild = (TextChild *) GetActiveChild() ;
    int iStart = 0;
    if (!bLastSearchFS) iStart = 1 + pChild -> textctrl -> GetInsertionPoint() ;
    iCurrent = DoReplaceExactText (sFind, sReplace, iStart, pChild) ;
}


void MyFrame::OnReplaceAgain (wxCommandEvent & event)
{
    TextChild * pChild = (TextChild *) GetActiveChild() ;
    if (iCurrent == wxNOT_FOUND) OnReplace(event);
    else
    iCurrent = DoReplaceExactText (sFind, sReplace, iCurrent + sReplace.Len(), pChild) ;
}


long MyFrame::DoFindExactly (const wxString & sIn, long iStart, TextChild * pChild, bool bCaseSensitive /* = TRUE */)
{
    // returns the position (no of chars) the text was found at or wxNOT_FOUND
    // iStart is the position to begin with

    wxString s = sIn ;
    if(!pChild) pChild = (TextChild *) GetActiveChild();
    mywxTextCtrl * tc = pChild -> textctrl ;
    int iMax = tc -> GetNumberOfLines ();
    long i,x ;
    tc -> PositionToXY (iStart, &x,&i);

    long iChar = 0;
    int iOffset ;
    wxString sLine = tc -> GetLineText (i);
    // deal with the current line first
    wxString sRight = sLine.Right(sLine.Len() - x );
    iOffset = sRight.Find(s);
    if ( iOffset >=0 )
    {
        iOffset = iOffset + x ;
    }
    else
    {
        //now look for the text in future lines
        i ++ ;
        bool bNotFound = TRUE ;
        while (( i < iMax ) && bNotFound )
        {
            //look for the line containg thesearch text
            sLine = tc -> GetLineText (i);
            if (!bCaseSensitive)
            {
                s.MakeLower();
                sLine.MakeLower();
            }
            iOffset = sLine.Find(s);
            if ( iOffset >=0 ) bNotFound = FALSE ;
            i++ ;
        }
        i -- ;
        if ( bNotFound )
        {
            SetStatusText(wxT("Text ") + s + wxT(" not found"),1);
            return wxNOT_FOUND ; // -1
        }
    }
    SetStatusText(wxEmptyString, 1);
    iChar = tc -> XYToPosition ( iOffset, i );
    tc -> SetSelection(iChar, iChar + s.Len()) ;
    tc -> ShowPosition (tc -> XYToPosition ( iOffset, i )) ;
    return iChar ;
}


void MyFrame::OnRenameitem (wxCommandEvent& event)
{
    int iIndex = pMenuChild -> canvas -> iSelected ;
    TBitmapMenu *current = pMenuChild -> canvas -> menuList->Item(iIndex) -> GetData();
    if (current -> IsSeparator() ) return ;

    wxArrayString saIn ;
    saIn.Add (current->GetLabel());
    saIn.Add (current->GetHelpString());
    saIn.Add (current->GetAccelString());

    wxString sID = current->GetIDString();

    wxString sTmp ;
    MyMenuDialog dialog(this,
    wxT("Menu Item... ") + current->GetConCatString(),
    saIn ,
    wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;
    //avoid bug with two cells having the same label
    current -> SetLabel (wxEmptyString);
    wxArrayString saOut = dialog.GetValue() ;
    wxString sNew = saOut[wxhMENU] ;

        //add it after the selected item

    if (!pMenuChild->canvas->OnAdd_Item (sNew, saOut[wxhACCEL], saOut[wxhHELP]))
    {
        return ;
    }
    (pMenuChild -> canvas -> iSelected ) ++ ;
    //  copy the body to a text array
    pMenuChild -> canvas -> iSelected = iIndex ;
    int iLine = DoGobody () ;
    if (iLine == wxNOT_FOUND)
    {
        wxMessageBox (wxT("Body not found in ") + pMain_cpp->filename );
        return;
    }
    // select & save matching text
    OnSelBrace(event);
    wxString sOld = pMain_cpp->textctrl->GetSelectedText();

    OnDelete (event);

    //now insert the text back again
    pMenuChild -> canvas -> iSelected = iIndex  ;
    iLine = DoGobody () ;
    //Select & remove empty body; then replace saved body
    OnSelBrace(event);
    pMain_cpp->textctrl->ReplaceSelection (wxEmptyString);
    pMain_cpp -> textctrl -> WriteText(sOld);

    //now check for toolbar and change ID if necessary
    sTmp = wxT("toolBar->AddTool(" + sID);
    iLine = DoFindLine ( sTmp, 0, pMain_cpp);
    if (iLine != wxNOT_FOUND)
    {
    wxString sLine = RemoveLine (iLine-1, pMain_cpp);
    current = pMenuChild -> canvas -> menuList->Item(iIndex) -> GetData();
    if (sLine.Replace(sID, current->GetIDString()) > 0)
        pMain_cpp -> textctrl -> WriteText(sLine);
    }
    pMenuChild -> Activate ();

}


void MyFrame::OnChangeWxWinDir (wxCommandEvent& WXUNUSED(event))
{
    wxString sPrompt = wxT("Please select the wxWidgets Directory");
    if ( Make24FileEndings[iCompiler].Lower().Contains(wxT("unx")) )
        sPrompt = wxT("Please select the directory to which wxWidgets was Installed");
    wxDirDialog MyDialog ((wxWindow *)this, sPrompt, wxFileName(sWXWIN).GetLongPath());
    if (MyDialog.ShowModal() == wxID_OK)
    {
        //FIX me check that include/wx/version.h exists
        sWXWIN = wxFileName(MyDialog.GetPath()).GetShortPath() ;
        bSetEnv = TRUE ;
        if (!sProjectDir.IsEmpty())
            GenerateMakefile ();

    }

}


void MyFrame::OnUpdateCopy (wxUpdateUIEvent & event)
{
    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            event.Enable(node->GetData()->textctrl->CanCopy());
            return ;
        }
        node = node->GetNext();
    }
    if (pChild == pOutputWin)
    {
        event.Enable(pOutputWin->ListBox->GetSelection() != wxNOT_FOUND);
        return ;
    }

    event.Enable(FALSE);
    return ;

}


void MyFrame::OnUpdatePaste (wxUpdateUIEvent & event)
{
    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            event.Enable(node->GetData() ->textctrl->CanPaste());
            return ;
        }
        node = node->GetNext();
    }
    event.Enable(FALSE);
}

void MyFrame::OnUpdateRedo (wxUpdateUIEvent & event)
{
    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            event.Enable(node->GetData() ->textctrl->CanRedo());
            return ;
        }
        node = node->GetNext();
    }
    event.Enable(FALSE);
}

void MyFrame::OnUpdateUndo (wxUpdateUIEvent & event)
{
    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            event.Enable(node->GetData() ->textctrl->CanUndo() );
            return ;
        }
        node = node->GetNext();
    }
    event.Enable(FALSE);

}


void MyFrame::OnUpdateFindmenu (wxUpdateUIEvent & event)
{
    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }   
    event.Enable(TRUE);
}

void MyFrame::OnUpdateDlgmenu (wxUpdateUIEvent & event)
{
    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        event.Enable(FALSE);
        return ;
    }
    if (pDlgWin == pChild)
    {
        event.Enable(TRUE);
        return ;
    }
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            event.Enable(node->GetData() -> textctrl -> eDlgType != IsNotDialog  );
            return ;
        }
        node = node->GetNext();
    }
    event.Enable(FALSE);
}


void MyFrame::OnUpdateCompile (wxUpdateUIEvent & event)
{
    event.Enable(GetActiveChild() != NULL);
}

void MyFrame::OnUpdateNextErr (wxUpdateUIEvent & event)
{
    event.Enable ( pOutputWin != NULL ) ;
}

void MyFrame::OnUpdateRun (wxUpdateUIEvent & event)
{
    if (GetActiveChild())
    {
        wxString cmd = sProjectDir + wxFILE_SEP_PATH + sName + sPrgExt ;
        if (wxFileExists(cmd))
        {
            event.Enable (TRUE);
            return ;
        }
    }
    event.Enable(FALSE);

}


void MyFrame::OnUpdateDebug(wxUpdateUIEvent & event)
{
    if (GetActiveChild() && iCompiler >= 0 && iCompiler < (int) compilerStrings.GetCount() )
    {
        wxString cmd = sProjectDir + wxFILE_SEP_PATH + sName + sPrgExt;
        if ( (wxFileExists(cmd)) && compilerStrings[iCompiler].Lower().Contains(wxT("debug")) )
        {
            event.Enable (TRUE);
            return ;
        }
    }
    event.Enable(FALSE);
}

void MyFrame::OnUpdateConfigure(wxUpdateUIEvent & event)
{
    event.Enable(bCanUseConfigure);
}

void MyFrame::OnUpdateRebuild(wxUpdateUIEvent & event)
{
    bool bResult = TRUE ;
#ifdef __XXX__
  wxString f = wxFindFirstFile(sWXWIN + wxFILE_SEP_PATH + wxT("lib") + wxFILE_SEP_PATH + wxT("*.dll"));
  while ( !f.IsEmpty() && bResult )
  {
    bResult = ! FileInUse(f);
    f = wxFindNextFile();
  }
#endif
    event.Enable (bResult);
}



void MyFrame::OnUpdateAdd_Item (wxUpdateUIEvent & event)
{
    if (!pMenuChild)
    {
        event.Enable(FALSE);
        return ;
    }
    event.Enable(pMenuChild -> canvas -> menuList->GetCount() > 0 ) ;
}

// this is never used
void MyFrame::OnUpdatePopup (wxUpdateUIEvent & event)
{
    if (!pMenuChild)
    {
        event.Enable(FALSE);
        return ;
    }
    event.Enable(pMenuChild -> canvas -> menuList->GetCount() > 0 ) ;
}

void MyFrame::OnUpdateSeparator (wxUpdateUIEvent & event)
{
    if (!pMenuChild)
    {
        event.Enable(FALSE);
        return ;
    }
    event.Enable(pMenuChild -> canvas -> menuList->GetCount() > 0 ) ;
}


wxString MyFrame::GetBitmap (const wxString & sIN)
{
    // sIn is like FileNew
    // this gets an appropriate bitmap if on exists, eg for File Open
    wxString sOut = wxT("mondrian.xpm") ;
    wxString sTest = sIN.Lower() ;
    if (sTest.Contains (wxT("filenew") ))   sOut = wxT("new.xpm");
    if (sTest.Contains (wxT("fileopen") ))  sOut = wxT("open.xpm");
    if (sTest.Contains (wxT("filesave") ))  sOut = wxT("save.xpm");
    if (sTest.Contains (wxT("fileprint") )) sOut = wxT("print.xpm");

    if (sTest.Contains (wxT("editcut") ))   sOut = wxT("cut.xpm");
    if (sTest.Contains (wxT("editcopy") ))  sOut = wxT("copy.xpm");
    if (sTest.Contains (wxT("editpaste") )) sOut = wxT("paste.xpm");
    if (sTest.Contains (wxT("editundo") ))  sOut = wxT("undo.xpm");
    if (sTest.Contains (wxT("editredo") ))  sOut = wxT("redo.xpm");

    if (sTest.Contains (wxT("help") ))      sOut = wxT("help.xpm");

    return sOut ;
}


void MyFrame::OnOpenTextWindow (wxCommandEvent& WXUNUSED(event))
{
    wxString myFilename ;
    wxFileDialog dialog(this, (wxT("Open")), sProjectDir, myFilename,
        wxT("Header files (*.h)|*.h|Source files (*.cpp)|*.cpp|Resource files (*.rc)|*.rc|XPM Bitmap files (*.xpm)|*.xpm|HTML files (*.htm*)|*.htm*|Makefiles (Makefile*)|Makefile*|All files (*.*)|*.*"),
        wxOPEN);                 // for opening files

    if (dialog.ShowModal() == wxID_OK)
    {
        myFilename = dialog.GetPath() ;
        DoNewTextWindow ( myFilename, FALSE );
    }
}


void MyFrame::OnGoFNoGUI (wxCommandEvent& WXUNUSED(event))
{
    wxString sDeclaration ;
    MyTextDialog dialog(this,
    wxT("Enter the declaration of the method e.g.\nint MyMethod (const wxString && s) ") ,
    wxT("Find or create Frame method"),
    sDeclaration,
    wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;
    sDeclaration = dialog.GetValue() ;

    pMain_cpp  -> Activate ();

    wxString sBody = sDeclaration.BeforeFirst(wxT(' ')) + wxT(" MyFrame::") + sDeclaration.AfterFirst(wxT(' '))  ;
    int iLine = DoFindLine ( sBody ,0, pMain_cpp) ;
    if (iLine != wxNOT_FOUND) DoShowLine(pMain_cpp, iLine + 1 );
    //if not found, add it
    else
    {
        // add to header
        wxString sTmp = wxT("DECLARE_EVENT_TABLE") ;
        iLine = DoFindLine ( sTmp, 0, pMain_h) ;
        WriteLine (pMain_h, iLine-1, wxT("\n    ") + sDeclaration + wxT(" ; "));
        AppendText (pMain_cpp, wxT( "\n") + sBody + wxT("\n{\n    \n}\n\n "));
        iLine = 1+ DoFindLine ( sBody ,0, pMain_cpp) ;
        DoShowLine (pMain_cpp, iLine );
    }

}

void MyFrame::OnGoCNoGUI (wxCommandEvent& WXUNUSED(event))
{
    wxString sDeclaration ;
    MyTextDialog dialog(this,
    wxT("Enter the declaration of the method e.g.\nint MyMethod (const wxString && s) ") ,
    wxT("Find or create method for ") + sClassName,
    sDeclaration,
    wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;
    sDeclaration = dialog.GetValue() ;

    pCanv_cpp  -> Activate ();

    wxString sBody = sDeclaration.BeforeFirst(wxT(' ')) + wxT(' ') + sClassName + wxT("::") + sDeclaration.AfterFirst(wxT(' '))  ;
    int iLine = DoFindLine ( sBody ,0, pCanv_cpp) ;
    if (iLine != wxNOT_FOUND) DoShowLine(pCanv_cpp, iLine + 1 );
    //if not found, add it
    else
    {
        // add to header
        wxString sTmp = wxT("DECLARE_EVENT_TABLE") ;
        iLine = DoFindLine ( sTmp, 0, pCanv_h) ;
        WriteLine (pCanv_h, iLine-1, wxT("\n    ") + sDeclaration + wxT(" ; "));
        AppendText (pCanv_cpp, wxT( "\n") + sBody + wxT("\n{\n    \n}\n\n "));
        iLine = 1+ DoFindLine ( sBody ,0, pCanv_cpp) ;
        DoShowLine (pCanv_cpp, iLine );
    }

}


void MyFrame::OnUpdateGoCNoGUI (wxUpdateUIEvent & event)
{
    event.Enable ( pCanv_cpp != NULL && eLastMode != eFrameOnly );
}

void MyFrame::FindError ( const wxString & sFilename, const int iLine, const wxString & errorMessage )
{
    TextChild * pChild = NULL;
    // strip off any ./ from filename
    wxString sFileOnly = sFilename.AfterLast(wxFILE_SEP_PATH);
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData()-> filename.Contains(sFileOnly)) pChild = node->GetData();
        node = node->GetNext();
    }
    
    if (!pChild)
    {
        // might be a wxWidgets file (e.g. if building library
        wxFileName ff (sFilename);    
        if (ff.IsRelative())
        {
            wxFileName ff_test = ff ;
            ff_test.MakeAbsolute (sWXWIN) ;
            while (!ff_test.FileExists() && ff.GetDirCount () > 0)
            {
                ff.RemoveDir(0);
                ff_test = ff ;
                ff_test.MakeAbsolute (sWXWIN) ;
            } 
            
            ff = ff_test;
        }
        
        if (ff.FileExists()) pChild = DoNewTextWindow ( ff.GetFullPath(), FALSE ) ;
    }
    if (!pChild)
    {     
        SetStatusText(wxT("File Contining current Error not open in current project \nOr in wxWidgets tree ") + sFilename ,1);
        return ;
    }
    
    pChild -> Activate ();
    long iPos = DoShowLine ( pChild, iLine-1 );
    pChild -> textctrl -> SetSelection ( iPos, iPos + pChild -> textctrl -> GetLine (iLine-1).Len() );
    SetStatusText (errorMessage,1) ;
}


void MyFrame::OnChangeFont(wxCommandEvent& WXUNUSED(event))
{

    wxFontData data;
    data.SetInitialFont(myFont);
    data.SetColour(myFontColour);

    wxFontDialog dialog(this, data);
    if (dialog.ShowModal() == wxID_OK)
    {
        wxFontData retData = dialog.GetFontData();
        myFont = retData.GetChosenFont();
        myFontColour = retData.GetColour();
        myFont.SetDefaultEncoding(myFont.GetEncoding());

        TTextChildList::Node *node = textWinList->GetFirst();
        while (node)
        {
            node -> GetData() -> textctrl -> SetFont(myFont);
	    node -> GetData() -> textctrl -> StyleSetFont(wxSTC_STYLE_DEFAULT, myFont);

            int i;
	    for (i=0; i < wxSTC_STYLE_LASTPREDEFINED; i++) node -> GetData() -> textctrl -> StyleSetSize(i, myFont.GetPointSize());
	    for (i=0; i < wxSTC_STYLE_LASTPREDEFINED; i++) node -> GetData() -> textctrl -> StyleSetFaceName(i, myFont.GetFaceName());
            node = node->GetNext();
        }

        if (pOutputWin) pOutputWin->ListBox -> SetFont(myFont);
//        if (pTreeWin)   pTreeWin  ->TreeBox -> SetFont(myFont);
    }

}


void MyFrame::OnUpdateToolMove ( wxUpdateUIEvent & event)
{
    int iCount = pMenuChild->canvas->toolList->GetCount() ;
    if ( iCount < 2 )
    {
        event.Enable(FALSE) ;
        return ;
    }
    TBitmapToolList::Node * pNode = pMenuChild->canvas->selBmp ;
    if ( !pNode )
    {
        event.Enable(FALSE) ;
        return ;
    }
    TBitmapTool *current = pNode->GetData();
    int iTool = pMenuChild->canvas->toolList->IndexOf (current);

    if ( (event.GetId() == wxH_TBMVELEFT) && ( iTool == 0 ) )
    {
        event.Enable(FALSE) ;
        return ;
    }
    if ( (event.GetId() == wxH_TBMVERIGHT) && ( iTool >= iCount - 1 ) )
    {
        event.Enable(FALSE) ;
        return ;
    }
    event.Enable(TRUE) ;
    return ;
}


void MyFrame::OnUpdateToolbar( wxUpdateUIEvent & event)
{
    event.Enable( pMenuChild->canvas->selBmp !=0 ) ;
}

void MyFrame::OnUpdateGoToolbarCode( wxUpdateUIEvent & event)
{
    event.Enable( pMenuChild->canvas->toolList->GetCount() > 0 ) ;
}


void MyFrame::OnNextErr(wxCommandEvent& WXUNUSED(event))
{
    int iMax = pOutputWin -> ListBox -> GetCount ();
    int iCurrent = 1 + pOutputWin -> ListBox -> GetSelection() ;
    bool bErrorfound  = FALSE ;
    while ( !bErrorfound && (iCurrent < iMax ) )
        {
        pOutputWin -> ListBox -> SetSelection ( iCurrent );
        bErrorfound = pOutputWin -> DoGetError() ;
        iCurrent ++ ;
        }
}


int MyFrame::DoFindmenuBarLine ( TBitmapMenu * pBM )
{
    int iBar = DoFindLine ( wxT("wxMenuBar *"), 0, pMain_cpp );
    if (iBar == wxNOT_FOUND )
    {
        return wxNOT_FOUND;
    }
    //wxMenuBar *menuBar = new wxMenuBar;
    wxString sTmp = pMain_cpp -> textctrl -> GetLineText (iBar-1);
    sTmp = sTmp.AfterFirst (wxT('*'));
    sTmp = sTmp.BeforeFirst (wxT('='));
    sTmp.Trim(TRUE).Trim(FALSE);
    //menuBar
    wxString  sMenuBarName = sTmp ;

    wxString sSearch = sMenuBarName + wxT("->Append(") + pBM -> GetMenuName();

    return DoFindLine ( sSearch, 0, pMain_cpp ) ;
}

void MyFrame::OnMenuL (wxCommandEvent & WXUNUSED(event))
{
    TBitmapMenu *current = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected) -> GetData();
    TBitmapMenu * prevbase  = NULL ;
        TBitmapMenuList::Node *node = pMenuChild -> canvas -> menuList->GetFirst();
        while (node && (node->GetData() != current) )
        {
            TBitmapMenu * tmp = node->GetData();
            if (tmp->IsBase()) prevbase = tmp;
            node = node->GetNext() ;
        }

    int iLine = DoFindmenuBarLine(current) -1 ;
    wxString sTmp = RemoveLine (iLine, pMain_cpp -> textctrl);
    iLine = DoFindmenuBarLine(prevbase) -1;
    WriteLine ( pMain_cpp, iLine , sTmp );
        pMenuChild -> canvas -> DoActivate() ;
}

void MyFrame::OnMenuR (wxCommandEvent & WXUNUSED(event))
{
    TBitmapMenu *current = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected) -> GetData();
    TBitmapMenu * nextbase  = NULL ;
        TBitmapMenuList::Node *node = pMenuChild -> canvas -> menuList->Item(pMenuChild -> canvas -> iSelected)->GetNext();
        while (node && (!node->GetData()->IsBase()) )
        {
            node = node->GetNext() ;
        }
    if (node)
    {
    nextbase = node->GetData();
    int iLine = DoFindmenuBarLine(current) -1 ;
    wxString sTmp = RemoveLine (iLine, pMain_cpp -> textctrl);
    iLine = DoFindmenuBarLine(nextbase) ;
    WriteLine ( pMain_cpp, iLine , sTmp );
    pMenuChild -> canvas -> DoActivate() ;
    }
}



void MyFrame::OnMenuDel (wxCommandEvent & event)
{
    int iSel = pMenuChild -> canvas -> iSelected;
    if (iSel == wxNOT_FOUND) return;

    wxString sMenuText ;
    sMenuText = pMenuChild -> canvas -> menuList->Item(iSel) -> GetData() -> GetMenuName();
    TBitmapMenuList::Node *node = pMenuChild -> canvas -> menuList->Item(iSel) -> GetNext();
    if (node) sMenuText = node -> GetData() -> GetMenuName();

    bool bNoNext = FALSE;
    if (node) bNoNext = node -> GetData()->IsBase();
      else bNoNext = TRUE;

    while (!bNoNext)
        {
            pMenuChild -> canvas -> iSelected = iSel + 1;
            OnDelete(event);
            node = NULL ;
            if (pMenuChild -> canvas -> menuList)
                node = pMenuChild -> canvas -> menuList->Item(iSel) ;
            if (node) node = node -> GetNext ();
            if (node) bNoNext = node -> GetData()->IsBase();
              else bNoNext = TRUE;
        }
    wxString sTmp = sMenuText + wxT("= new wxMenu");
    int iLine = DoFindLine ( sTmp, 0, pMain_cpp );
    RemoveLine (iLine -1, pMain_cpp);

    // if a normal menu, remove from menubar
    sTmp = wxT("menuBar->Append (") + sMenuText ;
    iLine = DoFindLine ( sTmp, 0, pMain_cpp );
    if (iLine != wxNOT_FOUND) RemoveLine (iLine -1, pMain_cpp);

    //if a popup menu
    sTmp = wxT("PopupMenu (") + sMenuText ;
    iLine = DoFindLine ( sTmp, 0, pMain_cpp );
    if (iLine != wxNOT_FOUND) RemoveLine (iLine -1, pMain_cpp);
    sTmp = wxT("delete") + sMenuText ;
    iLine = DoFindLine ( sTmp, 0, pMain_cpp );
    if (iLine != wxNOT_FOUND) RemoveLine (iLine -1, pMain_cpp);
    sTmp = wxT("wxMenu *") + sMenuText ;
    iLine = DoFindLine ( sTmp, 0, pMain_h );
    if (iLine != wxNOT_FOUND) RemoveLine (iLine -1, pMain_h);

    pMenuChild -> canvas -> iSelected = iSel ;
    pMenuChild -> canvas -> DeleteCurrentNode (TRUE);
    pMenuChild -> Activate ();

}


void MyFrame::OnTogglePreload (wxCommandEvent & WXUNUSED(event))
{
    bPreLoad = !bPreLoad ;
    if (bPreLoad)
	{
        LoadHelp(TRUE);
        }
}

void MyFrame::OnUpdatePreLoad (wxUpdateUIEvent & event)
{
    int iD = event.GetId();

    wxMenuBar * myMenubar = GetMenuBar();

    TextChild * tc = (TextChild *) GetActiveChild ();
    if (tc) 
	{
		myMenubar = tc -> GetMenuBar() ;

    	int iMenus = 0;
		if (myMenubar) iMenus = myMenubar -> GetMenuCount() ;
    	int i = 0 ;
    	wxMenu * myMenu = NULL;
    	wxMenuItem * myMenuItem = NULL ;
    	while ( (i < iMenus) && !myMenuItem )
    	{
        	myMenu = myMenubar -> GetMenu (i);
        	myMenuItem = myMenu -> FindItem (iD);
        	i ++ ;
    	}
    
        if (myMenuItem) myMenuItem -> Check(bPreLoad);
	}
}


void MyFrame::OnAnyTool(wxCommandEvent & event)
{
const wxString sInvComma = wxT("\"") ;
const wxString sSemiColon = wxT(";") ;
    int iD = event.GetId();
    iD = iD - (wxH_MAX + 60);
    wxString sTool  = saTools.Item(iD).AfterFirst (wxT(';')) ;
    sTool.Trim(TRUE).Trim(FALSE);
#ifdef __WXMSW__
    sTool = sInvComma + sTool ;
    sTool.Replace (wxT(".exe"), wxT(".exe") + sInvComma) ;
    sTool.Replace (wxT(".com"), wxT(".com") + sInvComma) ;
    sTool.Replace (wxT("%"), sInvComma + wxT("%") ) ;
    int i = 2 + sTool.Find(wxT('%'));
    if (i >= 2 )
    {
        wxString sLeft = sTool.Left(i) ;
        wxString sRight = sTool.Mid(i) ;
        sTool = sLeft + sInvComma + sRight ;
    }
#endif

    sTool.Replace(wxT("%w"),sWXWIN);

    TextChild * pChild = (TextChild *)GetActiveChild ();
    if (pChild) sTool.Replace(wxT("%f"),pChild->filename);

    if (bProjectLoaded) sTool.Replace(wxT("%d"), sProjectDir);
    if (bProjectLoaded) sTool.Replace(wxT("%n"), sName);
    sTool.Replace(wxT("%e"), sProjectDir + sName + sPrgExt);

    wxHSetEnv(GetMakeCommand());
    
    wxExecute ( sTool );
}

void MyFrame::wxHSetEnv (const wxString & cmd)
{
    bool bValidCompilerIndex = ((iCompiler >= 0) && (iCompiler < (int)Make24FileEndings.GetCount())) ;
    wxString sPATH = sStartPath ;
    //set WXWIN environment variable if needed - either no env on command line or we selected a new one
    if (bSetEnv) 
	{
		wxSetEnv (wxT("WXWIN"), sWXWIN );    
       
		if (bValidCompilerIndex && compilerStrings[iCompiler].Lower().Contains(wxT("mars"))) 
		{
			wxSetEnv (wxT("WXWIN"), wxFileName(sWXWIN).GetLongPath() ); 
		}
        
	}
    //iterate extra path [all compliers]
    size_t iCount ;
    for (iCount = 0; iCount < Paths.GetCount(); iCount ++)
        {
        if ( iReusePaths[iCount] == iCompiler    ) sPATH = Paths[iCount] + wxPATH_SEP  + sPATH ;
        if ( iReusePaths[iCount] == iAlwaysReuse ) sPATH = Paths[iCount] + wxPATH_SEP  + sPATH ;
        if ( iReusePaths[iCount] == iThisSession ) sPATH = Paths[iCount] + wxPATH_SEP  + sPATH ;
        }
        
    //if its a DLL add the path
    if ( bValidCompilerIndex)
    {
        // dll may be in /usr/local/lib
        // or C:\wx\wxWindows\lib
        // or C:\wx\wxWindows\lib\vc_dll {2.5. only}
        
        wxString sInstall = sWXWIN ;
        if (sInstall.IsEmpty()) sInstall = wxT("/usr/local") ;
        #ifdef __WXMSW__
          sPATH = sInstall + wxT("\\lib;") + sPATH ;
          if (Is25() && ! Make25FileEndings[iCompiler].AfterLast(dot).IsEmpty() )
            {
            // C:\wx\wxWindows\lib\vc_dll
            sPATH = sWXWIN + wxFILE_SEP_PATH + wxT("lib") + wxFILE_SEP_PATH +
               Make25FileEndings[iCompiler].AfterLast(dot) + wxT( "_dll" ) + wxPATH_SEP  + sPATH ;
            }          
        #else
        //linux default installation of wxWidgets
          wxSetEnv (wxT("LD_LIBRARY_PATH"), sInstall + wxT("/lib") ); 
        #endif
      
    } // end of valid compiler index
    
    //deal with peculiarites of compilers DMARS (above), VC, WATCOM
    wxPathList pathList;
    pathList.AddEnvList(wxT("PATH"));
    wxStringTokenizer tkz ( sPATH, wxPATH_SEP );
    while ( tkz.HasMoreTokens() )
    {
        wxString token = tkz.GetNextToken();
        pathList.Add ( token );
    }
    if (cmd.Contains(wxT("nmake"))) ///fix bug with MS-Visual C; need to set path and environment
    {
        wxString nmakepath = pathList.FindValidPath(wxT("nmake.exe")) ;
        nmakepath = nmakepath.BeforeLast(wxT('\\'));
        wxString MSVCDir = nmakepath.BeforeLast(wxT('\\'));
        wxString MSCommonPath = MSVCDir.BeforeLast(wxT('\\')) + wxT("\\COMMON") + wxT("\\msdev98\\bin") ;
        if (!pathList.Member(MSCommonPath))
        {
            sPATH = MSCommonPath + wxT(";") + sPATH ;
        }
        
        wxString includePath ;
        wxGetEnv(wxT("INCLUDE"), &includePath);
        if (!includePath.Contains(MSVCDir))
        {
            includePath = MSVCDir + wxT("\\INCLUDE;") + includePath ;
            wxSetEnv (wxT("INCLUDE"), includePath );
        }
        
        wxString libPath ;
        wxGetEnv(wxT("LIB"), &libPath);
        if (!libPath.Contains(MSVCDir))
        {
            libPath = MSVCDir + wxT("\\LIB;") + libPath ;
            wxSetEnv (wxT("LIB"), libPath );
        }
    }
    if (cmd.Contains(wxT("wmake"))) ///fix bug with Watcom; need to set include in environment
    {
        wxString wmakepath = pathList.FindValidPath(wxT("wmake.exe")) ;
        wmakepath = wmakepath.BeforeLast(wxT('\\'));
        wxString WATDir = wmakepath.BeforeLast(wxT('\\'));
        wxSetEnv (wxT("WATCOM"), WATDir );    
        
        wxString includePath ;
        wxGetEnv(wxT("INCLUDE"), &includePath);
        if (!includePath.Contains(WATDir))
        {
            includePath = WATDir + wxT("\\H;") + WATDir + wxT("\\H\\NT;") + includePath ;
            wxSetEnv (wxT("INCLUDE"), includePath );
        }        
    }
    
#ifdef __WXMSW__
    if (bCanUseConfigure)
    {
        //running under cygwin or msys
        sPATH = wxString(wxT("/usr/bin")) + wxPATH_SEP + sPATH ;
    }
#endif

    wxSetEnv (wxT("PATH"), sPATH );
}

void MyFrame::GetShPath ()
{
    wxPathList pathList;
    pathList.AddEnvList(wxT("PATH"));
    
    shPath = pathList.FindValidPath(wxT("sh") + sPrgExt) ;
    // wxMessageBox (wxT("sh path is \n") + shPath,wxT("wxHatch Testing"));
    // returns either empty string or c:\compiler\cygwin\bin\sh.exe
    // remove spaces
    shPath = wxFileName ( shPath ).GetShortPath();

    bCanUseConfigure =  ! shPath.IsEmpty();
}

void MyFrame::OnUpdateAnyTool(wxUpdateUIEvent & event)
{
    int iD = event.GetId();
    iD = iD - (wxH_MAX + 60);
    wxString sTool  = saTools.Item(iD) ;
    if (sTool.Contains(wxT("%w")))
    {
        event.Enable(TRUE);
        return ;
    }
    if ( (sTool.Contains(wxT("%d"))) || (sTool.Contains(wxT("%n"))) )
    {
        event.Enable(bProjectLoaded);
        return ;
    }
    if (sTool.Contains(wxT("%e")))
    {
        wxString cmd = sProjectDir + wxFILE_SEP_PATH + sName + sPrgExt ;
        event.Enable (wxFileExists(cmd) && bProjectLoaded);
        return ;
    }
    if (sTool.Contains(wxT("%f")))
    {
        wxMDIChildFrame * pChild = GetActiveChild ();
        if (!pChild)
        {
            event.Enable(FALSE);
            return ;
        }
        TTextChildList::Node *node = textWinList->GetFirst();
        while (node)
        {
            if ( node->GetData() == pChild )
            {
                event.Enable(TRUE);
                return ;
            }
            node = node->GetNext();
        }
        event.Enable(FALSE);
    }
}

void MyFrame::OnUpdateToolConfigure (wxUpdateUIEvent & event)
{
    event.Enable(saTools.GetCount() > 0) ;
}

void MyFrame::OnToolConfigure(wxCommandEvent & WXUNUSED(event))
{
    MyConfigDialog dialog (this, wxT("ConfigDlg"), wxT("Configure Tools..."),
        saTools, wxOK | wxCANCEL );

    if (dialog.ShowModal() != wxID_OK) return ;
    saTools = dialog.GetValue();

    ChangeMenus();
}

void MyFrame::OnToolAdd(wxCommandEvent & WXUNUSED(event))
{

    wxString sCmd = wxEmptyString ;
    wxString sParam = wxEmptyString ;
    MyToolDialog dialog(this,
    wxT("Enter the menu label "), wxT("command"),
    wxT("Enter the command to execute"), wxT("param"),
    wxT("Add Tool"),
    sCmd, sParam,
    wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;

    wxArrayString myResult = dialog.GetValue() ;
    sCmd = myResult [0] ;
    sParam = myResult [1] ;

    saTools.Add(sCmd + wxT(" ; ") + sParam);
    ChangeMenus();
}


void MyFrame::ChangeMenus ( )
{
   
//bug here in 2.4.2 GTK and subsequent with seg fault if nodes other than this
//Fixme

     DoChangeMenus (this);
#ifdef __WXMSW__
     DoChangeMenus (pOutputWin ) ;
     DoChangeMenus (pTreeWin) ;
     DoChangeMenus (pDlgWin ) ;
     DoChangeMenus (pMenuChild ) ;

     TTextChildList::Node *node = textWinList->GetFirst();
     while (node)
     {
     DoChangeMenus(node->GetData());
     node = node->GetNext();
     }
#endif
     
//now save the changes
     wxString sTmp;
     pConfig->SetPath(RegKey) ;
     for (size_t i=0; i < saTools.GetCount(); i++)
     {
        sTmp.Printf(wxT("Tool%d"),i) ;
        pConfig->Write (sTmp, saTools.Item(i));
     }
}


void MyFrame::DoChangeMenus ( wxFrame * pFrame ) //wxMenuBar * myMenubar )
{
    if (!pFrame) return ;
    wxMenuBar * myMenubar = pFrame -> GetMenuBar() ;
    if (!myMenubar) return ;
    int iMenuIndex = myMenubar -> FindMenu(wxT("&Tools")) ;
    if ( iMenuIndex == wxNOT_FOUND ) return ;

    wxMenu * tools_menu = new wxMenu ;
    CreateToolsMenu (tools_menu, TRUE);

    wxMenu * deadmenu = myMenubar -> Replace (iMenuIndex, tools_menu, wxT("&Tools")) ;
    delete deadmenu ;
}

void MyFrame::OnTimer(wxTimerEvent& WXUNUSED(event))
{
    if (bAlreadyWarning) return ;

        TTextChildList::Node *node = textWinList->GetFirst();
        while (node)
        {
            if ( node->GetData() -> bIsPartOfProject )
            {
                if (node->GetData()->textctrl->IsAlteredOnDisk() )
                    {
                    bAlreadyWarning = TRUE ;
                    if (wxYES == wxMessageBox (wxT("File Changed on Disk \n") + node->GetData()->textctrl->sFileName +
                        wxT("\nDo You want to use new version?"),
                    wxT("wxHatch Warning") ,  wxCENTRE | wxYES_NO ) )
                    {
                        node->GetData()->textctrl->LoadFile(node->GetData()->textctrl->sFileName);
                    }
                    else node->GetData()->textctrl->SetModTime();
                    }
            }
            node = node->GetNext();
        }

        if (pMenuChild)
        {
            TBitmapToolList::Node *tnode = pMenuChild->canvas->toolList->GetFirst();
            while (tnode)
            {
                if (tnode->GetData()->IsAlteredOnDisk() )
                    {
                        bAlreadyWarning = TRUE ;
                        if (wxYES == wxMessageBox (wxT("File Changed on Disk \n") + tnode->GetData()->myFilename
                            + wxT("Do You want to use new version?"),
                        wxT("wxHatch Warning"),  wxCENTRE | wxYES_NO ) )
                        {
                            if (pMenuChild) pMenuChild->Close();
                            pMenuChild = NULL ;
                            pMenuChild = DoNewMenuWindow ();
                            DoLoadMenuWindow () ;
                        }
                     tnode->GetData()->SetModTime();
                    }

                tnode = tnode->GetNext();
            }
        if ( pMenuChild->canvas-> IconIsAlteredOnDisk() )
        {
            bAlreadyWarning = TRUE ;
            if (wxYES == wxMessageBox (wxT("Icon Changed on Disk \nDo You want to use new version?"),
            wxT("wxHatch Warning ") ,  wxCENTRE | wxYES_NO ) )
            {
                if (pMenuChild) pMenuChild->Close();
                pMenuChild = NULL ;
                pMenuChild = DoNewMenuWindow ();
                DoLoadMenuWindow () ;
            }
            else pMenuChild -> canvas -> SetIconModTime();
        }
    } // end of if pMenuChild
    bAlreadyWarning = FALSE ;
}

void MyFrame::OnSelBrace(wxCommandEvent & WXUNUSED(event))
{
    TextChild * pChild = (TextChild *) GetActiveChild () ;
    mywxTextCtrl * pTC = pChild -> textctrl ;
    int myPos = pTC -> GetInsertionPoint ();
    int myFarEnd = pTC -> GetAnchor() ;
    if (myPos > myFarEnd)
    {
        //swap round
        int iTmp = myPos;
        myPos = myFarEnd ;
        myFarEnd = iTmp ;
    }
    int myStartPos = myPos ;

    // if we already have a selection, widen it
    int myBrace = pTC -> BraceMatch (myPos) + 1;
    if (myPos != myFarEnd && myFarEnd == myBrace) myPos = myPos - 1 ;
    myFarEnd = pTC -> BraceMatch (myPos) ;
    while ( ( myFarEnd == wxNOT_FOUND || myFarEnd < myStartPos ) && myPos > 0 )
    {
        myPos -- ;
        myFarEnd = pTC -> BraceMatch (myPos) ;
    }

    if ( myFarEnd != wxNOT_FOUND )
        {
        if (myPos < myFarEnd) pTC -> SetSelection(myPos, myFarEnd + 1);
            else pTC -> SetSelection(myPos + 1, myFarEnd);
        }

}

void MyFrame::OnIndentThisBrace (wxCommandEvent & event)
{
    OnSelBrace(event);
//TODO fix this code in common with brace match
    TextChild * pChild = (TextChild *) GetActiveChild () ;
    mywxTextCtrl * pTC = pChild -> textctrl ;
    int myPos = pTC -> GetInsertionPoint ();
    int myFarEnd = pTC -> GetAnchor() ;
    if (myPos > myFarEnd)
    {
        //swap round
        int iTmp = myPos;
        myPos = myFarEnd ;
        myFarEnd = iTmp ;
    }
    if (pTC -> BraceMatch (myPos) == wxNOT_FOUND)
    {
        SetStatusText(wxT("Braces did not match"));
        return ;
    }
    pTC -> ReIndent ( myPos, myFarEnd );

}

void MyFrame::OnUpdateSelBrace (wxUpdateUIEvent & WXUNUSED(event))
{
    //event.Enable () ;
}

#if wxUSE_DRAG_AND_DROP
bool DnDFile::OnDropFiles(wxCoord, wxCoord, const wxArrayString& filenames)
{
    size_t nFiles = filenames.GetCount();
    wxString s;
    s.Printf( _T("%d files dropped"), nFiles);
    m_pOwner->SetStatusText (s, 1);
    if (m_pOwner->bProjectLoaded)
    {
        for ( size_t n = 0; n < nFiles; n++ )
        {
            m_pOwner-> DoNewTextWindow ( filenames[n], FALSE );
        }
    }
    else
    {
        m_pOwner-> DoReOpenProject (wxPathOnly(filenames[0]));
    }
    return TRUE; //just return FALSE of now is not a good time to accept the files
}
//end of Do Drop Files
#endif



void MyFrame::OnPrintSetup(wxCommandEvent& WXUNUSED(event))
{
    m_Prn -> PrinterSetup();
}


void MyFrame::OnPageSetup(wxCommandEvent& WXUNUSED(event))
{
    m_Prn -> PageSetup();
}


void MyFrame::OnPrint(wxCommandEvent& WXUNUSED(event))
{
    TextChild * pChild = (TextChild *) GetActiveChild () ;
    mywxTextCtrl * tc = pChild -> textctrl ;
    wxString m_Name = pChild -> filename ;

    wxMemoryFSHandler::AddFile(m_Name, tc -> RenderAsHTML ());
    m_Prn -> SetHeader(m_Name + wxT("(@PAGENUM@/@PAGESCNT@)<hr>"), wxPAGE_ALL);
    m_Prn -> PrintFile(wxT("memory:") + m_Name);
    wxMemoryFSHandler::RemoveFile(m_Name);
}


void MyFrame::OnPreview(wxCommandEvent& WXUNUSED(event))
{
    TextChild * pChild = (TextChild *) GetActiveChild () ;
    mywxTextCtrl * tc = pChild -> textctrl ;
    wxString m_Name = wxFileNameFromPath(pChild -> filename) ;

    wxMemoryFSHandler::AddFile(m_Name, tc -> RenderAsHTML ());
    m_Prn -> SetHeader(m_Name + wxT("(@PAGENUM@/@PAGESCNT@)<hr>"), wxPAGE_ALL);
    m_Prn -> PreviewFile(wxT("memory:") + m_Name);
    wxMemoryFSHandler::RemoveFile(m_Name);
}


void MyFrame::OnAnymenuOpen (wxMenuEvent & WXUNUSED(event))
{
    DoAnymenuOpen();
}

void MyFrame::DoAnymenuOpen ()
{

    wxMDIChildFrame * pChild = GetActiveChild ();
    if (!pChild)
    {
        return ;
    }
    TextChild * tc =  NULL ;
    TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            tc = node->GetData() ;
        }
        node = node->GetNext();
    }
    if (tc == NULL) return ;

    wxMenuBar * myMenubar = tc -> GetMenuBar() ;
    int iMenus = myMenubar -> GetMenuCount() ;

    int iD = 0;
    int iMax = DisableArrays.GetCount() ;
    while (iD < iMax)
    {
        wxString sTest = DisableArrays.Item(iD) ;
        sTest = sTest.AfterLast(wxT('~'));
        if (sTest.IsEmpty()) return ;
        int iAlreadyFound ;
        iAlreadyFound = pMain_cpp->textctrl->FindTxt (0, pMain_cpp->textctrl->GetTextLength(), sTest, TRUE);

        int i = 0 ;
        wxMenu * myMenu = NULL;
        wxMenuItem * myMenuItem = NULL ;
        while ( (i < iMenus) && !myMenuItem )
        {
            myMenu = myMenubar -> GetMenu (i);
            int iItem = DisableIndexes.Item(iD) ;
            myMenuItem = myMenu -> FindItem (iItem);
            i ++ ;
        }
        if (myMenuItem)
        {
            bool bNotFound = (iAlreadyFound == wxNOT_FOUND) ;
            if (DisableArrays.Item(iD).Contains(wxT('~'))) bNotFound = ! bNotFound ;
            myMenuItem -> Enable (  bNotFound  ) ;
        }
        iD ++ ;
    }

}


void MyFrame::OnUpdateAddAnyCtrl (wxUpdateUIEvent & event)
{
  if (!pInc) 
  {
    event.Enable(FALSE);
    return ;
  }
  wxMDIChildFrame * pChild = GetActiveChild ();
  if ( pChild == pDlgWin )
  {
    wxString sParent =  pDlgWin  -> GetParentValue ();
    event.Enable (! sParent.IsEmpty());
    return ;
  }
  TTextChildList::Node *node = textWinList->GetFirst();
    while (node)
    {
        if ( node->GetData() == pChild )
        {
            event.Enable(node->GetData() -> textctrl -> eDlgType != IsNotDialog  );
            return ;
        }
        node = node->GetNext();
    }
  event.Enable (FALSE);  
}

void MyFrame::OnAddAnyCtrl(wxCommandEvent & event)
{
    bool bMustReshowDialogTree = FALSE;
    wxMDIChildFrame * pChild = GetActiveChild ();
    TextChild * tc = NULL ;
    
    //find menu item
    int iD = event.GetId();
    wxMenuBar * myMenubar = pChild -> GetMenuBar() ;
    int iMenus = myMenubar -> GetMenuCount() ;
    int i = 0 ;
    wxMenu * myMenu = NULL;
    wxMenuItem * myMenuItem = NULL ;
    while ( (i < iMenus) && !myMenuItem )
    {
        myMenu = myMenubar -> GetMenu (i);
        myMenuItem = myMenu -> FindItem (iD);
        i ++ ;
    }

    wxString sControl =  myMenu -> GetLabel(iD);

    int iLine = wxNOT_FOUND;
    if ( pChild != pDlgWin )
    {
        tc = (TextChild *)pChild ;
        iLine = tc -> textctrl -> GetCurrentLine();
    }
    else
    {
        bMustReshowDialogTree = TRUE ;
        //get selection before we show the dialog
        wxString selControl = pDlgWin  -> GetValue ();
        if (!selControl.IsEmpty())
        {
            wxString sParent =  pDlgWin  -> GetParentValue ();

            if ( sParent.IsEmpty() )
            {
                //trying to add to dialog root
                (void)wxMessageBox( wxT("Sorry, Can't add controls outside of sizer"), wxT("wxHatch warning"));
                return ;
            }
            tc = pDlgWin -> myTextChild ;
            // trying to add with a sizer selected; add before any other controls
            if ( IsSizer(selControl, tc ) )
            {
            // add immedaiately after creation of sizer
            // allow for take off later
                iLine = 2 + DoFindLine ( selControl + wxT("= new") , 0, tc) ;
                wxString sComment = tc -> GetLineText ( iLine - 2 ) ;
                if (sComment.Contains(wxT("//")))
                    {
                    iLine ++ ;
                    }
            }
            else
            {
                if (pDlgWin -> IsProperty())
                {
                    sParent = pDlgWin -> GetGrandParentValue();
                    selControl =  pDlgWin  -> GetParentValue ();
                }
                //    mainsizer -> Add (m_Button, 1, wxALL | wxEXPAND, 5);
                //    mainsizer -> Add (CreateButtonSizer(  wxOK|wxCANCEL ), 0, wxCENTER|wxALL, 10 );
                iLine = DoFindLine ( sParent + wxT("-> Add(") + selControl + wxT("("), 0, tc) ;
                if (iLine == wxNOT_FOUND)
                {
                    iLine = DoFindLine ( sParent + wxT("-> Add(") + selControl + wxT(","), 0, tc) ;
                }
            }
            //same as clicking on line BEFORE Add
            iLine = iLine - 2 ;
        }
    }
    if ( iLine < 0 )
    {
        (void)wxMessageBox( wxT("Attempt to add control failed; error parsing dialog: parent sizer not found"), wxT("wxHatch Warning"));
        return ;
    }
	wxString sControlType = sControl ;
    sControl.Replace (wxT("wx"), wxT("m_"));

    MyTextDialog dialog(this,
        wxT("Enter a name for this ") + sControlType,
        wxT("Add Control or sizer"),
        sControl,
        wxOK | wxCANCEL);

    if (dialog.ShowModal() != wxID_OK) return ;
    sControl = dialog.GetValue() ;

    //look for name in existing controls

    if ( wxNOT_FOUND != DoFindLine (sControl, 0, tc -> alternateWin) )
    {
        //already have a control with this name

        wxString sQuestion = wxT("Already have control with this name, try again?") ;
        if ( wxMessageBox(sQuestion, wxT("Please confirm"),
             wxICON_QUESTION | wxYES_NO) == wxYES )
        {
            OnAddAnyCtrl (event);
        }
        return ;
    }

    iD = iD - wxH_CTRL ;


    if (iD >=0 && iD < int ( sControlNames.GetCount() ))
    {
        DoAddAnyControl (iLine, iD, tc, sControl);
    }
    //make sure we force the harness .cpp file to recompile too
    if (eLastMode == eNewDialog) DoReplaceExactText (space, space, 0, pMain_cpp) ;
    if (bMustReshowDialogTree) pDlgWin -> DoActivate();
}

void MyFrame::DoAddAnyControl (int iLine, int iD, TextChild * tc, const wxString & sControl)
{
    if ( iLine < 0 )
    {
    (void)wxMessageBox( wxT("Attempt to add control failed; error parsing dialog"), wxT("wxHatch Warning"));
    return ;
    }
    TextChild * alt = tc -> alternateWin ;
    wxString sSizerName ;

    // find the next Add command and use that to determuine the current sizer
    int iSizerLine = iLine;
    iSizerLine = DoFindLine (wxT( "-> Add(" ), iSizerLine, tc) ;
    if ( iSizerLine != wxNOT_FOUND )
    {
        sSizerName = tc -> GetLineText ( iSizerLine - 1 ) ;
        //either line like
        //   mainsizer -> Add (CreateButtonSizer(  wxOK|wxCANCEL ), 0, wxCENTER|wxALL, 10 );
        //   mainsizer -> Add (m_CheckBox, 1, wxALL | wxEXPAND, 5);
        //   mainsizer -> Add (m_BoxSizer, 1, wxALL | wxEXPAND, 5);


        wxString sTmp = sSizerName.AfterFirst (wxT('('));
        sTmp = sTmp.BeforeFirst (wxT(','));
        //  m_CheckBox or  m_BoxSizer ??
        if (IsSizer(sTmp, pCanv_cpp))
        {
            sSizerName = sTmp ;
        }
        else
        {
            sSizerName = sSizerName.BeforeFirst ( wxT( '-' ) );
        }
    }
    else
    {
        // beyond end of additions this should be last line and occur only once
        iSizerLine = DoFindLine (wxT( "CreateButtonSizer" ), 0, tc) ;
        iLine =  iSizerLine - 1 ;
        if  ( iSizerLine == wxNOT_FOUND )
        {
                (void)wxMessageBox( wxT("Current file does not appear to be a dialog poject, CreateButtonSizer not found in file") + tc->filename,
            wxT("wxHatch Warning"));
            return ;
        }
    }
    sSizerName.Trim(TRUE).Trim(FALSE);
    //create control and add it to the sizer - note same iLine!!
    WriteLine (tc, iLine, wxT( "    " ));
    //default proportion 0 flag wxALL | wxEXPAND [border all round] with border of 5 pixels
    WriteLine (tc, iLine, wxT( "    " ) + sSizerName + wxT(" -> Add("  ) + sControl + wxT(", 0, wxALL | wxEXPAND, 5);" )) ;
    wxString s = sControlNames[iD] ;
    if ( s.Contains(wxT("Sizer")))
    {
        WriteLine (tc, iLine, wxT( "    " ));
        WriteLine (tc, iLine, wxT( "    " ));
        WriteLine (tc, iLine, wxT( "    // add controls here to " ) + sControl);
    }
    WriteLine (tc, iLine, wxT( "    " ) + sControl + wxT( " = new " + sConstructors[iD] ) );
    WriteLine (tc, iLine, wxT( "    " ));

    // add control to header
    int iPrivate = DoFindLine ( wxT("private"), 0, alt );
    WriteLine (alt, iPrivate, wxT( "        " ) + sControlNames[iD] + wxT (" * " ) + sControl + wxT(";") );

    //add include if necessary
    if (!sControlIncludes[iD].IsEmpty())
    {
        int iInsert = DoFindLine ( wxT("class"), 0, alt );
        WriteLine(alt, iInsert - 2, wxT("#include ") + sControlIncludes[iD] );
    }

    // Add Get and Set methods if needed to header
    wxString sGet = sGetValues [iD] ;
    if ( ! sGet.IsEmpty() )
    {
        wxString sRHS = sGet.AfterFirst(wxT( ' ' )  );
        sGet.Replace (space, space + sControl + underline, FALSE);
        sGet.Prepend (wxT( "    " ));
        sGet.Prepend (wxT( "    " ));
        //bool m_CheckBox_IsChecked()
        WriteLine (alt, iPrivate - 2, sGet );

        wxString sGetLine2 = wxT( "     { return " ) + sControl + wxT( " -> " ) + sRHS + wxT(" ; } ; " )  ;
        sGetLine2.Prepend (wxT( "    " ));
        sGetLine2.Prepend (wxT( "    " ));
        sGetLine2.Prepend (wxT( "    " ));
        //{ return m_CheckBox -> IsChecked() ; } ;
        WriteLine (alt, iPrivate - 1, sGetLine2 );

        //add to insertion of dialog
        if (pInc)
        {
            int iDialog = DoFindLine ( wxT( "dialog.ShowModal()" ), 0, pInc);
            if (iDialog != wxNOT_FOUND)
            {
                wxString sResult ;
                if ( sGet.Contains(wxT( "bool" ) )) sResult = wxT( "b" )   ;
                if ( sGet.Contains(wxT( "int" ) )) sResult = wxT( "i" )   ;
                if ( sGet.Contains(wxT( "long" ) )) sResult = wxT( "lng" )   ;
                if ( sGet.Contains(wxT( "wxString" ) )) sResult = wxT( "s" )   ;
                if ( sGet.Contains(wxT( "wxDateTime" ) )) sResult = wxT( "dt" )   ;
                if (sResult.IsEmpty())
                {
                    //todo - fix this
                    (void)wxMessageBox( wxT("Unrecognised Result, possible error in .inc file"), wxT("wxHatch Warning"));
                }

                wxString sIns = sGet.Trim(TRUE).Trim(FALSE);
                sIns = sIns.BeforeFirst(wxT( ' ' )) + wxT( " " ) ;
                sIns = sIns + sResult + sControl + wxT( " = dialog." ) ;
                sIns = sIns + sGet.AfterFirst(wxT( ' ' )) +  wxT( " ;" ) ;
                sIns.Prepend (wxT( "    " ));
                sIns.Prepend (wxT( "    " ));
                //bool bm_CheckBox = dialog.m_CheckBox_IsChecked() ;
                WriteLine (pInc, iDialog + 2, sIns);
            }
        }

    }

    wxString sSet = sSetValues [iD] ;
    if ( ! sSet.IsEmpty() )
    {
        //void SetValue(const bool state)
        wxString sRHS = sSet.AfterFirst(wxT( ' ' )  );
        //SetValue(const bool state)
        wxString sStart = sRHS.BeforeFirst (wxT( '(' ) ) + wxT( " ( " );
        //SetValue(

        wxString sInside = sRHS.AfterFirst (wxT( '(' ) ).BeforeFirst(wxT( ')' ) ) ;
        sInside.Trim(TRUE).Trim(FALSE);
        //const bool state
        wxString sVar=sInside.AfterLast(wxT(' '));
        //state

        sSet.Replace (space, space + sControl + underline, FALSE);
        sSet.Prepend (wxT( "    " ));
        sSet.Prepend (wxT( "    " ));
        //void m_CheckBox_SetValue(const bool state)
        WriteLine (alt, iPrivate - 2, sSet );

        wxString sSetLine2 = wxT( "     { " ) + sControl + wxT( " -> " ) + sStart + sVar + wxT(" ) ; } ; " )  ;
        sSetLine2.Prepend (wxT( "    " ));
        sSetLine2.Prepend (wxT( "    " ));
        sSetLine2.Prepend (wxT( "    " ));
        //{ m_CheckBox -> SetValue ( state ) ; } ;
        WriteLine (alt, iPrivate - 1, sSetLine2 );

        // add set to to Insertion sample code
        // add to insertion of dialog
        if (pInc)
        {
            int iDialog = DoFindLine ( wxT( "dialog.ShowModal()" ), 0, pInc);
            if (iDialog != wxNOT_FOUND)
            {
                //const bool state
                sInside = sInside.BeforeLast(wxT( ' ' )  );
                //const bool
                sInside.Prepend (wxT( "/* " )) ;
                sInside.Append  (wxT( " */ " )) ;
                // /* const bool */

                sSet.Trim(TRUE).Trim(FALSE);
                wxString sIns = wxT( "dialog." )  ;
                sIns = sIns + sSet.AfterFirst(wxT( ' ' )  ).BeforeFirst (wxT( '(' ) ) + wxT( " ( " );
                sIns = sIns + sInside + sVar + wxT( ");" )  ;
                sIns.Prepend (wxT( "    " ));
                //dialog.m_CheckBox_SetValue ( /* const bool */ state);
                WriteLine (pInc, iDialog - 1, sIns);
            }
        }

    }
    // add event
    // EVT_BUTTON(id, func), wxCommandEvent
    wxString sEvent = sEvents [iD];
    if ( ! sEvent.IsEmpty() )
    {
        // Todo test if event has been unlinked??

        // newdlg03365::newdlg03365(wxFrame *parent, const wxString &title )
        iLine = frame -> DoFindLine (wxT( "(wxFrame *parent" ), 0, tc);
        wxString sDialogName = tc -> GetLineText (iLine-1);
        sDialogName = sDialogName.BeforeFirst(wxT( ':' ));
        sDialogName.Trim(TRUE).Trim(FALSE);

        // wxCommandEvent
        wxString sEventType = sEvent.AfterLast(wxT(','));
        sEventType.Trim(TRUE).Trim(FALSE);

        //add enum, add to event table, add outline method, add method declaration, replace -1 with enum
        //NameId
        wxString sNameId = sControl ;
        sNameId.Trim(TRUE).Trim(FALSE);
        wxString sMethodName = wxT("On") +  sNameId + wxT("Event") ;
        sNameId = sNameId + wxT("Id");
        //add enum
        long iEnum = DoFindLine ( wxT("enum"), 0, alt );
        if (iEnum == wxNOT_FOUND)
        {
            iEnum = DoFindLine ( wxT("class"), 0, alt);
            WriteLine ( alt, iEnum - 3, wxT("enum \n{\n};\n") );
            iEnum = DoFindLine ( wxT("enum"), 0, alt );
        }
        iEnum = DoFindLine ( wxT("{"), 0, alt );
        WriteLine ( alt, iEnum, wxT("    ") + sNameId + wxT(",") );

        //EVT_BUTTON(NameId, newDlg203::OnNameEvent)
        wxString sEVT = sEvent.BeforeFirst(wxT('(')).Trim(TRUE).Trim(FALSE);
        sEVT = sEVT + wxT("(") + sNameId + wxT(", ") + sDialogName + wxT("::") + sMethodName + wxT(")");
        long iEVT = DoFindLine ( wxT("BEGIN_EVENT_TABLE"), 0, tc );
        WriteLine ( tc, iEVT, wxT("    ") + sEVT );

        //void newDlg203::OnNameEvent ( wxCommandEvent & event ) \n { \n    \n};
        wxString sBody = wxT("void ") + sDialogName + wxT("::") + sMethodName + wxT(" ( ");
        sBody = sBody + sEventType + wxT(" & event ) \n{ \n    \n};") ;
        AppendText (tc, wxT("\n\n\n") +  sBody );

        //void OnNameEvent ( wxCommandEvent & event );
        wxString sDec = sBody = wxT("void ") +  sMethodName + wxT(" ( ");
        sDec = sDec + sEventType + wxT(" & event );") ;
        long iPrivate = DoFindLine ( wxT("private"), 0, alt );
        WriteLine (alt, iPrivate, wxT("    ") + sDec );

        //replace -1 with enum
        long iNegative = DoFindLine ( sControl + wxT("=new"), 0, tc );
        wxString sLine = RemoveLine (  iNegative - 1, tc );
        sLine.Replace ( wxT("-1"), sNameId );
        WriteLine (tc,  iNegative-2, sLine );

    }
    //go back to original insertion point and show it
    DoShowLine ( tc, iLine );
}


bool MyFrame::IsSizer (const wxString & s, TextChild * tc)
{
    int iControlLine = DoFindLine (s + wxT("=new"), 0, tc) ;
    if ( iControlLine == wxNOT_FOUND ) return FALSE ;

    wxString sControlType = tc -> GetLineText ( iControlLine - 1 ) ;

    sControlType = sControlType.AfterFirst(wxT('='));
    sControlType = sControlType.AfterFirst(wxT('w'));
    sControlType = sControlType.BeforeFirst(wxT('('));
    sControlType.Trim(TRUE).Trim(FALSE);

    return sControlType.Contains(wxT("Sizer")) ;
}

bool MyFrame::DoDlgSanityCheck (TextChild * tc, int iLevel)
{
    bool bIsSane = TRUE ;
    // check that new always comes before add
    int iAddLine = iAddLine = DoFindLine (wxT("-> Add("), 0, tc) ;
    while (iAddLine != wxNOT_FOUND && bIsSane)
        {

         wxString sAddLine = tc -> GetLineText ( iAddLine - 1 ) ;
         //mainsizer -> Add(m_Button, 1, wxALL | wxEXPAND, 5);
         sAddLine = sAddLine.AfterFirst(wxT('(')).BeforeFirst(wxT(','));
         int iPrevLine = DoFindLine  (sAddLine + wxT("=new"), 0, tc) ;
         if (iPrevLine > iAddLine)
             {
             bIsSane = FALSE ;
             wxString sLine = RemoveLine (  iPrevLine - 1, tc );
             WriteLine (tc, iAddLine - 1, sLine );
             }
         iAddLine = DoFindLine (wxT("-> Add("), iAddLine, tc) ;
         }
    // check that things aren't added to sizers before the sizers' new
    iAddLine = iAddLine = DoFindLine (wxT("-> Add("), 0, tc) ;
    while (iAddLine != wxNOT_FOUND && bIsSane)
        {
        wxString sAddLine = tc -> GetLineText ( iAddLine - 1 ) ;
        //mainsizer -> Add(m_Button, 1, wxALL | wxEXPAND, 5);
        sAddLine = sAddLine.BeforeFirst(wxT('-'));
        //mainsizer
         int iPrevLine = DoFindLine  (sAddLine + wxT("=new"), 0, tc) ;
         if (iPrevLine > iAddLine)
             {
             bIsSane = FALSE ;
             wxString sLine = RemoveLine (  iPrevLine - 1, tc );
             WriteLine (tc, iAddLine - 1, sLine );
             }
        iAddLine = DoFindLine (wxT("-> Add("), iAddLine, tc) ;
        }

    if ( ! bIsSane && iLevel < 100 ) return DoDlgSanityCheck (tc, iLevel + 1) ;
    return bIsSane ;
}


void MyFrame::OnCtrlRen(wxCommandEvent& WXUNUSED ( event ) )
{
    wxString selControl = pDlgWin  -> GetValue ();
    TextChild * tc = pDlgWin  -> myTextChild ;
    
    //find if another control has same identifier
    int iLine = DoFindLine ( wxT("private:"), 0, tc->alternateWin ) ;
    int iControlCount = 0;
    while ( iLine != wxNOT_FOUND )
    { 
        // wxButton * aButton;
        iLine = DoFindLine ( wxT("*"), iLine, tc->alternateWin ) ;
        wxString sLine = tc -> alternateWin -> GetLineText (iLine-1);
        if (sLine.Contains (selControl)) iControlCount ++ ;
    }
    if (iControlCount > 1)
    {
        (void)wxMessageBox( wxT("Sorry, another control's name appears to contain ") + selControl +
            wxT("\nCannot safely rename control"), wxT("wxHatch warning"));
        return ;
    }
    
    wxString myText ;
    wxTextEntryDialog dialog(this,
        wxT("Please enter new name"),
        wxT("wxHatch: Rename control from ") + selControl,
        myText,
        wxOK | wxCANCEL);
    
    if (dialog.ShowModal() != wxID_OK) return ;
    
    myText = dialog.GetValue() ;
    
    //check for another control with this name
    iLine = DoFindLine ( wxT("private:"), 0, tc->alternateWin ) ;

    // wxButton * aButton;
    iLine = DoFindLine ( wxT("*") + myText + wxT(";"), iLine, tc->alternateWin ) ;
    if (iLine != wxNOT_FOUND)
    {
        (void)wxMessageBox( wxT("Sorry, another control appears to be called ") + myText +
            wxT(" already \nCannot safely rename control"), wxT("wxHatch warning"));
        return ;
    }
    
    int iOff = 1 + myText.Find( selControl );        
    int iPos = 0;
    while (iPos != wxNOT_FOUND) 
    {
        //avoid replacing it again
        iPos = iPos + iOff ;
        iPos = DoReplaceExactText (selControl, myText, iPos, tc) ;
    }
    iPos = 0;
    while (iPos != wxNOT_FOUND) 
    {
        iPos = iPos + iOff ;
        iPos = DoReplaceExactText (selControl, myText, iPos, tc->alternateWin ) ;
    }
    iPos = 0;
    while (iPos != wxNOT_FOUND && pInc) 
    {
        iPos = iPos + iOff ;
        iPos = DoReplaceExactText (selControl, myText, iPos, pInc) ;
    }
    tc->textctrl->isDlgUpDated = TRUE ;
    pDlgWin -> DoActivate ();
}


bool MyFrame::LoadSurrounds (const wxString & sPath)
{
//clear out any existing commands
    SurroundBeforeStrings.Clear();
    SurroundAfterStrings.Clear();

    wxTextFile fCmds (sPath + wxFILE_SEP_PATH + wxT("surrounds.csv") );
	bool bResult = fCmds.Exists();
    if (bResult)
    {
        fCmds.Open( ) ;
        wxString str ;
        size_t i ;
        for ( i=0; i < fCmds.GetLineCount(); i ++ )
        {
            str = fCmds[i] ;
            if ( str.Find(dot) > 0 )
            {
                if ( ! ( str.StartsWith(wxT("//")) || str.StartsWith(wxT("\"//")) || str.StartsWith(wxT("#")))  )
                {
                    str.Replace (wxT("\\t"),wxT("\t"));
                    SurroundBeforeStrings.Add(str.BeforeFirst(dot)) ;
                    SurroundAfterStrings.Add(str.AfterLast(dot)) ;
                } //end of if not a comment
            }  // end of valid text test
        }//end of for
        fCmds.Close() ;
	}
/*    else
    {
        wxString sTmp ;
        sTmp << wxT( "The surrounds file \n" ) << sPath << wxFILE_SEP_PATH << wxT("surrounds.csv \nwas not found on disk")
             << wxT( "\nPlease download a fresh copy" )  ;
        (void)wxMessageBox( sTmp, wxT("wxHatch warning"));
    } */
	return bResult ;

}


bool MyFrame::LoadAutoTexts (const wxString & sPath)
{
    //clear out any existing autotexts
    sAutoTexts.Clear();

    wxTextFile fCmds (sPath);
	bool bResult = fCmds.Exists();
    if (bResult)
    {
        fCmds.Open( ) ;
        wxString str ;
        size_t i ;
        for ( i=0; i < fCmds.GetLineCount(); i ++ )
        {
            str = fCmds[i] ;
            if ( str.Find(comma) > 0 )
            {
                if ( ! ( str.StartsWith(wxT("//")) || str.StartsWith(wxT("\"//")) || str.StartsWith(wxT("#")))  )
                {
                    str.Trim(TRUE).Trim(FALSE);
                    sAutoTexts.Add(str) ;
                } //end of if not a comment
            }  // end of valid text test
        }//end of for
        fCmds.Close() ;
        iAutoTexts = sAutoTexts.GetCount() ;
	}
    else
    {
        wxString sTmp ;
        sTmp << wxT( "The autotext file \n" ) << sPath  << wxT("\nwas not found on disk")
        << wxT( "\nPlease download a fresh copy" )  ;
        (void)wxMessageBox( sTmp, wxT("wxHatch warning"));
    } 
	return bResult ;

}


void MyFrame::OnUpdateCtrl_Tab_Up (wxUpdateUIEvent & event)
{
    if (!pDlgWin)
    {
		event.Enable(FALSE);
		return ;
	}
	event.Enable (pDlgWin -> CanTabUp ()) ;
}

void MyFrame::OnUpdateCtrl_Tab_Down (wxUpdateUIEvent & event)
{
    if (!pDlgWin)
    {
		event.Enable(FALSE);
		return ;
	}
	event.Enable (pDlgWin -> CanTabDown ()) ;
}

void MyFrame::OnCtrl_Tab_Up (wxCommandEvent& WXUNUSED(event))
{
    TextChild * tc = pDlgWin  -> myTextChild ;
	// lines to be exchanged look like this...
    //m_RadioButton5 = new wxRadioButton(this, -1, wxT("label 5"));
    //m_RadioButton2 = new wxRadioButton(this, -1, wxT("label 2"));

    wxString selControl = pDlgWin  -> GetTabBoxSel() ;
    wxString above_ctrl = pDlgWin  -> GetTabBoxPrev ();

    int iOldLine = DoFindLine ( selControl + wxT("= new"), 0, tc) ;
    if (  iOldLine == wxNOT_FOUND ) return ;
    int iNewLine = DoFindLine ( above_ctrl + wxT("= new"), 0, tc) ;

    wxString sNewLine = RemoveLine ( iOldLine - 1, tc );
    
    WriteLine (tc, iNewLine - 1, sNewLine );
    DoDlgSanityCheck (tc,0);
	pDlgWin -> DoActivate();    
}

void MyFrame::OnCtrl_Tab_Down (wxCommandEvent& WXUNUSED(event))
{
    TextChild * tc = pDlgWin  -> myTextChild ;
	// lines to be exchanged look like this...
    //m_RadioButton5 = new wxRadioButton(this, -1, wxT("label 5"));
    //m_RadioButton2 = new wxRadioButton(this, -1, wxT("label 2"));

    wxString selControl = pDlgWin  -> GetTabBoxSel() ;
    wxString below_ctrl = pDlgWin  -> GetTabBoxNext ();

    int iOldLine = DoFindLine ( below_ctrl + wxT("= new"), 0, tc) ;
    int iNewLine = DoFindLine ( selControl + wxT("= new"), 0, tc) ;
    if (  iOldLine == wxNOT_FOUND ) return ;

    wxString sNewLine = RemoveLine ( iOldLine - 1, tc );
  
    WriteLine (tc, iNewLine - 1, sNewLine );
    DoDlgSanityCheck (tc,0);
	pDlgWin -> DoActivate();     
}

void MyFrame::OnUpdateCtrlDel  (wxUpdateUIEvent & event)
{
    if (!pInc)
    {
        event.Enable (FALSE);
        return ;
    }
    if (!pDlgWin)
    {
		event.Enable(FALSE);
		return ;
	}
	if (pDlgWin -> IsProperty ())
	{
        event.Enable (FALSE);
        return ;
    }
    event.Enable ( pDlgWin -> CanDel () ) ;
}

void MyFrame::OnUpdateCtrlRen  (wxUpdateUIEvent & event)
{
    if (!pInc)
    {
        event.Enable (FALSE);
        return ;
    }
    if (!pDlgWin)
    {
		event.Enable(FALSE);
		return ;
	}
	if (pDlgWin -> IsProperty ())
	{
        event.Enable (FALSE);
        return ;
    }
    event.Enable ( pDlgWin -> CanDlgSel (event) ) ;
}



void MyFrame::OnCtrlUp (wxCommandEvent& WXUNUSED(event))
{
    TextChild * tc = pDlgWin  -> myTextChild ;
	// lines to be exchanged look like this...
    //mainsizer -> Add(m_Button, 1, wxALL | wxEXPAND, 5);
    //mainsizer -> Add(m_Sizer, 1, wxALL | wxEXPAND, 5);

    wxString selControl = pDlgWin  -> GetValue ();
    wxString above_ctrl = pDlgWin  -> GetPreviousValue ();

    int iOldLine = DoFindLine (wxT("-> Add(") + selControl + comma, 0, tc) ;
    if (  iOldLine == wxNOT_FOUND ) return ;
    int iNewLine = DoFindLine (wxT("-> Add(") + above_ctrl + comma, 0, tc) ;

    if (iNewLine > iOldLine )  iNewLine -- ;

    wxString sNewLine = RemoveLine ( iOldLine - 1, tc );
  
    WriteLine (tc, iNewLine - 1, sNewLine );
    DoDlgSanityCheck (tc,0);
	pDlgWin -> DoActivate();

}

void MyFrame::OnCtrlDown (wxCommandEvent& event)
{
	if (pDlgWin && pDlgWin -> SelectNextValue()) OnCtrlUp (event);
}


void MyFrame::OnUpdateCtrlMove (wxUpdateUIEvent & event)
{
    if (!pDlgWin)
    {
		event.Enable(FALSE);
		return ;
	}
	if (pDlgWin -> IsProperty ())
	{
        event.Enable (FALSE);
        return ;
    }
    event.Enable ( pDlgWin -> CanDlgSel (event) ) ;
}


void MyFrame::OnCtrlLeft (wxCommandEvent& WXUNUSED(event))
{
    TextChild * tc = pDlgWin  -> myTextChild ;
	// lines to be exchanged look like this...
    //mainsizer -> Add(m_Button, 1, wxALL | wxEXPAND, 5);
    //mainsizer -> Add(m_Sizer, 1, wxALL | wxEXPAND, 5);

    wxString selControl = pDlgWin  -> GetValue ();
    wxString Left_ctrl  = pDlgWin  -> GetGrandParentValue ();

    int iOldLine = DoFindLine (wxT("-> Add(") + selControl + comma, 0, tc) ;
    if (  iOldLine == wxNOT_FOUND ) return ;
    int iNewLine = DoFindLine (wxT("-> Add(") + Left_ctrl  + comma, 0, tc) ;

    if (iNewLine > iOldLine )  iNewLine -- ;

    wxString sNewLine = RemoveLine ( iOldLine - 1, tc );
    wxString sOldSizer = sNewLine.BeforeFirst(wxT('-')).Trim(TRUE).Trim(FALSE);

    sNewLine.Replace( sOldSizer, Left_ctrl );
    
    WriteLine (tc, iNewLine - 1, sNewLine );
    DoDlgSanityCheck (tc,0);
	pDlgWin -> DoActivate();
}

void MyFrame::OnCtrlRight (wxCommandEvent& WXUNUSED(event))
{
    TextChild * tc = pDlgWin  -> myTextChild ;
	// lines to be exchanged look like this...
    //mainsizer -> Add(m_Button, 1, wxALL | wxEXPAND, 5);
    //mainsizer -> Add(m_Sizer, 1, wxALL | wxEXPAND, 5);

    wxString selControl = pDlgWin  -> GetValue ();
    wxString Right_ctrl = pDlgWin  -> GetSubSizer ();

    int iOldLine = DoFindLine (wxT("-> Add(") + selControl + comma, 0, tc) ;
    if (  iOldLine == wxNOT_FOUND ) return ;
    int iNewLine = DoFindLine (wxT("-> Add(") + Right_ctrl + comma, 0, tc) ;

    if (iNewLine > iOldLine )  iNewLine -- ;

    wxString sNewLine = RemoveLine ( iOldLine - 1, tc );
    wxString sOldSizer = sNewLine.BeforeFirst(wxT('-')).Trim(TRUE).Trim(FALSE);

     sNewLine.Replace( sOldSizer, Right_ctrl );
    
    WriteLine (tc, iNewLine - 1, sNewLine );
    DoDlgSanityCheck (tc,0);
	pDlgWin -> DoActivate();
}

void MyFrame::OnCtrlDel(wxCommandEvent& WXUNUSED ( event ) )
{
    TextChild * tc = pDlgWin  -> myTextChild ;
    wxString selControl = pDlgWin  -> GetValue ();

    //remove Add
    int iOldLine = DoFindLine (wxT("-> Add(") + selControl + comma, 0, tc) ;
    wxString sOldLine = RemoveLine ( iOldLine - 1, tc );

    //remove new
    iOldLine = DoFindLine (selControl + wxT("=new"), 0, tc) ;
    sOldLine = RemoveLine ( iOldLine - 1, tc );

    //now remove from header
    tc = pDlgWin -> myTextChild -> alternateWin ;

    //wxRadioButton * m_RadioButton;
    iOldLine = DoFindLine (wxT("*") + selControl + wxT(";"), 0, tc) ;
    sOldLine = RemoveLine ( iOldLine - 1, tc );

    // Set and Get don't necessarily exist
            // bool m_RadioButton_GetValue() 

            // { return m_RadioButton -> GetValue()  ; } ; 
    iOldLine = DoFindLine (wxT("return") + selControl + wxT("->"), 0, tc) ;
    if (iOldLine != wxNOT_FOUND )
    {
        sOldLine = RemoveLine ( iOldLine - 1, tc );
        sOldLine = RemoveLine ( iOldLine - 2, tc );
    }
    iOldLine = DoFindLine (wxT("{") + selControl + wxT("->"), 0, tc) ;
    if (iOldLine != wxNOT_FOUND )
    {
        sOldLine = RemoveLine ( iOldLine - 1, tc );
        sOldLine = RemoveLine ( iOldLine - 2, tc );
    }
    // leave the event handler alone in case their body is needed again
    
    // now do the Inc file
    // bool b = dialog.m_RadioButton_GetValue() ;
    if (pInc)
    {
        tc = pInc ;

        iOldLine = DoFindLine (wxT(".") + selControl + wxT("_"), 0, tc) ;
        if (iOldLine != wxNOT_FOUND )
        {
            sOldLine = RemoveLine ( iOldLine - 1, tc );
        }
        iOldLine = DoFindLine (wxT(".") + selControl + wxT("_"), 0, tc) ;
        if (iOldLine != wxNOT_FOUND )
        {
            sOldLine = RemoveLine ( iOldLine - 1, tc );
        }
    }
    DoDlgSanityCheck (pDlgWin  -> myTextChild,0);
	pDlgWin -> DoActivate();
}


